/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/product/common/productService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(z){for(var e=[],v=0,L=z.length;v<L;v++)e[v]=J[z[v]];return e};define(J[102],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,A){if(!L)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=v}),define(J[46],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(E){return(n,w,y)=>{let i=null,I=null;if(typeof y.value=="function"?(i="value",I=y.value):typeof y.get=="function"&&(i="get",I=y.get),!I)throw new Error("not supported");y[i]=E(I,w)}}e.createDecorator=v;function L(E,n,w){let y=null,i=null;if(typeof w.value=="function"?(y="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(y="get",i=w.get),!i)throw new Error("not supported");const I=`$memoize$${n}`;w[y]=function(...P){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,P)}),this[I]}}e.memoize=L;function A(E,n,w){return v((y,i)=>{const I=`$debounce$${i}`,P=`$debounce$result$${i}`;return function(...p){this[P]||(this[P]=w?w():void 0),clearTimeout(this[I]),n&&(this[P]=n(this[P],...p),p=[this[P]]),this[I]=setTimeout(()=>{y.apply(this,p),this[P]=w?w():void 0},E)}})}e.debounce=A;function S(E,n,w){return v((y,i)=>{const I=`$throttle$timer$${i}`,P=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,g=`$throttle$pending$${i}`;return function(...m){if(this[P]||(this[P]=w?w():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),n&&(this[P]=n(this[P],...m)),this[g])return;const D=this[p]+E;D<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[P]]),this[P]=w?w():void 0):(this[g]=!0,this[I]=setTimeout(()=>{this[g]=!1,this[p]=Date.now(),y.apply(this,[this[P]]),this[P]=w?w():void 0},D-Date.now()))}})}e.throttle=S}),define(J[19],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function L(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=L;function A(o){w(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=A;function S(o){w(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=S;function E(o){if(o instanceof Error){let{name:t,message:r}=o;const s=o.stacktrace||o.stack;return{$isError:!0,name:t,message:r,stack:s}}return o}e.transformErrorForSerialization=E;const n="Canceled";function w(o){return o instanceof Error&&o.name===n&&o.message===n}e.isPromiseCanceledError=w;class y extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=y;function i(){const o=new Error(n);return o.name=o.message,o}e.canceled=i;function I(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=I;function P(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=P;function p(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function g(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=g;function m(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=m;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function u(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function l(o,t=Object.create(null)){const r=new Error(o);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(J[35],Z([0,1,19]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(N,F=0){return N[N.length-(1+F)]}e.tail=L;function A(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=A;function S(N,F,R=(O,M)=>O===M){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let O=0,M=N.length;O<M;O++)if(!R(N[O],F[O]))return!1;return!0}e.equals=S;function E(N,F,R){let O=0,M=N.length-1;for(;O<=M;){const W=(O+M)/2|0,_=R(N[W],F);if(_<0)O=W+1;else if(_>0)M=W-1;else return W}return-(O+1)}e.binarySearch=E;function n(N,F){let R=0,O=N.length;if(O===0)return 0;for(;R<O;){const M=Math.floor((R+O)/2);F(N[M])?O=M:R=M+1}return R}e.findFirstInSorted=n;function w(N,F,R){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let O=F[Math.floor(F.length*Math.random())],M=[],W=[],_=[];for(let q of F){const K=R(q,O);K<0?M.push(q):K>0?W.push(q):_.push(q)}return N<M.length?w(N,M,R):N<M.length+_.length?_[0]:w(N-(M.length+_.length),W,R)}e.quickSelect=w;function y(N,F){const R=[];let O;for(const M of N.slice(0).sort(F))!O||F(O[0],M)!==0?(O=[M],R.push(O)):O.push(M);return R}e.groupBy=y;function i(N,F,R){const O=[];function M(q,K,H){if(K===0&&H.length===0)return;const x=O[O.length-1];x&&x.start+x.deleteCount===q?(x.deleteCount+=K,x.toInsert.push(...H)):O.push({start:q,deleteCount:K,toInsert:H})}let W=0,_=0;for(;;){if(W===N.length){M(W,0,F.slice(_));break}if(_===F.length){M(W,N.length-W,[]);break}const q=N[W],K=F[_],H=R(q,K);H===0?(W+=1,_+=1):H<0?(M(W,1,[]),W+=1):H>0&&(M(W,0,[K]),_+=1)}return O}e.sortedDiff=i;function I(N,F,R){const O=i(N,F,R),M=[],W=[];for(const _ of O)M.push(...N.slice(_.start,_.start+_.deleteCount)),W.push(..._.toInsert);return{removed:M,added:W}}e.delta=I;function P(N,F,R){if(R===0)return[];const O=N.slice(0,R).sort(F);return g(N,F,O,R,N.length),O}e.top=P;function p(N,F,R,O,M){return R===0?Promise.resolve([]):new Promise((W,_)=>{(async()=>{const q=N.length,K=N.slice(0,R).sort(F);for(let H=R,x=Math.min(R+O,q);H<q;H=x,x=Math.min(x+O,q)){if(H>R&&await new Promise(ne=>setTimeout(ne)),M&&M.isCancellationRequested)throw v.canceled();g(N,F,K,H,x)}return K})().then(W,_)})}e.topAsync=p;function g(N,F,R,O,M){for(const W=R.length;O<M;O++){const _=N[O];if(F(_,R[W-1])<0){R.pop();const q=n(R,K=>F(_,K)<0);R.splice(q,0,_)}}}function m(N){return N.filter(F=>!!F)}e.coalesce=m;function D(N){let F=0;for(let R=0;R<N.length;R++)N[R]&&(N[F]=N[R],F+=1);N.length=F}e.coalesceInPlace=D;function b(N,F,R){N.splice(R,0,N.splice(F,1)[0])}e.move=b;function c(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=c;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function l(N,F){if(!F)return N.filter((O,M)=>N.indexOf(O)===M);const R=Object.create(null);return N.filter(O=>{const M=F(O);return R[M]?!1:(R[M]=!0,!0)})}e.distinct=l;function o(N){const F=new Set;return N.filter(R=>F.has(R)?!1:(F.add(R),!0))}e.distinctES6=o;function t(N){const F=Object.create(null);return R=>{const O=N(R);return F[O]?!1:(F[O]=!0,!0)}}e.uniqueFilter=t;function r(N,F){for(let R=N.length-1;R>=0;R--){const O=N[R];if(F(O))return R}return-1}e.lastIndex=r;function s(N,F){return N.length>0?N[0]:F}e.firstOrDefault=s;function a(N,F,R=(O,M)=>O===M){let O=0;for(let M=0,W=Math.min(N.length,F.length);M<W&&R(N[M],F[M]);M++)O++;return O}e.commonPrefixLength=a;function h(N){return[].concat(...N)}e.flatten=h;function f(N,F){let R=typeof F=="number"?N:0;typeof F=="number"?R=N:(R=0,F=N);const O=[];if(R<=F)for(let M=R;M<F;M++)O.push(M);else for(let M=R;M>F;M--)O.push(M);return O}e.range=f;function d(N,F,R){return N.reduce((O,M)=>(O[F(M)]=R?R(M):M,O),Object.create(null))}e.index=d;function k(N,F){return N.push(F),()=>T(N,F)}e.insert=k;function T(N,F){const R=N.indexOf(F);if(R>-1)return N.splice(R,1),F}e.remove=T;function C(N,F,R){const O=N.slice(0,F),M=N.slice(F);return O.concat(R,M)}e.arrayInsert=C;function V(N,F){let R;if(typeof F=="number"){let O=F;R=()=>{const M=Math.sin(O++)*179426549;return M-Math.floor(M)}}else R=Math.random;for(let O=N.length-1;O>0;O-=1){const M=Math.floor(R()*(O+1)),W=N[O];N[O]=N[M],N[M]=W}}e.shuffle=V;function X(N,F){const R=N.indexOf(F);R>-1&&(N.splice(R,1),N.unshift(F))}e.pushToStart=X;function ee(N,F){const R=N.indexOf(F);R>-1&&(N.splice(R,1),N.push(F))}e.pushToEnd=ee;function B(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=B;function Y(N){return Array.isArray(N)?N:[N]}e.asArray=Y;function Q(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=Q;function U(N,F){for(const R of N){const O=F(R);if(O!==void 0)return O}}e.mapFind=U;function $(N,F){let R=Number.MAX_SAFE_INTEGER,O=0;return N.forEach((M,W)=>{const _=F(M);_<R&&(R=_,O=W)}),O}e.minIndex=$;function G(N,F){let R=Number.MIN_SAFE_INTEGER,O=0;return N.forEach((M,W)=>{const _=F(M);_>R&&(R=_,O=W)}),O}e.maxIndex=G}),define(J[42],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const A=this;let S=!1,E;return function(){return S||(S=!0,E=L.apply(A,arguments)),E}}e.once=v}),define(J[63],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function A(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}L.is=A;const S=Object.freeze([]);function E(){return S}L.empty=E;function*n(o){yield o}L.single=n;function w(o){return o||S}L.from=w;function y(o){return!o||o[Symbol.iterator]().next().done===!0}L.isEmpty=y;function i(o){return o[Symbol.iterator]().next().value}L.first=i;function I(o,t){for(const r of o)if(t(r))return!0;return!1}L.some=I;function P(o,t){for(const r of o)if(t(r))return r}L.find=P;function*p(o,t){for(const r of o)t(r)&&(yield r)}L.filter=p;function*g(o,t){let r=0;for(const s of o)yield t(s,r++)}L.map=g;function*m(...o){for(const t of o)for(const r of t)yield r}L.concat=m;function*D(o){for(const t of o)for(const r of t)yield r}L.concatNested=D;function b(o,t,r){let s=r;for(const a of o)s=t(s,a);return s}L.reduce=b;function*c(o,t,r=o.length){for(t<0&&(t+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);t<r;t++)yield o[t]}L.slice=c;function u(o,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,o];const s=o[Symbol.iterator]();for(let a=0;a<t;a++){const h=s.next();if(h.done)return[r,L.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=u;function l(o,t,r=(s,a)=>s===a){const s=o[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const h=s.next(),f=a.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!r(h.value,f.value))return!1}}L.equals=l})(v=e.Iterable||(e.Iterable={}))}),define(J[43],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function E(t,r=!1){let s=0,a=t.length,h="",f=0,d=16,k=0;function T(Q){let U=0,$=0;for(;U<Q;){const G=t.charCodeAt(s);if(G>=48&&G<=57)$=$*16+G-48;else if(G>=65&&G<=70)$=$*16+G-65+10;else if(G>=97&&G<=102)$=$*16+G-97+10;else break;s++,U++}return U<Q&&($=-1),$}function C(Q){s=Q,h="",f=0,d=16,k=0}function V(){const Q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return k=3,t.substring(Q,s);let U=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;U=s}else k=3;return t.substring(Q,U)}function X(){let Q="",U=s;for(;;){if(s>=a){Q+=t.substring(U,s),k=2;break}const $=t.charCodeAt(s);if($===34){Q+=t.substring(U,s),s++;break}if($===92){if(Q+=t.substring(U,s),s++,s>=a){k=2;break}switch(t.charCodeAt(s++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const N=T(4);N>=0?Q+=String.fromCharCode(N):k=4;break;default:k=5}U=s;continue}if($>=0&&$<=31)if(w($)){Q+=t.substring(U,s),k=2;break}else k=6;s++}return Q}function ee(){if(h="",k=0,f=s,s>=a)return f=a,d=17;let Q=t.charCodeAt(s);if(n(Q)){do s++,h+=String.fromCharCode(Q),Q=t.charCodeAt(s);while(n(Q));return d=15}if(w(Q))return s++,h+=String.fromCharCode(Q),Q===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),d=14;switch(Q){case 123:return s++,d=1;case 125:return s++,d=2;case 91:return s++,d=3;case 93:return s++,d=4;case 58:return s++,d=6;case 44:return s++,d=5;case 34:return s++,h=X(),d=10;case 47:const U=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!w(t.charCodeAt(s));)s++;return h=t.substring(U,s),d=12}if(t.charCodeAt(s+1)===42){s+=2;const $=a-1;let G=!1;for(;s<$;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,G=!0;break}s++}return G||(s++,k=1),h=t.substring(U,s),d=13}return h+=String.fromCharCode(Q),s++,d=16;case 45:if(h+=String.fromCharCode(Q),s++,s===a||!y(t.charCodeAt(s)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=V(),d=11;default:for(;s<a&&B(Q);)s++,Q=t.charCodeAt(s);if(f!==s){switch(h=t.substring(f,s),h){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return h+=String.fromCharCode(Q),s++,d=16}}function B(Q){if(n(Q)||w(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let Q;do Q=ee();while(Q>=12&&Q<=15);return Q}return{setPosition:C,getPosition:()=>s,scan:r?Y:ee,getToken:()=>d,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>k}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,r){const s=[],a=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function k(T,C,V,X){f.value=T,f.offset=C,f.length=V,f.type=X,f.colonOffset=void 0,h=f}try{u(t,{onObjectBegin:(T,C)=>{if(r<=T)throw a;h=void 0,d=r>T,s.push("")},onObjectProperty:(T,C,V)=>{if(r<C||(k(T,C,V,"property"),s[s.length-1]=T,r<=C+V))throw a},onObjectEnd:(T,C)=>{if(r<=T)throw a;h=void 0,s.pop()},onArrayBegin:(T,C)=>{if(r<=T)throw a;h=void 0,s.push(0)},onArrayEnd:(T,C)=>{if(r<=T)throw a;h=void 0,s.pop()},onLiteralValue:(T,C,V)=>{if(r<C||(k(T,C,V,o(T)),r<=C+V))throw a},onSeparator:(T,C,V)=>{if(r<=C)throw a;if(T===":"&&h&&h.type==="property")h.colonOffset=C,d=!1,h=void 0;else if(T===","){const X=s[s.length-1];typeof X=="number"?s[s.length-1]=X+1:(d=!0,s[s.length-1]=""),h=void 0}}})}catch(T){if(T!==a)throw T}return{path:s,previousNode:h,isAtPropertyKey:d,matches:T=>{let C=0;for(let V=0;C<T.length&&V<s.length;V++)if(T[C]===s[V]||T[C]==="*")C++;else if(T[C]!=="**")return!1;return C===T.length}}}e.getLocation=I;function P(t,r=[],s=S.DEFAULT){let a=null,h=[];const f=[];function d(T){Array.isArray(h)?h.push(T):a!==null&&(h[a]=T)}return u(t,{onObjectBegin:()=>{const T={};d(T),f.push(h),h=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const T=[];d(T),f.push(h),h=T,a=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:d,onError:(T,C,V)=>{r.push({error:T,offset:C,length:V})}},s),h[0]}e.parse=P;function p(t,r=[],s=S.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(T){a.type==="property"&&(a.length=T-a.offset,a=a.parent)}function f(T){return a.children.push(T),T}u(t,{onObjectBegin:T=>{a=f({type:"object",offset:T,length:-1,parent:a,children:[]})},onObjectProperty:(T,C,V)=>{a=f({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:T,offset:C,length:V,parent:a})},onObjectEnd:(T,C)=>{a.length=T+C-a.offset,a=a.parent,h(T+C)},onArrayBegin:(T,C)=>{a=f({type:"array",offset:T,length:-1,parent:a,children:[]})},onArrayEnd:(T,C)=>{a.length=T+C-a.offset,a=a.parent,h(T+C)},onLiteralValue:(T,C,V)=>{f({type:o(T),offset:C,length:V,parent:a,value:T}),h(C+V)},onSeparator:(T,C,V)=>{a.type==="property"&&(T===":"?a.colonOffset=C:T===","&&h(C))},onError:(T,C,V)=>{r.push({error:T,offset:C,length:V})}},s);const k=a.children[0];return k&&delete k.parent,k}e.parseTree=p;function g(t,r){if(!t)return;let s=t;for(let a of r)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===a){s=f.children[1],h=!0;break}if(!h)return}else{const h=a;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}e.findNodeAtLocation=g;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=m;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let s of t.children){const a=s.children[1];a&&(r[s.children[0].value]=D(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=b;function c(t,r,s=!1){if(b(t,r,s)){const a=t.children;if(Array.isArray(a))for(let h=0;h<a.length&&a[h].offset<=r;h++){const f=c(a[h],r,s);if(f)return f}return t}}e.findNodeAtOffset=c;function u(t,r,s=S.DEFAULT){const a=E(t,!1);function h(_){return _?()=>_(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f(_){return _?q=>_(q,a.getTokenOffset(),a.getTokenLength()):()=>!0}const d=h(r.onObjectBegin),k=f(r.onObjectProperty),T=h(r.onObjectEnd),C=h(r.onArrayBegin),V=h(r.onArrayEnd),X=f(r.onLiteralValue),ee=f(r.onSeparator),B=h(r.onComment),Y=f(r.onError),Q=s&&s.disallowComments,U=s&&s.allowTrailingComma;function $(){for(;;){const _=a.scan();switch(a.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:Q||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(_){case 12:case 13:Q?G(10):B();break;case 16:G(1);break;case 15:case 14:break;default:return _}}}function G(_,q=[],K=[]){if(Y(_),q.length+K.length>0){let H=a.getToken();for(;H!==17;){if(q.indexOf(H)!==-1){$();break}else if(K.indexOf(H)!==-1)break;H=$()}}}function N(_){const q=a.getTokenValue();return _?X(q):k(q),$(),!0}function F(){switch(a.getToken()){case 11:let _=0;try{_=JSON.parse(a.getTokenValue()),typeof _!="number"&&(G(2),_=0)}catch(q){G(2)}X(_);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return $(),!0}function R(){return a.getToken()!==10?(G(3,[],[2,5]),!1):(N(!1),a.getToken()===6?(ee(":"),$(),W()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function O(){d(),$();let _=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(_||G(4,[],[]),ee(","),$(),a.getToken()===2&&U)break}else _&&G(6,[],[]);R()||G(4,[],[2,5]),_=!0}return T(),a.getToken()!==2?G(7,[2],[]):$(),!0}function M(){C(),$();let _=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(_||G(4,[],[]),ee(","),$(),a.getToken()===4&&U)break}else _&&G(6,[],[]);W()||G(4,[],[4,5]),_=!0}return V(),a.getToken()!==4?G(8,[4],[]):$(),!0}function W(){switch(a.getToken()){case 3:return M();case 1:return O();case 10:return N(!0);default:return F()}}return $(),a.getToken()===17?s.allowEmptyContent?!0:(G(4,[],[]),!1):W()?(a.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=u;function l(t,r){let s=E(t),a=[],h,f=0,d;do switch(d=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:f!==d&&a.push(t.substring(f,d)),r!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(h!==17);return a.join("")}e.stripComments=l;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(J[103],Z([0,1,43]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,y,i){let I,P,p,g,m;if(y){for(g=y.offset,m=g+y.length,p=g;p>0&&!n(w,p-1);)p--;let f=m;for(;f<w.length&&!n(w,f);)f++;P=w.substring(p,f),I=S(P,i)}else P=w,I=0,p=0,g=0,m=w.length;const D=E(i,w);let b=!1,c=0,u;i.insertSpaces?u=A(" ",i.tabSize||4):u="	";const l=v.createScanner(P,!1);let o=!1;function t(){return D+A(u,I+c)}function r(){let f=l.scan();for(b=!1;f===15||f===14;)b=b||f===14,f=l.scan();return o=f===16||l.getTokenError()!==0,f}const s=[];function a(f,d,k){!o&&d<m&&k>g&&w.substring(d,k)!==f&&s.push({offset:d,length:k-d,content:f})}let h=r();if(h!==17){const f=l.getTokenOffset()+p,d=A(u,I);a(d,p,f)}for(;h!==17;){let f=l.getTokenOffset()+l.getTokenLength()+p,d=r(),k="";for(;!b&&(d===12||d===13);){const C=l.getTokenOffset()+p;a(" ",f,C),f=l.getTokenOffset()+l.getTokenLength()+p,k=d===12?t():"",d=r()}if(d===2)h!==1&&(c--,k=t());else if(d===4)h!==3&&(c--,k=t());else{switch(h){case 3:case 1:c++,k=t();break;case 5:case 12:k=t();break;case 13:b?k=t():k=" ";break;case 6:k=" ";break;case 10:if(d===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?k=" ":d!==5&&d!==17&&(o=!0);break;case 16:o=!0;break}b&&(d===12||d===13)&&(k=t())}const T=l.getTokenOffset()+p;a(k,f,T),h=d}return s}e.format=L;function A(w,y){let i="";for(let I=0;I<y;I++)i+=w;return i}function S(w,y){let i=0,I=0;const P=y.tabSize||4;for(;i<w.length;){const p=w.charAt(i);if(p===" ")I++;else if(p==="	")I+=P;else break;i++}return Math.floor(I/P)}function E(w,y){for(let i=0;i<y.length;i++){const I=y.charAt(i);if(I==="\r")return i+1<y.length&&y.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=E;function n(w,y){return`\r
`.indexOf(w.charAt(y))!==-1}e.isEOL=n}),define(J[104],Z([0,1,43,103]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(y,i,I){return S(y,i,void 0,I)}e.removeProperty=A;function S(y,i,I,P,p){const g=i.slice(),m=[],D=v.parseTree(y,m);let b,c;for(;g.length>0&&(c=g.pop(),b=v.findNodeAtLocation(D,g),b===void 0&&I!==void 0);)typeof c=="string"?I={[c]:I}:I=[I];if(b)if(b.type==="object"&&typeof c=="string"&&Array.isArray(b.children)){const u=v.findNodeAtLocation(b,[c]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const l=b.children.indexOf(u.parent);let o,t=u.parent.offset+u.parent.length;if(l>0){const r=b.children[l-1];o=r.offset+r.length}else o=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return E(y,{offset:o,length:t-o,content:""},P)}else return E(y,{offset:u.offset,length:u.length,content:JSON.stringify(I)},P);else{if(I===void 0)return[];const l=`${JSON.stringify(c)}: ${JSON.stringify(I)}`,o=p?p(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(o>0){const r=b.children[o-1];t={offset:r.offset+r.length,length:0,content:","+l}}else b.children.length===0?t={offset:b.offset+1,length:0,content:l}:t={offset:b.offset+1,length:0,content:l+","};return E(y,t,P)}}else if(b.type==="array"&&typeof c=="number"&&Array.isArray(b.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let l;if(b.children.length===0||c===0)l={offset:b.offset+1,length:0,content:b.children.length===0?u:u+","};else{const o=c===-1||c>b.children.length?b.children.length:c,t=b.children[o-1];l={offset:t.offset+t.length,length:0,content:","+u}}return E(y,l,P)}else{const u=c,l=b.children[u];let o;if(b.children.length===1)o={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===u){const t=b.children[u-1],r=t.offset+t.length,s=b.offset+b.length;o={offset:r,length:s-2-r,content:""}}else o={offset:l.offset,length:b.children[u+1].offset-l.offset,content:""};return E(y,o,P)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(y,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},P)}}e.setProperty=S;function E(y,i,I){let P=n(y,i),p=i.offset,g=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!L.isEOL(P,p-1);)p--;for(;g<P.length&&!L.isEOL(P,g);)g++}const m=L.format(P,{offset:p,length:g-p},I);for(let b=m.length-1;b>=0;b--){const c=m[b];P=n(P,c),p=Math.min(p,c.offset),g=Math.max(g,c.offset+c.length),g+=c.content.length-c.length}const D=y.length-(P.length-g)-p;return[{offset:p,length:D,content:P.substring(p,g)}]}e.withFormatting=E;function n(y,i){return y.substring(0,i.offset)+i.content+y.substring(i.offset+i.length)}e.applyEdit=n;function w(y,i){let I=i.slice(0).sort((p,g)=>{const m=p.offset-g.offset;return m===0?p.length-g.length:m}),P=y.length;for(let p=I.length-1;p>=0;p--){let g=I[p];if(g.offset+g.length<=P)y=n(y,g);else throw new Error("Overlapping edit");P=g.offset}return y}e.applyEdits=w}),define(J[57],Z([0,1,19]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,l){this._keyCodeToStr[u]=l,this._strToKeyCode[l.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const S=new A,E=new A,n=new A;(function(){function c(u,l,o=l,t=o){S.define(u,l),E.define(u,o),n.define(u,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var w;(function(c){function u(s){return S.keyCodeToStr(s)}c.toString=u;function l(s){return S.strToKeyCode(s)}c.fromString=l;function o(s){return E.keyCodeToStr(s)}c.toUserSettingsUS=o;function t(s){return n.keyCodeToStr(s)}c.toUserSettingsGeneral=t;function r(s){return E.strToKeyCode(s)||n.strToKeyCode(s)}c.fromUserSettings=r})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(y||(y={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function I(c,u){const l=(u&65535)<<16>>>0;return(c|l)>>>0}e.KeyChord=I;function P(c,u){if(c===0)return null;const l=(c&65535)>>>0,o=(c&4294901760)>>>16;return o!==0?new m([p(l,u),p(o,u)]):new m([p(l,u)])}e.createKeybinding=P;function p(c,u){const l=!!(c&2048),o=!!(c&256),t=u===2?o:l,r=!!(c&1024),s=!!(c&512),a=u===2?l:o,h=c&255;return new g(t,r,s,a,h)}e.createSimpleKeybinding=p;class g{constructor(u,l,o,t,r){this.ctrlKey=u,this.shiftKey=l,this.altKey=o,this.metaKey=t,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",o=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${l}${o}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=g;class m{constructor(u){if(u.length===0)throw v.illegalArgument("parts");this.parts=u}getHashCode(){let u="";for(let l=0,o=this.parts.length;l<o;l++)l!==0&&(u+=";"),u+=this.parts[l].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let l=0;l<this.parts.length;l++)if(!this.parts[l].equals(u.parts[l]))return!1;return!0}}e.ChordKeybinding=m;class D{constructor(u,l,o,t,r,s){this.ctrlKey=u,this.shiftKey=l,this.altKey=o,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=D;class b{}e.ResolvedKeybinding=b}),define(J[2],Z([0,1,42,63]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let S=null;function E(l){S=l}if(e.setDisposableTracker=E,A){const l="__is_disposable_tracked__";S=new class{trackDisposable(o){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(t)},3e3)}markTracked(o){if(o&&o!==m.None)try{o[l]=!0}catch(t){}}}}function n(l){!S||S.markTracked(l)}function w(l){return S&&S.trackDisposable(l),l}e.trackDisposable=w;class y extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=y;function i(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=i;function I(l){if(L.Iterable.is(l)){let o=[];for(const t of l)if(t){n(t);try{t.dispose()}catch(r){o.push(r)}}if(o.length===1)throw o[0];if(o.length>1)throw new y(o);return Array.isArray(l)?[]:l}else if(l)return n(l),l.dispose(),l}e.dispose=I;function P(...l){return l.forEach(n),p(()=>I(l))}e.combinedDisposable=P;function p(l){const o=w({dispose:()=>{n(o),l()}});return o}e.toDisposable=p;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return n(o),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new g,w(this)}dispose(){n(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var t;this._isDisposed||o===this._value||((t=this._value)===null||t===void 0||t.dispose(),o&&n(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,n(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=D;class b{constructor(){this.references=new Map}acquire(o,...t){let r=this.references.get(o);r||(r={counter:0,object:this.createReferencedObject(o,...t)},this.references.set(o,r));const{object:s}=r,a=v.once(()=>{--r.counter==0&&(this.destroyReferencedObject(o,r.object),this.references.delete(o))});return r.counter++,{object:s,dispose:a}}}e.ReferenceCollection=b;class c{constructor(o){this.referenceCollection=o}async acquire(o,...t){const r=this.referenceCollection.acquire(o,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(s){throw r.dispose(),s}}}e.AsyncReferenceCollection=c;class u{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=u}),define(J[78],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let S=this._first;for(;S!==v.Undefined;){const E=S.next;S.prev=v.Undefined,S.next=v.Undefined,S=E}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,E){const n=new v(S);if(this._first===v.Undefined)this._first=n,this._last=n;else if(E){const y=this._last;this._last=n,n.prev=y,y.next=n}else{const y=this._first;this._first=n,n.next=y,y.prev=n}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==v.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const E=S.prev;E.next=S.next,S.next.prev=E}else S.prev===v.Undefined&&S.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):S.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):S.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(){function z(A){const S=[];typeof A=="number"&&S.push("code/timeOrigin",A);function E(w){S.push(w,Date.now())}function n(){const w=[];for(let y=0;y<S.length;y+=2)w.push({name:S[y],startTime:S[y+1]});return w}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const E of performance.getEntriesByType("mark"))S.push({name:E.name,startTime:Math.round(A+E.startTime)});return S}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function v(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(J[3],Z([0,1]),function(z,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let A=!1,S=!1,E=!1,n=!1,w=!1,y=!1,i=!1,I,P=L,p,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const D=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=D&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=m==null?void 0:m.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)g=navigator.userAgent,A=g.indexOf("Windows")>=0,S=g.indexOf("Macintosh")>=0,i=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=g.indexOf("Linux")>=0,y=!0,I=navigator.language,P=I;else if(typeof m=="object"){A=m.platform==="win32",S=m.platform==="darwin",E=m.platform==="linux",n=E&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,I=L,P=L;const a=m.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),f=h.availableLanguages["*"];I=h.locale,P=f||L,p=h._translationsConfigFile}catch(h){}w=!0}else console.error("Unable to resolve platform.");var b;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function c(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let u=0;S?u=1:A?u=3:E&&(u=2),e.isWindows=A,e.isMacintosh=S,e.isLinux=E,e.isLinuxSnap=n,e.isNative=w,e.isWeb=y,e.isIOS=i,e.platform=u,e.userAgent=g,e.language=P;var l;(function(a){function h(){return e.language}a.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=f;function d(){return e.language==="en"}a.isDefault=d})(l=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeSetImmediateId)for(let T=0,C=f.length;T<C;T++){const V=f[T];if(V.id===k.data.vscodeSetImmediateId){f.splice(T,1),V.callback();return}}});let d=0;return k=>{const T=++d;f.push({id:T,callback:k}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const h=Promise.resolve();return f=>h.then(f)}();var o;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||i?2:A?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(J[32],Z([0,1,3]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const A=v.globals.vscode.process;L={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(S){return v.setImmediate(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(A){return v.setImmediate(A)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(J[8],Z([0,1,32]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,A=97,S=90,E=122,n=46,w=47,y=92,i=58,I=63;class P extends Error{constructor(l,o,t){let r;typeof o=="string"&&o.indexOf("not ")===0?(r="must not be",o=o.replace(/^not /,"")):r="must be";const s=l.indexOf(".")!==-1?"property":"argument";let a=`The "${l}" ${s} ${r} of type ${o}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,l){if(typeof u!="string")throw new P(l,"string",u)}function g(u){return u===w||u===y}function m(u){return u===w}function D(u){return u>=L&&u<=S||u>=A&&u<=E}function b(u,l,o,t){let r="",s=0,a=-1,h=0,f=0;for(let d=0;d<=u.length;++d){if(d<u.length)f=u.charCodeAt(d);else{if(t(f))break;f=w}if(t(f)){if(!(a===d-1||h===1))if(h===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const k=r.lastIndexOf(o);k===-1?(r="",s=0):(r=r.slice(0,k),s=r.length-1-r.lastIndexOf(o)),a=d,h=0;continue}else if(r.length!==0){r="",s=0,a=d,h=0;continue}}l&&(r+=r.length>0?`${o}..`:"..",s=2)}else r.length>0?r+=`${o}${u.slice(a+1,d)}`:r=u.slice(a+1,d),s=d-a-1;a=d,h=0}else f===n&&h!==-1?++h:h=-1}return r}function c(u,l){if(l===null||typeof l!="object")throw new P("pathObject","Object",l);const o=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return o?o===l.root?`${o}${t}`:`${o}${u}${t}`:t}e.win32={resolve(...u){let l="",o="",t=!1;for(let r=u.length-1;r>=-1;r--){let s;if(r>=0){if(s=u[r],p(s,"path"),s.length===0)continue}else l.length===0?s=v.cwd():(s=v.env[`=${l}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${l}\\`));const a=s.length;let h=0,f="",d=!1;const k=s.charCodeAt(0);if(a===1)g(k)&&(h=1,d=!0);else if(g(k))if(d=!0,g(s.charCodeAt(1))){let T=2,C=T;for(;T<a&&!g(s.charCodeAt(T));)T++;if(T<a&&T!==C){const V=s.slice(C,T);for(C=T;T<a&&g(s.charCodeAt(T));)T++;if(T<a&&T!==C){for(C=T;T<a&&!g(s.charCodeAt(T));)T++;(T===a||T!==C)&&(f=`\\\\${V}\\${s.slice(C,T)}`,h=T)}}}else h=1;else D(k)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),h=2,a>2&&g(s.charCodeAt(2))&&(d=!0,h=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(o=`${s.slice(h)}\\${o}`,t=d,d&&l.length>0)break}return o=b(o,!t,"\\",g),t?`${l}\\${o}`:`${l}${o}`||"."},normalize(u){p(u,"path");const l=u.length;if(l===0)return".";let o=0,t,r=!1;const s=u.charCodeAt(0);if(l===1)return m(s)?"\\":u;if(g(s))if(r=!0,g(u.charCodeAt(1))){let h=2,f=h;for(;h<l&&!g(u.charCodeAt(h));)h++;if(h<l&&h!==f){const d=u.slice(f,h);for(f=h;h<l&&g(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!g(u.charCodeAt(h));)h++;if(h===l)return`\\\\${d}\\${u.slice(f)}\\`;h!==f&&(t=`\\\\${d}\\${u.slice(f,h)}`,o=h)}}}else o=1;else D(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),o=2,l>2&&g(u.charCodeAt(2))&&(r=!0,o=3));let a=o<l?b(u.slice(o),!r,"\\",g):"";return a.length===0&&!r&&(a="."),a.length>0&&g(u.charCodeAt(l-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(u){p(u,"path");const l=u.length;if(l===0)return!1;const o=u.charCodeAt(0);return g(o)||l>2&&D(o)&&u.charCodeAt(1)===i&&g(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,o;for(let s=0;s<u.length;++s){const a=u[s];p(a,"path"),a.length>0&&(l===void 0?l=o=a:l+=`\\${a}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof o=="string"&&g(o.charCodeAt(0))){++r;const s=o.length;s>1&&g(o.charCodeAt(1))&&(++r,s>2&&(g(o.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&g(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(u,l){if(p(u,"from"),p(l,"to"),u===l)return"";const o=e.win32.resolve(u),t=e.win32.resolve(l);if(o===t||(u=o.toLowerCase(),l=t.toLowerCase(),u===l))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===y;)r++;let s=u.length;for(;s-1>r&&u.charCodeAt(s-1)===y;)s--;const a=s-r;let h=0;for(;h<l.length&&l.charCodeAt(h)===y;)h++;let f=l.length;for(;f-1>h&&l.charCodeAt(f-1)===y;)f--;const d=f-h,k=a<d?a:d;let T=-1,C=0;for(;C<k;C++){const X=u.charCodeAt(r+C);if(X!==l.charCodeAt(h+C))break;X===y&&(T=C)}if(C!==k){if(T===-1)return t}else{if(d>k){if(l.charCodeAt(h+C)===y)return t.slice(h+C+1);if(C===2)return t.slice(h+C)}a>k&&(u.charCodeAt(r+C)===y?T=C:C===2&&(T=3)),T===-1&&(T=0)}let V="";for(C=r+T+1;C<=s;++C)(C===s||u.charCodeAt(C)===y)&&(V+=V.length===0?"..":"\\..");return h+=T,V.length>0?`${V}${t.slice(h,f)}`:(t.charCodeAt(h)===y&&++h,t.slice(h,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===y){if(l.charCodeAt(1)===y){const o=l.charCodeAt(2);if(o!==I&&o!==n)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(D(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===y)return`\\\\?\\${l}`;return u},dirname(u){p(u,"path");const l=u.length;if(l===0)return".";let o=-1,t=0;const r=u.charCodeAt(0);if(l===1)return g(r)?u:".";if(g(r)){if(o=t=1,g(u.charCodeAt(1))){let h=2,f=h;for(;h<l&&!g(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&g(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!g(u.charCodeAt(h));)h++;if(h===l)return u;h!==f&&(o=t=h+1)}}}}else D(r)&&u.charCodeAt(1)===i&&(o=l>2&&g(u.charCodeAt(2))?3:2,t=o);let s=-1,a=!0;for(let h=l-1;h>=t;--h)if(g(u.charCodeAt(h))){if(!a){s=h;break}}else a=!1;if(s===-1){if(o===-1)return".";s=o}return u.slice(0,s)},basename(u,l){l!==void 0&&p(l,"ext"),p(u,"path");let o=0,t=-1,r=!0,s;if(u.length>=2&&D(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(o=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let a=l.length-1,h=-1;for(s=u.length-1;s>=o;--s){const f=u.charCodeAt(s);if(g(f)){if(!r){o=s+1;break}}else h===-1&&(r=!1,h=s+1),a>=0&&(f===l.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return o===t?t=h:t===-1&&(t=u.length),u.slice(o,t)}for(s=u.length-1;s>=o;--s)if(g(u.charCodeAt(s))){if(!r){o=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(o,t)},extname(u){p(u,"path");let l=0,o=-1,t=0,r=-1,s=!0,a=0;u.length>=2&&u.charCodeAt(1)===i&&D(u.charCodeAt(0))&&(l=t=2);for(let h=u.length-1;h>=l;--h){const f=u.charCodeAt(h);if(g(f)){if(!s){t=h+1;break}continue}r===-1&&(s=!1,r=h+1),f===n?o===-1?o=h:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||r===-1||a===0||a===1&&o===r-1&&o===t+1?"":u.slice(o,r)},format:c.bind(null,"\\"),parse(u){p(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const o=u.length;let t=0,r=u.charCodeAt(0);if(o===1)return g(r)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(g(r)){if(t=1,g(u.charCodeAt(1))){let T=2,C=T;for(;T<o&&!g(u.charCodeAt(T));)T++;if(T<o&&T!==C){for(C=T;T<o&&g(u.charCodeAt(T));)T++;if(T<o&&T!==C){for(C=T;T<o&&!g(u.charCodeAt(T));)T++;T===o?t=T:T!==C&&(t=T+1)}}}}else if(D(r)&&u.charCodeAt(1)===i){if(o<=2)return l.root=l.dir=u,l;if(t=2,g(u.charCodeAt(2))){if(o===3)return l.root=l.dir=u,l;t=3}}t>0&&(l.root=u.slice(0,t));let s=-1,a=t,h=-1,f=!0,d=u.length-1,k=0;for(;d>=t;--d){if(r=u.charCodeAt(d),g(r)){if(!f){a=d+1;break}continue}h===-1&&(f=!1,h=d+1),r===n?s===-1?s=d:k!==1&&(k=1):s!==-1&&(k=-1)}return h!==-1&&(s===-1||k===0||k===1&&s===h-1&&s===a+1?l.base=l.name=u.slice(a,h):(l.name=u.slice(a,s),l.base=u.slice(a,h),l.ext=u.slice(s,h))),a>0&&a!==t?l.dir=u.slice(0,a-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",o=!1;for(let t=u.length-1;t>=-1&&!o;t--){const r=t>=0?u[t]:v.cwd();p(r,"path"),r.length!==0&&(l=`${r}/${l}`,o=r.charCodeAt(0)===w)}return l=b(l,!o,"/",m),o?`/${l}`:l.length>0?l:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===w,o=u.charCodeAt(u.length-1)===w;return u=b(u,!l,"/",m),u.length===0?l?"/":o?"./":".":(o&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let l;for(let o=0;o<u.length;++o){const t=u[o];p(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(p(u,"from"),p(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const o=1,t=u.length,r=t-o,s=1,a=l.length-s,h=r<a?r:a;let f=-1,d=0;for(;d<h;d++){const T=u.charCodeAt(o+d);if(T!==l.charCodeAt(s+d))break;T===w&&(f=d)}if(d===h)if(a>h){if(l.charCodeAt(s+d)===w)return l.slice(s+d+1);if(d===0)return l.slice(s+d)}else r>h&&(u.charCodeAt(o+d)===w?f=d:d===0&&(f=0));let k="";for(d=o+f+1;d<=t;++d)(d===t||u.charCodeAt(d)===w)&&(k+=k.length===0?"..":"/..");return`${k}${l.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===w;let o=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===w){if(!t){o=r;break}}else t=!1;return o===-1?l?"/":".":l&&o===1?"//":u.slice(0,o)},basename(u,l){l!==void 0&&p(l,"ext"),p(u,"path");let o=0,t=-1,r=!0,s;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let a=l.length-1,h=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===w){if(!r){o=s+1;break}}else h===-1&&(r=!1,h=s+1),a>=0&&(f===l.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return o===t?t=h:t===-1&&(t=u.length),u.slice(o,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!r){o=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(o,t)},extname(u){p(u,"path");let l=-1,o=0,t=-1,r=!0,s=0;for(let a=u.length-1;a>=0;--a){const h=u.charCodeAt(a);if(h===w){if(!r){o=a+1;break}continue}t===-1&&(r=!1,t=a+1),h===n?l===-1?l=a:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||t===-1||s===0||s===1&&l===t-1&&l===o+1?"":u.slice(l,t)},format:c.bind(null,"/"),parse(u){p(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const o=u.charCodeAt(0)===w;let t;o?(l.root="/",t=1):t=0;let r=-1,s=0,a=-1,h=!0,f=u.length-1,d=0;for(;f>=t;--f){const k=u.charCodeAt(f);if(k===w){if(!h){s=f+1;break}continue}a===-1&&(h=!1,a=f+1),k===n?r===-1?r=f:d!==1&&(d=1):r!==-1&&(d=-1)}if(a!==-1){const k=s===0&&o?1:s;r===-1||d===0||d===1&&r===a-1&&r===s+1?l.base=l.name=u.slice(k,a):(l.name=u.slice(k,r),l.base=u.slice(k,a),l.ext=u.slice(r,a))}return s>0?l.dir=u.slice(0,s-1):o&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(S,...E){const n=E.reduce((i,I)=>(i[I]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!n[i]).forEach(i=>{for(let I=0;I<w.length;I++)if(i.search(w[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=A}),define(J[79],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const L=[],A=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>A[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(w,y,i,I,P){this.ctrlKey=w,this.shiftKey=y,this.altKey=i,this.metaKey=I,this.scanCode=P}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(w,y){L[w]=y,A[y]=w,S[y.toLowerCase()]=w}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function n(w,y){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[y]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,79]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class A{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,w=!1,y=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(E)&&(w=!0,E=E.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(E)&&(y=!0,E=E.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),I=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),I=!0);while(I);let P;const p=E.indexOf(" ");return p>0?(P=E.substring(0,p),E=E.substring(p)):(P=E,E=""),{remains:E,ctrl:n,shift:w,alt:y,meta:i,key:P}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),w=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseKeybinding(E,n){if(!E)return null;const w=[];let y;do[y,E]=this.parseSimpleKeybinding(E),w.push(y);while(E.length>0);return new v.ChordKeybinding(w)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),w=n.key.match(/^\[([^\]]+)\]$/);if(w){const i=w[1],I=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const y=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let w;for(;E.length>0;)[w,E]=this.parseSimpleUserBinding(E),n.push(w);return n}}e.KeybindingParser=A}),define(J[107],Z([0,1,3]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class A{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new A(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=A}),define(J[5],Z([0,1,19,42,2,78,107]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(b){b.None=()=>A.Disposable.None;function c(Q){return(U,$=null,G)=>{let N=!1,F;return F=Q(R=>{if(!N)return F?F.dispose():N=!0,U.call($,R)},null,G),N&&F.dispose(),F}}b.once=c;function u(Q,U){return a(($,G=null,N)=>Q(F=>$.call(G,U(F)),null,N))}b.map=u;function l(Q,U){return a(($,G=null,N)=>Q(F=>{U(F),$.call(G,F)},null,N))}b.forEach=l;function o(Q,U){return a(($,G=null,N)=>Q(F=>U(F)&&$.call(G,F),null,N))}b.filter=o;function t(Q){return Q}b.signal=t;function r(...Q){return(U,$=null,G)=>A.combinedDisposable(...Q.map(N=>N(F=>U.call($,F),null,G)))}b.any=r;function s(Q,U,$){let G=$;return u(Q,N=>(G=U(G,N),G))}b.reduce=s;function a(Q){let U;const $=new P({onFirstListenerAdd(){U=Q($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}b.snapshot=a;function h(Q,U,$=100,G=!1,N){let F,R,O,M=0;const W=new P({leakWarningThreshold:N,onFirstListenerAdd(){F=Q(_=>{M++,R=U(R,_),G&&!O&&(W.fire(R),R=void 0),clearTimeout(O),O=setTimeout(()=>{const q=R;R=void 0,O=void 0,(!G||M>1)&&W.fire(q),M=0},$)})},onLastListenerRemove(){F.dispose()}});return W.event}b.debounce=h;function f(Q){const U=new Date().getTime();return u(c(Q),$=>new Date().getTime()-U)}b.stopwatch=f;function d(Q,U=($,G)=>$===G){let $=!0,G;return o(Q,N=>{const F=$||!U(N,G);return $=!1,G=N,F})}b.latch=d;function k(Q,U){return[b.filter(Q,U),b.filter(Q,$=>!U($))]}b.split=k;function T(Q,U=!1,$=[]){let G=$.slice(),N=Q(O=>{G?G.push(O):R.fire(O)});const F=()=>{G&&G.forEach(O=>R.fire(O)),G=null},R=new P({onFirstListenerAdd(){N||(N=Q(O=>R.fire(O)))},onFirstListenerDidAdd(){G&&(U?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return R.event}b.buffer=T;class C{constructor(U){this.event=U}map(U){return new C(u(this.event,U))}forEach(U){return new C(l(this.event,U))}filter(U){return new C(o(this.event,U))}reduce(U,$){return new C(s(this.event,U,$))}latch(){return new C(d(this.event))}debounce(U,$=100,G=!1,N){return new C(h(this.event,U,$,G,N))}on(U,$,G){return this.event(U,$,G)}once(U,$,G){return c(this.event)(U,$,G)}}function V(Q){return new C(Q)}b.chain=V;function X(Q,U,$=G=>G){const G=(...O)=>R.fire($(...O)),N=()=>Q.on(U,G),F=()=>Q.removeListener(U,G),R=new P({onFirstListenerAdd:N,onLastListenerRemove:F});return R.event}b.fromNodeEventEmitter=X;function ee(Q,U,$=G=>G){const G=(...O)=>R.fire($(...O)),N=()=>Q.addEventListener(U,G),F=()=>Q.removeEventListener(U,G),R=new P({onFirstListenerAdd:N,onLastListenerRemove:F});return R.event}b.fromDOMEventEmitter=ee;function B(Q){const U=new P;let $=!1;return Q.then(void 0,()=>null).then(()=>{$?U.fire(void 0):setTimeout(()=>U.fire(void 0),0)}),$=!0,U.event}b.fromPromise=B;function Y(Q){return new Promise(U=>c(Q)(U))}b.toPromise=Y})(n=e.Event||(e.Event={}));class w{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${w._idPool++}`}start(c){this._stopWatch=new E.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let y=-1;function i(b){const c=y;return y=b,{dispose(){y=c}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(c,u=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let u=y;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||c<u)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(l)||0;if(this._stacks.set(l,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,r=0;for(const[s,a]of this._stacks)(!t||r<a)&&(t=s,r=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}class P{constructor(c){var u;this._disposed=!1,this._options=c,this._leakageMon=y>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(c,u,l)=>{var o;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[c,u]:c);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,u);const s=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let a;return a={dispose:()=>{s&&s(),a.dispose=P._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof A.DisposableStore?l.add(a):Array.isArray(l)&&l.push(a),a}),this._event}fire(c){var u,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,c]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(r){v.onUnexpectedError(r)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var c,u,l,o,t;this._disposed||(this._disposed=!0,(c=this._listeners)===null||c===void 0||c.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(o=(l=this._options)===null||l===void 0?void 0:l.onLastListenerRemove)===null||o===void 0||o.call(l),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=P,P._noop=function(){};class p extends P{constructor(c){super(c);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=c==null?void 0:c.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=p;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const u={event:c,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const l=()=>{this.hasListeners&&this.unhook(u);const o=this.events.indexOf(u);this.events.splice(o,1)};return A.toDisposable(L.once(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(u=>this.emitter.fire(u))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class m{constructor(){this.buffers=[]}wrapEvent(c){return(u,l,o)=>c(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>u.call(l,t)):u.call(l,t)},void 0,o)}bufferEvents(c){const u=[];this.buffers.push(u);const l=c();return this.buffers.pop(),u.forEach(o=>o()),l}}e.EventBufferer=m;class D{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=A.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(J[25],Z([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,w){const y=setTimeout(n.bind(w),0);return{dispose(){clearTimeout(y)}}});var A;(function(n){function w(y){return y===n.None||y===n.Cancelled||y instanceof S?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}n.isCancellationToken=w,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=A.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=E}),define(J[108],Z([0,1,5]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const P=this._icons.get(I.id);P?I.description?P.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new L;e.iconRegistry=A;function S(i,I){return new n(i,I)}e.registerCodicon=S;function E(i){return i?i.replace(/\$\((.*?)\)/g,(I,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(I,P,p){this.id=I,this.definition=P,this.description=p,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function w(i,I){const P=["codicon","codicon-"+i];return I&&P.push("codicon-modifier-"+I),P}e.getClassNamesArray=w;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function P(m){if(m instanceof n)return["codicon","codicon-"+m.id];const D=I.exec(m.id);if(!D)return P(n.error);let[,b,c]=D;const u=["codicon","codicon-"+b];return c&&u.push("codicon-modifier-"+c.substr(1)),u}i.asClassNameArray=P;function p(m){return P(m).join(" ")}i.asClassName=p;function g(m){return"."+P(m).join(".")}i.asCSSSelector=g})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,19,2]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=A;function S(u){const l=u;return l?A(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=S;function E(u,l){return new n(u,l)}e.newWriteableStream=E;class n{constructor(l,o){this.reducer=l,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var o;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((o=this.options)===null||o===void 0?void 0:o.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(o=>o(l))}emitError(l){this.listeners.error.length===0?v.onUnexpectedError(l):this.listeners.error.slice(0).forEach(o=>o(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,o){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(l,o){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(o);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,l){const o=[];let t;for(;(t=u.read())!==null;)o.push(t);return l(o)}e.consumeReadable=w;function y(u,l,o){const t=[];let r;for(;(r=u.read())!==null&&t.length<o;)t.push(r);return r===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return u.read()}}}e.peekReadable=y;function i(u,l){return new Promise((o,t)=>{const r=[];I(u,{onData:s=>{l&&r.push(s)},onError:s=>{l?t(s):o(void 0)},onEnd:()=>{o(l?l(r):void 0)}})})}e.consumeStream=i;function I(u,l){u.on("error",o=>l.onError(o)),u.on("end",()=>l.onEnd()),u.on("data",o=>l.onData(o))}e.listenStream=I;function P(u,l){return new Promise((o,t)=>{const r=new L.DisposableStore,s=[],a=d=>{if(s.push(d),s.length>l)return r.dispose(),u.pause(),o({stream:u,buffer:s,ended:!1})},h=d=>t(d),f=()=>o({stream:u,buffer:s,ended:!0});r.add(L.toDisposable(()=>u.removeListener("error",h))),u.on("error",h),r.add(L.toDisposable(()=>u.removeListener("end",f))),u.on("end",f),r.add(L.toDisposable(()=>u.removeListener("data",a))),u.on("data",a)})}e.peekStream=P;function p(u,l){const o=E(l);return o.end(u),o}e.toStream=p;function g(){const u=E(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=g;function m(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.toReadable=m;function D(u,l,o){const t=E(o);return I(u,{onData:r=>t.write(l.data(r)),onError:r=>t.error(l.error?l.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(u,l,o){let t=!1;return{read:()=>{const r=l.read();return t?r:(t=!0,r!==null?o([u,r]):u)}}}e.prefixedReadable=b;function c(u,l,o){let t=!1;const r=E(o);return I(l,{onData:s=>t?r.write(s):(t=!0,r.write(o([u,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=c}),define(J[23],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function A(j,...ie){return ie.length===0?j:j.replace(L,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ie.length?ae:ie[fe]})}e.format=A;function S(j){return j.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=S;function E(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function n(j,ie){let ae=0;const ce=ie.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===ce&&ae++;return ae}e.count=n;function w(j,ie,ae="\u2026"){return j.length<=ie?j:`${j.substr(0,ie)}${ae}`}e.truncate=w;function y(j,ie=" "){const ae=i(j,ie);return I(ae,ie)}e.trim=y;function i(j,ie){if(!j||!ie)return j;const ae=ie.length;if(ae===0||j.length===0)return j;let ce=0;for(;j.indexOf(ie,ce)===ce;)ce=ce+ae;return j.substring(ce)}e.ltrim=i;function I(j,ie){if(!j||!ie)return j;const ae=ie.length,ce=j.length;if(ae===0||ce===0)return j;let fe=ce,be=-1;for(;be=j.lastIndexOf(ie,fe-1),!(be===-1||be+ae!==fe);){if(be===0)return"";fe=be}return j.substring(0,fe)}e.rtrim=I;function P(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=P;function p(j){return j.replace(/\*/g,"")}e.stripWildcards=p;function g(j,ie,ae={}){if(!j)throw new Error("Cannot create regex from empty string");ie||(j=E(j)),ae.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(j,ce)}e.createRegExp=g;function m(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function D(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function b(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=b;function c(j){return j.split(/\r\n|\r|\n/)}e.splitLines=c;function u(j){for(let ie=0,ae=j.length;ie<ae;ie++){const ce=j.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function l(j,ie=0,ae=j.length){for(let ce=ie;ce<ae;ce++){const fe=j.charCodeAt(ce);if(fe!==32&&fe!==9)return j.substring(ie,ce)}return j.substring(ie,ae)}e.getLeadingWhitespace=l;function o(j,ie=j.length-1){for(let ae=ie;ae>=0;ae--){const ce=j.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=o;function t(j,ie){return j<ie?-1:j>ie?1:0}e.compare=t;function r(j,ie,ae=0,ce=j.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue<ze)return-1;if(Ue>ze)return 1}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstring=r;function s(j,ie){return a(j,ie,0,j.length,0,ie.length)}e.compareIgnoreCase=s;function a(j,ie,ae=0,ce=j.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue===ze)continue;const de=Ue-ze;if(!(de===32&&f(ze))&&!(de===-32&&f(Ue)))return h(Ue)&&h(ze)?de:r(j.toLowerCase(),ie.toLowerCase(),ae,ce,fe,be)}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstringIgnoreCase=a;function h(j){return j>=97&&j<=122}e.isLowerAsciiLetter=h;function f(j){return j>=65&&j<=90}e.isUpperAsciiLetter=f;function d(j){return h(j)||f(j)}function k(j,ie){return j.length===ie.length&&T(j,ie)}e.equalsIgnoreCase=k;function T(j,ie,ae=j.length){for(let ce=0;ce<ae;ce++){const fe=j.charCodeAt(ce),be=ie.charCodeAt(ce);if(fe!==be){if(d(fe)&&d(be)){const Me=Math.abs(fe-be);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function C(j,ie){const ae=ie.length;return ie.length>j.length?!1:T(j,ie,ae)}e.startsWithIgnoreCase=C;function V(j,ie){let ae,ce=Math.min(j.length,ie.length);for(ae=0;ae<ce;ae++)if(j.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=V;function X(j,ie){let ae,ce=Math.min(j.length,ie.length);const fe=j.length-1,be=ie.length-1;for(ae=0;ae<ce;ae++)if(j.charCodeAt(fe-ae)!==ie.charCodeAt(be-ae))return ae;return ce}e.commonSuffixLength=X;function ee(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ee;function B(j){return 56320<=j&&j<=57343}e.isLowSurrogate=B;function Y(j,ie){return(j-55296<<10)+(ie-56320)+65536}e.computeCodePoint=Y;function Q(j,ie,ae){const ce=j.charCodeAt(ae);if(ee(ce)&&ae+1<ie){const fe=j.charCodeAt(ae+1);if(B(fe))return Y(ce,fe)}return ce}e.getNextCodePoint=Q;function U(j,ie){const ae=j.charCodeAt(ie-1);if(B(ae)&&ie>1){const ce=j.charCodeAt(ie-2);if(ee(ce))return Y(ce,ae)}return ae}function $(j,ie){const ae=Be.getInstance(),ce=ie,fe=j.length,be=Q(j,fe,ie);ie+=be>=65536?2:1;let Me=ae.getGraphemeBreakType(be);for(;ie<fe;){const Fe=Q(j,fe,ie),Ue=ae.getGraphemeBreakType(Fe);if(He(Me,Ue))break;ie+=Fe>=65536?2:1,Me=Ue}return ie-ce}e.nextCharLength=$;function G(j,ie){const ae=Be.getInstance(),ce=ie,fe=U(j,ie);ie-=fe>=65536?2:1;let be=ae.getGraphemeBreakType(fe);for(;ie>0;){const Me=U(j,ie),Fe=ae.getGraphemeBreakType(Me);if(He(Fe,be))break;ie-=Me>=65536?2:1,be=Fe}return ce-ie}e.prevCharLength=G;function N(j,ie){const ae=Be.getInstance(),ce=j.length,fe=ie,be=Q(j,ce,ie),Me=ae.getGraphemeBreakType(be);ie+=be>=65536?2:1;let Fe=Me;for(;ie<ce;){const ze=Q(j,ce,ie),de=ae.getGraphemeBreakType(ze);if(He(Fe,de))break;ie+=ze>=65536?2:1,Fe=de}const Ue=ie;for(ie=fe,Fe=Me;ie>0;){const ze=U(j,ie),de=ae.getGraphemeBreakType(ze);if(He(de,Fe))break;ie-=ze>=65536?2:1,Fe=de}return[ie,Ue]}function F(j,ie){return ie>0&&B(j.charCodeAt(ie))?N(j,ie-1):N(j,ie)}e.getCharContainingOffset=F;function R(j){const ie=j.length;let ae=0,ce=0;for(;ce<ie;){const Me=Q(j,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const fe=new Uint8Array(ae);ce=0;let be=0;for(;ce<ie;){const Me=Q(j,ie,ce);ce+=Me>=65536?2:1,Me<128?fe[be++]=Me:Me<2048?(fe[be++]=192|(Me&1984)>>>6,fe[be++]=128|(Me&63)>>>0):Me<65536?(fe[be++]=224|(Me&61440)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0):(fe[be++]=240|(Me&1835008)>>>18,fe[be++]=128|(Me&258048)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0)}return fe}e.encodeUTF8=R;function O(j){const ie=j.byteLength,ae=[];let ce=0;for(;ce<ie;){const fe=j[ce];let be;if(fe>=240&&ce+3<ie?be=(j[ce++]&7)<<18>>>0|(j[ce++]&63)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=224&&ce+2<ie?be=(j[ce++]&15)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=192&&ce+1<ie?be=(j[ce++]&31)<<6>>>0|(j[ce++]&63)<<0>>>0:be=j[ce++],be>=0&&be<=55295||be>=57344&&be<=65535)ae.push(String.fromCharCode(be));else if(be>=65536&&be<=1114111){const Me=be-65536,Fe=55296+((Me&1047552)>>>10),Ue=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Fe)),ae.push(String.fromCharCode(Ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=O;const M=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(j){return M.test(j)}e.containsRTL=W;const _=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function q(j){return _.test(j)}e.containsEmoji=q;const K=/^[\t\n\r\x20-\x7E]*$/;function H(j){return K.test(j)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=x;function ne(j){for(let ie=0,ae=j.length;ie<ae;ie++)if(re(j.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function re(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=re;function se(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=se;function le(j,ie){if(j.length<ie)return j;const ae=/\b/g;let ce=0;for(;ae.test(j)&&!(j.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return j.substring(ce).replace(/^\s/,"")}e.lcut=le;const oe=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Se(j){return j&&(j=j.replace(oe,""),j=j.replace(ue,""),j=j.replace(me,"")),j}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Ie(j){return De(j)?j.substr(1):j}e.stripUTF8BOM=Ie;function we(j,ie){if(!j||!ie||j.length<ie.length)return!1;const ae=ie.length,ce=j.toLowerCase();let fe=0,be=-1;for(;fe<ae;){const Me=ce.indexOf(ie[fe],be+1);if(Me<0)return!1;be=Me,fe++}return!0}e.fuzzyContains=we;function ye(j,ie=!1){return j?(ie&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=ye;function Ae(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Ae;function Te(j,ie=1){if(ie===0)return"";let ae=-1;do ae=j.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?j:(j[ae-1]==="\r"&&ae--,j.substr(0,ae))}e.getNLines=Te;function $e(j){const ie=90-65+1;return j=j%(2*ie),j<ie?String.fromCharCode(97+j):String.fromCharCode(65+j-ie)}e.singleLetterHash=$e;function Ne(j){return Be.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Ne;function He(j,ie){return j===0?ie!==5&&ie!==7:j===2&&ie===3?!1:j===4||j===2||j===3||ie===4||ie===2||ie===3?!0:!(j===8&&(ie===8||ie===9||ie===11||ie===12)||(j===11||j===9)&&(ie===9||ie===10)||(j===12||j===10)&&ie===10||ie===5||ie===13||ie===7||j===1||j===13&&ie===14||j===6&&ie===6)}e.breakBetweenGraphemeBreakType=He;var et;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ie<ae[3*fe])fe=2*fe;else if(ie>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(j,ie){if(j===0)return 0;const ae=ut(j,ie);if(ae!==void 0)return ae;const ce=U(ie,j);return j-=Xe(ce),j}e.getLeftDeleteOffset=tt;function ut(j,ie){let ae=U(ie,j);for(j-=Xe(ae);ht(ae)||ae===65039||ae===8419;){if(j===0)return;ae=U(ie,j),j-=Xe(ae)}if(!!se(ae)){if(j>=0){const ce=U(ie,j);ce===8205&&(j-=Xe(ce))}return j}}function Xe(j){return j>=65536?2:1}function ht(j){return 127995<=j&&j<=127999}var ot;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={}))}),define(J[20],Z([0,1,23,64]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let n,w;class y{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return A?new y(Buffer.allocUnsafe(d)):new y(new Uint8Array(d))}static wrap(d){return A&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new y(d)}static fromString(d,k){return!((k==null?void 0:k.dontUseNodeBuffer)||!1)&&A?new y(Buffer.from(d)):S?(n||(n=new TextEncoder),new y(n.encode(d))):new y(v.encodeUTF8(d))}static concat(d,k){if(typeof k=="undefined"){k=0;for(let V=0,X=d.length;V<X;V++)k+=d[V].byteLength}const T=y.alloc(k);let C=0;for(let V=0,X=d.length;V<X;V++){const ee=d[V];T.set(ee,C),C+=ee.byteLength}return T}toString(){return A?this.buffer.toString():E?(w||(w=new TextDecoder),w.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(d,k){return new y(this.buffer.subarray(d,k))}set(d,k){d instanceof y?this.buffer.set(d.buffer,k):this.buffer.set(d,k)}readUInt32BE(d){return P(this.buffer,d)}writeUInt32BE(d,k){p(this.buffer,d,k)}readUInt32LE(d){return g(this.buffer,d)}writeUInt32LE(d,k){m(this.buffer,d,k)}readUInt8(d){return D(this.buffer,d)}writeUInt8(d,k){b(this.buffer,d,k)}}e.VSBuffer=y;function i(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0}e.readUInt16LE=i;function I(f,d,k){f[k+0]=d&255,d=d>>>8,f[k+1]=d&255}e.writeUInt16LE=I;function P(f,d){return f[d]*2**24+f[d+1]*2**16+f[d+2]*2**8+f[d+3]}e.readUInt32BE=P;function p(f,d,k){f[k+3]=d,d=d>>>8,f[k+2]=d,d=d>>>8,f[k+1]=d,d=d>>>8,f[k]=d}e.writeUInt32BE=p;function g(f,d){return f[d+0]<<0>>>0|f[d+1]<<8>>>0|f[d+2]<<16>>>0|f[d+3]<<24>>>0}e.readUInt32LE=g;function m(f,d,k){f[k+0]=d&255,d=d>>>8,f[k+1]=d&255,d=d>>>8,f[k+2]=d&255,d=d>>>8,f[k+3]=d&255}e.writeUInt32LE=m;function D(f,d){return f[d]}e.readUInt8=D;function b(f,d,k){f[k]=d}e.writeUInt8=b;function c(f){return L.consumeReadable(f,d=>y.concat(d))}e.readableToBuffer=c;function u(f){return L.toReadable(f)}e.bufferToReadable=u;function l(f){return L.consumeStream(f,d=>y.concat(d))}e.streamToBuffer=l;async function o(f){return f.ended?y.concat(f.buffer):y.concat([...f.buffer,await l(f.stream)])}e.bufferedStreamToBuffer=o;function t(f){return L.toStream(f,d=>y.concat(d))}e.bufferToStream=t;function r(f){return L.transform(f,{data:d=>typeof d=="string"?y.fromString(d):y.wrap(d)},d=>y.concat(d))}e.streamToBufferReadableStream=r;function s(f){return L.newWriteableStream(d=>y.concat(d),f)}e.newWriteableBufferStream=s;function a(f,d){return L.prefixedReadable(f,d,k=>y.concat(k))}e.prefixedBufferReadable=a;function h(f,d){return L.prefixedStream(f,d,k=>y.concat(k))}e.prefixedBufferStream=h}),define(J[80],Z([0,1,23]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(b){return A(b,0)}e.hash=L;function A(b,c){switch(typeof b){case"object":return b===null?S(349,c):Array.isArray(b)?w(b,c):y(b,c);case"string":return n(b,c);case"boolean":return E(b,c);case"number":return S(b,c);case"undefined":return S(937,c);default:return S(617,c)}}e.doHash=A;function S(b,c){return(c<<5)-c+b|0}function E(b,c){return S(b?433:863,c)}function n(b,c){c=S(149417,c);for(let u=0,l=b.length;u<l;u++)c=S(b.charCodeAt(u),c);return c}e.stringHash=n;function w(b,c){return c=S(104579,c),b.reduce((u,l)=>A(l,u),c)}function y(b,c){return c=S(181387,c),Object.keys(b).sort().reduce((u,l)=>(u=n(l,u),A(b[l],u)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=A(c,this._value),this._value}}e.Hasher=i;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function P(b,c,u=32){const l=u-c,o=~((1<<l)-1);return(b<<c|(o&b)>>>l)>>>0}function p(b,c=0,u=b.byteLength,l=0){for(let o=0;o<u;o++)b[c+o]=l}function g(b,c,u="0"){for(;b.length<c;)b=u+b;return b}function m(b,c=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((b>>>0).toString(16),c/4)}e.toHexString=m;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const u=c.length;if(u===0)return;const l=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=c.charCodeAt(0),s=0);;){let a=r;if(v.isHighSurrogate(r))if(s+1<u){const h=c.charCodeAt(s+1);v.isLowSurrogate(h)?(s++,a=v.computeCodePoint(r,h)):a=65533}else{t=r;break}else v.isLowSurrogate(r)&&(a=65533);if(o=this._push(l,o,a),s++,s<u)r=c.charCodeAt(s);else break}this._buffLen=o,this._leftoverHighSurrogate=t}_push(c,u,l){return l<128?c[u++]=l:l<2048?(c[u++]=192|(l&1984)>>>6,c[u++]=128|(l&63)>>>0):l<65536?(c[u++]=224|(l&61440)>>>12,c[u++]=128|(l&4032)>>>6,c[u++]=128|(l&63)>>>0):(c[u++]=240|(l&1835008)>>>18,c[u++]=128|(l&258048)>>>12,c[u++]=128|(l&4032)>>>6,c[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=D._bigBlock32,u=this._buffDV;for(let d=0;d<64;d+=4)c.setUint32(d,u.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)c.setUint32(d,P(c.getUint32(d-12,!1)^c.getUint32(d-32,!1)^c.getUint32(d-56,!1)^c.getUint32(d-64,!1),1),!1);let l=this._h0,o=this._h1,t=this._h2,r=this._h3,s=this._h4,a,h,f;for(let d=0;d<80;d++)d<20?(a=o&t|~o&r,h=1518500249):d<40?(a=o^t^r,h=1859775393):d<60?(a=o&t|o&r|t&r,h=2400959708):(a=o^t^r,h=3395469782),f=P(l,5)+a+s+h+c.getUint32(d*4,!1)&4294967295,s=r,r=t,t=P(o,30),o=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(d){return Array.isArray(d)}e.isArray=v;function L(d){return typeof d=="string"}e.isString=L;function A(d){return Array.isArray(d)&&d.every(k=>L(k))}e.isStringArray=A;function S(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=S;function E(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=E;function n(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=n;function w(d){return d===!0||d===!1}e.isBoolean=w;function y(d){return typeof d=="undefined"}e.isUndefined=y;function i(d){return!I(d)}e.isDefined=i;function I(d){return y(d)||d===null}e.isUndefinedOrNull=I;function P(d,k){if(!d)throw new Error(k?`Unexpected type, expected '${k}'`:"Unexpected type")}e.assertType=P;function p(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=p;function g(...d){const k=[];for(let T=0;T<d.length;T++){const C=d[T];if(I(C))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);k.push(C)}return k}e.assertAllDefined=g;const m=Object.prototype.hasOwnProperty;function D(d){if(!S(d))return!1;for(let k in d)if(m.call(d,k))return!1;return!0}e.isEmptyObject=D;function b(d){return typeof d=="function"}e.isFunction=b;function c(...d){return d.length>0&&d.every(b)}e.areFunctions=c;function u(d,k){const T=Math.min(d.length,k.length);for(let C=0;C<T;C++)l(d[C],k[C])}e.validateConstraints=u;function l(d,k){if(L(k)){if(typeof d!==k)throw new Error(`argument does not match constraint: typeof ${k}`)}else if(b(k)){try{if(d instanceof k)return}catch(T){}if(!I(d)&&d.constructor===k||k.length===1&&k.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function o(d){let k=[],T=Object.getPrototypeOf(d);for(;Object.prototype!==T;)k=k.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return k}e.getAllPropertyNames=o;function t(d){const k=[];for(const T of o(d))typeof d[T]=="function"&&k.push(T);return k}e.getAllMethodNames=t;function r(d,k){const T=V=>function(){const X=Array.prototype.slice.call(arguments,0);return k(V,X)};let C={};for(const V of d)C[V]=T(V);return C}e.createProxyObject=r;function s(d){return d===null?void 0:d}e.withNullAsUndefined=s;function a(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=a;function h(d){return class{constructor(){return new Proxy({},{get(k,T){if(k[T])return k[T];throw new Error(`Not Implemented: ${d}->${String(T)}`)}})}}}e.NotImplementedProxy=h;function f(d){throw new Error("Unreachable")}e.assertNever=f}),define(J[29],Z([0,1,3,23,8,13]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(s){return s===47||s===92}e.isPathSeparator=E;function n(s){return s.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=n;function w(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function y(s,a=A.posix.sep){if(!s)return"";const h=s.length,f=s.charCodeAt(0);if(E(f)){if(E(s.charCodeAt(1))&&!E(s.charCodeAt(2))){let k=3;const T=k;for(;k<h&&!E(s.charCodeAt(k));k++);if(T!==k&&!E(s.charCodeAt(k+1))){for(k+=1;k<h;k++)if(E(s.charCodeAt(k)))return s.slice(0,k+1).replace(/[\\/]/g,a)}}return a}else if(b(f)&&s.charCodeAt(1)===58)return E(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let d=s.indexOf("://");if(d!==-1){for(d+=3;d<h;d++)if(E(s.charCodeAt(d)))return s.slice(0,d+1)}return""}e.getRoot=y;function i(s){if(!v.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let h=2;const f=h;for(;h<s.length&&(a=s.charCodeAt(h),a!==92);h++);return!(f===h||(a=s.charCodeAt(h+1),isNaN(a)||a===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(s,a=v.isWindows){const h=a?I:P;return!(!s||s.length===0||/^\s+$/.test(s)||(h.lastIndex=0,h.test(s))||a&&p.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=g;function m(s,a,h){const f=s===a;return!h||f?f:!s||!a?!1:L.equalsIgnoreCase(s,a)}e.isEqual=m;function D(s,a,h,f=A.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(h){if(!L.startsWithIgnoreCase(s,a))return!1;if(a.length===s.length)return!0;let k=a.length;return a.charAt(a.length-1)===f&&k--,s.charAt(k)===f}return a.charAt(a.length-1)!==f&&(a+=f),s.indexOf(a)===0}e.isEqualOrParent=D;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function c(s,a){return v.isWindows&&s.endsWith(":")&&(s+=A.sep),A.isAbsolute(s)||(s=A.join(a,s)),s=A.normalize(s),v.isWindows?(s=L.rtrim(s,A.sep),s.endsWith(":")&&(s+=A.sep)):(s=L.rtrim(s,A.sep),s||(s=A.sep)),s}e.sanitizeFilePath=c;function u(s){const a=A.normalize(s);return v.isWindows?s.length>3?!1:l(a)&&(s.length===2||a.charCodeAt(2)===92):a===A.posix.sep}e.isRootOrDriveLetter=u;function l(s){return v.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function o(s){return l(s)?s[0]:void 0}e.getDriveLetter=o;function t(s,a,h){return a.length>s.length?-1:s===a?0:(h&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=t;function r(s){const a=s.split(":");let h,f,d;if(a.forEach(k=>{const T=Number(k);S.isNumber(T)?f===void 0?f=T:d===void 0&&(d=T):h=h?[h,k].join(":"):k}),!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:f!==void 0?f:void 0,column:d!==void 0?d:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(J[44],Z([0,1,13]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const D=Array.isArray(m)?[]:{};return Object.keys(m).forEach(b=>{m[b]&&typeof m[b]=="object"?D[b]=L(m[b]):D[b]=m[b]}),D}e.deepClone=L;function A(m){if(!m||typeof m!="object")return m;const D=[m];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const c in b)if(S.call(b,c)){const u=b[c];typeof u=="object"&&!Object.isFrozen(u)&&D.push(u)}}return m}e.deepFreeze=A;const S=Object.prototype.hasOwnProperty;function E(m,D){return n(m,D,new Set)}e.cloneAndChange=E;function n(m,D,b){if(v.isUndefinedOrNull(m))return m;const c=D(m);if(typeof c!="undefined")return c;if(v.isArray(m)){const u=[];for(const l of m)u.push(n(l,D,b));return u}if(v.isObject(m)){if(b.has(m))throw new Error("Cannot clone recursive data-structure");b.add(m);const u={};for(let l in m)S.call(m,l)&&(u[l]=n(m[l],D,b));return b.delete(m),u}return m}function w(m,D,b=!0){return v.isObject(m)?(v.isObject(D)&&Object.keys(D).forEach(c=>{c in m?b&&(v.isObject(m[c])&&v.isObject(D[c])?w(m[c],D[c],b):m[c]=D[c]):m[c]=D[c]}),m):D}e.mixin=w;function y(m,D){if(m===D)return!0;if(m==null||D===null||D===void 0||typeof m!=typeof D||typeof m!="object"||Array.isArray(m)!==Array.isArray(D))return!1;let b,c;if(Array.isArray(m)){if(m.length!==D.length)return!1;for(b=0;b<m.length;b++)if(!y(m[b],D[b]))return!1}else{const u=[];for(c in m)u.push(c);u.sort();const l=[];for(c in D)l.push(c);if(l.sort(),!y(u,l))return!1;for(b=0;b<u.length;b++)if(!y(m[u[b]],D[u[b]]))return!1}return!0}e.equals=y;function i(m){const D=new Set;return JSON.stringify(m,(b,c)=>{if(v.isObject(c)||Array.isArray(c)){if(D.has(c))return"[Circular]";D.add(c)}return c})}e.safeStringify=i;function I(m,D,b){const c=D(m);return typeof c=="undefined"?b:c}e.getOrDefault=I;function P(m,D){const b=Object.create(null);return!m||!D||Object.keys(D).forEach(u=>{const l=m[u],o=D[u];y(l,o)||(b[u]=o)}),b}e.distinct=P;function p(m,D){const b=D.toLowerCase(),c=Object.keys(m).find(u=>u.toLowerCase()===b);return c?m[c]:m[D]}e.getCaseInsensitive=p;function g(m,D){const b=Object.create(null);for(const c of Object.keys(m))D(c,m[c])&&(b[c]=m[c]);return b}e.filter=g}),define(J[7],Z([0,1,3,8]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,S=/^\//,E=/^\/\//;function n(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,a){return!s&&!a?"file":s}function y(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const i="",I="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(a,h,f,d,k,T=!1){typeof a=="object"?(this.scheme=a.scheme||i,this.authority=a.authority||i,this.path=a.path||i,this.query=a.query||i,this.fragment=a.fragment||i):(this.scheme=w(a,T),this.authority=h||i,this.path=y(this.scheme,f||i),this.query=d||i,this.fragment=k||i,n(this,T))}static isUri(a){return a instanceof p?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:f,path:d,query:k,fragment:T}=a;return h===void 0?h=this.scheme:h===null&&(h=i),f===void 0?f=this.authority:f===null&&(f=i),d===void 0?d=this.path:d===null&&(d=i),k===void 0?k=this.query:k===null&&(k=i),T===void 0?T=this.fragment:T===null&&(T=i),h===this.scheme&&f===this.authority&&d===this.path&&k===this.query&&T===this.fragment?this:new m(h,f,d,k,T)}static parse(a,h=!1){const f=P.exec(a);return f?new m(f[2]||i,r(f[4]||i),r(f[5]||i),r(f[7]||i),r(f[9]||i),h):new m(i,i,i,i,i)}static file(a){let h=i;if(v.isWindows&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const f=a.indexOf(I,2);f===-1?(h=a.substring(2),a=I):(h=a.substring(2,f),a=a.substring(f)||I)}return new m("file",h,a,i,i)}static from(a){const h=new m(a.scheme,a.authority,a.path,a.query,a.fragment);return n(h,!0),h}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return v.isWindows&&a.scheme==="file"?f=p.file(L.win32.join(u(a,!0),...h)).path:f=L.posix.join(a.path,...h),a.with({path:f})}toString(a=!1){return l(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof p)return a;{const h=new m(a);return h._formatted=a.external,h._fsPath=a._sep===g?a.fsPath:null,h}}else return a}}e.URI=p;const g=v.isWindows?1:void 0;class m extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=g),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,a){let h,f=-1;for(let d=0;d<s.length;d++){const k=s.charCodeAt(d);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||a&&k===47)f!==-1&&(h+=encodeURIComponent(s.substring(f,d)),f=-1),h!==void 0&&(h+=s.charAt(d));else{h===void 0&&(h=s.substr(0,d));const T=D[k];T!==void 0?(f!==-1&&(h+=encodeURIComponent(s.substring(f,d)),f=-1),h+=T):f===-1&&(f=d)}}return f!==-1&&(h+=encodeURIComponent(s.substring(f))),h!==void 0?h:s}function c(s){let a;for(let h=0;h<s.length;h++){const f=s.charCodeAt(h);f===35||f===63?(a===void 0&&(a=s.substr(0,h)),a+=D[f]):a!==void 0&&(a+=s[h])}return a!==void 0?a:s}function u(s,a){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,v.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=u;function l(s,a){const h=a?c:b;let f="",{scheme:d,authority:k,path:T,query:C,fragment:V}=s;if(d&&(f+=d,f+=":"),(k||d==="file")&&(f+=I,f+=I),k){let X=k.indexOf("@");if(X!==-1){const ee=k.substr(0,X);k=k.substr(X+1),X=ee.indexOf(":"),X===-1?f+=h(ee,!1):(f+=h(ee.substr(0,X),!1),f+=":",f+=h(ee.substr(X+1),!1)),f+="@"}k=k.toLowerCase(),X=k.indexOf(":"),X===-1?f+=h(k,!1):(f+=h(k.substr(0,X),!1),f+=k.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}f+=h(T,!0)}return C&&(f+="?",f+=h(C,!1)),V&&(f+="#",f+=a?V:b(V,!1)),f}function o(s){try{return decodeURIComponent(s)}catch(a){return s.length>3?s.substr(0,3)+o(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,a=>o(a)):s}}),define(J[109],Z([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(y){const i=y;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function A(y){const i=[];let I;try{const P=JSON.parse(y.arguments),p=P[P.length-1];p&&p.__$stack&&(P.pop(),I=p.__$stack),i.push(...P)}catch(P){i.push("Unable to log remote console arguments",y.arguments)}return{args:i,stack:I}}e.parse=A;function S(y){if(typeof y!="string")return S(A(y).stack);const i=y;if(i){const I=E(i),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(P&&P.length===4)return{uri:v.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}e.getFirstFrame=S;function E(y){if(!y)return y;const i=y.indexOf(`
`);return i===-1?y:y.substring(0,i)}function n(y,i){const{args:I,stack:P}=A(y),p=typeof I[0]=="string"&&I.length===1;let g=E(P);g&&(g=`(${g.trim()})`);let m=[];if(typeof I[0]=="string"?g&&p?m=[`%c[${i}] %c${I[0]} %c${g}`,w("blue"),w(""),w("grey")]:m=[`%c[${i}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:m=[`%c[${i}]%`,w("blue"),...I],g&&!p&&m.push(g),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,m)}e.log=n;function w(y){return`color: ${y}`}});var It=this&&this.__classPrivateFieldSet||function(z,e,v,L,A){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?z!==e||!A:!e.has(z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?A.call(z,v):A?A.value=v:e.set(z,v),v},Ye=this&&this.__classPrivateFieldGet||function(z,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?z!==e||!L:!e.has(z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(z):L?L.value:e.get(z)};define(J[36],Z([0,1,7,23]),function(z,e,v,L){"use strict";var A,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,r,s){let a=t.get(r);return a===void 0&&(a=s,t.set(r,a)),a}e.getOrSet=n;function w(t){const r=[];return t.forEach((s,a)=>{r.push(`${a} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=w;function y(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class P{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=P;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new P(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return L.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return L.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return L.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return L.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new g(r))}static forPaths(){return new D(new P)}static forStrings(){return new D(new i)}static forConfigKeys(){return new D(new I)}clear(){this._root=void 0}set(r,s){const a=this._iter.reset(r);let h;for(this._root||(this._root=new m,this._root.segment=a.value()),h=this._root;;){const d=a.cmp(h.segment);if(d>0)h.left||(h.left=new m,h.left.segment=a.value()),h=h.left;else if(d<0)h.right||(h.right=new m,h.right.segment=a.value()),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new m,h.mid.segment=a.value()),h=h.mid;else break}const f=h.value;return h.value=s,h.key=r,f}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const a=this._iter.reset(r),h=[];let f=this._root;for(;f;){const d=a.cmp(f.segment);if(d>0)h.push([1,f]),f=f.left;else if(d<0)h.push([-1,f]),f=f.right;else if(a.hasNext())a.next(),h.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;h.length>0&&f.isEmpty();){let[k,T]=h.pop();switch(k){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(r){const s=this._iter.reset(r);let a=this._root,h;for(;a;){const f=s.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(s.hasNext())s.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[s,a]of this)r(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const a=s.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&s.push(a.left),a.mid&&s.push(a.mid),a.right&&s.push(a.right))}}}e.TernarySearchTree=D;class b{constructor(r,s){this[A]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[a,h]of this.map)r(h,v.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class u{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const a=this._map.get(r);if(!!a)return s!==0&&this.touch(a,s),a.value}set(r,s,a=0){let h=this._map.get(r);if(h)h.value=s,a!==0&&this.touch(h,a);else{switch(h={key:r,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const a=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.key,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.value,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:[a.key,a.value],done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>r;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,a=r.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const a=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const a=r.next,h=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,a)=>{r.push([a,s])}),r}fromJSON(r){this.clear();for(const[s,a]of r)this.set(s,a)}}e.LinkedMap=u;class l extends u{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class o{constructor(r){E.set(this,void 0),It(this,E,r,"f")}get size(){return Ye(this,E,"f").size}forEach(r,s){Ye(this,E,"f").forEach(r,s)}get(r){return Ye(this,E,"f").get(r)}has(r){return Ye(this,E,"f").has(r)}entries(){return Ye(this,E,"f").entries()}keys(){return Ye(this,E,"f").keys()}values(){return Ye(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Ye(this,E,"f").entries()}}e.ReadonlyMapView=o}),define(J[110],Z([0,1,20,23,7]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(y){return JSON.stringify(y,n)}e.stringify=S;function E(y){let i=JSON.parse(y);return i=w(i),i}e.parse=E;function n(y,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:L.regExpFlags(i)}:i}function w(y,i=0){if(!y||i>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return A.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof v.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let I=0;I<y.length;++I)y[I]=w(y[I],i+1);else for(const I in y)Object.hasOwnProperty.call(y,I)&&(y[I]=w(y[I],i+1))}return y}e.revive=w}),define(J[10],Z([0,1,7,3]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,y,i){this._hosts[w]=y,this._ports[w]=i}setConnectionToken(w,y){this._connectionTokens[w]=y}rewrite(w){if(this._delegate)return this._delegate(w);const y=w.authority;let i=this._hosts[y];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[y],P=this._connectionTokens[y];let p=`path=${encodeURIComponent(w.path)}`;return typeof P=="string"&&(p+=`&tkn=${encodeURIComponent(P)}`),v.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,y,i){const I=this.toUri(w,y);return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&I.scheme===A.file?I.with({scheme:A.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,y){const i=this.toUri(w,y);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,y){return v.URI.isUri(w)?w:v.URI.parse(y.toUrl(w))}}e.FileAccess=new E}),define(J[65],Z([0,1,36]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new v.LRUCache(1e4);function A(y){return w(y,"NFC",L)}e.normalizeNFC=A;const S=new v.LRUCache(1e4);function E(y){return w(y,"NFD",S)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function w(y,i,I){if(!e.canNormalize||!y)return y;const P=I.get(y);if(P)return P;let p;return n.test(y)?p=y.normalize(i):p=y,I.set(y,p),p}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(i){return E(i).replace(y,"")}}else return function(y){return y}}()}),define(J[15],Z([0,1,29,8,7,23,10,3]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(p){return A.uriToFsPath(p,!0)}e.originalFSPath=w;class y{constructor(g){this._ignorePathCasing=g}compare(g,m,D=!1){return g===m?0:S.compare(this.getComparisonKey(g,D),this.getComparisonKey(m,D))}isEqual(g,m,D=!1){return g===m?!0:!g||!m?!1:this.getComparisonKey(g,D)===this.getComparisonKey(m,D)}getComparisonKey(g,m=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,m,D=!1){if(g.scheme===m.scheme){if(g.scheme===E.Schemas.file)return v.isEqualOrParent(w(g),w(m),this._ignorePathCasing(g))&&g.query===m.query&&(D||g.fragment===m.fragment);if(e.isEqualAuthority(g.authority,m.authority))return v.isEqualOrParent(g.path,m.path,this._ignorePathCasing(g),"/")&&g.query===m.query&&(D||g.fragment===m.fragment)}return!1}joinPath(g,...m){return A.URI.joinPath(g,...m)}basenameOrAuthority(g){return e.basename(g)||g.authority}basename(g){return L.posix.basename(g.path)}extname(g){return L.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let m;return g.scheme===E.Schemas.file?m=A.URI.file(L.dirname(w(g))).path:(m=L.posix.dirname(g.path),g.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),m="/")),g.with({path:m})}normalizePath(g){if(!g.path.length)return g;let m;return g.scheme===E.Schemas.file?m=A.URI.file(L.normalize(w(g))).path:m=L.posix.normalize(g.path),g.with({path:m})}relativePath(g,m){if(g.scheme!==m.scheme||!e.isEqualAuthority(g.authority,m.authority))return;if(g.scheme===E.Schemas.file){const c=L.relative(w(g),w(m));return n.isWindows?v.toSlashes(c):c}let D=g.path||"/",b=m.path||"/";if(this._ignorePathCasing(g)){let c=0;for(const u=Math.min(D.length,b.length);c<u&&!(D.charCodeAt(c)!==b.charCodeAt(c)&&D.charAt(c).toLowerCase()!==b.charAt(c).toLowerCase());c++);D=b.substr(0,c)+D.substr(c)}return L.posix.relative(D,b)}resolvePath(g,m){if(g.scheme===E.Schemas.file){const D=A.URI.file(L.resolve(w(g),m));return g.with({authority:D.authority,path:D.path})}return m=v.toPosixPath(m),g.with({path:L.posix.resolve(g.path,m)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,m){return g===m||S.equalsIgnoreCase(g,m)}hasTrailingPathSeparator(g,m=L.sep){if(g.scheme===E.Schemas.file){const D=w(g);return D.length>v.getRoot(D).length&&D[D.length-1]===m}else{const D=g.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,m=L.sep){return e.hasTrailingPathSeparator(g,m)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,m=L.sep){let D=!1;if(g.scheme===E.Schemas.file){const b=w(g);D=b!==void 0&&b.length===v.getRoot(b).length&&b[b.length-1]===m}else{m="/";const b=g.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!e.hasTrailingPathSeparator(g,m)?g.with({path:g.path+"/"}):g}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===E.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,g){const m=[];for(let D=0;D<p.length;D++){const b=g(p[D]);p.some((c,u)=>u===D?!1:e.isEqualOrParent(b,g(c)))||m.push(p[D])}return m}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function g(m){const D=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,o]=u.split(":");l&&o&&D.set(l,o)});const c=m.path.substring(0,m.path.indexOf(";"));return c&&D.set(p.META_DATA_MIME,c),D}p.parseMetaData=g})(I=e.DataUri||(e.DataUri={}));function P(p,g,m){if(g){let D=p.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),p.with({scheme:m,authority:g,path:D})}return p.with({scheme:m})}e.toLocalResource=P}),define(J[9],Z([0,1,25,19,5,2,78,15]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(N){return!!N&&typeof N.then=="function"}e.isThenable=w;function y(N){const F=new v.CancellationTokenSource,R=N(F.token),O=new Promise((M,W)=>{F.token.onCancellationRequested(()=>{W(L.canceled())}),Promise.resolve(R).then(_=>{F.dispose(),M(_)},_=>{F.dispose(),W(_)})});return new class{cancel(){F.cancel()}then(M,W){return O.then(M,W)}catch(M){return this.then(void 0,M)}finally(M){return O.finally(M)}}}e.createCancelablePromise=y;function i(N,F,R){return Promise.race([N,new Promise(O=>F.onCancellationRequested(()=>O(R)))])}e.raceCancellation=i;async function I(N){let F=-1;const R=N.map((M,W)=>M.then(_=>(F=W,_))),O=await Promise.race(R);return N.forEach((M,W)=>{W!==F&&M.cancel()}),O}e.raceCancellablePromises=I;function P(N,F,R){let O;const M=setTimeout(()=>{O==null||O(void 0),R==null||R()},F);return Promise.race([N.finally(()=>clearTimeout(M)),new Promise(W=>O=W)])}e.raceTimeout=P;function p(N){return new Promise((F,R)=>{const O=N();w(O)?O.then(F,R):F(O)})}e.asPromise=p;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(R,R).then(O)})}return new Promise((R,O)=>{this.queuedPromise.then(R,O)})}return this.activePromise=F(),new Promise((R,O)=>{this.activePromise.then(M=>{this.activePromise=null,R(M)},M=>{this.activePromise=null,O(M)})})}}e.Throttler=g;class m{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=m;class D{constructor(){this.promiseMap=new Map}queue(F,R){var O;const W=((O=this.promiseMap.get(F))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(F)===W&&this.promiseMap.delete(F)});return this.promiseMap.set(F,W),W}}e.SequencerByKey=D;class b{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,R=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,M)=>{this.doResolve=O,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(L.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class c{constructor(F){this.delayer=new b(F),this.throttler=new g}trigger(F,R){return this.delayer.trigger(()=>this.throttler.queue(F),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,R)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class l extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function o(N,F){return F?new Promise((R,O)=>{const M=setTimeout(R,N);F.onCancellationRequested(()=>{clearTimeout(M),O(L.canceled())})}):y(R=>o(N,R))}e.timeout=o;function t(N,F=0){const R=setTimeout(N,F);return S.toDisposable(()=>clearTimeout(R))}e.disposableTimeout=t;function r(N){return N.then(void 0,F=>{})}e.ignoreErrors=r;function s(N){const F=[];let R=0;const O=N.length;function M(){return R<O?N[R++]():null}function W(_){_!=null&&F.push(_);const q=M();return q?q.then(W):Promise.resolve(F)}return Promise.resolve(null).then(W)}e.sequence=s;function a(N,F=O=>!!O,R=null){let O=0;const M=N.length,W=()=>{if(O>=M)return Promise.resolve(R);const _=N[O++];return Promise.resolve(_()).then(K=>F(K)?Promise.resolve(K):W())};return W()}e.first=a;function h(N,F=O=>!!O,R=null){if(N.length===0)return Promise.resolve(R);let O=N.length;const M=()=>{var W,_;O=-1;for(const q of N)(_=(W=q).cancel)===null||_===void 0||_.call(W)};return new Promise((W,_)=>{for(const q of N)q.then(K=>{--O>=0&&F(K)?(M(),W(K)):O===0&&W(R)}).catch(K=>{--O>=0&&(M(),_(K))})})}e.firstParallel=h;class f{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((R,O)=>{this.outstandingPromises.push({factory:F,c:R,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const R=F.factory();R.then(F.c,F.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class d extends f{constructor(){super(1)}}e.Queue=d;class k{constructor(){this.queues=new Map}queueFor(F,R=n.extUri){const O=R.getComparisonKey(F);let M=this.queues.get(O);return M||(M=new d,A.Event.once(M.onFinished)(()=>{M==null||M.dispose(),this.queues.delete(O)}),this.queues.set(O,M)),M}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=k;class T{constructor(F,R){this._token=-1,typeof F=="function"&&typeof R=="number"&&this.setIfNotSet(F,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},R)}setIfNotSet(F,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},R))}}e.TimeoutTimer=T;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setInterval(()=>{F()},R)}}e.IntervalTimer=C;class V{constructor(F,R){this.timeoutToken=-1,this.runner=F,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=V;class X extends V{constructor(F,R){super(F,R);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const R=setTimeout(()=>F(N));let O=!1;return{dispose(){O||(O=!0,clearTimeout(R))}}}}else e.runWhenIdle=(N,F)=>{const R=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(R))}}}}();class ee{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ee;async function B(N,F,R){let O;for(let M=0;M<R;M++)try{return await N()}catch(W){O=W,await o(F)}throw O}e.retry=B;class Y{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,R,O){return this._pending={taskId:F,cancel:()=>O==null?void 0:O(),promise:R},R.then(()=>this.donePending(F),()=>this.donePending(F)),R}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let R,O;const M=new Promise((W,_)=>{R=W,O=_});this._next={run:F,promise:M,promiseResolve:R,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=Y;class Q{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,R)=>{this.completeCallback=F,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(R=>{this.completeCallback(F),this.resolved=!0,R()})}error(F){return new Promise(R=>{this.errorCallback(F),this.rejected=!0,R()})}cancel(){new Promise(F=>{this.errorCallback(L.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=U;class $ extends A.Emitter{async fireAsync(F,R,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,F]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[M,W]=this._asyncDeliveryQueue.shift(),_=[],q=Object.assign(Object.assign({},W),{waitUntil:K=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");O&&(K=O(K,typeof M=="function"?M:M[0])),_.push(K)}});try{typeof M=="function"?M.call(void 0,q):M[0].call(M[1],q)}catch(K){L.onUnexpectedError(K);continue}Object.freeze(_),await G.settled(_).catch(K=>L.onUnexpectedError(K))}}}}e.AsyncEmitter=$;var G;(function(N){async function F(W){return typeof Promise.allSettled=="function"?R(W):O(W)}N.allSettled=F;async function R(W){return Promise.allSettled(W)}async function O(W){return Promise.all(W.map(_=>_.then(q=>({status:"fulfilled",value:q}),q=>({status:"rejected",reason:q}))))}async function M(W){let _;const q=await Promise.all(W.map(K=>K.then(H=>H,H=>{_||(_=H)})));if(typeof _!="undefined")throw _;return q}N.settled=M})(G=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,23,29,8,36,9]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const w="**",y="/",i="[/\\\\]",I="[^/\\\\]",P=/\//g;function p(R){switch(R){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function g(R,O){if(!R)return[];const M=[];let W=!1,_=!1,q="";for(const K of R){switch(K){case O:if(!W&&!_){M.push(q),q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":_=!0;break;case"]":_=!1;break}q+=K}return q&&M.push(q),M}e.splitGlobAware=g;function m(R){if(!R)return"";let O="";const M=g(R,y);if(M.every(W=>W===w))O=".*";else{let W=!1;M.forEach((_,q)=>{if(_===w){W||(O+=p(2),W=!0);return}let K=!1,H="",x=!1,ne="";for(const re of _){if(re!=="}"&&K){H+=re;continue}if(x&&(re!=="]"||!ne)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!ne?se="^":re===y?se="":se=v.escapeRegExpCharacters(re),ne+=se;continue}switch(re){case"{":K=!0;continue;case"[":x=!0;continue;case"}":O+=`(?:${g(H,",").map(oe=>m(oe)).join("|")})`,K=!1,H="";break;case"]":O+="["+ne+"]",x=!1,ne="";break;case"?":O+=I;continue;case"*":O+=p(1);continue;default:O+=v.escapeRegExpCharacters(re)}}q<M.length-1&&(M[q+1]!==w||q+2<M.length)&&(O+=i),W=!1})}return O}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},s=function(){return null};function a(R,O){if(!R)return s;let M;typeof R!="string"?M=R.pattern:M=R,M=M.trim();const W=`${M}_${!!O.trimForExclusions}`;let _=t.get(W);if(_)return h(_,R);let q;if(D.test(M)){const K=M.substr(4);_=function(H,x){return typeof H=="string"&&H.endsWith(K)?M:null}}else(q=b.exec(f(M,O)))?_=d(q[1],M):(O.trimForExclusions?u:c).test(M)?_=k(M,O):(q=l.exec(f(M,O)))?_=T(q[1].substr(1),M,!0):(q=o.exec(f(M,O)))?_=T(q[1],M,!1):_=C(M);return t.set(W,_),h(_,R)}function h(R,O){return typeof O=="string"?R:function(M,W){return L.isEqualOrParent(M,O.base)?R(A.relative(O.base,M),W):null}}function f(R,O){return O.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function d(R,O){const M=`/${R}`,W=`\\${R}`,_=function(K,H){return typeof K!="string"?null:H?H===R?O:null:K===R||K.endsWith(M)||K.endsWith(W)?O:null},q=[R];return _.basenames=q,_.patterns=[O],_.allBasenames=q,_}function k(R,O){const M=F(R.slice(1,-1).split(",").map(H=>a(H,O)).filter(H=>H!==s),R),W=M.length;if(!W)return s;if(W===1)return M[0];const _=function(H,x){for(let ne=0,re=M.length;ne<re;ne++)if(M[ne](H,x))return R;return null},q=M.find(H=>!!H.allBasenames);q&&(_.allBasenames=q.allBasenames);const K=M.reduce((H,x)=>x.allPaths?H.concat(x.allPaths):H,[]);return K.length&&(_.allPaths=K),_}function T(R,O,M){const W=A.sep===A.posix.sep,_=W?R:R.replace(P,A.sep),q=A.sep+_,K=A.posix.sep+R,H=M?function(x,ne){return typeof x=="string"&&(x===_||x.endsWith(q)||!W&&(x===R||x.endsWith(K)))?O:null}:function(x,ne){return typeof x=="string"&&(x===_||!W&&x===R)?O:null};return H.allPaths=[(M?"*/":"./")+R],H}function C(R){try{const O=new RegExp(`^${m(R)}$`);return function(M){return O.lastIndex=0,typeof M=="string"&&O.test(M)?R:null}}catch(O){return s}}function V(R,O,M){return!R||typeof O!="string"?!1:X(R)(O,void 0,M)}e.match=V;function X(R,O={}){if(!R)return r;if(typeof R=="string"||Q(R)){const M=a(R,O);if(M===s)return r;const W=function(_,q){return!!M(_,q)};return M.allBasenames&&(W.allBasenames=M.allBasenames),M.allPaths&&(W.allPaths=M.allPaths),W}return G(R,O)}e.parse=X;function ee(R){if(!R)return;let O;return M=>(O||(O=(R()||Promise.resolve([])).then(W=>W?Y(W):{})),O.then(W=>!!W[M]))}e.hasSiblingPromiseFn=ee;function B(R){if(!R)return;let O;return M=>{if(!O){const W=R();O=W?Y(W):{}}return!!O[M]}}e.hasSiblingFn=B;function Y(R){const O={};for(const M of R)O[M]=!0;return O}function Q(R){const O=R;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=Q;function U(R){return R.allBasenames||[]}e.getBasenameTerms=U;function $(R){return R.allPaths||[]}e.getPathTerms=$;function G(R,O){const M=F(Object.getOwnPropertyNames(R).map(H=>N(H,R[H],O)).filter(H=>H!==s)),W=M.length;if(!W)return s;if(!M.some(H=>!!H.requiresSiblings)){if(W===1)return M[0];const H=function(re,se){for(let le=0,oe=M.length;le<oe;le++){const ue=M[le](re,se);if(ue)return ue}return null},x=M.find(re=>!!re.allBasenames);x&&(H.allBasenames=x.allBasenames);const ne=M.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return ne.length&&(H.allPaths=ne),H}const _=function(H,x,ne){let re;for(let se=0,le=M.length;se<le;se++){const oe=M[se];oe.requiresSiblings&&ne&&(x||(x=A.basename(H)),re||(re=x.substr(0,x.length-A.extname(H).length)));const ue=oe(H,x,re,ne);if(ue)return ue}return null},q=M.find(H=>!!H.allBasenames);q&&(_.allBasenames=q.allBasenames);const K=M.reduce((H,x)=>x.allPaths?H.concat(x.allPaths):H,[]);return K.length&&(_.allPaths=K),_}function N(R,O,M){if(O===!1)return s;const W=a(R,M);if(W===s)return s;if(typeof O=="boolean")return W;if(O){const _=O.when;if(typeof _=="string"){const q=(K,H,x,ne)=>{if(!ne||!W(K,H))return null;const re=_.replace("$(basename)",x),se=ne(re);return E.isThenable(se)?se.then(le=>le?R:null):se?R:null};return q.requiresSiblings=!0,q}}return W}function F(R,O){const M=R.filter(H=>!!H.basenames);if(M.length<2)return R;const W=M.reduce((H,x)=>{const ne=x.basenames;return ne?H.concat(ne):H},[]);let _;if(O){_=[];for(let H=0,x=W.length;H<x;H++)_.push(O)}else _=M.reduce((H,x)=>{const ne=x.patterns;return ne?H.concat(ne):H},[]);const q=function(H,x){if(typeof H!="string")return null;if(!x){let re;for(re=H.length;re>0;re--){const se=H.charCodeAt(re-1);if(se===47||se===92)break}x=H.substr(re)}const ne=W.indexOf(x);return ne!==-1?_[ne]:null};q.basenames=W,q.patterns=_,q.allBasenames=W;const K=R.filter(H=>!H.basenames);return K.push(q),K}}),define(J[39],Z([0,1,7,8,23,10,3,15,29]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(a,h,f){if(typeof a=="string"&&(a=v.URI.file(a)),f){const k=f.getWorkspaceFolder(a);if(k){const T=f.getWorkspace().folders.length>1;let C;if(n.isEqual(k.uri,a)?C="":C=n.relativePath(k.uri,a),T){const V=k.name?k.name:n.basename(k.uri);C=C?V+" \u2022 "+C:V}return C}}if(a.scheme!==S.Schemas.file&&a.scheme!==S.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if(w.hasDriveLetter(a.fsPath))return L.normalize(I(a.fsPath));let d=L.normalize(a.fsPath);return!E.isWindows&&(h==null?void 0:h.userHome)&&(d=p(d,h.userHome.fsPath)),d}e.getPathLabel=y;function i(a){if(!a)return;typeof a=="string"&&(a=v.URI.file(a));const h=n.basename(a)||(a.scheme===S.Schemas.file?a.fsPath:a.path);return E.isWindows&&w.isRootOrDriveLetter(h)?I(h):h}e.getBaseLabel=i;function I(a){return w.hasDriveLetter(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=I;let P=Object.create(null);function p(a,h){if(E.isWindows||!a||!h)return a;let f=P.original===h?P.normalized:void 0;return f||(f=`${A.rtrim(h,L.posix.sep)}${L.posix.sep}`,P={original:h,normalized:f}),(E.isLinux?a.startsWith(f):A.startsWithIgnoreCase(a,f))&&(a=`~/${a.substr(f.length)}`),a}e.tildify=p;function g(a,h){return a.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=g;const m="\u2026",D="\\\\",b="~";function c(a,h=L.sep){const f=new Array(a.length);let d=!1;for(let k=0;k<a.length;k++){let T=a[k];if(T===""){f[k]=`.${h}`;continue}if(!T){f[k]=T;continue}d=!0;let C="";T.indexOf(D)===0?(C=T.substr(0,T.indexOf(D)+D.length),T=T.substr(T.indexOf(D)+D.length)):T.indexOf(h)===0?(C=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(b)===0&&(C=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const V=T.split(h);for(let X=1;d&&X<=V.length;X++)for(let ee=V.length-X;d&&ee>=0;ee--){d=!1;let B=V.slice(ee,ee+X).join(h);for(let Y=0;!d&&Y<a.length;Y++)if(Y!==k&&a[Y]&&a[Y].indexOf(B)>-1){const Q=ee+X===V.length,U=ee>0&&a[Y].indexOf(h)>-1?h+B:B,$=a[Y].endsWith(U);d=!Q||$}if(!d){let Y="";(V[0].endsWith(":")||C!=="")&&(ee===1&&(ee=0,X++,B=V[0]+h+B),ee>0&&(Y=V[0]+h),Y=C+Y),ee>0&&(Y=Y+m+h),Y=Y+B,ee+X<V.length&&(Y=Y+h+m),f[k]=Y}}d&&(f[k]=T)}return f}e.shorten=c;var u;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function l(a,h=Object.create(null)){const f=[];let d=!1,k="";for(const T of a)if(T==="$"||d&&T==="{")k&&f.push({value:k,type:u.TEXT}),k="",d=!0;else if(T==="}"&&d){const C=h[k];if(typeof C=="string")C.length&&f.push({value:C,type:u.VARIABLE});else if(C){const V=f[f.length-1];(!V||V.type!==u.SEPARATOR)&&f.push({value:C.label,type:u.SEPARATOR})}k="",d=!1}else k+=T;return k&&!d&&f.push({value:k,type:u.TEXT}),f.filter((T,C)=>{if(T.type===u.SEPARATOR){const V=f[C-1],X=f[C+1];return[V,X].every(ee=>ee&&(ee.type===u.VARIABLE||ee.type===u.TEXT)&&ee.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=l;function o(a,h){return E.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function t(a,h){return E.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,""):E.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(a){const h=a.indexOf("/")!==-1?L.posix:L.win32,f=h.basename(a),d=h.dirname(a);return f.length?{name:f,parentPath:d}:{name:d,parentPath:""}}e.splitName=s}),define(J[27],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return v.test(w)}e.isUUID=L;const A=new Uint8Array(16),S=[];for(let w=0;w<256;w++)S.push(w.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(w){for(let y=0;y<w.length;y++)w[y]=Math.floor(Math.random()*256);return w};function n(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let w=0,y="";return y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y}e.generateUuid=n}),define(J[112],Z([0,1,30,58,42]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(E,n){if(await new Promise((i,I)=>{const P=v.createReadStream(E),p=L.createHash("sha1");P.pipe(p);const g=A.once((m,D)=>{P.removeAllListeners(),p.removeAllListeners(),m?I(m):i(D)});P.once("error",g),P.once("end",g),p.once("error",g),p.once("data",m=>g(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(J[81],Z([0,1,237]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new v.StringDecoder(S),this.remaining=null}write(S){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return E;let w=0,y,i=w;for(;i<n.length;)if(y=n.charCodeAt(i),y===13||y===10){if(E.push(n.substring(w,i)),i++,i<n.length){const I=y;y=n.charCodeAt(i),(I===13&&y===10||I===10&&y===13)&&i++}w=i}else i++;return this.remaining=w<n.length?n.substr(w):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],Z([0,1,26]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(n){const w=n.replace(/\-/g,":").toLowerCase();return!L.has(w)}function S(){return new Promise(async(n,w)=>{const y=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){w(i)}finally{clearTimeout(y)}})}e.getMac=S;function E(){return new Promise((n,w)=>{try{const y=v.networkInterfaces();for(let i in y){const I=y[i];if(I){for(const{mac:P}of I)if(A(P))return n(P)}}w("Unable to retrieve mac address (unexpected format)")}catch(y){w(y)}})}}),define(J[66],Z([0,1,19,27,26,36,113]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const P=A.networkInterfaces();for(let p in P){const g=P[p];if(g)for(const{mac:m,internal:D}of g)D||(I+=1,this._isVirtualMachineMacAdress(m.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let n;async function w(){return n||(n=(async()=>await y()||L.generateUuid())()),n}e.getMachineId=w;async function y(){try{const i=await new Promise((P,p)=>{z(["crypto"],P,p)}),I=await E.getMac();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){v.onUnexpectedError(i);return}}}),define(J[16],Z([0,1,30,26,114,8,9,3,29,27,65,15,7]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function g(U,$=p.UNLINK){if(w.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");return $===p.UNLINK?D(U):m(U)}async function m(U){try{const $=S.join(L.tmpdir(),y.generateUuid());try{await e.Promises.rename(U,$)}catch(G){return D(U)}D($).catch(G=>{})}catch($){if($.code!=="ENOENT")throw $}}async function D(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if(w.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function c(U,$){return o(await($?u(U):A.promisify(v.readdir)(U)))}async function u(U){try{return await A.promisify(v.readdir)(U,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const $=[],G=await c(U);for(const N of G){let F=!1,R=!1,O=!1;try{const M=await e.Promises.lstat(S.join(U,N));F=M.isFile(),R=M.isDirectory(),O=M.isSymbolicLink()}catch(M){console.warn("[node.js fs] unexpected error from lstat after readdir: ",M)}$.push({name:N,isFile:()=>F,isDirectory:()=>R,isSymbolicLink:()=>O})}return $}function l(U){return o(v.readdirSync(U))}e.readdirSync=l;function o(U){return U.map($=>typeof $=="string"?n.isMacintosh?i.normalizeNFC($):$:($.name=n.isMacintosh?i.normalizeNFC($.name):$.name,$))}async function t(U){const $=await c(U),G=[];for(const N of $)await s.existsDirectory(S.join(U,N))&&G.push(N);return G}function r(U,$=1e3){return new Promise(G=>{let N=!1;const F=setInterval(()=>{N||(N=!0,v.access(U,R=>{N=!1,R&&(clearInterval(F),G(void 0))}))},$)})}e.whenDeleted=r;var s;(function(U){async function $(F){let R;try{if(R=await e.Promises.lstat(F),!R.isSymbolicLink())return{stat:R}}catch(O){}try{return{stat:await e.Promises.stat(F),symbolicLink:(R==null?void 0:R.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(n.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(M){if(M.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw M}throw O}}U.stat=$;async function G(F){try{const{stat:R,symbolicLink:O}=await U.stat(F);return R.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(R){}return!1}U.existsFile=G;async function N(F){try{const{stat:R,symbolicLink:O}=await U.stat(F);return R.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(R){}return!1}U.existsDirectory=N})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new E.ResourceQueue;function h(U,$,G){return a.queueFor(P.URI.file(U),I.extUriBiasedIgnorePathCase).queue(()=>{const N=T(G);return new Promise((F,R)=>d(U,$,N,O=>O?R(O):F()))})}let f=!0;function d(U,$,G,N){if(!f)return v.writeFile(U,$,{mode:G.mode,flag:G.flag},N);v.open(U,G.flag,G.mode,(F,R)=>{if(F)return N(F);v.writeFile(R,$,O=>{if(O)return v.close(R,()=>N(O));v.fdatasync(R,M=>(M&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",M),f=!1),v.close(R,W=>N(W))))})})}function k(U,$,G){const N=T(G);if(!f)return v.writeFileSync(U,$,{mode:N.mode,flag:N.flag});const F=v.openSync(U,N.flag,N.mode);try{v.writeFileSync(F,$);try{v.fdatasyncSync(F)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),f=!1}}finally{v.closeSync(F)}}e.writeFileSync=k;function T(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function C(U,$){if(U===$)return;async function G(N){try{const F=await e.Promises.lstat(N);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(N,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(U,$),await G($)}catch(N){if(U.toLowerCase()!==$.toLowerCase()&&N.code==="EXDEV"||U.endsWith("."))await V(U,$,{preserveSymlinks:!1}),await g(U,p.MOVE),await G($);else throw N}}async function V(U,$,G){return ee(U,$,{root:{source:U,target:$},options:G,handledSourcePaths:new Set})}const X=511;async function ee(U,$,G){if(G.handledSourcePaths.has(U))return;G.handledSourcePaths.add(U);const{stat:N,symbolicLink:F}=await s.stat(U);if(F){if(G.options.preserveSymlinks)try{return await Q(U,$,G)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(F.dangling)return}return N.isDirectory()?B(U,$,N.mode&X,G):Y(U,$,N.mode&X)}async function B(U,$,G,N){await e.Promises.mkdir($,{recursive:!0,mode:G});const F=await c(U);for(const R of F)await ee(S.join(U,R),S.join($,R),N)}async function Y(U,$,G){await e.Promises.copyFile(U,$),await e.Promises.chmod($,G)}async function Q(U,$,G){let N=await e.Promises.readlink(U);w.isEqualOrParent(N,G.root.source,!n.isLinux)&&(N=S.join(G.root.target,N.substr(G.root.source.length+1))),await e.Promises.symlink(N,$)}e.Promises=new class{get access(){return A.promisify(v.access)}get stat(){return A.promisify(v.stat)}get lstat(){return A.promisify(v.lstat)}get utimes(){return A.promisify(v.utimes)}get read(){return A.promisify(v.read)}get readFile(){return A.promisify(v.readFile)}get write(){return A.promisify(v.write)}get appendFile(){return A.promisify(v.appendFile)}get fdatasync(){return A.promisify(v.fdatasync)}get truncate(){return A.promisify(v.truncate)}get rename(){return A.promisify(v.rename)}get copyFile(){return A.promisify(v.copyFile)}get open(){return A.promisify(v.open)}get close(){return A.promisify(v.close)}get symlink(){return A.promisify(v.symlink)}get readlink(){return A.promisify(v.readlink)}get chmod(){return A.promisify(v.chmod)}get mkdir(){return A.promisify(v.mkdir)}get unlink(){return A.promisify(v.unlink)}get rmdir(){return A.promisify(v.rmdir)}get realpath(){return A.promisify(v.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch($){return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return h}get rm(){return g}get move(){return C}get copy(){return V}}}),define(J[82],Z([0,1,30,23,8,16]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const I=A.dirname(i);if(i===I)return i;const P=(A.basename(i)||i).toLowerCase();try{const g=S.readdirSync(I).filter(m=>m.toLowerCase()===P);if(g.length===1){const m=E(I);if(m)return A.join(m,g[0])}else if(g.length>1){const m=g.indexOf(P);if(m>=0){const D=E(I);if(D)return A.join(D,g[m])}}}catch(p){}return null}e.realcaseSync=E;async function n(i){try{return await S.Promises.realpath(i)}catch(I){const P=y(i);return await S.Promises.access(P,v.constants.R_OK),P}}e.realpath=n;function w(i){try{return v.realpathSync(i)}catch(I){const P=y(i);return v.accessSync(P,v.constants.R_OK),P}}e.realpathSync=w;function y(i){return L.rtrim(A.normalize(i),A.sep)}}),define(J[115],Z([0,1,59]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,w,y){let i=!1;return new Promise(I=>{const P=setTimeout(()=>{if(!i)return i=!0,I(0)},y);A(n,w,p=>{if(!i)return i=!0,clearTimeout(P),I(p)})})}e.findFreePort=L;function A(n,w,y){if(w===0)return y(0);const i=new v.Socket;i.once("connect",()=>(E(i),A(n+1,w-1,y))),i.once("data",()=>{}),i.once("error",I=>(E(i),I.code!=="ECONNREFUSED"?A(n+1,w-1,y):y(n))),i.connect(n,"127.0.0.1")}function S(n,w,y){let i=!1,I,P=1;const p=v.createServer({pauseOnConnect:!0});function g(m,D){i||(i=!0,p.removeAllListeners(),p.close(),I&&clearTimeout(I),D(m))}return new Promise(m=>{I=setTimeout(()=>{g(0,m)},y),p.on("listening",()=>{g(n,m)}),p.on("error",D=>{D&&(D.code==="EADDRINUSE"||D.code==="EACCES")&&P<w?(n++,P++,p.listen(n,"127.0.0.1")):g(0,m)}),p.on("close",()=>{g(0,m)}),p.listen(n,"127.0.0.1")})}e.findFreePortFaster=S;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(w){console.error(w)}}});var Oe=this&&this.__await||function(z){return this instanceof Oe?(this.v=z,this):new Oe(z)},wt=this&&this.__asyncGenerator||function(z,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=v.apply(z,e||[]),A,S=[];return A={},E("next"),E("throw"),E("return"),A[Symbol.asyncIterator]=function(){return this},A;function E(P){L[P]&&(A[P]=function(p){return new Promise(function(g,m){S.push([P,p,g,m])>1||n(P,p)})})}function n(P,p){try{w(L[P](p))}catch(g){I(S[0][3],g)}}function w(P){P.value instanceof Oe?Promise.resolve(P.value.v).then(y,i):I(S[0][2],P)}function y(P){n("next",P)}function i(P){n("throw",P)}function I(P,p){P(p),S.shift(),S.length&&n(S[0][0],S[0][1])}},pt=this&&this.__asyncValues||function(z){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=z[Symbol.asyncIterator],v;return e?e.call(z):(z=typeof __values=="function"?__values(z):z[Symbol.iterator](),v={},L("next"),L("throw"),L("return"),v[Symbol.asyncIterator]=function(){return this},v);function L(S){v[S]=z[S]&&function(E){return new Promise(function(n,w){E=z[S](E),A(n,w,E.done,E.value)})}}function A(S,E,n,w){Promise.resolve(w).then(function(y){S({value:y,done:n})},E)}};define(J[116],Z([0,1,16,26,8]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var w;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(w||(w={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function P({useAlternateBitness:l=!1}={}){return l?y===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:l=!1,findPreview:o=!1}={}){const t=P({useAlternateBitness:l});if(!t)return null;const r=A.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let s=-1,a=null;for(const d of await v.Promises.readdir(r)){let k=-1;if(o){const C=d.indexOf("-");if(C<0)continue;const V=d.substring(0,C);if(!S.test(V)||d.substring(C+1)!=="preview")continue;k=parseInt(V,10)}else{if(!S.test(d))continue;k=parseInt(d,10)}if(k<=s)continue;const T=A.join(r,d,"pwsh.exe");!await v.SymlinkSupport.existsFile(T)||(a=T,s=k)}if(!a)return null;const h=t.includes("x86")?" (x86)":"",f=o?" Preview":"";return new I(a,`PowerShell${f}${h}`,!0)}async function g({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const o=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=l?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const s of await v.Promises.readdir(o))if(t.test(s)){const a=A.join(o,s,"pwsh.exe");return new I(a,r)}return null}function m(){const l=A.join(L.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function D(){const l=A.join(process.env.windir,y===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}function b(){return wt(this,arguments,function*(){let o=yield Oe(p());o&&(yield yield Oe(o)),o=yield Oe(p({useAlternateBitness:!0})),o&&(yield yield Oe(o)),o=yield Oe(g()),o&&(yield yield Oe(o)),o=m(),o&&(yield yield Oe(o)),o=yield Oe(p({findPreview:!0})),o&&(yield yield Oe(o)),o=yield Oe(g({findPreview:!0})),o&&(yield yield Oe(o)),o=yield Oe(p({useAlternateBitness:!0,findPreview:!0})),o&&(yield yield Oe(o)),o=D(),o&&(yield yield Oe(o))})}function c(){return wt(this,arguments,function*(){var o,t;try{for(var r=pt(b()),s;s=yield Oe(r.next()),!s.done;){const a=s.value;(yield Oe(a.exists()))&&(yield yield Oe(a))}}catch(a){o={error:a}}finally{try{s&&!s.done&&(t=r.return)&&(yield Oe(t.call(r)))}finally{if(o)throw o.error}}})}e.enumeratePowerShellInstallations=c;async function u(){var l,o;try{for(var t=pt(c()),r;r=await t.next(),!r.done;)return r.value}catch(s){l={error:s}}finally{try{r&&!r.done&&(o=t.return)&&await o.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(J[83],Z([0,1,40,10]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(E){return new Promise((n,w)=>{let y;const i=new Map;function I(p,g,m,D,b){const c=i.get(g);if(p===E||c){const u={name:P(m),cmd:m,pid:p,ppid:g,load:D,mem:b};i.set(p,u),p===E&&(y=u),c&&(c.children||(c.children=[]),c.children.push(u),c.children.length>1&&(c.children=c.children.sort((l,o)=>l.pid-o.pid)))}}function P(p){const g=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,c=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(m.exec(p))return"watcherService ";if(D.exec(p))return"electron-crash-reporter";if(b.exec(p))return"winpty-process";if(c.exec(p))return"console-window-host (Windows internal process)";let l=u.exec(p);if(l&&l.length===2)return l[1]==="renderer"?g.exec(p)?"shared-process":"window":l[1];const o=/[a-zA-Z-]+\.js/g;let t="";do l=o.exec(p),l&&(t+=l+" ");while(l);return t&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${t}`:p}if(process.platform==="win32"){const p=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,m)=>{z(["windows-process-tree"],g,m)}).then(g=>{g.getProcessList(E,m=>{g.getProcessCpuUsage(m,D=>{const b=new Map;D.forEach(c=>{const u=p(c.commandLine||"");b.set(c.pid,{name:P(u),cmd:u,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),y=b.get(E),y?(b.forEach(c=>{const u=b.get(c.ppid);u&&(u.children||(u.children=[]),u.children.push(c))}),b.forEach(c=>{c.children&&(c.children=c.children.sort((u,l)=>u.pid-l.pid))}),n(y)):w(new Error(`Root process ${E} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let p=function(){let g=[y];const m=[];for(;g.length;){const b=g.shift();b&&(m.push(b.pid),b.children&&(g=g.concat(b.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",z).fsPath);D+=" "+m.join(" "),v.exec(D,{},(b,c,u)=>{if(b||u)w(b||new Error(u.toString()));else{const l=c.toString().split(`
`);for(let o=0;o<m.length;o++){const t=i.get(m[o]);t.load=parseFloat(l[o])}if(!y){w(new Error(`Root process ${E} not found`));return}n(y)}})};v.exec("which ps",{},(g,m,D)=>{if(g||D)if(process.platform!=="linux")w(g||new Error(D.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",z).fsPath);v.exec(b,{},(c,u,l)=>{c||l?w(c||new Error(l.toString())):(S(u,I),p())})}else{const b=m.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";v.exec(`${b} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,o)=>{u||o&&!o.includes("screen size is bogus")?w(u||new Error(o.toString())):(S(l,I),process.platform==="linux"?p():y?n(y):w(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=A;function S(E,n){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=E.toString().split(`
`);for(const i of y){const I=w.exec(i.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[117],Z([0,1,8,30,3,65,2,16]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(I,P,p){return i({path:I,isDirectory:!1},P,p)}e.watchFile=w;function y(I,P,p){return i({path:I,isDirectory:!0},P,p)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function i(I,P,p){const g=v.basename(I.path),m=new Map;let D=!1,b=[E.toDisposable(()=>{m.forEach(c=>E.dispose(c)),m.clear()})];try{const c=L.watch(I.path);b.push(E.toDisposable(()=>{c.removeAllListeners(),c.close()}));const u=new Set;I.isDirectory&&n.Promises.readdir(I.path).then(l=>l.forEach(o=>u.add(o))),c.on("error",(l,o)=>{D||p(`Failed to watch ${I.path} for changes using fs.watch() (${l}, ${o})`)}),c.on("change",(l,o)=>{if(D)return;let t="";if(o&&(t=o.toString(),A.isMacintosh&&(t=S.normalizeNFC(t))),!t||l!=="change"&&l!=="rename")return;const r=I.isDirectory?v.join(I.path,t):I.path;if(I.isDirectory)if(l==="rename"){const s=m.get(r);s&&E.dispose(s);const a=setTimeout(async()=>{m.delete(r);const h=await n.Promises.exists(r);if(D)return;let f;h?u.has(t)?f="changed":(f="added",u.add(t)):(u.delete(t),f="deleted"),P(f,r)},e.CHANGE_BUFFER_DELAY);m.set(r,E.toDisposable(()=>clearTimeout(a)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),P(s,r)}else if(l==="rename"||t!==g){const s=setTimeout(async()=>{const a=await n.Promises.exists(r);D||(a?(P("changed",r),b=[i(I,P,p)]):P("deleted",r))},e.CHANGE_BUFFER_DELAY);E.dispose(b),b=[E.toDisposable(()=>clearTimeout(s))]}else P("changed",r)})}catch(c){n.Promises.exists(I.path).then(u=>{u&&!D&&p(`Failed to watch ${I.path} for changes using fs.watch() (${c.toString()})`)})}return E.toDisposable(()=>{D=!0,b=E.dispose(b)})}}),define(J[118],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,118,13]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){v.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(n,w,y,i,I)=>{const P=E(n,i,y);P.popup({window:A.withNullAsUndefined(v.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{P&&n.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=S;function E(n,w,y){const i=new v.Menu;return y.forEach(I=>{let P;I.type==="separator"?P=new v.MenuItem({type:I.type}):Array.isArray(I.submenu)?P=new v.MenuItem({submenu:E(n,w,I.submenu),label:I.label}):P=new v.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(p,g,m)=>n.sender.send(w,I.id,m)}),i.append(P)}),i}});var he=this&&this.__decorate||function(z,e,v,L){var A=arguments.length,S=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(z,e,v,L);else for(var n=z.length-1;n>=0;n--)(E=z[n])&&(S=(A<3?E(S):A>3?E(e,v,S):E(e,v))||S);return A>3&&S&&Object.defineProperty(e,v,S),S};define(J[33],Z([0,1,5,2,9,25,19,20,35,13,110,23,46]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function g(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class c{constructor(R){this.buffer=R,this.pos=0}read(R){const O=this.buffer.slice(this.pos,this.pos+R);return this.pos+=O.byteLength,O}}class u{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var l;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(l||(l={}));function o(F){const R=n.VSBuffer.alloc(4);return R.writeUInt32BE(F,0),R}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const R=n.VSBuffer.alloc(1);return R.writeUInt8(F,0),R}const s={Undefined:r(l.Undefined),String:r(l.String),Buffer:r(l.Buffer),VSBuffer:r(l.VSBuffer),Array:r(l.Array),Object:r(l.Object)},a=typeof Buffer!="undefined";function h(F,R){if(typeof R=="undefined")F.write(s.Undefined);else if(typeof R=="string"){const O=n.VSBuffer.fromString(R);F.write(s.String),F.write(o(O.byteLength)),F.write(O)}else if(a&&Buffer.isBuffer(R)){const O=n.VSBuffer.wrap(R);F.write(s.Buffer),F.write(o(O.byteLength)),F.write(O)}else if(R instanceof n.VSBuffer)F.write(s.VSBuffer),F.write(o(R.byteLength)),F.write(R);else if(Array.isArray(R)){F.write(s.Array),F.write(o(R.length));for(const O of R)h(F,O)}else{const O=n.VSBuffer.fromString(JSON.stringify(R));F.write(s.Object),F.write(o(O.byteLength)),F.write(O)}}function f(F){switch(F.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return F.read(t(F)).toString();case l.Buffer:return F.read(t(F)).buffer;case l.VSBuffer:return F.read(t(F));case l.Array:{const O=t(F),M=[];for(let W=0;W<O;W++)M.push(f(F));return M}case l.Object:return JSON.parse(F.read(t(F)).toString())}}class d{constructor(R,O,M=null,W=1e3){this.protocol=R,this.ctx=O,this.logger=M,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(R,O){this.channels.set(R,O),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const O=this.send([R.type]);this.logger&&this.logger.logOutgoing(O,0,1,D(R.type));return}case 201:case 202:case 204:case 203:{const O=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(O,R.id,1,D(R.type),R.data);return}}}send(R,O=void 0){const M=new u;return h(M,R),h(M,O),this.sendBuffer(M.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onRawMessage(R){const O=new c(R),M=f(O),W=f(O),_=M[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,M[1],1,`${g(_)}: ${M[2]}.${M[3]}`,W),this.onPromise({type:_,id:M[1],channelName:M[2],name:M[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,M[1],1,`${g(_)}: ${M[2]}.${M[3]}`,W),this.onEventListen({type:_,id:M[1],channelName:M[2],name:M[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,M[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:M[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,M[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:M[1]})}}onPromise(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const M=new S.CancellationTokenSource;let W;try{W=O.call(this.ctx,R.name,R.arg,M.token)}catch(K){W=Promise.reject(K)}const _=R.id;W.then(K=>{this.sendResponse({id:_,data:K,type:201}),this.activeRequests.delete(R.id)},K=>{K instanceof Error?this.sendResponse({id:_,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:_,data:K,type:203}),this.activeRequests.delete(R.id)});const q=L.toDisposable(()=>M.cancel());this.activeRequests.set(R.id,q)}onEventListen(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const M=R.id,_=O.listen(this.ctx,R.name,R.arg)(q=>this.sendResponse({id:M,data:q,type:204}));this.activeRequests.set(R.id,_)}disposeActiveRequest(R){const O=this.activeRequests.get(R.id);O&&(O.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let O=this.pendingRequests.get(R.channelName);O||(O=[],this.pendingRequests.set(R.channelName,O));const M=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:R,timeoutTimer:M})}flushPendingRequests(R){const O=this.pendingRequests.get(R);if(O){for(const M of O)switch(clearTimeout(M.timeoutTimer),M.request.type){case 100:this.onPromise(M.request);break;case 102:this.onEventListen(M.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var k;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(R,O=null){this.protocol=R,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(M=>this.onBuffer(M)),this.logger=O}getChannel(R){const O=this;return{call(M,W,_){return O.isDisposed?Promise.reject(E.canceled()):O.requestPromise(R,M,W,_)},listen(M,W){return O.isDisposed?Promise.reject(E.canceled()):O.requestEvent(R,M,W)}}}requestPromise(R,O,M,W=S.CancellationToken.None){const _=this.lastRequestId++,K={id:_,type:100,channelName:R,name:O,arg:M};if(W.isCancellationRequested)return Promise.reject(E.canceled());let H;return new Promise((ne,re)=>{if(W.isCancellationRequested)return re(E.canceled());const se=()=>{const me=Se=>{switch(Se.type){case 201:this.handlers.delete(_),ne(Se.data);break;case 202:this.handlers.delete(_);const De=new Error(Se.data.message);De.stack=Se.data.stack,De.name=Se.data.name,re(De);break;case 203:this.handlers.delete(_),re(Se.data);break}};this.handlers.set(_,me),this.sendRequest(K)};let le=null;this.state===b.Idle?se():(le=A.createCancelablePromise(me=>this.whenInitialized()),le.then(()=>{le=null,se()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:_,type:101}),re(E.canceled())},ue=W.onCancellationRequested(oe);H=L.combinedDisposable(L.toDisposable(oe),ue),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(R,O,M){const W=this.lastRequestId++,q={id:W,type:102,channelName:R,name:O,arg:M};let K=null;const H=new v.Emitter({onFirstListenerAdd:()=>{K=A.createCancelablePromise(ne=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(H),this.sendRequest(q)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(H),this.sendRequest({id:W,type:103}))}}),x=ne=>H.fire(ne.data);return this.handlers.set(W,x),H.event}sendRequest(R){switch(R.type){case 100:case 102:{const O=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(O,R.id,0,`${g(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const O=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(O,R.id,0,g(R.type));return}}}send(R,O=void 0){const M=new u;return h(M,R),h(M,O),this.sendBuffer(M.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onBuffer(R){const O=new c(R),M=f(O),W=f(O),_=M[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,D(_)),this.onResponse({type:M[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,M[1],0,D(_),W),this.onResponse({type:M[0],id:M[1],data:W})}}onResponse(R){if(R.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(R.id);O&&O(R)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}he([P.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class C{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:O,onDidClientDisconnect:M})=>{v.Event.once(O.onMessage)(_=>{const q=new c(_),K=f(q),H=new d(O,K),x=new T(O);this.channels.forEach((re,se)=>H.registerChannel(se,re));const ne={channelServer:H,channelClient:x,ctx:K};this._connections.add(ne),this._onDidAddConnection.fire(ne),M(()=>{H.dispose(),x.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const R=[];return this._connections.forEach(O=>R.push(O)),R}getChannel(R,O){const M=this;return{call(W,_,q){let K;if(y.isFunction(O)){let x=w.getRandomElement(M.connections.filter(O));K=x?Promise.resolve(x):v.Event.toPromise(v.Event.filter(M.onDidAddConnection,O))}else K=O.routeCall(M,W,_);const H=K.then(x=>x.channelClient.getChannel(R));return X(H).call(W,_,q)},listen(W,_){if(y.isFunction(O))return M.getMulticastEvent(R,O,W,_);const q=O.routeEvent(M,W,_).then(K=>K.channelClient.getChannel(R));return X(q).listen(W,_)}}}getMulticastEvent(R,O,M,W){const _=this;let q=new L.DisposableStore;const K=new v.Emitter({onFirstListenerAdd:()=>{q=new L.DisposableStore;const H=new v.EventMultiplexer,x=new Map,ne=se=>{const oe=se.channelClient.getChannel(R).listen(M,W),ue=H.add(oe);x.set(se,ue)},re=se=>{const le=x.get(se);!le||(le.dispose(),x.delete(se))};_.connections.filter(O).forEach(ne),v.Event.filter(_.onDidAddConnection,O)(ne,void 0,q),_.onDidRemoveConnection(re,void 0,q),H.event(K.fire,K,q),q.add(H)},onLastListenerRemove:()=>{q.dispose()}});return K.event}registerChannel(R,O){this.channels.set(R,O),this._connections.forEach(M=>{M.channelServer.registerChannel(R,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=C;class V{constructor(R,O,M=null){const W=new u;h(W,O),R.send(W.buffer),this.channelClient=new T(R,M),this.channelServer=new d(R,O,M)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,O){this.channelServer.registerChannel(R,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=V;function X(F){return{call(R,O,M){return F.then(W=>W.call(R,O,M))},listen(R,O){const M=new v.Relay;return F.then(W=>M.input=W.listen(R,O)),M.event}}}e.getDelayedChannel=X;function ee(F){let R=!1;return{call(O,M,W){return R?F.call(O,M,W):A.timeout(0).then(()=>R=!0).then(()=>F.call(O,M,W))},listen(O,M){if(R)return F.listen(O,M);const W=new v.Relay;return A.timeout(0).then(()=>R=!0).then(()=>W.input=F.listen(O,M)),W.event}}}e.getNextTickChannel=ee;class B{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const O of R.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await v.Event.toPromise(R.onDidAddConnection),await this.route(R)}}e.StaticRouter=B;var Y;(function(F){function R(W,_){const q=W,K=_&&_.disableMarshalling,H=new Map;for(const x in q)M(x)&&H.set(x,v.Event.buffer(q[x],!0));return new class{listen(x,ne){const re=H.get(ne);if(re)return re;throw new Error(`Event not found: ${ne}`)}call(x,ne,re){const se=q[ne];if(typeof se=="function"){if(!K&&Array.isArray(re))for(let le=0;le<re.length;le++)re[le]=i.revive(re[le]);return se.apply(q,re)}throw new Error(`Method not found: ${ne}`)}}}F.fromService=R;function O(W,_){const q=_&&_.disableMarshalling;return new Proxy({},{get(K,H){var x;if(typeof H=="string")return((x=_==null?void 0:_.properties)===null||x===void 0?void 0:x.has(H))?_.properties.get(H):M(H)?W.listen(H):async function(...ne){let re;_&&!y.isUndefinedOrNull(_.context)?re=[_.context,...ne]:re=ne;const se=await W.call(H,re);return q?se:i.revive(se)};throw new Error(`Property not found: ${String(H)}`)}})}F.toService=O;function M(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let R=F.toString();if(R!=="[object Object]")return R}return F}function $(F){return Array.isArray(F)?F.map(U):U(F)}function G(F,R,O,M,W,_,q){q=$(q);const K=Q[W],H=K[M%K.length];let x=[`%c[${F}]%c[${String(R).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(M).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(_)?(x=x.concat(q),x.push(")")):x.push(q),console.log.apply(console,x)}e.logWithColors=G;class N{constructor(R,O){this._outgoingPrefix=R,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,O,M,W,_){this._totalOutgoing+=R,G(this._outgoingPrefix,this._totalOutgoing,R,O,M,W,_)}logIncoming(R,O,M,W,_){this._totalIncoming+=R,G(this._incomingPrefix,this._totalIncoming,R,O,M,W,_)}}e.IPCLogger=N}),define(J[120],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(A,S){this.sender=A,this.onMessage=S}send(A){try{this.sender.send("vscode:message",A.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(J[121],Z([0,1,5,33,20]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(w){this.port=w,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",y=>A.VSBuffer.wrap(y.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class E extends L.IPCClient{constructor(w,y){const i=new S(w);super(i,y);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[84],Z([0,1,5,33,2,20,3,32]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function i(){return y||(y=S.VSBuffer.alloc(0)),y}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,h){if(a===0)return i();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const T=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=a),T}if(this._chunks[0].byteLength>a){const T=this._chunks[0].slice(0,a);return h&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),T}let f=S.VSBuffer.alloc(a),d=0,k=0;for(;a>0;){const T=this._chunks[k];if(T.byteLength>a){const C=T.slice(0,a);f.set(C,d),d+=a,h&&(this._chunks[k]=T.slice(a),this._totalLength-=a),a-=a}else f.set(T,d),d+=T.byteLength,h?(this._chunks.shift(),this._totalLength-=T.byteLength):k++,a-=T.byteLength}return f}}e.ChunkStream=I;var P;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(P||(P={}));var p;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(a,h,f,d){this.type=a,this.id=h,this.ack=f,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends A.Disposable{constructor(a){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5);else{const f=this._state.messageType,d=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(f,d,k,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=S.VSBuffer.alloc(13);h.writeUInt8(a.type,0),h.writeUInt32BE(a.id,1),h.writeUInt32BE(a.ack,5),h.writeUInt32BE(a.data.byteLength,9),this._writeSoon(h,a.data)}_bufferAdd(a,h){const f=this._totalLength===0;return this._data.push(a,h),this._totalLength+=a.byteLength+h.byteLength,f}_bufferTake(){const a=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,h){this._bufferAdd(a,h)&&E.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends A.Disposable{constructor(a){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new g(1,0,0,a))}}e.Protocol=b;class c extends L.IPCClient{constructor(a,h,f=null){super(a,h,f);this.protocol=a}static fromSocket(a,h){return new c(new b(a),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=c;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class l{constructor(a){this.data=a,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],h=0,f=this._first;for(;f;)a[h++]=f.data,f=f.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const h=new l(a);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class t{constructor(){this.lastRuns=[];const a=Date.now();for(let h=0;h<t._HISTORY_LENGTH;h++)this.lastRuns[h]=a-1e3*h;setInterval(()=>{for(let h=t._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const a=Date.now(),h=(1+t._HISTORY_LENGTH)*1e3;let f=0;for(let d=0;d<t._HISTORY_LENGTH;d++)a-this.lastRuns[d]<=h&&f++;return 1-f/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class r{constructor(a,h=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),h&&this._socketReader.acceptChunk(h),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=A.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new g(5,0,0,i());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const h=new g(4,0,0,i());this._socketWriter.write(h),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,h){this._isReconnecting=!0,this._socketDisposables=A.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let h=0,f=a.length;h<f;h++)this._socketWriter.write(a[h]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new g(6,0,0,i())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const h=this._outgoingUnackMsg.toArray();for(let f=0,d=h.length;f<d;f++)this._socketWriter.write(h[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new g(1,h,this._incomingAckId,a);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(a){const h=new g(2,0,0,a);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const a=this._outgoingUnackMsg.peek(),h=Date.now()-a.writtenTime;if(h>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-h,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new g(3,0,this._incomingAckId,i());this._socketWriter.write(a)}}e.PersistentProtocol=r}),define(J[122],Z([0,1,14,5,33,120,2,20]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(i,I){const P=L.Event.fromNodeEventEmitter(v.ipcMain,I,(g,m)=>({event:g,message:m})),p=L.Event.filter(P,({event:g})=>g.sender.id===i);return L.Event.map(p,({message:g})=>g&&n.VSBuffer.wrap(g))}class y extends A.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const I=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:P})=>P);return L.Event.map(I,P=>{const p=P.id,g=y.Clients.get(p);g&&g.dispose();const m=new L.Emitter;y.Clients.set(p,E.toDisposable(()=>m.fire()));const D=w(p,"vscode:message"),b=L.Event.any(L.Event.signal(w(p,"vscode:disconnect")),m.event);return{protocol:new S.Protocol(P,D),onDidClientDisconnect:b}})}}e.Server=y,y.Clients=new Map}),define(J[85],Z([0,1,14,5,27,121]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends S.Client{constructor(y,i){super({addEventListener:(I,P)=>y.addListener(I,P),removeEventListener:(I,P)=>y.removeListener(I,P),postMessage:I=>y.postMessage(I),start:()=>y.start(),close:()=>y.close()},i)}}e.Client=E;async function n(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=A.generateUuid();w.webContents.send("vscode:createMessageChannel",y);const i=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(P,p)=>({nonce:p,port:P.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,P=>P.nonce===y)));return I}e.connect=n}),define(J[86],Z([0,1,2,5,9,13]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var E;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class w extends v.Disposable{constructor(I,P=Object.create(null)){super();this.database=I,this.options=P,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){var P,p;(P=I.changed)===null||P===void 0||P.forEach((g,m)=>this.accept(m,g)),(p=I.deleted)===null||p===void 0||p.forEach(g=>this.accept(g,void 0))}accept(I,P){if(this.state===n.Closed)return;let p=!1;S.isUndefinedOrNull(P)?p=this.cache.delete(I):this.cache.get(I)!==P&&(this.cache.set(I,P),p=!0),p&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,P){const p=this.cache.get(I);return S.isUndefinedOrNull(p)?P:p}getBoolean(I,P){const p=this.get(I);return S.isUndefinedOrNull(p)?P:p==="true"}getNumber(I,P){const p=this.get(I);return S.isUndefinedOrNull(p)?P:parseInt(p,10)}async set(I,P){if(this.state===n.Closed)return;if(S.isUndefinedOrNull(P))return this.delete(I);const p=String(P);if(this.cache.get(I)!==p)return this.cache.set(I,p),this.pendingInserts.set(I,p),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async delete(I){if(!(this.state===n.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{var P;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(P=this.whenFlushedCallbacks.pop())===null||P===void 0||P()})}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((P,p)=>this.items.set(p,P)),I.delete&&I.delete.forEach(P=>this.items.delete(P))}async close(){}}e.InMemoryStorageDatabase=y}),define(J[123],Z([0,1,5,9,36,8,16]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=S.basename(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return v.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(p=>I.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?A.mapToString(I.insert):"0"}), delete(${I.delete?A.setToString(I.delete):"0"})`),this.transaction(i,()=>{const P=I.insert,p=I.delete;if(P&&P.size>0){const g=[];g.push([]);let m=0;P.forEach((D,b)=>{let c=g[m];c.length>n.MAX_HOST_PARAMETERS&&(m++,c=[],g.push(c)),c.push(b,D)}),g.forEach(D=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(D.length/2).fill("(?,?)").join(",")}`,b=>b.run(D),()=>{const b=[];let c=0;return P.forEach((u,l)=>{b.push(l),c+=u.length}),`Keys: ${b.join(", ")} Length: ${c}`})})}if(p&&p.size){const g=[];g.push([]);let m=0;p.forEach(D=>{let b=g[m];b.length>n.MAX_HOST_PARAMETERS&&(m++,b=[],g.push(b)),b.push(D)}),g.forEach(D=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(D.length).fill("?").join(",")})`,b=>b.run(D),()=>{const b=[];return p.forEach(c=>{b.push(c)}),`Keys: ${b.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((P,p)=>{i.db.close(g=>(g&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${g}`),this.path===n.IN_MEMORY_PATH?P():!i.isErroneous&&!i.isInMemory?this.backup().then(P,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),P())):typeof I=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const D=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:I()}).then(()=>D(),b=>(D(),Promise.reject(b)))})).then(P,p):p(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return E.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,P=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),p=i?P.integrity_check:P.quick_check;return I.isErroneous?`${p} (last error: ${I.lastError})`:I.isInMemory?`${p} (in-memory!)`:p}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(P){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${P}`),P.code==="SQLITE_BUSY"&&I)return await L.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(p){}return await this.doConnect(i)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,P)=>{new Promise((p,g)=>{z(["vscode-sqlite3"],p,g)}).then(p=>{const g={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(i,m=>m?g.db?g.db.close(()=>P(m)):P(m):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(g),D=>g.db.close(()=>P(D)))),isInMemory:i===n.IN_MEMORY_PATH};g.db.on("error",m=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&g.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},P)})}exec(i,I){return new Promise((P,p)=>{i.db.exec(I,g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${g}`),p(g)):P())})}get(i,I){return new Promise((P,p)=>{i.db.get(I,(g,m)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${g}`),p(g)):P(m))})}all(i,I){return new Promise((P,p)=>{i.db.all(I,(g,m)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${g}`),p(g)):P(m))})}transaction(i,I){return new Promise((P,p)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${g}`),p(g)):P())})})}prepare(i,I,P,p){const g=i.db.prepare(I),m=D=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${D} (${I}). Details: ${p()}`)};g.on("error",m),P(g),g.finalize(D=>{D&&m(D),g.removeListener("error",m)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class w{constructor(i){i&&typeof i.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(z,e){return z.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,A=L*60,S=A*24,E=S*7,n=S*30,w=S*365;function y(I,P){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return v.localize(0,null,y(new Date().getTime()+p*1e3,!1));if(p<30)return v.localize(1,null);let g;return p<L?(g=p,P?g===1?v.localize(2,null,g):v.localize(3,null,g):g===1?v.localize(4,null,g):v.localize(5,null,g)):p<A?(g=Math.floor(p/L),P?g===1?v.localize(6,null,g):v.localize(7,null,g):g===1?v.localize(8,null,g):v.localize(9,null,g)):p<S?(g=Math.floor(p/A),P?g===1?v.localize(10,null,g):v.localize(11,null,g):g===1?v.localize(12,null,g):v.localize(13,null,g)):p<E?(g=Math.floor(p/S),P?g===1?v.localize(14,null,g):v.localize(15,null,g):g===1?v.localize(16,null,g):v.localize(17,null,g)):p<n?(g=Math.floor(p/E),P?g===1?v.localize(18,null,g):v.localize(19,null,g):g===1?v.localize(20,null,g):v.localize(21,null,g)):p<w?(g=Math.floor(p/n),P?g===1?v.localize(22,null,g):v.localize(23,null,g):g===1?v.localize(24,null,g):v.localize(25,null,g)):(g=Math.floor(p/w),P?g===1?v.localize(26,null,g):v.localize(27,null,g):g===1?v.localize(28,null,g):v.localize(29,null,g))}e.fromNow=y;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[126],Z([12,11]),function(z,e){return z.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,126,13,35]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(y,i){return i&&(y.stack||y.stacktrace)?v.localize(0,null,n(y),E(y.stack)||E(y.stacktrace)):n(y)}function E(y){return Array.isArray(y)?y.join(`
`):y}function n(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?v.localize(1,null,y.message):y.message||v.localize(2,null)}function w(y=null,i=!1){if(!y)return v.localize(3,null);if(Array.isArray(y)){const I=A.coalesce(y),P=w(I[0],i);return I.length>1?v.localize(4,null,P,I.length):P}if(L.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return y.stack?S(y,i):y.message?y.message:v.localize(5,null)}e.toErrorMessage=w}),define(J[127],Z([12,11]),function(z,e){return z.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,w=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=w}toLabel(E,n,w){if(n.length===0)return null;const y=[];for(let i=0,I=n.length;i<I;i++){const P=n[i],p=w(P);if(p===null)return null;y[i]=A(P,p,this.modifierLabels[E])}return y.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function A(S,E,n){if(E===null)return"";const w=[];return S.ctrlKey&&w.push(n.ctrlKey),S.shiftKey&&w.push(n.shiftKey),S.altKey&&w.push(n.altKey),S.metaKey&&w.push(n.metaKey),E!==""&&w.push(E),w.join(n.separator)}}),define(J[129],Z([12,11]),function(z,e){return z.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,16,40,129,32,13,44,29,3,81,10]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(l,o){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};o&&(t.cwd=o);const r=A.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],t);return new Promise(s=>{r.once("error",a=>{s({success:!1,error:a})}),r.once("exit",(a,h)=>{s(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(r=>{A.execFile(t,[l.pid.toString()],{encoding:"utf8",shell:!0},(s,a,h)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function m(l=E.env){return l.comspec||"cmd.exe"}e.getWindowsShell=m;class D{constructor(o,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=o,this.args=t,this.shell=r,this.options=s;else{const a=o;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(E.env).forEach(h=>{a[h]=E.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const t=o.lastIndexOf(v.sep);return t!==-1&&(o=o.substring(t+1)),D.WellKnowCommands[o]?o:"other"}start(o){return i.isWindows&&(this.options&&this.options.cwd&&y.isUNC(this.options.cwd)||!this.options&&y.isUNC(E.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let r,s;const a=new Promise((h,f)=>{r=h,s=f});if(t){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=A.exec(h,this.options,(f,d,k)=>{this.childProcess=null;const T=f;T&&T.killed?s({killed:this.terminateRequested,stdout:d.toString(),stderr:k.toString()}):this.handleExec(r,o,f,d,k)})}else{let h=null;const f=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,r,o,s);const k={terminated:this.terminateRequested};n.isNumber(d)&&(k.cmdCode=d),r(k)};if(this.shell&&i.isWindows){const d=w.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let k=!1,T=!1;const C=[];let V=this.ensureQuotes(this.cmd);C.push(V.value),k=V.quoted,this.args&&this.args.forEach(ee=>{V=this.ensureQuotes(ee),C.push(V.value),T=T&&V.quoted});const X=["/s","/c"];k?T?X.push('"'+C.join(" ")+'"'):C.length>1?X.push('"'+C[0]+'" '+C.slice(1).join(" ")):X.push('"'+C[0]+'"'):X.push(C.join(" ")),h=A.spawn(m(),X,d)}else this.cmd&&(h=A.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(n.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",d=>{this.childProcess=null,s({terminated:this.terminateRequested,error:d})}),h.pid&&(this.childProcess.on("close",f),this.handleSpawn(h,r,o,s,!0)))}return a})}handleClose(o,t,r,s){}ensureQuotes(o){return D.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,g(o,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!i.isWindows)return o(!1);const t=A.spawn(m(),["/s","/c"]);t.on("error",r=>o(!0)),t.on("exit",r=>o(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(o,t,r,s){super(o,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,t,r,s,a){[s,a].forEach((h,f)=>{const d=new I.LineDecoder;d.write(h).forEach(C=>{t({line:C,source:f===0?0:1})});const T=d.end();T&&t({line:T,source:f===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,t,r,s,a){const h=new I.LineDecoder,f=new I.LineDecoder;o.stdout.on("data",d=>{h.write(d).forEach(T=>r({line:T,source:0}))}),o.stderr.on("data",d=>{f.write(d).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=f}handleClose(o,t,r,s){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&r({line:h,source:1})}}e.LineProcess=b;function c(l){let o=[],t=!1;const r=function(s){if(t){o.push(s);return}(!l.send(s,h=>{if(h&&console.error(h),t=!1,o.length>0){const f=o.slice(0);o=[],f.forEach(d=>r(d))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=c;var u;(function(l){async function o(t,r,s){if(v.isAbsolute(t))return t;if(r===void 0&&(r=E.cwd()),v.dirname(t)!=="."||(s===void 0&&n.isString(E.env.PATH)&&(s=E.env.PATH.split(v.delimiter)),s===void 0||s.length===0))return v.join(r,t);async function h(f){return await L.Promises.exists(f)?!(await L.Promises.stat(f)).isDirectory():!1}for(let f of s){let d;if(v.isAbsolute(f)?d=v.join(f,t):d=v.join(r,f,t),await h(d))return d;let k=d+".com";if(await h(k)||(k=d+".exe",await h(k)))return k}return v.join(r,t)}l.findExecutable=o})(u=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(p,g){return p===1?L.isWindows?I():S.getWindowsShell(g):y(p,g)}e.getSystemShell=E;function n(p,g){return p===1?L.isWindows?P(g):S.getWindowsShell(g):y(p,g)}e.getSystemShellSync=n;let w=null;function y(p,g){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!w){let m;if(L.isWindows)m="/bin/bash";else{if(m=g.SHELL,!m)try{m=v.userInfo().shell}catch(D){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}w=m}return w}let i=null;async function I(){return i||(i=(await A.getFirstAvailablePowerShellInstallation()).exePath),i}function P(p){if(i)return i;const g=L.isWindows&&parseFloat(v.release())>=10,m=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${p.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?D:S.getWindowsShell(p)}}),define(J[87],Z([0,1,40,2,9,44,5,68,33,109,25,19,20,3]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends w.ChannelServer{constructor(b){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(u){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",c=>P.VSBuffer.wrap(Buffer.from(c,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=g;class m{constructor(b,c){this.modulePath=b,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new A.Delayer(u),this.child=null,this._client=null}getChannel(b){const c=this;return{call(u,l,o){return c.requestPromise(b,u,l,o)},listen(u,l){return c.requestEvent(b,u,l)}}}requestPromise(b,c,u,l=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(b),t=A.createCancelablePromise(a=>o.call(c,u,a)),r=l.onCancellationRequested(()=>t.cancel()),s=L.toDisposable(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,c,u){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let l;const o=new E.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(b).listen(c,u)(o.fire,o),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env=Object.assign(Object.assign({},S.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(c.env=Object.assign(Object.assign({},c.env),this.options.env)),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),p.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=v.fork(this.modulePath,b,c);const u=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if(y.isRemoteConsoleLog(h)){y.log(h,`IPC Library: ${this.options.serverName}`);return}u.fire(P.VSBuffer.wrap(Buffer.from(h,"base64")))});const o=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=h=>this.child&&this.child.connected&&o.send(h.buffer.toString("base64")),r=u.event,s={send:t,onMessage:r};this._client=new w.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",a),this.activeRequests.forEach(d=>L.dispose(d)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(b){let c=this.channels.get(b);return c||(c=this.client.getChannel(b),this.channels.set(b,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(J[131],Z([12,11]),function(z,e){return z.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(z,e){return z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(z,e){return z.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(z,e){return z.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(z,e){return z.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(z,e){return z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(z,e){return z.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(z,e){return z.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(z,e){return z.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(z,e){return z.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(z,e){return z.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(z,e){return z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(z,e){return z.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(z,e){return z.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(z,e){return z.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(z,e){return z.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(z,e){return z.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(z,e){return z.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(z,e){return z.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(z,e){return z.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(z,e){return z.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(z,e){return z.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class A{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,w,y){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(n,w,y){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=A,A.ChannelName="extensionhostdebugservice";class S extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,w,y){this.channel.call("attach",[n,w,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,w){this.channel.call("terminate",[n,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,w,y){return this.channel.call("openExtensionDevelopmentHostWindow",[n,w||{},y])}}e.ExtensionHostDebugChannelClient=S}),define(J[155],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,w){switch(n){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=v;class L{constructor(E){this.channel=E}click(E,n,w){return this.channel.call("click",[E,n,w])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,w){return this.channel.call("getElementXY",[E,n,w])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}}e.WindowDriverChannelClient=L;class A{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=A}),define(J[156],Z([0,1,8,15,46,125,10,7,32]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(g,m,D){this._args=g,this.paths=m,this.productService=D}get appRoot(){return v.dirname(E.FileAccess.asFileUri("",z).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file(v.join(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return L.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return L.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=S.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=v.join(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file(v.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return L.joinPath(n.URI.file(v.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return L.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return L.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=w.env.VSCODE_PORTABLE;return g?n.URI.file(v.join(g,"argv.json")):L.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return L.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file(v.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return v.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?v.resolve(g):v.normalize(v.join(E.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?v.resolve(g):v.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return v.resolve(g);const m=w.env.VSCODE_EXTENSIONS;if(m)return m;const D=w.env.VSCODE_PORTABLE;return D?v.join(D,"extensions"):L.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(m=>/^[^:/?#]+?:\/\//.test(m)?n.URI.parse(m):n.URI.file(v.normalize(m)))}get extensionDevelopmentKind(){var g;return(g=this.args.extensionDevelopmentKind)===null||g===void 0?void 0:g.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?n.URI.parse(g):n.URI.file(v.normalize(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return L.joinPath(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file(v.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([A.memoize],y.prototype,"appRoot",null),he([A.memoize],y.prototype,"userHome",null),he([A.memoize],y.prototype,"userDataPath",null),he([A.memoize],y.prototype,"appSettingsHome",null),he([A.memoize],y.prototype,"tmpDir",null),he([A.memoize],y.prototype,"userRoamingDataHome",null),he([A.memoize],y.prototype,"settingsResource",null),he([A.memoize],y.prototype,"userDataSyncHome",null),he([A.memoize],y.prototype,"userDataSyncLogResource",null),he([A.memoize],y.prototype,"sync",null),he([A.memoize],y.prototype,"machineSettingsResource",null),he([A.memoize],y.prototype,"globalStorageHome",null),he([A.memoize],y.prototype,"workspaceStorageHome",null),he([A.memoize],y.prototype,"keybindingsResource",null),he([A.memoize],y.prototype,"keyboardLayoutResource",null),he([A.memoize],y.prototype,"argvResource",null),he([A.memoize],y.prototype,"snippetsHome",null),he([A.memoize],y.prototype,"isExtensionDevelopment",null),he([A.memoize],y.prototype,"untitledWorkspacesHome",null),he([A.memoize],y.prototype,"installSourcePath",null),he([A.memoize],y.prototype,"builtinExtensionsPath",null),he([A.memoize],y.prototype,"extensionsPath",null),he([A.memoize],y.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],y.prototype,"extensionDevelopmentKind",null),he([A.memoize],y.prototype,"extensionTestsLocationURI",null),he([A.memoize],y.prototype,"debugExtensionHost",null),he([A.memoize],y.prototype,"serviceMachineIdResource",null),he([A.memoize],y.prototype,"telemetryLogResource",null),he([A.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function i(p,g){return P(p["inspect-extensions"],p["inspect-brk-extensions"],5870,g,p.debugId)}e.parseExtensionHostPort=i;function I(p,g){return P(p["inspect-search"],p["inspect-brk-search"],5876,g)}e.parseSearchPort=I;function P(p,g,m,D,b){const u=Number(g||p)||(D?null:m),l=u?Boolean(!!g):!1;return{port:u,break:l,debugId:b}}}),define(J[88],Z([0,1,238,134,3]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:L.localize(0,null),e:L.localize(1,null),t:L.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:L.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:L.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:L.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:L.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:L.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:L.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:L.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:L.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:L.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:L.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:L.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:L.localize(14,null)},category:{type:"string",cat:"e",description:L.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:L.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:L.localize(19,null)},verbose:{type:"boolean",cat:"t",description:L.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:L.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:L.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:L.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:L.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:L.localize(25,null)},sync:{type:"string",cat:"t",description:L.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:L.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:L.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:L.localize(29,null)},"max-memory":{type:"string",cat:"t",description:L.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:L.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(g,m,D=E){const b={},c=[],u=[];for(let r in m){const s=m[r];s.alias&&(b[r]=s.alias),s.type==="string"||s.type==="string[]"?(c.push(r),s.deprecates&&c.push(s.deprecates)):s.type==="boolean"&&(u.push(r),s.deprecates&&u.push(s.deprecates))}const l=v(g,{string:c,boolean:u,alias:b}),o={},t=l;o._=l._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in m){const s=m[r];s.alias&&delete t[s.alias];let a=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(a||(a=t[s.deprecates]),delete t[s.deprecates]),typeof a!="undefined"&&(s.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):s.type==="string"&&Array.isArray(a)&&(a=a.pop(),D.onMultipleValues(r,a)),o[r]=a),delete t[r]}for(let r in t)D.onUnknownOption(r);return o}e.parseArgs=n;function w(g,m){let D="";return m.args&&(Array.isArray(m.args)?D=` <${m.args.join("> <")}>`:D=` <${m.args}>`),m.alias?`-${m.alias} --${g}${D}`:`--${g}${D}`}function y(g,m){let D=0,b=[];for(const o in g){const t=g[o],r=w(o,t);D=Math.max(D,r.length),b.push([r,t.description])}let c=D+2+1;if(m-c<25)return b.reduce((o,t)=>o.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=m-c-1,l=[];for(const o of b){let t=o[0],r=I(o[1],u),s=i(c-t.length-2);l.push("  "+t+s+r[0]);for(let a=1;a<r.length;a++)l.push(i(c)+r[a])}return l}e.formatOptions=y;function i(g){return" ".repeat(g)}function I(g,m){let D=[];for(;g.length;){let b=g.length<m?g.length:g.lastIndexOf(" ",m),c=g.slice(0,b).trim();g=g.slice(b),D.push(c)}return D}function P(g,m,D,b,c=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${g} ${D}`];l.push(""),l.push(`${L.localize(32,null)}: ${m} [${L.localize(33,null)}][${L.localize(34,null)}...]`),l.push(""),c&&(A.isWindows?l.push(L.localize(35,null,m)):l.push(L.localize(36,null,m)),l.push(""));const o={};for(const t in b){const r=b[t];if(r.description&&r.cat){let s=o[r.cat];s||(o[r.cat]=s={}),s[t]=r}}for(let t in o){const r=t;let s=o[r];s&&(l.push(S[r]),l.push(...y(s,u)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=P;function p(g,m){return`${g||L.localize(37,null)}
${m||L.localize(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(J[157],Z([0,1,88,59,154]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends A.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,w,y){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1],y[2]):super.call(n,w,y)}async openExtensionDevelopmentHostWindow(n,w,y){const i=v.parseArgs(n,v.OPTIONS);i.debugRenderer=y;const I=i.extensionDevelopmentPath;if(!I)return{success:!1};let P;const p=Object.keys(w);for(let u of p){let l=w[u];l===null||(P||(P=Object.create(null)),P[u]=l)}const[g]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:i,userEnv:P});if(!y)return{success:!0};const m=g.win;if(!m)return{success:!0};const D=m.webContents.debugger;let b=D.isAttached()?Infinity:0;const c=L.createServer(u=>{b++==0&&D.attach();let l=!1;const o=s=>{l||u.write(JSON.stringify(s)+"\0")},t=(s,a,h,f)=>o({method:a,params:h,sessionId:f});m.on("close",()=>{D.removeListener("message",t),u.end(),l=!0}),D.addListener("message",t);let r=Buffer.alloc(0);u.on("data",s=>{r=Buffer.concat([r,s]);for(let a=r.indexOf(0);a!==-1;a=r.indexOf(0)){let h;try{const f=r.slice(0,a).toString("utf8");r=r.slice(a+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}D.sendCommand(h.method,h.params,h.sessionId).then(f=>o({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>o({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{l=!0,--b==0&&D.detach()})});return await new Promise(u=>c.listen(0,u)),m.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function z(e,v,L,A){function S(n){const w=E(n),y=[w];return e.isAbsolute(w)||y.unshift(A),e.resolve(...y)}function E(n){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const y=n["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(I,"AppData","Roaming")}break;case"darwin":i=e.join(v.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,L)}return{getUserDataPath:S}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,32]),function(e,v,L,A,S,E){const n=S.dirname(A.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);return z(v,L,w.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=z(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,158,156]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends A.AbstractNativeEnvironmentService{constructor(n,w){super(n,{homeDir:v.homedir(),tmpDir:v.tmpdir(),userDataDir:L.getUserDataPath(n)},w)}}e.NativeEnvironmentService=S}),define(J[161],Z([0,1,30,26,8]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(E){const n=A.join(L.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(w){E&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=S}),define(J[162],Z([0,1,137]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function S(P){return P=P.trim(),P==="*"||L.test(P)}e.isValidVersionStr=S;function E(P){if(!S(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=P.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=E;function n(P){if(!P)return null;let p=P.majorBase,g=P.majorMustEqual,m=P.minorBase,D=P.minorMustEqual,b=P.patchBase,c=P.patchMustEqual;P.hasCaret&&(p===0||(D=!1),c=!1);let u=0;if(P.preRelease){const l=A.exec(P.preRelease);if(l){const[,o,t,r]=l;u=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:p,majorMustEqual:g,minorBase:m,minorMustEqual:D,patchBase:b,patchMustEqual:c,isMinimum:P.hasGreaterEquals,notBefore:u}}e.normalizeVersion=n;function w(P,p,g){let m;typeof P=="string"?m=n(E(P)):m=P;let D;p instanceof Date?D=p.getTime():typeof p=="string"&&(D=new Date(p).getTime());let b;if(typeof g=="string"?b=n(E(g)):b=g,!m||!b)return!1;let c=m.majorBase,u=m.minorBase,l=m.patchBase,o=b.majorBase,t=b.minorBase,r=b.patchBase,s=b.notBefore,a=b.majorMustEqual,h=b.minorMustEqual,f=b.patchMustEqual;return b.isMinimum?c>o?!0:c<o?!1:u>t?!0:u<t||D&&D<s?!1:l>=r:(c===1&&o===0&&(!a||!h||!f)&&(o=1,t=0,r=0,a=!0,h=!1,f=!1),c<o?!1:c>o?!a:u<t?!1:u>t?!h:l<r?!1:l>r?!f:!(D&&D<s))}e.isValidVersion=w;function y(P,p,g,m){return g.isBuiltin||typeof g.main=="undefined"?!0:I(P,p,g.engines.vscode,m)}e.isValidExtensionVersion=y;function i(P,p,g){return P==="*"||I(p,g,P)}e.isEngineValid=i;function I(P,p,g,m=[]){let D=n(E(g));if(!D)return m.push(v.localize(0,null,g)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return m.push(v.localize(1,null,g)),!1}else if(!D.majorMustEqual)return m.push(v.localize(2,null,g)),!1;return w(P,p,D)?!0:(m.push(v.localize(3,null,P,g)),!1)}}),define(J[163],Z([0,1,33,87,2,10]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,y,i,I){super();this.folders=w,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[164],Z([0,1,33,87,2,10]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,y,i,I,P={}){super();this.folders=w,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,40,81,111,10]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(w,y,i,I,P){this.watchedFolder=w,this.eventCallback=i,this.logCallback=I,this.verboseLogging=P,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(p=>A.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=v.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",z).fsPath,w);const y=new L.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];y.write(i).forEach(P=>{const p=P.split("|");if(p.length===2){const g=Number(p[0]),m=p[1];if(g>=0&&g<3){if(this.ignored&&this.ignored.some(D=>D(m))){this.verboseLogging&&this.log(m);return}I.push({type:E.changeTypeMap[g],path:m})}else this.log(p[1])}}),I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(w){this.error("process error: "+w.toString())}onExit(w,y){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${y})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,165,8,23]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,w,y,i){this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=A.rtrim(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(J[69],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(S,E=[],n=!1){this.ctor=S,this.staticArguments=E,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=v;const L=(A,...S)=>new v(A,S);e.createSyncDescriptor=L}),define(J[167],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=v;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let E of this._nodes.values())E.outgoing.size===0&&S.push(E);return S}insertEdge(S,E){const n=this.lookupOrInsertNode(S),w=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),w),w.incoming.set(this._hashFn(S),n)}removeNode(S){const E=this._hashFn(S);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(S){const E=this._hashFn(S);let n=this._nodes.get(E);return n||(n=new v(S),this._nodes.set(E,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[E,n]of this._nodes)S.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,E]of this._nodes){const n=new Set([S]),w=this._findCycle(E,n);if(w)return w}}_findCycle(S,E){for(let[n,w]of S.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const y=this._findCycle(w,E);if(y)return y;E.delete(n)}}}e.Graph=L}),define(J[4],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function w(y){return y[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=w})(v=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function L(n,w,y,i){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:n,index:y,optional:i}):(w[v.DI_DEPENDENCIES]=[{id:n,index:y,optional:i}],w[v.DI_TARGET]=w)}function A(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const w=function(y,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,y,I,!1)};return w.toString=()=>n,v.serviceIds.set(n,w),w}e.createDecorator=A;function S(n){return n}e.refineServiceDecorator=S;function E(n){return function(w,y,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,w,i,!0)}}e.optional=E}),define(J[70],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=v.createDecorator(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L}),define(J[89],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=v.createDecorator("encryptionMainService");class L{constructor(S){this.machineId=S}encryption(){return new Promise((S,E)=>z(["vscode-encrypt"],S,E))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(E){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(E){return S}}}e.EncryptionMainService=L}),define(J[53],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=v.createDecorator("environmentService"),e.INativeEnvironmentService=v.refineServiceDecorator(e.IEnvironmentService)}),define(J[168],Z([0,1,136,4,10]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=S;var E;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var n;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var w;(function(I){I.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=L.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(P,p){super(P);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=L.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=L.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=L.createDecorator("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=L.createDecorator("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=v.createDecorator("extensionUrlTrustService")}),define(J[170],Z([0,1,23,4]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=A;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,P){if(typeof I=="undefined"||I===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof I=="string"||typeof P=="string"){let p=typeof I=="string"?I:I.value,g=typeof P=="string"?P:P.value;return v.equalsIgnoreCase(p,g)}return I._lower===P._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function w(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=L.createDecorator("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,23,170]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(p,g){return p.uuid&&g.uuid?p.uuid===g.uuid:p.id===g.id?!0:v.compareIgnoreCase(p.id,g.id)===0}e.areSameExtensions=A;class S{constructor(g,m){this.version=m,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof S?A(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=S;function E(p,g){return`${p}.${g}`}e.getExtensionId=E;function n(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function w(p,g){return n(E(p,g))}e.getGalleryExtensionId=w;function y(p,g){const m=[],D=b=>{for(const c of m)if(c.some(u=>A(g(u),g(b))))return c;return null};for(const b of p){const c=D(b);c?c.push(b):m.push([b])}return m}e.groupByExtension=y;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function P(p){const g=new Set;for(const m of p)m.malicious&&g.add(m.id.id);return g}e.getMaliciousExtensionsSet=P}),define(J[90],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=v.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=v.createDecorator("externalTerminal")}),define(J[172],Z([0,1,40,8,68,138,16,3,90,10,105]),function(z,e,v,L,A,S,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=S.localize(0,null);class P{async getDefaultTerminalForPlatforms(){const l=await m.getDefaultTerminalLinuxReady();return{windows:p.getDefaultTerminalWindows(),linux:l,osx:"xterm"}}}class p extends P{openTerminal(l,o){return this.spawnTerminal(v,l,A.getWindowsShell(),o)}spawnTerminal(l,o,t,r){const s=o.windowsExec||p.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const a=L.basename(s).toLowerCase();if(a==="cmder"||a==="cmder.exe")return l.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return s.indexOf(" ")>=0&&h.push('""'),h.push(s),(a==="wt"||a==="wt.exe")&&h.push("-d ."),new Promise((f,d)=>{const k=D(process),T=l.spawn(t,h,{cwd:r,env:k});T.on("error",d),T.on("exit",()=>f())})}runInTerminal(l,o,t,r,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:p.getDefaultTerminalWindows();return new Promise((h,f)=>{const d=`"${o} - ${I}"`,k=`""${t.join('" "')}" & pause"`,T=["/c","start",d,"/wait",a,"/c",k],C=Object.assign({},D(process),r);Object.keys(C).filter(ee=>C[ee]===null).forEach(ee=>delete C[ee]);const V={cwd:o,env:C,windowsVerbatimArguments:!0};v.spawn(p.CMD,T,V).on("error",ee=>{f(b(ee))}),h(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class g extends P{openTerminal(l,o){return this.spawnTerminal(v,l,o)}runInTerminal(l,o,t,r,s){const a=s.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((h,f)=>{if(a===w.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const d=a===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[y.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,z).fsPath,"-t",l||I,"-w",o];for(let X of t)T.push("-a"),T.push(X);if(r)for(let X in r){const ee=r[X];ee===null?(T.push("-u"),T.push(X)):(T.push("-e"),T.push(`${X}=${ee}`))}let C="";const V=v.spawn(g.OSASCRIPT,T);V.on("error",X=>{f(b(X))}),V.stderr.on("data",X=>{C+=X.toString()}),V.on("exit",X=>{if(X===0)h(void 0);else if(C){const ee=C.split(`
`,1);f(new Error(ee[0]))}else f(new Error(S.localize(1,null,d,X)))})}else f(new Error(S.localize(2,null,a)))})}spawnTerminal(l,o,t){const r=o.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{const h=["-a",r];t&&h.push(t);const f=l.spawn("/usr/bin/open",h);f.on("error",a),f.on("exit",()=>s())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class m extends P{openTerminal(l,o){return this.spawnTerminal(v,l,o)}runInTerminal(l,o,t,r,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,f)=>{let d=[];a.then(k=>{k.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const T=`${c(t)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;d.push(`''${T}''`);const C=Object.assign({},process.env,r);Object.keys(C).filter(B=>C[B]===null).forEach(B=>delete C[B]);const V={cwd:o,env:C};let X="";const ee=v.spawn(k,d,V);ee.on("error",B=>{f(b(B))}),ee.stderr.on("data",B=>{X+=B.toString()}),ee.on("exit",B=>{if(B===0)h(void 0);else if(X){const Y=X.split(`
`,1);f(new Error(Y[0]))}else f(new Error(S.localize(4,null,k,B)))})})})}static async getDefaultTerminalLinuxReady(){return m._DEFAULT_TERMINAL_LINUX_READY||(m._DEFAULT_TERMINAL_LINUX_READY=new Promise(async l=>{n.isLinux?await E.Promises.exists("/etc/debian_version")?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm"):l("xterm")})),m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,o,t){const r=o.linuxExec?Promise.resolve(o.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{r.then(h=>{const f=D(process),d=l.spawn(h,[],{cwd:t,env:f});d.on("error",a),d.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=S.localize(3,null);function D(u){const l=u.env;return i.sanitizeProcessEnvironment(l),l}function b(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(S.localize(5,null,u.path)):u}function c(u){let l="";for(let o of u)o.indexOf(" ")>=0?l+='"'+o+'"':l+=o,l+=" ";return l}}),define(J[21],Z([0,1,140,8,7,4,23,13,36]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=S.createDecorator("fileService");function y(U){return U.create===!0}e.isFileOpenForWriteOptions=y;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var P;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function g(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=g;function m(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function D(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor($,G){super($);this.code=G}}e.FileSystemProviderError=c;function u(U,$){const G=new c(U.toString(),$);return o(G,$),G}e.createFileSystemProviderError=u;function l(U){return U||u(v.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=l;function o(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=o;function t(U){if(!U)return b.Unknown;if(U instanceof c)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return b.Unknown;switch($[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof k)return U.fileOperationResult;switch(t(U)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor($,G,N){this.resource=$,this.operation=G,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var h;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class f{constructor($,G){this.changes=$,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const N of $)switch(N.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>G)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>G)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>G)),this.deleted.set(N.resource,N);break}}contains($,...G){return this.doContains($,{includeChildren:!1},...G)}affects($,...G){return this.doContains($,{includeChildren:!0},...G)}doContains($,G,...N){var F,R,O,M,W,_;if(!$)return!1;const q=N.length>0;return!!((!q||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get($))||G.includeChildren&&((R=this.added)===null||R===void 0?void 0:R.findSuperstr($)))||(!q||N.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get($))||G.includeChildren&&((M=this.updated)===null||M===void 0?void 0:M.findSuperstr($)))||(!q||N.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr($))||G.includeChildren&&((_=this.deleted)===null||_===void 0?void 0:_.findSuperstr($))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function d(U,$,G){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),G?E.startsWithIgnoreCase(U,$):U.indexOf($)===0)}e.isParent=d;class k extends Error{constructor($,G,N){super($);this.fileOperationResult=G,this.options=N}}e.FileOperationError=k;class T extends k{constructor($,G,N){super($,2,N);this.stat=G}}e.NotModifiedSinceFileOperationError=T;var C;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(C=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=X;async function ee(U,$){if(!$.canHandleResource(A.URI.from({scheme:U.scheme})))return new Promise(G=>{const N=$.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===U.scheme&&F.added&&(N.dispose(),G())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize($){return n.isNumber($)||($=0),$<B.KB?v.localize(1,null,$.toFixed(0)):$<B.MB?v.localize(2,null,($/B.KB).toFixed(2)):$<B.GB?v.localize(3,null,($/B.MB).toFixed(2)):$<B.TB?v.localize(4,null,($/B.GB).toFixed(2)):v.localize(5,null,($/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Y;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function Q(U){return{maxFileSize:U===0?300*B.MB:16*B.GB,maxHeapSize:U===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,239,135,21,88]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(P,p){const g={onUnknownOption:D=>{console.warn(L.localize(0,null,D))},onMultipleValues:(D,b)=>{console.warn(L.localize(1,null,D,b))}},m=S.parseArgs(P,S.OPTIONS,p?g:void 0);return m.goto&&m._.forEach(D=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),L.localize(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(P){const p=P.findIndex(g=>!/^-/.test(g));if(p>-1)return[...P.slice(0,p),...P.slice(p+1)]}function w(P){let[,...p]=P;process.env.VSCODE_DEV&&(p=n(p)||[]);const g=!I(process.env);return E(p,g)}e.parseMainProcessArgv=w;function y(P){const[,,...p]=P;return E(p,!0)}e.parseCLIProcessArgv=y;function i(P,...p){const g=P.indexOf("--");return g===-1?P.push(...p):P.splice(g,0,...p),P}e.addArg=i;function I(P){return P.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(J[91],Z([0,1,159,40,27,3,54,67,130]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(P,p,g){return p["force-disable-user-env"]?(P.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(P.trace("resolveShellEnv(): skipped (Windows)"),{}):E.isLaunchedFromCli(g)&&!p["force-user-env"]?(P.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(E.isLaunchedFromCli(g)?P.trace("resolveShellEnv(): running (--force-user-env)"):P.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=I(P)),i)}e.resolveShellEnv=y;let i;async function I(P){const p=new Promise(async(g,m)=>{const D=process.env.ELECTRON_RUN_AS_NODE;P.trace("getUnixShellEnvironment#runAsNode",D);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;P.trace("getUnixShellEnvironment#noAttach",b);const c=A.generateUuid().replace(/-/g,"").substr(0,12),u=new RegExp(c+"(.*)"+c),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});P.trace("getUnixShellEnvironment#env",l);const o=await w.getSystemShell(S.OS,l);P.trace("getUnixShellEnvironment#shell",o);const t=v.basename(o);let r,s;/^pwsh(-preview)?$/.test(t)?(r=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,s=["-Login","-Command"]):(r=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,s=["-ilc"]),P.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),r);const a=L.spawn(o,[...s,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});a.on("error",d=>{P.error("getUnixShellEnvironment#errorChildProcess",n.toErrorMessage(d)),g({})});const h=[];a.stdout.on("data",d=>h.push(d));const f=[];a.stderr.on("data",d=>f.push(d)),a.on("close",(d,k)=>{const T=Buffer.concat(h).toString("utf8");P.trace("getUnixShellEnvironment#raw",T);const C=Buffer.concat(f).toString("utf8");if(C.trim()&&P.trace("getUnixShellEnvironment#stderr",C),d||k)return m(new Error(`Failed to get environment (code ${d}, signal ${k})`));const V=u.exec(T),X=V?V[1]:"{}";try{const ee=JSON.parse(X);D?ee.ELECTRON_RUN_AS_NODE=D:delete ee.ELECTRON_RUN_AS_NODE,b?ee.ELECTRON_NO_ATTACH_CONSOLE=b:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,P.trace("getUnixShellEnvironment#result",ee),g(ee)}catch(ee){P.error("getUnixShellEnvironment#errorCaught",n.toErrorMessage(ee)),m(ee)}})});try{return await p}catch(g){return P.error("getUnixShellEnvironment#error",n.toErrorMessage(g)),{}}}}),define(J[92],Z([0,1,7,21,3]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(w){return w.map(y=>({type:y.type,resource:v.URI.file(y.path)}))}e.toFileChanges=S;function E(w){const y=new n;for(const i of w)y.processEvent(i);return y.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const i=this.mapPathToChange.get(y.path);if(i){const I=i.type,P=y.type;I===1&&P===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(i),1)):I===2&&P===1?i.type=0:I===1&&P===0||(i.type=P)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],i=[];return this.normalized.filter(I=>I.type!==2?(y.push(I),!1):!0).sort((I,P)=>I.path.length-P.path.length).filter(I=>i.some(P=>L.isParent(I.path,P,!A.isLinux))?!1:(i.push(I.path),!0)).concat(y)}}}),define(J[173],Z([0,1,92,2,16,82,117,9,8]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends L.Disposable{constructor(I,P,p,g){super();this.path=I,this.onDidFilesChange=P,this.onLogMessage=p,this.verboseLogging=g,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:P}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(P)try{p=await S.realpath(p)}catch(g){if(this.onError(g),P.dangling)return}I.isDirectory()?this._register(E.watchFolder(p,(g,m)=>{this.onFileChange({type:g==="changed"?0:g==="added"?1:2,path:w.join(this.path,w.basename(m))})},g=>this.onError(g))):this._register(E.watchFile(p,g=>{this.onFileChange({type:g==="changed"?0:2,path:this.path})},g=>this.onError(g)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const P=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=v.normalizeFileChanges(P);this.verboseLogging&&p.forEach(g=>{this.onVerbose(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`)}),p.length>0&&this.onDidFilesChange(p)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(J[71],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...A){this._entries=new Map;for(let[S,E]of A)this.set(S,E)}set(A,S){const E=this._entries.get(A);return this._entries.set(A,S),E}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=v}),define(J[174],Z([0,1,19,167,69,4,71,9]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class y extends Error{constructor(g){var m;super("cyclic dependency between services");this.message=(m=g.findCycleSlow())!==null&&m!==void 0?m:`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class i{constructor(g=new E.ServiceCollection,m=!1,D){this._activeInstantiations=new Set,this._services=g,this._strict=m,this._parent=D,this._services.set(S.IInstantiationService,this)}createChild(g){return new i(g,this._strict,this)}invokeFunction(g,...m){let D=P.traceInvocation(g),b=!1;try{return g({get:(u,l)=>{if(b)throw v.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(u,D);if(!o&&l!==S.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return o}},...m)}finally{b=!0,D.stop()}}createInstance(g,...m){let D,b;return g instanceof A.SyncDescriptor?(D=P.traceCreation(g.ctor),b=this._createInstance(g.ctor,g.staticArguments.concat(m),D)):(D=P.traceCreation(g),b=this._createInstance(g,m,D)),D.stop(),b}_createInstance(g,m=[],D){let b=S._util.getServiceDependencies(g).sort((l,o)=>l.index-o.index),c=[];for(const l of b){let o=this._getOrCreateServiceInstance(l.id,D);if(!o&&this._strict&&!l.optional)throw new Error(`[createInstance] ${g.name} depends on UNKNOWN service ${l.id}.`);c.push(o)}let u=b.length>0?b[0].index:m.length;if(m.length!==u){console.warn(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${m.length} static arguments`);let l=u-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,u)}return new g(...[...m,...c])}_setServiceInstance(g,m){if(this._services.get(g)instanceof A.SyncDescriptor)this._services.set(g,m);else if(this._parent)this._parent._setServiceInstance(g,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let m=this._services.get(g);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):m}_getOrCreateServiceInstance(g,m){let D=this._getServiceInstanceOrDescriptor(g);return D instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,D,m.branch(g,!0)):(m.branch(g,!1),D)}_safeCreateAndCacheServiceInstance(g,m,D){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,m,D)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,m,D){const b=new L.Graph(l=>l.id.toString());let c=0;const u=[{id:g,desc:m,_trace:D}];for(;u.length;){const l=u.pop();if(b.lookupOrInsertNode(l),c++>1e3)throw new y(b);for(let o of S._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const r={id:o.id,desc:t,_trace:l._trace.branch(o.id,!0)};b.insertEdge(l,r),u.push(r)}}}for(;;){const l=b.roots();if(l.length===0){if(!b.isEmpty())throw new y(b);break}for(const{data:o}of l){if(this._getServiceInstanceOrDescriptor(o.id)instanceof A.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}b.removeNode(o)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,m,D=[],b,c){if(this._services.get(g)instanceof A.SyncDescriptor)return this._createServiceInstance(m,D,b,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,m,D,b,c);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(g,m=[],D,b){if(D){const c=new n.IdleValue(()=>this._createInstance(g,m,b));return new Proxy(Object.create(null),{get(u,l){if(l in u)return u[l];let o=c.value,t=o[l];return typeof t!="function"||(t=t.bind(o),u[l]=t),t},set(u,l,o){return c.value[l]=o,!0}})}else return this._createInstance(g,m,b)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class P{constructor(g,m){this.type=g,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return w?new P(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):P._None}static traceCreation(g){return w?new P(0,g.name):P._None}branch(g,m){let D=new P(2,g.toString());return this._dep.push([g,m,D]),D}stop(){let g=Date.now()-this._start;P._totals+=g;let m=!1;function D(c,u){let l=[],o=new Array(c+1).join("	");for(const[t,r,s]of u._dep)if(r&&s){m=!0,l.push(`${o}CREATES -> ${t}`);let a=D(c+1,s);a&&l.push(a)}else l.push(`${o}uses -> ${t}`);return l.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(g>2||m)&&console.log(b.join(`
`))}}P._None=new class extends P{constructor(){super(-1,null)}stop(){}branch(){return this}},P._totals=0}),define(J[175],Z([0,1,19,128,57]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends A.ResolvedKeybinding{constructor(n,w){super();if(w.length===0)throw v.illegalArgument("parts");this._os=n,this._parts=w}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new A.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(J[176],Z([0,1,57,175]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class A extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return A.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=A}),define(J[177],Z([0,1,9]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(A,S){if(A.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let w of A){if(w===!0)return Promise.resolve(!0);v.isThenable(w)&&E.push(w.then(y=>{y&&(n=!0)},y=>{S(y),n=!0}))}return v.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(J[6],Z([0,1,4,2,3,5,67]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function n(){return new Date().toISOString()}var w;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class y extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class i extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let a=t[s];if(typeof a=="object")try{a=JSON.stringify(a)}catch(h){}r+=(s>0?" ":"")+a}return r}}e.AbstractMessageLogger=i;class I extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...r){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}debug(t,...r){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}info(t,...r){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}warn(t,...r){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...r):console.warn(`[main ${n()}]`,t,...r))}error(t,...r){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}critical(t,...r){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class P extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=P;class p extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:E.toErrorMessage(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class g extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=g;class m extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=m;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?w.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function c(o){if(o.verbose)return w.Trace;if(typeof o.logLevel=="string"){const t=u(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(o){switch(o){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=u;function l(o){switch(o){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=l}),define(J[93],Z([0,1,6]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(S,E){switch(E){case v.LogLevel.Trace:return S.trace;case v.LogLevel.Debug:return S.debug;case v.LogLevel.Info:return S.info;case v.LogLevel.Warning:return S.warn;case v.LogLevel.Error:return S.error;case v.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class A extends v.AbstractLogger{constructor(E=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:w}of this.buffer)L(E,n).apply(E,w);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(v.LogLevel.Trace,E,...n)}debug(E,...n){this._log(v.LogLevel.Debug,E,...n)}info(E,...n){this._log(v.LogLevel.Info,E,...n)}warn(E,...n){this._log(v.LogLevel.Warning,E,...n)}error(E,...n){this._log(v.LogLevel.Error,E,...n)}critical(E,...n){this._log(v.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=A});var te=this&&this.__param||function(z,e){return function(v,L){e(v,L,z)}};define(J[178],Z([0,1,6,21,9,20,15,4,93]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*L.ByteSize.MB;let i=class extends v.AbstractLogger{constructor(p,g,m,D){super();this.name=p,this.resource=g,this.fileService=D,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new A.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=p.stack,this._log(v.LogLevel.Error,this.format(g))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(p,g){this._log(p,this.format(g))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,g){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>y&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(m)),m=""),m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${g}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(m))})}getCurrentTimestamp(){const p=D=>D<10?`0${D}`:D,g=D=>D<10?`00${D}`:D<100?`0${D}`:D,m=new Date;return`${m.getFullYear()}-${p(m.getMonth()+1)}-${p(m.getDate())} ${p(m.getHours())}:${p(m.getMinutes())}:${p(m.getSeconds())}.${g(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,E.joinPath(E.dirname(this.resource),`${E.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(p){let g="";for(let m=0;m<p.length;m++){let D=p[m];if(typeof D=="object")try{D=JSON.stringify(D)}catch(b){}g+=(m>0?" ":"")+D}return g}};i=he([te(3,L.IFileService)],i),e.FileLogger=i;let I=class extends v.AbstractLoggerService{constructor(p,g,m){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=g,this.fileService=m}doCreateLogger(p,g){const m=new w.BufferLogService(g);return L.whenProviderRegistered(p,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(i,E.basename(p),p,m.getLevel())),m}};I=he([te(0,v.ILogService),te(1,n.IInstantiationService),te(2,L.IFileService)],I),e.FileLoggerService=I}),define(J[179],Z([0,1,6,5,7]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(P){this.service=P,this.onDidChangeLogLevel=L.Event.buffer(P.onDidChangeLogLevel,!0)}listen(P,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(P,p,g){switch(p){case"setLevel":return this.service.setLevel(g)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=S;class E{constructor(P){this.channel=P}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(P){E.setLevel(this.channel,P)}static setLevel(P,p){return P.call("setLevel",p)}}e.LogLevelChannelClient=E;class n{constructor(P){this.loggerService=P,this.loggers=new Map}listen(P,p){throw new Error(`Event not found: ${p}`)}async call(P,p,g){switch(p){case"createLogger":this.createLogger(A.URI.revive(g[0]),g[1]);return;case"log":return this.log(A.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${p}`)}createLogger(P,p){this.loggers.set(P.toString(),this.loggerService.createLogger(P,p))}consoleLog(P,p){let g=console.log;switch(P){case v.LogLevel.Error:g=console.error;break;case v.LogLevel.Warning:g=console.warn;break;case v.LogLevel.Info:g=console.info;break}g.call(console,...p)}log(P,p){const g=this.loggers.get(P.toString());if(!g)throw new Error("Create the logger before logging");for(const[m,D]of p)switch(m){case v.LogLevel.Trace:g.trace(D);break;case v.LogLevel.Debug:g.debug(D);break;case v.LogLevel.Info:g.info(D);break;case v.LogLevel.Warning:g.warn(D);break;case v.LogLevel.Error:g.error(D);break;case v.LogLevel.Critical:g.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class w extends v.AbstractLoggerService{constructor(P,p,g){super(P,p);this.channel=g}createConsoleMainLogger(){return new v.AdapterLogger({log:(P,p)=>{this.channel.call("consoleLog",[P,p])}})}doCreateLogger(P,p,g){return new y(this.channel,P,p,g)}}e.LoggerChannelClient=w;class y extends v.AbstractMessageLogger{constructor(P,p,g,m){super(m==null?void 0:m.always);this.channel=P,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[p,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(P,p){const g=[[P,p]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(P){this.channel.call("log",[this.file,P])}}class i extends v.LogService{constructor(P,p){super(p);this.parent=P,this._register(P.onDidChangeLogLevel(g=>p.setLevel(g)))}setLevel(P){super.setLevel(P),this.parent.setLevel(P)}}e.FollowerLogService=i}),define(J[94],Z([0,1,6,21]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(w,y,i,I){try{const P=await new Promise((p,g)=>{z(["spdlog"],p,g)});return P.setFlushOn(v.LogLevel.Trace),P.createAsyncRotatingLogger(w,y,i,I)}catch(P){console.error(P)}return null}function S(w,y,i,I){const P=z.__$__nodeRequire("spdlog");return P.setFlushOn(v.LogLevel.Trace),P.createRotatingLogger(w,y,i,I)}e.createRotatingLogger=S;function E(w,y,i){switch(y){case v.LogLevel.Trace:w.trace(i);break;case v.LogLevel.Debug:w.debug(i);break;case v.LogLevel.Info:w.info(i);break;case v.LogLevel.Warning:w.warn(i);break;case v.LogLevel.Error:w.error(i);break;case v.LogLevel.Critical:w.critical(i);break;default:throw new Error("Invalid log level")}}class n extends v.AbstractMessageLogger{constructor(y,i,I,P){super();this.name=y,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(P),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const y=this.rotating?6:1,i=30/y*L.ByteSize.MB;return A(this.name,this.filepath,i,y).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:P,message:p}of this.buffer)E(this._logger,P,p);this.buffer=[]}})}log(y,i){this._logger?E(this._logger,y,i):this.getLevel()<=y&&this.buffer.push({level:y,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[180],Z([0,1,6,15,10,178,94,21,27]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends v.AbstractLoggerService{constructor(I,P){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=P}doCreateLogger(I,P,p){var g;if(I.scheme===A.Schemas.file){const m=new E.SpdLogLogger((p==null?void 0:p.name)||w.generateUuid(),I.fsPath,!(p==null?void 0:p.donotRotate),P);return(p==null?void 0:p.donotUseFormatters)&&m.clearFormatters(),m}else return new S.FileLogger((g=p==null?void 0:p.name)!==null&&g!==void 0?g:L.basename(I),I,P,this.fileService)}};y=he([te(0,v.ILogService),te(1,n.IFileService)],y),e.LoggerService=y}),define(J[181],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function A(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=A;function S(E){return!v(E)&&!L(E)&&!A(E)}e.isMenubarMenuItemAction=S}),define(J[47],Z([0,1,10,3,32,15]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(z==null?void 0:z.__$__nodeRequire)=="function"){const n=S.dirname(v.FileAccess.asFileUri("",z));E=z.__$__nodeRequire(S.joinPath(n,"product.json").fsPath);const w=z.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:w.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.58.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[95],Z([0,1,141,20,21,19,47]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,P,p,g,m,D){let b;try{await w(I,P,p,g,m,D)}catch(c){b=c}finally{b&&m.errorTransformer&&(b=m.errorTransformer(b)),typeof b!="undefined"&&p.error(b),p.end()}}e.readFileIntoStream=n;async function w(I,P,p,g,m,D){y(D);const b=await I.open(P,{create:!1});try{y(D);let c=0,u=0,l=m&&typeof m.length=="number"?m.length:void 0,o=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),t=m&&typeof m.position=="number"?m.position:0,r=0;do u=await I.read(b,t,o.buffer,r,o.byteLength-r),t+=u,r+=u,c+=u,typeof l=="number"&&(l-=u),r===o.byteLength&&(await p.write(g(o)),o=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),r=0);while(u>0&&(typeof l!="number"||l>0)&&y(D)&&i(c,m));if(r>0){let s=r;typeof l=="number"&&(s=Math.min(r,l)),p.write(g(o.slice(0,s)))}}catch(c){throw A.ensureFileSystemProviderError(c)}finally{await I.close(b)}}function y(I){if(I.isCancellationRequested)throw S.canceled();return!0}function i(I,P){if(P==null?void 0:P.limits){if(typeof P.limits.memory=="number"&&I>P.limits.memory)throw A.createFileSystemProviderError(v.localize(0,null,E.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&I>P.limits.size)throw A.createFileSystemProviderError(v.localize(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[182],Z([0,1,139,72,2,21,5,15,36,35,6,20,64,9,25,10,95,63]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends A.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(l,o){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);L.mark(`code/registerFilesystem/${l}`),this.provider.set(l,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:o});const t=new A.DisposableStore;return t.add(o.onDidChangeFile(r=>this._onDidFilesChange.fire(new S.FileChangesEvent(r,!this.isPathCaseSensitive(o))))),t.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:l}))),typeof o.onDidErrorOccur=="function"&&t.add(o.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),A.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:o}),this.provider.delete(l),A.dispose(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){o.push(t)}}),!this.provider.has(l)&&await p.Promises.settled(o)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,o){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return b.Iterable.map(this.provider,([l,o])=>({scheme:l,capabilities:o.capabilities}))}async withProvider(l){if(!n.isAbsolutePath(l))throw new S.FileOperationError(v.localize(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const o=this.provider.get(l.scheme);if(!o){const t=new Error;throw t.name="ENOPRO",t.message=v.localize(1,null,l.toString()),t}return o}async withReadProvider(l){const o=await this.withProvider(l);if(S.hasOpenReadWriteCloseCapability(o)||S.hasReadWriteCapability(o)||S.hasFileReadStreamCapability(o))return o;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const o=await this.withProvider(l);if(S.hasOpenReadWriteCloseCapability(o)||S.hasReadWriteCapability(o))return o;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,o){try{return await this.doResolveFile(l,o)}catch(t){throw S.toFileSystemProviderErrorCode(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError(v.localize(2,null,this.resourceForError(l)),1):S.ensureFileSystemProviderError(t)}}async doResolveFile(l,o){const t=await this.withProvider(l),r=this.isPathCaseSensitive(t),s=o==null?void 0:o.resolveTo,a=o==null?void 0:o.resolveSingleChildDescendants,h=o==null?void 0:o.resolveMetadata,f=await t.stat(l);let d;return this.toFileStat(t,l,f,void 0,!!h,(k,T)=>(d||(d=w.TernarySearchTree.forUris(()=>!r),d.set(l,!0),y.isNonEmptyArray(s)&&s.forEach(C=>d.set(C,!0))),Boolean(d.findSuperstr(k.resource)||d.get(k.resource))?!0:k.isDirectory&&a?T===1:!1))}async toFileStat(l,o,t,r,s,a){var h;const{providerExtUri:f}=this.getExtUri(l),d={resource:o,name:f.basename(o),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((h=t.permissions)!==null&&h!==void 0?h:0)&S.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:S.etag({mtime:t.mtime,size:t.size})};if(d.isDirectory&&a(d,r)){try{const k=await l.readdir(o),T=await p.Promises.settled(k.map(async([C,V])=>{try{const X=f.joinPath(o,C),ee=s?await l.stat(X):{type:V};return await this.toFileStat(l,X,ee,k.length,s,a)}catch(X){return this.logService.trace(X),null}}));d.children=y.coalesce(T)}catch(k){this.logService.trace(k),d.children=[]}return d}return d}async resolveAll(l){return p.Promises.settled(l.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const o=await this.withProvider(l);try{return!!await o.stat(l)}catch(t){return!1}}async canCreateFile(l,o){try{await this.doValidateCreateFile(l,o)}catch(t){return t}return!0}async doValidateCreateFile(l,o){if(!(o==null?void 0:o.overwrite)&&await this.exists(l))throw new S.FileOperationError(v.localize(3,null,this.resourceForError(l)),3,o)}async createFile(l,o=I.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const r=await this.writeFile(l,o);return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,r)),r}async writeFile(l,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,l,t)||await this.mkdirp(r,s.dirname(l));let h;if(S.hasReadWriteCapability(r)&&!(o instanceof I.VSBuffer))if(P.isReadableStream(o)){const f=await P.peekStream(o,3);f.ended?h=I.VSBuffer.concat(f.buffer):h=f}else h=P.peekReadable(o,f=>I.VSBuffer.concat(f),3);else h=o;!S.hasOpenReadWriteCloseCapability(r)||S.hasReadWriteCapability(r)&&h instanceof I.VSBuffer?await this.doWriteUnbuffered(r,l,t,h):await this.doWriteBuffered(r,l,t,h instanceof I.VSBuffer?I.bufferToReadable(h):h)}catch(a){throw new S.FileOperationError(v.localize(4,null,this.resourceForError(l),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,o,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error(v.localize(5,null,this.resourceForError(o)));let s;try{s=await l.stat(o)}catch(a){return}if((s.type&S.FileType.Directory)!=0)throw new S.FileOperationError(v.localize(6,null,this.resourceForError(o)),0,t);if(this.throwIfFileIsReadonly(o,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==S.etag({mtime:t.mtime,size:s.size}))throw new S.FileOperationError(v.localize(7,null),3,t);return s}async readFile(l,o){const t=await this.withReadProvider(l);return(o==null?void 0:o.atomic)?this.doReadFileAtomic(t,l,o):this.doReadFile(t,l,o)}async doReadFileAtomic(l,o,t){return new Promise((r,s)=>{this.writeQueue.queueFor(o,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,o,t);r(a)}catch(a){s(a)}})})}async doReadFile(l,o,t){const r=await this.doReadFileStream(l,o,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await I.streamToBuffer(r.value)})}async readFileStream(l,o){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,o)}async doReadFileStream(l,o,t){const r=new g.CancellationTokenSource,s=this.validateReadFile(o,t).then(h=>h,h=>{throw r.cancel(),h});let a;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await s,!(S.hasOpenReadWriteCloseCapability(l)||S.hasFileReadStreamCapability(l))||S.hasReadWriteCapability(l)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(l,o,t):S.hasFileReadStreamCapability(l)?a=this.readFileStreamed(l,o,r.token,t):a=this.readFileBuffered(l,o,r.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:a})}catch(h){a&&await P.consumeStream(a);const f=v.localize(8,null,this.resourceForError(o),S.ensureFileSystemProviderError(h).toString());throw h instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(f,h.stat,t):new S.FileOperationError(f,S.toFileOperationResult(h),t)}}readFileStreamed(l,o,t,r=Object.create(null)){const s=l.readFileStream(o,r,t);return P.transform(s,{data:a=>a instanceof I.VSBuffer?a:I.VSBuffer.wrap(a),error:a=>new S.FileOperationError(v.localize(9,null,this.resourceForError(o),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),r)},a=>I.VSBuffer.concat(a))}readFileBuffered(l,o,t,r=Object.create(null)){const s=I.newWriteableBufferStream();return D.readFileIntoStream(l,o,s,a=>a,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new S.FileOperationError(v.localize(10,null,this.resourceForError(o),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),r)}),t),s}readFileUnbuffered(l,o,t){const r=P.newWriteableStream(s=>I.VSBuffer.concat(s));return(async()=>{try{let s=await l.readFile(o);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(o,s.byteLength,t),r.end(I.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(l,o){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError(v.localize(11,null,this.resourceForError(l)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==S.ETAG_DISABLED&&o.etag===t.etag)throw new S.NotModifiedSinceFileOperationError(v.localize(12,null),t,o);return this.validateReadFileLimits(l,t.size,o),t}validateReadFileLimits(l,o,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&o>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError(v.localize(13,null,this.resourceForError(l)),r)}}async canMove(l,o,t){return this.doCanMoveCopy(l,o,"move",t)}async canCopy(l,o,t){return this.doCanMoveCopy(l,o,"copy",t)}async doCanMoveCopy(l,o,t,r){if(l.toString()!==o.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(s,l,a,o,t,r)}catch(s){return s}return!0}async move(l,o,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(r,l,s,o,"move",!!t),h=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,a==="move"?2:3,h)),h}async copy(l,o,t){const r=await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),a=await this.doMoveCopy(r,l,s,o,"copy",!!t),h=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,a==="copy"?3:2,h)),h}async doMoveCopy(l,o,t,r,s,a){if(o.toString()===r.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(l,o,t,r,s,a);if(h&&!f&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(l===t&&S.hasFileFolderCopyCapability(l))await l.copy(o,r,{overwrite:a});else{const d=await this.resolve(o);d.isDirectory?await this.doCopyFolder(l,d,t,r):await this.doCopyFile(l,o,t,r)}return s}else return l===t?(await l.rename(o,r,{overwrite:a}),s):(await this.doMoveCopy(l,o,t,r,"copy",a),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(l,o,t,r){if(S.hasOpenReadWriteCloseCapability(l)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(l,o,t,r);if(S.hasOpenReadWriteCloseCapability(l)&&S.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(l,o,t,r);if(S.hasReadWriteCapability(l)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(l,o,t,r);if(S.hasReadWriteCapability(l)&&S.hasReadWriteCapability(t))return this.doPipeUnbuffered(l,o,t,r)}async doCopyFolder(l,o,t,r){await t.mkdir(r),Array.isArray(o.children)&&await p.Promises.settled(o.children.map(async s=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(l,await this.resolve(s.resource),t,a):this.doCopyFile(l,s.resource,t,a)}))}async doValidateMoveCopy(l,o,t,r,s,a){let h=!1;if(l===t){const{providerExtUri:d,isPathCaseSensitive:k}=this.getExtUri(l);if(k||(h=d.isEqual(o,r)),h&&s==="copy")throw new Error(v.localize(14,null,this.resourceForError(o),this.resourceForError(r)));if(!h&&d.isEqualOrParent(r,o))throw new Error(v.localize(15,null,this.resourceForError(o),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!h){if(!a)throw new S.FileOperationError(v.localize(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(l===t){const{providerExtUri:d}=this.getExtUri(l);if(d.isEqualOrParent(o,r))throw new Error(v.localize(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(l){const o=this.isPathCaseSensitive(l);return{providerExtUri:o?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(o,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,t)),t}async mkdirp(l,o){const t=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(o,r.dirname(o));)try{if(((await l.stat(o)).type&S.FileType.Directory)==0)throw new Error(v.localize(18,null,this.resourceForError(o)));break}catch(s){if(S.toFileSystemProviderErrorCode(s)!==S.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(o)),o=r.dirname(o)}for(let s=t.length-1;s>=0;s--){o=r.joinPath(o,t[s]);try{await l.mkdir(o)}catch(a){if(S.toFileSystemProviderErrorCode(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(l,o){try{await this.doValidateDelete(l,o)}catch(t){return t}return!0}async doValidateDelete(l,o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(o==null?void 0:o.useTrash)&&!(t.capabilities&4096))throw new Error(v.localize(19,null,this.resourceForError(l)));let s;try{s=await t.stat(l)}catch(h){}if(s)this.throwIfFileIsReadonly(l,s);else throw new S.FileOperationError(v.localize(20,null,this.resourceForError(l)),1);if(!!!(o==null?void 0:o.recursive)){const h=await this.resolve(l);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error(v.localize(21,null,this.resourceForError(l)))}return t}async del(l,o){const t=await this.doValidateDelete(l,o),r=!!(o==null?void 0:o.useTrash),s=!!(o==null?void 0:o.recursive);await t.delete(l,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(l,1))}watch(l,o={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(l,o).then(s=>{t?A.dispose(s):r=()=>A.dispose(s)},s=>this.logService.error(s)),A.toDisposable(()=>r())}async doWatch(l,o){const t=await this.withProvider(l),r=this.toWatchKey(t,l,o),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(l,o)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,A.toDisposable(()=>{s.count--,s.count===0&&(A.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(l,o,t){const{providerExtUri:r}=this.getExtUri(l);return[r.getComparisonKey(o),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>A.dispose(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(l).providerExtUri).queue(async()=>{var s;const a=await l.open(o,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{P.isReadableStream(r)||P.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(l,a,r):await this.doWriteReadableBufferedQueued(l,a,r)}catch(h){throw S.ensureFileSystemProviderError(h)}finally{await l.close(a)}})}async doWriteStreamBufferedQueued(l,o,t){let r=0,s;if(P.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=I.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,o,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(a,h)=>{P.listenStream(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(l,o,f,f.byteLength,r,0)}catch(d){return h(d)}r+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>h(f),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(l,o,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(l,o,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(l,o,t,r,s,a){let h=0;for(;h<r;)h+=await l.write(o,s+h,t.buffer,a+h,r-h)}async doWriteUnbuffered(l,o,t,r){return this.writeQueue.queueFor(o,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,o,t,r))}async doWriteUnbufferedQueued(l,o,t,r){var s;let a;r instanceof I.VSBuffer?a=r:P.isReadableStream(r)?a=await I.streamToBuffer(r):P.isReadableBufferedStream(r)?a=await I.bufferedStreamToBuffer(r):a=I.readableToBuffer(r),await l.writeFile(o,a.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(l,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,o,t,r))}async doPipeBufferedQueued(l,o,t,r){let s,a;try{s=await l.open(o,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const h=I.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,d=0,k=0;do k=await l.read(s,f,h.buffer,d,h.byteLength-d),await this.doWriteBuffer(t,a,h,k,f,d),f+=k,d+=k,d===h.byteLength&&(d=0);while(k>0)}catch(h){throw S.ensureFileSystemProviderError(h)}finally{await p.Promises.settled([typeof s=="number"?l.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(l,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,o,t,r))}async doPipeUnbufferedQueued(l,o,t,r){return t.writeFile(r,await l.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,o,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,o,t,r))}async doPipeUnbufferedToBufferedQueued(l,o,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const a=await l.readFile(o);await this.doWriteBuffer(t,s,I.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw S.ensureFileSystemProviderError(a)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(l,o,t,r){const s=await I.streamToBuffer(this.readFileBuffered(l,o,g.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(l,o){if(l.capabilities&2048)throw new S.FileOperationError(v.localize(22,null,this.resourceForError(o)),6);return l}throwIfFileIsReadonly(l,o){var t;if(((t=o.permissions)!==null&&t!==void 0?t:0)&S.FilePermission.Readonly)throw new S.FileOperationError(v.localize(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===m.Schemas.file?l.fsPath:l.toString(!0)}};c=he([te(0,i.ILogService)],c),e.FileService=c}),define(J[183],Z([0,1,2,21,5,3,16,8,15,29,9,6,142,92,164,166,163,173,64,95,35,20]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends v.Disposable{constructor(s,a){var h;super();this.logService=s,this.options=a,this.BUFFER_SIZE=((h=this.options)===null||h===void 0?void 0:h.bufferSize)||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:a,symbolicLink:h}=await E.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(a,h),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(s){try{const a=await E.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),h=[];return await Promise.all(a.map(async f=>{try{let d;f.isSymbolicLink()?d=(await this.stat(w.joinPath(s,f.name))).type:d=this.toType(f),h.push([f.name,d])}catch(d){this.logService.trace(d)}})),h}catch(a){throw this.toFileSystemProviderError(a)}}toType(s,a){let h;return(a==null?void 0:a.dangling)?h=L.FileType.Unknown:s.isFile()?h=L.FileType.File:s.isDirectory()?h=L.FileType.Directory:h=L.FileType.Unknown,a&&(h|=L.FileType.SymbolicLink),h}async readFile(s){try{const a=this.toFilePath(s);return await E.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(s,a,h){const f=c.newWriteableStream(d=>o.VSBuffer.concat(d.map(k=>o.VSBuffer.wrap(k))).buffer);return u.readFileIntoStream(this,s,f,d=>d.buffer,Object.assign(Object.assign({},a),{bufferSize:this.BUFFER_SIZE}),h),f}async writeFile(s,a,h){let f;try{const d=this.toFilePath(s);if(!h.create||!h.overwrite){if(await E.Promises.exists(d)){if(!h.overwrite)throw L.createFileSystemProviderError(P.localize(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw L.createFileSystemProviderError(P.localize(1,null),L.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(s,{create:!0,unlock:h.unlock}),await this.write(f,0,a,0,a.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(s,d)}finally{typeof f=="number"&&await this.close(f)}}async open(s,a){try{const h=this.toFilePath(s);if(L.isFileOpenForWriteOptions(a)&&a.unlock)try{const{stat:k}=await E.SymlinkSupport.stat(h);k.mode&128||await E.Promises.chmod(h,k.mode|128)}catch(k){this.logService.trace(k)}let f;if(L.isFileOpenForWriteOptions(a)){if(S.isWindows)try{await E.Promises.truncate(h,0),f="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}f||(f="w")}else f="r";const d=await E.Promises.open(h,f);return this.mapHandleToPos.set(d,0),L.isFileOpenForWriteOptions(a)&&this.writeHandles.set(d,s),d}catch(h){throw L.isFileOpenForWriteOptions(a)?await this.toFileSystemProviderWriteError(s,h):this.toFileSystemProviderError(h)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await E.Promises.fdatasync(s)}catch(a){this.canFlush=!1,this.logService.error(a)}return await E.Promises.close(s)}catch(a){throw this.toFileSystemProviderError(a)}}async read(s,a,h,f,d){const k=this.normalizePos(s,a);let T=null;try{const C=await E.Promises.read(s,h,f,d,k);return typeof C=="number"?T=C:T=C.bytesRead,T}catch(C){throw this.toFileSystemProviderError(C)}finally{this.updatePos(s,k,T)}}normalizePos(s,a){return a===this.mapHandleToPos.get(s)?null:a}updatePos(s,a,h){const f=this.mapHandleToPos.get(s);typeof f=="number"&&(typeof a=="number"||(typeof h=="number"?this.mapHandleToPos.set(s,f+h):this.mapHandleToPos.delete(s)))}async write(s,a,h,f,d){return i.retry(()=>this.doWrite(s,a,h,f,d),100,3)}async doWrite(s,a,h,f,d){const k=this.normalizePos(s,a);let T=null;try{const C=await E.Promises.write(s,h,f,d,k);return typeof C=="number"?T=C:T=C.bytesWritten,T}catch(C){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),C)}finally{this.updatePos(s,k,T)}}async mkdir(s){try{await E.Promises.mkdir(this.toFilePath(s))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(s,a){try{const h=this.toFilePath(s);await this.doDelete(h,a)}catch(h){throw this.toFileSystemProviderError(h)}}async doDelete(s,a){a.recursive?await E.Promises.rm(s,E.RimRafMode.MOVE):await E.Promises.unlink(s)}async rename(s,a,h){const f=this.toFilePath(s),d=this.toFilePath(a);if(f!==d)try{await this.validateTargetDeleted(s,a,"move",h.overwrite),await E.Promises.move(f,d)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error(P.localize(2,null,n.basename(f),n.basename(n.dirname(d)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(s,a,h){const f=this.toFilePath(s),d=this.toFilePath(a);if(f!==d)try{await this.validateTargetDeleted(s,a,"copy",h.overwrite),await E.Promises.copy(f,d,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error(P.localize(3,null,n.basename(f),n.basename(n.dirname(d)),k.toString()))),this.toFileSystemProviderError(k)}}async validateTargetDeleted(s,a,h,f){const d=this.toFilePath(s),k=this.toFilePath(a);let T=!1;if(!!(this.capabilities&1024)||(T=y.isEqual(d,k,!0)),T&&h==="copy")throw L.createFileSystemProviderError(P.localize(4,null),L.FileSystemProviderErrorCode.FileExists);if(!T&&await E.Promises.exists(k)){if(!f)throw L.createFileSystemProviderError(P.localize(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(s,a){return a.recursive?this.watchRecursive(s,a.excludes):this.watchNonRecursive(s)}watchRecursive(s,a){const h={path:this.toFilePath(s),excludes:a},f=l.insert(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),v.toDisposable(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,a,h;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let f,d;((a=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||a===void 0?void 0:a.usePolling)?(f=g.FileWatcher,d=(h=this.options)===null||h===void 0?void 0:h.watcher):this.recursiveFoldersToWatch.length===1?S.isWindows?f=m.FileWatcher:f=g.FileWatcher:f=D.FileWatcher,this.recursiveWatcher=new f(this.recursiveFoldersToWatch,k=>this._onDidChangeFile.fire(p.toFileChanges(k)),k=>{k.type==="error"&&this._onDidWatchErrorOccur.fire(k.message),this.logService[k.type](k.message)},this.logService.getLevel()===I.LogLevel.Trace,d),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(s){const a=new b.FileWatcher(this.toFilePath(s),f=>this._onDidChangeFile.fire(p.toFileChanges(f)),f=>{f.type==="error"&&this._onDidWatchErrorOccur.fire(f.message),this.logService[f.type](f.message)},this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return v.combinedDisposable(a,h)}toFilePath(s){return n.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof L.FileSystemProviderError)return s;let a;switch(s.code){case"ENOENT":a=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=L.FileSystemProviderErrorCode.NoPermissions;break;default:a=L.FileSystemProviderErrorCode.Unknown}return L.createFileSystemProviderError(s,a)}async toFileSystemProviderWriteError(s,a){let h=this.toFileSystemProviderError(a);if(s&&h.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await E.SymlinkSupport.stat(this.toFilePath(s));f.mode&128||(h=L.createFileSystemProviderError(a,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return h}dispose(){super.dispose(),v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,v.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[22],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=v.createDecorator("productService")}),define(J[184],Z([0,1,58,6,22]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,w){this.productService=n,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(w);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,i,I]=y;let P=this.trustedExtensionUrlPublicKeys.get(n);if(!P){if(P=this.productService.trustedExtensionUrlPublicKeys[n],!P||P.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...P])}const p=Buffer.from(decodeURIComponent(I),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const g=p.slice(0,6),m=p.readUIntBE(0,6),D=Date.now()-m;if(D<0||D>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const b=p.slice(6),c=v.createVerify("SHA256");c.write(g),c.write(Buffer.from(i)),c.end();for(let u=0;u<P.length;u++){let l=P[u];if(l!==null){if(typeof l=="string")try{l=v.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),P[u]=l}catch(o){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${n}:`,o),P[u]=null;continue}if(c.verify(l,b))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};S=he([te(0,A.IProductService),te(1,L.ILogService)],S),e.ExtensionUrlTrustService=S}),define(J[55],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=v.createDecorator("protocolMainService")}),define(J[185],Z([0,1,2,10,7,53,14,6,36,3,15,27]),function(z,e,v,L,A,S,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let P=class extends v.Disposable{constructor(g,m){super();this.logService=m,this.validRoots=w.TernarySearchTree.forUris(()=>!y.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(A.URI.file(g.appRoot)),this.addValidFileRoot(A.URI.file(g.extensionsPath)),this.addValidFileRoot(g.globalStorageHome),this.addValidFileRoot(g.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:g}=E.session;g.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(m,D)=>this.handleResourceRequest(m,D)),g.protocol.interceptFileProtocol(L.Schemas.file,(m,D)=>this.handleFileRequest(m,D)),this._register(v.toDisposable(()=>{g.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(L.Schemas.file)}))}addValidFileRoot(g){return this.validRoots.get(g)?v.Disposable.None:(this.validRoots.set(g,!0),v.toDisposable(()=>this.validRoots.delete(g)))}handleFileRequest(g,m){const D=A.URI.parse(g.url);return y.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),m({error:-3})):this.validRoots.findSubstr(D)?m({path:D.fsPath}):this.validExtensions.has(i.extname(D))?m({path:D.fsPath}):(this.logService.error(`${L.Schemas.file}: Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),m({error:-3}))}handleResourceRequest(g,m){const D=A.URI.parse(g.url),b=L.FileAccess.asFileUri(D);return this.validRoots.findSubstr(b)?m({path:b.fsPath}):this.validExtensions.has(i.extname(b))?m({path:b.fsPath}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${b.fsPath} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),m({error:-3}))}createIPCObjectUrl(){let g;const m=A.URI.from({scheme:"vscode",path:I.generateUuid()}),D=m.toString(),b=async()=>g;return E.ipcMain.handle(D,b),this.logService.trace(`IPC Object URL: Registered new channel ${D}.`),{resource:m,update:c=>g=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${D}.`),E.ipcMain.removeHandler(D)}}}};P=he([te(0,S.INativeEnvironmentService),te(1,n.ILogService)],P),e.ProtocolMainService=P}),define(J[37],Z([0,1,13,102]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(E,n){L.ok(v.isString(E)),L.ok(v.isObject(n)),L.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new A}),define(J[186],Z([0,1,37,5]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,y){this.schemasById[A(w)]=y,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new S;v.Registry.add(e.Extensions.JSONContribution,E)}),define(J[48],Z([0,1,132,5,37,13,186]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=A.Registry.as(E.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,c=!0){this.registerConfigurations([b],c)}registerConfigurations(b,c=!0){const u=[];b.forEach(l=>{u.push(...this.validateAndRegisterProperties(l,c,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(b){const c=[],u=l=>{if(l.properties)for(const o in l.properties)c.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,l.properties[o]);l.allOf&&l.allOf.forEach(o=>u(o))};for(const l of b){u(l);const o=this.configurationContributors.indexOf(l);o!==-1&&this.configurationContributors.splice(o,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(b){const c=[],u=[];for(const l of b)for(const o in l)if(c.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),l[o]);const t={type:"object",default:this.defaultValues[o],description:v.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(o)),this.configurationProperties[o]=t,this.defaultLanguageConfigurationOverridesNode.properties[o]=t}else{this.defaultValues[o]=l[o];const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(b){const c=[];for(const u of b)for(const l in u)if(c.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const o=this.configurationProperties[l];o&&(this.updatePropertyDefaultValue(l,o),this.updateSchema(l,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const c of b)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,c=!0,u,l=3){var o;l=S.isUndefinedOrNull(b.scope)?l:b.scope;let t=[],r=b.properties;if(r)for(let a in r){if(c&&g(a)){delete r[a];continue}const h=r[a];if(this.updatePropertyDefaultValue(a,h),e.OVERRIDE_PROPERTY_PATTERN.test(a)?h.scope=void 0:(h.scope=S.isUndefinedOrNull(h.scope)?l:h.scope,h.restricted=S.isUndefinedOrNull(h.restricted)?!!((o=u==null?void 0:u.restrictedConfigurations)===null||o===void 0?void 0:o.includes(a)):h.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let s=b.allOf;if(s)for(let a of s)t.push(...this.validateAndRegisterProperties(a,c,u,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const c=u=>{let l=u.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let o=u.allOf;o&&o.forEach(c)};c(b)}updateSchema(b,c){switch(e.allSettings.properties[b]=c,c.scope){case 1:e.applicationSettings.properties[b]=c;break;case 2:e.machineSettings.properties[b]=c;break;case 6:e.machineOverridableSettings.properties[b]=c;break;case 3:e.windowSettings.properties[b]=c;break;case 4:e.resourceSettings.properties[b]=c;break;case 5:e.resourceSettings.properties[b]=c,this.resourceLanguageSettingsSchema.properties[b]=c;break}}removeFromSchema(b,c){switch(delete e.allSettings.properties[b],c.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const c=`[${b}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,u),e.allSettings.properties[c]=u,e.applicationSettings.properties[c]=u,e.machineSettings.properties[c]=u,e.machineOverridableSettings.properties[c]=u,e.windowSettings.properties[c]=u,e.resourceSettings.properties[c]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,c){let u=this.defaultValues[b];S.isUndefined(u)&&(u=c.default),S.isUndefined(u)&&(u=P(c.type)),c.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=I;function P(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=P;const p=new y;A.Registry.add(e.Extensions.Configuration,p);function g(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?v.localize(5,null,D):p.getConfigurationProperties()[D]!==void 0?v.localize(6,null,D):null:v.localize(4,null)}e.validateProperty=g;function m(){const D=[],b=p.getConfigurationProperties();for(const c of Object.keys(b))D.push([c,b[c].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=m}),define(J[17],Z([0,1,44,13,7,37,4,48]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=E.createDecorator("configurationService");function w(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=w;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(r,s){const a=s?r?s.keys.filter(V=>r.keys.indexOf(V)===-1):[...s.keys]:[],h=r?s?r.keys.filter(V=>s.keys.indexOf(V)===-1):[...r.keys]:[],f=[];if(s&&r){for(const V of r.keys)if(s.keys.indexOf(V)!==-1){const X=b(r.contents,V),ee=b(s.contents,V);v.equals(X,ee)||f.push(V)}}const d=[],k=V=>{const X={};for(const ee of V)for(const B of ee.identifiers)X[o(B)]=ee;return X},T=s?k(s.overrides):{},C=r?k(r.overrides):{};if(Object.keys(T).length)for(const V of a){const X=T[V];X&&d.push([n.overrideIdentifierFromKey(V),X.keys])}if(Object.keys(C).length)for(const V of h){const X=C[V];X&&d.push([n.overrideIdentifierFromKey(V),X.keys])}if(Object.keys(T).length&&Object.keys(C).length)for(const V of f){const X=C[V],ee=T[V];if(X&&ee){const B=I({contents:X.contents,keys:X.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});d.push([n.overrideIdentifierFromKey(V),[...B.added,...B.removed,...B.updated]])}}return{added:a,removed:h,updated:f,overrides:d}}e.compare=I;function P(r,s){const a=[];for(const h of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const d in r[h])f[d]=r[h][d];a.push({identifiers:[n.overrideIdentifierFromKey(h).trim()],keys:Object.keys(f),contents:p(f,s)})}return a}e.toOverrides=P;function p(r,s){const a=Object.create(null);for(let h in r)g(a,h,r[h],s);return a}e.toValuesTree=p;function g(r,s,a,h){const f=s.split("."),d=f.pop();let k=r;for(let T=0;T<f.length;T++){let C=f[T],V=k[C];switch(typeof V){case"undefined":V=k[C]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(V)}`);return}k=V}if(typeof k=="object"&&k!==null)try{k[d]=a}catch(T){h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}else h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=g;function m(r,s){const a=s.split(".");D(r,a)}e.removeFromValueTree=m;function D(r,s){const a=s.shift();if(s.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const h=r[a];typeof h=="object"&&!Array.isArray(h)&&(D(h,s),Object.keys(h).length===0&&delete r[a])}}function b(r,s,a){function h(k,T){let C=k;for(const V of T){if(typeof C!="object"||C===null)return;C=C[V]}return C}const f=s.split("."),d=h(r,f);return typeof d=="undefined"?a:d}e.getConfigurationValue=b;function c(r,s,a){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in r?L.isObject(r[h])&&L.isObject(s[h])?c(r[h],s[h],a):a&&(r[h]=s[h]):r[h]=s[h])})}e.merge=c;function u(){const r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function l(){const r=Object.create(null),s=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let a in s){let h=s[a].default;g(r,a,h,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=l;function o(r){return`[${r}]`}e.keyFromOverrideIdentifier=o;function t(r,s,a){const h=r.inspect(s),f=r.inspect(a);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(J[187],Z([0,1,43,36,35,13,44,7,48,17,37,2,5]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?y.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?y.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const a of A.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[a],f=r[a];f&&(typeof h=="object"&&typeof f=="object"?(h=E.deepClone(h),this.mergeContents(h,f)):h=f),s[a]=h}return new p(s,this.keys,this.overrides)}merge(...t){const r=E.deepClone(this.contents),s=E.deepClone(this.overrides),a=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const f of h.overrides){const[d]=s.filter(k=>A.equals(k.identifiers,f.identifiers));d?this.mergeContents(d.contents,f.contents):s.push(E.deepClone(f))}for(const f of h.keys)a.indexOf(f)===-1&&a.push(f)}return new p(r,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&S.isObject(t[s])&&S.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=E.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),y.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&y.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class g extends p{constructor(){const t=y.getDefaultValues(),r=y.getConfigurationKeys(),s=[];for(const a of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[w.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:y.toValuesTree(t[a],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,s)}}e.DefaultConfigurationModel=g;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:a,overrides:h,restricted:f}=this.doParseRaw(t,r);this._configurationModel=new p(s,a,h),this._restrictedConfigurations=f||[]}doParseContent(t){let r={},s=null,a=[],h=[],f=[];function d(T){Array.isArray(a)?a.push(T):s&&(a[s]=T)}let k={onObjectBegin:()=>{let T={};d(T),h.push(a),a=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let T=[];d(T),h.push(a),a=T,s=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:d,onError:(T,C,V)=>{f.push({error:T,offset:C,length:V})}};if(t)try{v.visit(t,k),r=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,s,!0,r);t=a.raw;const h=y.toValuesTree(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),f=Object.keys(t),d=y.toOverrides(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:h,keys:f,overrides:d,restricted:a.restricted}}filter(t,r,s,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const h={},f=[];for(let d in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(d)&&s){const k=this.filter(t[d],r,!1,a);h[d]=k.raw,f.push(...k.restricted)}else{const k=r[d],T=k?typeof k.scope!="undefined"?k.scope:3:void 0;(k==null?void 0:k.restricted)&&f.push(d),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&(a.skipRestricted&&(k==null?void 0:k.restricted)||(h[d]=t[d]))}return{raw:h,restricted:f}}}e.ConfigurationModelParser=m;class D extends I.Disposable{constructor(t,r,s,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,s=new p,a=new p,h=new L.ResourceMap,f=new p,d=new L.ResourceMap,k=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=d,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new p,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const a=this.getConsolidateConfigurationModel(r,s),h=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,d=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),k=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),C=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),V=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,ee=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),B=a.getValue(t),Y=A.distinct(A.flatten(a.overrides.map(Q=>Q.identifiers))).filter(Q=>a.getOverrideValue(t,Q)!==void 0);return{defaultValue:d,userValue:k,userLocalValue:T,userRemoteValue:C,workspaceValue:V,workspaceFolderValue:X,memoryValue:ee,value:B,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:C!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(a=>w.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const h=w.overrideIdentifierFromKey(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),d=t.getKeysForOverrideIdentifier(h),k=[...d.filter(T=>f.indexOf(T)===-1),...f.filter(T=>d.indexOf(T)===-1),...f.filter(T=>!E.equals(this._defaultConfiguration.override(h).getValue(T),t.override(h).getValue(T)))];return[h,k]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:h}=y.compare(this.localUserConfiguration,t),f=[...r,...s,...a];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:a,overrides:h}=y.compare(this.remoteUserConfiguration,t);let f=[...r,...s,...a];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:a,overrides:h}=y.compare(this.workspaceConfiguration,t);let f=[...r,...s,...a];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:a,updated:h,removed:f,overrides:d}=y.compare(s,r);let k=[...a,...h,...f];return(k.length||!s)&&this.updateFolderConfiguration(t,r),{keys:k,overrides:d}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:h,overrides:f}=y.compare(r,void 0);return{keys:[...s,...a,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=s.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:a,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:a,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,d)=>(f.set(n.URI.revive(d[0]),this.parseConfigurationModel(d[1])),f),new L.ResourceMap);return new b(r,s,new p,a,h,new p,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function c(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,r=new Map;for(const a of o)a.keys.forEach(h=>t.add(h)),a.overrides.forEach(([h,f])=>{const d=L.getOrSet(r,h,new Set);f.forEach(k=>d.add(k))});const s=[];return r.forEach((a,h)=>s.push([h,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=c;class u{constructor(t,r,s,a){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(d=>h.add(d)),t.overrides.forEach(([,d])=>d.forEach(k=>h.add(k))),this.affectedKeys=[...h.values()];const f=new p;this.affectedKeys.forEach(d=>f.setValue(d,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!E.equals(a,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=y.toValuesTree({[r]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=u;class l extends u{constructor(t,r,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=l}),define(J[188],Z([0,1,37,48,2,17,187,5,9,15]),function(z,e,v,L,A,S,E,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends A.Disposable{constructor(P,p){super();this.settingsResource=P,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,p)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(g=>this.onDidDefaultConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const P=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,P)}getConfigurationData(){return this.configuration.toData()}getValue(P,p){const g=typeof P=="string"?P:void 0,m=S.isConfigurationOverrides(P)?P:S.isConfigurationOverrides(p)?p:{};return this.configuration.getValue(g,m,void 0)}updateValue(P,p,g,m){return Promise.reject(new Error("not supported"))}inspect(P){return this.configuration.inspect(P,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const P=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(P)}onDidChangeUserConfiguration(P){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(P);this.trigger(g,p,1)}onDidDefaultConfigurationChange(P){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,P);this.trigger(g,p,6)}trigger(P,p,g){const m=new E.ConfigurationChangeEvent(P,{data:p},this.configuration);m.source=g,m.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(P){switch(P){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[189],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=v.createDecorator("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(E,n=L.Unknown,w){super(E);this._message=E,this._code=n,this._detail=w,this.isHandled=n===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(E){return E instanceof A&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof A&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof A&&E.isHandled}}e.RemoteAuthorityResolverError=A}),define(J[190],Z([0,1,84,27,2,20,5,189,19,9,25]),function(z,e,v,L,A,S,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var P;(function(M){M[M.Management=1]="Management",M[M.ExtensionHost=2]="ExtensionHost",M[M.Tunnel=3]="Tunnel"})(P=e.ConnectionType||(e.ConnectionType={}));function p(M){switch(M){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(M){const W=new i.CancellationTokenSource;return setTimeout(()=>W.cancel(),M),W.token}function m(M,W){if(M.isCancellationRequested||W.isCancellationRequested)return i.CancellationToken.Cancelled;const _=new i.CancellationTokenSource;return M.onCancellationRequested(()=>_.cancel()),W.onCancellationRequested(()=>_.cancel()),_.token}class D{constructor(W){this._state="pending",this._disposables=new A.DisposableStore,this.promise=new Promise((_,q)=>{this._resolvePromise=_,this._rejectPromise=q}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function b(M,W){const _=new D(W);return _.registerDisposable(M.onControlMessage(q=>{const K=JSON.parse(q.toString()),H=G(K);H?_.reject(H):_.resolve(K)})),_.promise}function c(M,W,_,q,K,H){const x=new D(H);return W.connect(_,q,K,(ne,re)=>{x.didTimeout?(ne&&M.error(ne),re==null||re.dispose()):ne||!re?x.reject(ne):x.resolve(re)}),x.promise}function u(M,W){const _=new D(W);return M.then(q=>{_.didTimeout||_.resolve(q)},q=>{_.didTimeout||_.reject(q)}),_.promise}async function l(M,W,_,q){const K=R(M,W);M.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let H;try{H=await c(M.logService,M.socketFactory,M.host,M.port,`reconnectionToken=${M.reconnectionToken}&reconnection=${M.reconnectionProtocol?"true":"false"}`,q)}catch(se){throw M.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),M.logService.error(se),se}M.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let x,ne;M.reconnectionProtocol?(M.reconnectionProtocol.beginAcceptReconnection(H,null),x=M.reconnectionProtocol,ne=!1):(x=new v.PersistentProtocol(H,null),ne=!0),M.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:M.connectionToken||"00000000000000000000"};x.sendControl(S.VSBuffer.fromString(JSON.stringify(re)));try{const se=await b(x,m(q,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}M.logService.trace(`${K} 4/6. received SignRequest control message.`);const le=await u(M.signService.sign(se.data),q),oe={type:"connectionType",commit:M.commit,signedData:le,desiredConnectionType:W};return _&&(oe.args=_),M.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(S.VSBuffer.fromString(JSON.stringify(oe))),{protocol:x,ownsProtocol:ne}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(M.logService.error(`${K} the handshake timed out. Error:`),M.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(M.logService.error(`${K} received error control message when negotiating connection. Error:`),M.logService.error(se)),ne&&$(x),se}}async function o(M,W,_,q){const K=Date.now(),H=R(M,W),{protocol:x,ownsProtocol:ne}=await l(M,W,_,q),re=new D(q);return re.registerDisposable(x.onControlMessage(se=>{const le=JSON.parse(se.toString()),oe=G(le);oe?(M.logService.error(`${H} received error control message when negotiating connection. Error:`),M.logService.error(oe),ne&&$(x),re.reject(oe)):(M.reconnectionProtocol&&M.reconnectionProtocol.endAcceptReconnection(),M.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${O(K)}!`),re.resolve({protocol:x,firstMessage:le}))})),re.promise}async function t(M,W){const{protocol:_}=await o(M,1,void 0,W);return{protocol:_}}async function r(M,W,_){const{protocol:q,firstMessage:K}=await o(M,2,W,_),H=K&&K.debugPort;return{protocol:q,debugPort:H}}async function s(M,W,_){const q=Date.now(),K=R(M,3),{protocol:H}=await l(M,3,W,_);return M.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${O(q)}!`),H}async function a(M,W,_){const{host:q,port:K,connectionToken:H}=await M.addressProvider.getAddress();return{commit:M.commit,host:q,port:K,connectionToken:H,reconnectionToken:W,reconnectionProtocol:_,socketFactory:M.socketFactory,signService:M.signService,logService:M.logService}}async function h(M,W,_){try{const q=L.generateUuid(),K=await a(M,q,null),{protocol:H}=await t(K,i.CancellationToken.None);return new Q(M,W,_,q,H)}catch(q){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(q),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=h;async function f(M,W){try{const _=L.generateUuid(),q=await a(M,_,null),{protocol:K,debugPort:H}=await r(q,W,i.CancellationToken.None);return new U(M,W,_,K,H)}catch(_){throw M.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),M.logService.error(_),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=f;async function d(M,W){const _=await a(M,L.generateUuid(),null);return await s(_,{port:W},i.CancellationToken.None)}e.connectRemoteAgentTunnel=d;function k(M){return y.createCancelablePromise(W=>new Promise((_,q)=>{const K=setTimeout(_,M*1e3);W.onCancellationRequested(()=>{clearTimeout(K),_()})}))}var T;(function(M){M[M.ConnectionLost=0]="ConnectionLost",M[M.ReconnectionWait=1]="ReconnectionWait",M[M.ReconnectionRunning=2]="ReconnectionRunning",M[M.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",M[M.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class C{constructor(W,_){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=C;class V{constructor(W,_,q,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.durationSeconds=q,this.cancellableTimer=K,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=V;class X{constructor(W,_,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=X;class ee{constructor(W,_,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=4}}e.ConnectionGainEvent=ee;class B{constructor(W,_,q,K){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.attempt=q,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class Y extends A.Disposable{constructor(W,_,q,K){super();this._connectionType=W,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=q,this.protocol=K,this._isReconnecting=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(K.onSocketClose(H=>{const x=F(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${x} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(K.onSocketTimeout(()=>{const H=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${H} received socket timeout event.`),this._beginReconnecting()})),Y._instances.push(this),Y._permanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(W,_,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=_,this._permanentFailureHandled=q,this._instances.forEach(K=>K._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(Y._permanentFailure)return;const W=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const K=q<_.length?_[q]:_[_.length-1];try{if(K>0){const x=k(K);this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,x)),this._options.logService.info(`${W} waiting for ${K} seconds before reconnecting...`);try{await x}catch(ne){}}if(Y._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${W} resolving connection...`);const H=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${H.host}:${H.port}...`),await this._reconnect(H,g(I)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(w.isPromiseCanceledError(H)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,n.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!Y._permanentFailure)}_gotoPermanentFailure(W,_,q){this._onDidStateChange.fire(new B(this.reconnectionToken,W,_,q)),$(this.protocol)}}Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class Q extends Y{constructor(W,_,q,K,H){super(1,W,K,H);this.client=this._register(new v.Client(H,{remoteAuthority:_,clientId:q},W.ipcLogger))}async _reconnect(W,_){await t(W,_)}}e.ManagementPersistentConnection=Q;class U extends Y{constructor(W,_,q,K,H){super(2,W,q,K);this._startArguments=_,this.debugPort=H}async _reconnect(W,_){await r(W,this._startArguments,_)}}e.ExtensionHostPersistentConnection=U;function $(M){try{M.acceptDisconnect();const W=M.getSocket();M.dispose(),W.dispose()}catch(W){w.onUnexpectedError(W)}}function G(M){if(M&&M.type==="error"){const W=new Error(`Connection error: ${M.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function N(M,W){for(;M.length<W;)M+=" ";return M}function F(M,W,_){return`[remote-connection][${N(p(M),13)}][${W.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function R(M,W){return`${F(W,M.reconnectionToken,!!M.reconnectionProtocol)}[${M.host}:${M.port}]`}function O(M){return`${Date.now()-M} ms`}}),define(J[73],Z([0,1,10]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===v.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function A(y){if(!y)return;const i=y.indexOf("+");return i<0?y:y.substr(0,i)}e.getRemoteName=A;function S(y){return y.scheme!==v.Schemas.file&&y.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=S;function E(y){if(y.folders.length)return y.folders.every(i=>S(i.uri))?y.folders[0].uri:void 0;if(y.configuration&&S(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=E;function n(y){var i;return(i=E(y))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=n;function w(y){return E(y)!==void 0}e.isVirtualWorkspace=w}),define(J[74],Z([0,1,5,3,4,6]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=A.createDecorator("tunnelService");var E;(function(P){P[P.Notify=1]="Notify",P[P.OpenBrowser=2]="OpenBrowser",P[P.OpenPreview=3]="OpenPreview",P[P.Silent=4]="Silent",P[P.Ignore=5]="Ignore"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(P){if(P.scheme!=="http"&&P.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(P.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(P){return e.LOCALHOST_ADDRESSES.indexOf(P)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(P){return e.ALL_INTERFACES_ADDRESSES.indexOf(P)>=0}e.isAllInterfaces=y;function i(P,p){return p?p!==1&&P<1024:!L.isWindows&&P<1024}e.isPortPrivileged=i;let I=class{constructor(p){this.logService=p,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,g){return this._tunnelProvider=p,p?(this._canElevate=g.elevation,this._canMakePublic=g.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async p=>{const g=[],m=Array.from(this._tunnels.values());for(let D of m){const b=Array.from(D.values());for(let c of b){const u=await c.value;u&&g.push(u)}}p(g)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:g}of p.values())await g.then(m=>m==null?void 0:m.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,g,m,D,b=!1,c=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${m} on local port ${D}.`),!p)return;g||(g="localhost");const u=this.retainOrCreateTunnel(p,g,m,D,b,c);return u?u.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(l);return(l.tunnelRemoteHost!==g||l.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,public:p.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const g=this._tunnels.get(p.tunnelRemoteHost);if(g){const m=g.get(p.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,m))}}}}async tryDisposeTunnel(p,g,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${g}.`);const D=m.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(g),D}}async closeTunnel(p,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${g} `);const m=this._tunnels.get(p);if(m&&m.has(g)){const D=m.get(g);D.refcount=0,await this.tryDisposeTunnel(p,g,D)}}addTunnelToMap(p,g,m){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(g,{refcount:1,value:m})}async removeEmptyTunnelFromMap(p,g){const m=this._tunnels.get(p);m&&(await m.get(g)||m.delete(g),m.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,g){let m=[p];w(p)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):y(p)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const D=m.map(b=>this._tunnels.get(b));for(const b of D){const c=b==null?void 0:b.get(g);if(c)return c}}canTunnel(p){return!!n(p)}createWithProvider(p,g,m,D,b,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${m} on local port ${D}.`);const l={elevationRequired:b?i(D===void 0?m:D):!1},o={remoteAddress:{host:g,port:m},localAddressPort:D,public:c},t=p.forwardPort(o,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(g,m,t),t}};I=he([te(0,S.ILogService)],I),e.AbstractTunnelService=I}),define(J[49],Z([0,1,146,4,48,37,20]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=L.createDecorator("requestService");function n(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=n;function w(g){return g.res.statusCode===204}async function y(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);return w(g)?null:(await E.streamToBuffer(g.stream)).toString()}e.asText=y;async function i(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);if(w(g))return null;const D=(await E.streamToBuffer(g.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=i;function I(g){p(g)}e.updateProxyConfigurationsScope=I;let P;function p(g){const m=S.Registry.as(A.Extensions.Configuration);P&&m.deregisterConfigurations([P]),P={id:"http",order:15,title:v.localize(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:v.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:v.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:v.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[v.localize(4,null),v.localize(5,null),v.localize(6,null),v.localize(7,null)],default:"override",description:v.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:v.localize(9,null),restricted:!0}}},m.registerConfiguration(P)}p(2)}),define(J[191],Z([0,1,192,13]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function A(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(E,n,w={}){const y=v.parse(E),i=w.proxyUrl||A(y,n);if(!i)return null;const I=v.parse(i);if(!/^https?:$/.test(I.protocol||""))return null;const P={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:L.isBoolean(w.strictSSL)?w.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((p,g)=>{z(["http-proxy-agent"],p,g)}))(P):new(await new Promise((p,g)=>{z(["https-proxy-agent"],p,g)}))(P)}e.getProxyAgent=S}),define(J[193],Z([0,1,27,20]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(S,E,n){let w=n&&n.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await E.readFile(S.serviceMachineIdResource)).value.toString();w=v.isUUID(i)?i:null}catch(y){w=null}if(!w){w=v.generateUuid();try{await E.writeFile(S.serviceMachineIdResource,L.VSBuffer.fromString(w))}catch(y){}}return n&&n.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=A}),define(J[75],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=v.createDecorator(e.SIGN_SERVICE_ID)}),define(J[194],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((A,S)=>z(["vsda"],A,S))}async sign(A){try{const S=await this.vsda(),E=new S.signer;if(E)return E.sign(A)}catch(S){}return A}}e.SignService=v}),define(J[38],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=v.createDecorator("stateMainService")}),define(J[18],Z([0,1,14,6,38,5,4,177,3,2,9,13,32]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=E.createDecorator("lifecycleMainService");var p;(function(D){D[D.CLOSE=1]="CLOSE",D[D.QUIT=2]="QUIT",D[D.RELOAD=3]="RELOAD",D[D.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var g;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class lt extends y.Disposable{constructor(b,c){super();this.logService=b,this.stateMainService=c,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",b);const c=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",c),v.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",b),v.app.removeListener("window-all-closed",c),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(c){b.push(c)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(b)}catch(c){this.logService.error(c)}try{await this.stateMainService.close()}catch(c){this.logService.error(c)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const c=this.phaseWhen.get(this._phase);c&&(c.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let c=this.phaseWhen.get(b);c||(c=new i.Barrier,this.phaseWhen.set(b,c)),await c.wait()}registerWindow(b){const c=new y.DisposableStore;this.windowCounter++,c.add(b.onWillLoad(l=>this._onWillLoadWindow.fire({window:b,workspace:l.workspace})));const u=I.assertIsDefined(b.win);u.on("close",l=>{const o=b.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),l.preventDefault(),this.unload(b,1).then(t=>{if(t){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(b),b.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,c.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,c){await this.unload(b,3)||b.reload(c)}async unload(b,c){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const u=this._quitRequested?2:c;let l=await this.onBeforeUnloadWindowInRenderer(b,u);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(b,u),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,u),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,c){return new Promise(u=>{const l=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${l}`,t=`vscode:cancel${l}`;v.ipcMain.once(o,()=>{u(!1)}),v.ipcMain.once(t,()=>{u(!0)}),b.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:t,reason:c})})}onBeforeUnloadWindowInMain(b,c){const u=[];return this._onBeforeUnloadWindow.fire({reason:c,window:b,veto(l){u.push(l)}}),n.handleVetos(u,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(b,c){return new Promise(u=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(o,()=>u()),b.send("vscode:onWillUnload",{replyChannel:o,reason:c})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(c=>{this.pendingQuitPromiseResolve=c,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const c=process.argv.slice(1);if((b==null?void 0:b.addArgs)&&c.push(...b.addArgs),b==null?void 0:b.removeArgs)for(const o of b.removeArgs){const t=c.indexOf(o);t>=0&&c.splice(t,1)}const u=()=>{try{if(w.isWindows){const o=P.cwd();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:c})};v.app.once("quit",u),await this.quit(!0)&&v.app.removeListener("quit",u)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([i.timeout(1e3),(async()=>{for(const c of v.BrowserWindow.getAllWindows())if(c&&!c.isDestroyed()){let u;c.webContents&&!c.webContents.isDestroyed()?u=new Promise(l=>c.once("closed",l)):u=Promise.resolve(),c.destroy(),await u}})()]),v.app.exit(b)}};m.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",m=he([te(0,L.ILogService),te(1,A.IStateMainService)],m),e.LifecycleMainService=m}),define(J[195],Z([0,1,4,5,2,18]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=v.createDecorator("keyboardLayoutMainService");let E=class extends A.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((i,I)=>{z(["native-keymap"],i,I)});this._keyboardLayoutData=n(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([te(0,S.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(w){const y=w.getKeyMap(),i=w.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:i}}}),define(J[96],Z([0,1,4,5,2,13,86,9]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=v.createDecorator("storageService");var y;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class P extends A.Disposable{constructor(D={flushInterval:P.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=n.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){A.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===w?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,c){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.get(D,c)}getBoolean(D,b,c){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.getBoolean(D,c)}getNumber(D,b,c){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.getNumber(D,c)}store(D,b,c,u){if(S.isUndefinedOrNull(b)){this.remove(D,c);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(D,c,u),(l=this.getStorage(c))===null||l===void 0||l.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{var c;this.updateKeyTarget(D,b,void 0),(c=this.getStorage(b))===null||c===void 0||c.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const c=[],u=this.getKeyTargets(D);for(const l of Object.keys(u))u[l]===b&&c.push(l);return c}updateKeyTarget(D,b,c){var u,l;const o=this.getKeyTargets(b);typeof c=="number"?o[D]!==c&&(o[D]=c,(u=this.getStorage(b))===null||u===void 0||u.set(w,JSON.stringify(o))):typeof o[D]=="number"&&(delete o[D],(l=this.getStorage(b))===null||l===void 0||l.set(w,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(w,D);if(b)try{return JSON.parse(b)}catch(c){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,b,c,u;this._onWillSaveState.fire({reason:y.NONE}),await n.Promises.settled([(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&b!==void 0?b:Promise.resolve(),(u=(c=this.getStorage(1))===null||c===void 0?void 0:c.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var D,b,c,u,l,o;const t=(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&b!==void 0?b:new Map,r=(u=(c=this.getStorage(1))===null||c===void 0?void 0:c.items)!==null&&u!==void 0?u:new Map;return g(t,r,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(o=this.getLogDetails(1))!==null&&o!==void 0?o:"")}}e.AbstractStorageService=P,P.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends P{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=p;async function g(m,D,b,c){const u=h=>{try{return JSON.parse(h)}catch(f){return h}},l=new Map,o=new Map;m.forEach((h,f)=>{l.set(f,h),o.set(f,u(h))});const t=new Map,r=new Map;D.forEach((h,f)=>{t.set(f,h),r.set(f,u(h))}),console.group(`Storage: Global (path: ${b})`);let s=[];l.forEach((h,f)=>{s.push({key:f,value:h})}),console.table(s),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${c})`);let a=[];t.forEach((h,f)=>{a.push({key:f,value:h})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=g}),define(J[196],Z([0,1,3,32,27,7]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(y){if(v.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function n(y,i,I,P,p,g,m,D,b,c){const u=Object.create(null);u["common.machineId"]=m,u.sessionID=A.generateUuid()+Date.now(),u.commitHash=p,u.version=g,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=v.PlatformToString(v.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=P,u["common.product"]=c||"desktop";const l=w(D||[]);l&&(u["common.msftInternal"]=l);let o=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),v.isLinuxSnap&&(u["common.snap"]="true");const r=E(I);r&&(u["common.platformDetail"]=r);try{const s=await y.readFile(S.URI.file(b));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=n;function w(y){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return y.some(P=>I===P)}e.verifyMicrosoftInternalDomain=w}),define(J[31],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=v.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=v.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[197],Z([0,1,26,66,70,8,43,83,22,3,7,31,63,10,21,16]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(o,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,a=new Map,h=2e4;function f(T,C,V,X){const ee=C.substring(T.length+1);return new Promise(async B=>{var Y,Q,U;let $;try{$=await m.Promises.readdir(C,{withFileTypes:!0})}catch(F){B();return}if(X.count>=h){X.count+=$.length,X.maxReached=!0,B();return}let G=$.length;if(G===0){B();return}let N=$;X.count+$.length>h&&(X.maxReached=!0,G=h-X.count,N=$.slice(0,G)),X.count+=$.length;for(const F of N)if(F.isDirectory()){if(V.includes(F.name)||await f(T,S.join(C,F.name),V,X),--G==0){B();return}}else{const R=F.name.lastIndexOf(".");if(R>=0){const O=F.name.substring(R+1);O&&s.set(O,((Y=s.get(O))!==null&&Y!==void 0?Y:0)+1)}for(const O of r)((Q=O.relativePathPattern)===null||Q===void 0?void 0:Q.test(ee))!==!1&&O.filePattern.test(F.name)&&a.set(O.tag,((U=a.get(O.tag))!==null&&U!==void 0?U:0)+1);if(--G==0){B();return}}})}const d={count:0,maxReached:!1};await f(o,o,t,d);const k=await u(o);return{configFiles:b(a),fileTypes:b(s),fileCount:d.count,maxFilesReached:d.maxReached,launchConfigFiles:k}}e.collectWorkspaceStats=D;function b(o){return[...P.Iterable.map(o.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function c(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=v.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=c;async function u(o){try{const t=new Map,r=S.join(o,".vscode","launch.json"),s=await m.Promises.readFile(r),a=[],h=E.parse(s.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if(E.getNodeType(h)==="object"&&h.configurations)for(const f of h.configurations){const d=f.type;d&&(t.has(d)?t.set(d,t.get(d)+1):t.set(d,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=u;let l=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),y.isWindows||r.push(`Load (avg):       ${v.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([n.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[a,h]=s,f=this.formatProcessList(t,a);return r.forEach(d=>{if(A.isRemoteDiagnosticError(d))f+=`
${d.errorMessage}`,h+=`
${d.errorMessage}`;else if(f+=`

Remote: ${d.hostName}`,d.processes&&(f+=`
${this.formatProcessList(t,d.processes)}`),d.workspaceMetadata){h+=`
|  Remote: ${d.hostName}`;for(const k of Object.keys(d.workspaceMetadata)){const T=d.workspaceMetadata[k];let C=`${T.fileCount} files`;T.maxFilesReached&&(C=`more than ${C}`),h+=`|    Folder (${k}): ${C}`,h+=this.formatWorkspaceStats(T)}}}),{processInfo:f,workspaceInfo:h}})}async getSystemInfo(t,r){const{memory:s,vmHint:a,os:h,cpus:f}=c(),d={os:h,memory:s,cpus:f,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return y.isWindows||(d.load=`${v.loadavg().map(k=>Math.round(k)).join(", ")}`),y.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(t,r){const s=[];return n.listProcesses(t.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,a)),t.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),r.forEach(h=>{if(A.isRemoteDiagnosticError(h))s.push(`
${h.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${h.hostName}`),s.push(this.formatMachineInfo(h.machineInfo)),h.processes&&s.push(this.formatProcessList(t,h.processes)),h.workspaceMetadata)for(const f of Object.keys(h.workspaceMetadata)){const d=h.workspaceMetadata[f];let k=`${d.fileCount} files`;d.maxFilesReached&&(k=`more than ${k}`),s.push(`Folder (${f}): ${k}`),s.push(this.formatWorkspaceStats(d))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const r=[],s=60;let a=0;const h=(T,C)=>{const V=` ${T}(${C})`;a+V.length>s?(r.push(f),f="|                 ",a=f.length):a+=V.length,f+=V};let f="|      File types:";const d=10;let k=t.fileTypes.length>d?d:t.fileTypes.length;for(let T=0;T<k;T++){const C=t.fileTypes[T];h(C.name,C.count)}if(r.push(f),t.configFiles.length>=0&&(f="|      Conf files:",a=0,t.configFiles.forEach(T=>{h(T.name,T.count)}),r.push(f)),t.launchConfigFiles.length>0){let T="|      Launch Configs:";t.launchConfigFiles.forEach(C=>{T+=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`}),r.push(T)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],s=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(h=>{const f=i.URI.revive(h);if(f.scheme===p.Schemas.file){const d=f.fsPath;s.push(D(d,["node_modules",".git"]).then(k=>{let T=`${k.fileCount} files`;k.maxFilesReached&&(T=`more than ${T}`),r.push(`|    Folder (${S.basename(d)}): ${T}`),r.push(this.formatWorkspaceStats(k))}).catch(k=>{r.push(`|      Error: Unable to collect workspace stats for folder ${d} (${k.toString()})`)}))}else r.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const s=new Map;t.windows.forEach(h=>s.set(h.pid,h.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,s,a,r,0),a.join(`
`)}formatProcessItem(t,r,s,a,h){const f=h===0;let d;f?d=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(h)} ${a.name}`,a.name==="window"&&(d=`${d} (${r.get(a.pid)})`));const k=process.platform==="win32"?a.mem:v.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(k/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(a.children)&&a.children.forEach(T=>this.formatProcessItem(t,r,s,T,h+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const s=i.URI.revive(r);if(s.scheme!==p.Schemas.file)continue;const a=s.fsPath;try{const h=await D(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),h.fileTypes.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),h.launchConfigFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})}),h.configFiles.forEach(f=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:f.name,count:f.count})})}catch(h){}}}};l=he([te(0,I.ITelemetryService),te(1,w.IProductService)],l),e.DiagnosticsService=l}),define(J[198],Z([0,1,19,168,171,44,31,49,162,53,25,6,21,7,22,96,193,4,15]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(u||(u={}));function l(...F){return String(F.reduce((R,O)=>R|O,0))}var o;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class h{constructor(R=a){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,O=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:O}))}withFilter(R,...O){const M=[...this.state.criteria,...O.length?O.map(W=>({filterType:R,value:W})):[{filterType:R}]];return new h(Object.assign(Object.assign({},this.state),{criteria:M}))}withSortBy(R){return new h(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new h(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new h(Object.assign(Object.assign({},this.state),{flags:R.reduce((O,M)=>O|M,0)}))}withAssetTypes(...R){return new h(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:O,pageSize:M,sortBy:W,sortOrder:_,flags:q,assetTypes:K}=this.state;return{filters:[{criteria:R,pageNumber:O,pageSize:M,sortBy:W,sortOrder:_}],assetTypes:K,flags:q}}get searchText(){const R=this.state.criteria.filter(O=>O.filterType===o.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(F,R){const O=(F||[]).filter(M=>M.statisticName===R)[0];return O?O.value:0}function d(F){const R="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(M=>M.assetType.indexOf(R)===0).reduce((M,W)=>{const _=V(F,W.assetType);return _&&M.push([W.assetType.substring(R.length),_]),M},[])}function k(F){if(F.properties){const R=F.properties.filter(W=>W.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=R.filter(W=>O.test(W.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return V(F,t.Repository)}function T(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function C(F){const R=V(F,t.Icon);if(R)return R;const O=L.DefaultIconPath;return{uri:O,fallbackUri:O}}function V(F,R){return F.files.filter(M=>M.assetType===R)[0]?{uri:`${F.assetUri}/${R}`,fallbackUri:`${F.fallbackAssetUri}/${R}`}:null}function X(F,R){const O=F.properties?F.properties.filter(W=>W.key===R):[],M=O.length>0&&O[0].value;return M?M.split(",").map(W=>A.adoptToGalleryExtensionId(W)):[]}function ee(F){const R=F.properties?F.properties.filter(O=>O.key===r.Engine):[];return R.length>0&&R[0].value||""}function B(F){const R=F.properties?F.properties.filter(M=>M.key===r.LocalizedLanguages):[],O=R.length>0&&R[0].value||"";return O?O.split(","):[]}function Y(F){return F.indexOf("preview")!==-1}function Q(F){const R=F.properties?F.properties.find(O=>O.key===r.WebExtension):void 0;return!!R&&R.value==="true"}function U(F){return F.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?c.joinPath(p.URI.parse(F.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function $(F,R,O,M,W){const _={manifest:V(R,t.Manifest),readme:V(R,t.Details),changelog:V(R,t.Changelog),license:V(R,t.License),repository:k(R),download:T(R),icon:C(R),coreTranslations:d(R)};return{identifier:{id:A.getGalleryExtensionId(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:R.version,date:R.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:f(F.statistics,"install"),rating:f(F.statistics,"averagerating"),ratingCount:f(F.statistics,"ratingcount"),assetUri:p.URI.parse(R.assetUri),webResource:U(R),assetTypes:R.files.map(({assetType:q})=>q),assets:_,properties:{dependencies:X(R,r.Dependency),extensionPack:X(R,r.ExtensionPack),engine:ee(R),localizedLanguages:B(R),webExtension:Q(R)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+O,querySource:W},preview:Y(F.flags)}}let G=class{constructor(R,O,M,W,_,q,K){this.requestService=R,this.logService=O,this.environmentService=M,this.telemetryService=W,this.fileService=_,this.productService=q;const H=q.extensionsGallery;this.extensionsGalleryUrl=H&&H.serviceUrl,this.extensionsControlUrl=H&&H.controlUrl,this.commonHeadersPromise=N(q.version,this.environmentService,this.fileService,K)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,O){const M=[];let{total:W,firstPage:_,getPage:q}=await this.query({names:R,pageSize:R.length},O);M.push(..._);for(let K=1;M.length<W&&(_=await q(K,O),_.length);K++)M.push(..._);return M}async getCompatibleExtension(R,O){const M=await this.getCompatibleExtensionByEngine(R,O);return(M==null?void 0:M.properties.webExtension)?M.webResource?M:null:M}async getCompatibleExtensionByEngine(R,O){const M=L.isIExtensionIdentifier(R)?null:R;if(M&&M.properties.engine&&w.isEngineValid(M.properties.engine,this.productService.version,this.productService.date))return M;const{id:W,uuid:_}=M?M.identifier:R;let q=new h().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");_?q=q.withFilter(o.ExtensionId,_):q=q.withFilter(o.ExtensionName,W);const{galleryExtensions:K}=await this.queryGallery(q,i.CancellationToken.None),[H]=K;if(!H||!H.versions.length)return null;if(O){const ne=H.versions.filter(re=>re.version===O)[0];if(ne){const re=$(H,ne,0,q);if(re.properties.engine&&w.isEngineValid(re.properties.engine,this.productService.version,this.productService.date))return re}return null}const x=await this.getLastValidExtensionVersion(H,H.versions);return x?$(H,x,0,q):null}async query(R,O){const M=i.CancellationToken.isCancellationToken(R)?{}:R,W=i.CancellationToken.isCancellationToken(R)?R:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=M.text||"";const q=S.getOrDefault(M,se=>se.pageSize,50);let K=new h().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,q).withFilter(o.Target,"Microsoft.VisualStudio.Code");_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(o.Category,oe||le),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(K=K.withFilter(o.Tag,oe||le),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(o.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),K=K.withFilter(o.SearchText,_)),K=K.withSortBy(0)):M.ids?K=K.withFilter(o.ExtensionId,...M.ids):M.names?K=K.withFilter(o.ExtensionName,...M.names):K=K.withSortBy(4),typeof M.sortBy=="number"&&(K=K.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(K=K.withSortOrder(M.sortOrder));const{galleryExtensions:H,total:x}=await this.queryGallery(K,W),ne=H.map((se,le)=>$(se,se.versions[0],le,K,M.source)),re=async(se,le)=>{if(le.isCancellationRequested)throw v.canceled();const oe=K.withPage(se+1),{galleryExtensions:ue}=await this.queryGallery(oe,le);return ue.map((me,Se)=>$(me,me.versions[0],Se,oe,M.source))};return{firstPage:ne,total:x,pageSize:K.pageSize,getPage:re}}async queryGallery(R,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,u.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,l(u.Unpublished));const M=await this.commonHeadersPromise,W=JSON.stringify(R.raw),_=Object.assign(Object.assign({},M),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),q=new Date().getTime();let K,H,x=0;try{if(K=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:_},O),K.res.statusCode&&K.res.statusCode>=400&&K.res.statusCode<500)return{galleryExtensions:[],total:x};const ne=await n.asJson(K);if(ne){const re=ne.results[0],se=re.extensions,le=re.resultMetadata&&re.resultMetadata.filter(oe=>oe.metadataType==="ResultCount")[0];return x=le&&le.metadataItems.filter(oe=>oe.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:x}}return{galleryExtensions:[],total:x}}catch(ne){throw H=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-q,success:!!K&&n.isSuccess(K),responseBodySize:K==null?void 0:K.res.headers["Content-Length"],statusCode:K?String(K.res.statusCode):void 0,errorCode:H?v.isPromiseCanceledError(H)?"canceled":v.getErrorMessage(H).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(x)}))}}async reportStatistic(R,O,M,W){if(!this.isEnabled())return;const _=await this.commonHeadersPromise,q=Object.assign(Object.assign({},_),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${O}/${M}/stats?statType=${W}`),headers:q},i.CancellationToken.None)}catch(K){}}async download(R,O,M){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const W=A.getGalleryExtensionTelemetryData(R),_=new Date().getTime(),q=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ne})),K=M===1?"install":M===2?"update":"",H=K?{uri:`${R.assets.download.uri}&${K}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${K}=true`}:R.assets.download,x=await this.getAsset(H);await this.fileService.writeFile(O,x.stream),q(new Date().getTime()-_)}async getReadme(R,O){if(R.assets.readme){const M=await this.getAsset(R.assets.readme,{},O);return await n.asText(M)||""}return""}async getManifest(R,O){if(R.assets.manifest){const M=await this.getAsset(R.assets.manifest,{},O),W=await n.asText(M);return W?JSON.parse(W):null}return null}async getCoreTranslation(R,O){const M=R.assets.coreTranslations.filter(W=>W[0]===O.toUpperCase())[0];if(M){const W=await this.getAsset(M[1]),_=await n.asText(W);return _?JSON.parse(_):null}return null}async getChangelog(R,O){if(R.assets.changelog){const M=await this.getAsset(R.assets.changelog,{},O);return await n.asText(M)||""}return""}async getAllVersions(R,O){let M=new h().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?M=M.withFilter(o.ExtensionId,R.identifier.uuid):M=M.withFilter(o.ExtensionName,R.identifier.id);const W=[],{galleryExtensions:_}=await this.queryGallery(M,i.CancellationToken.None);return _.length&&(O?await Promise.all(_[0].versions.map(async q=>{let K;try{K=await this.getEngine(q)}catch(H){}K&&w.isEngineValid(K,this.productService.version,this.productService.date)&&W.push({version:q.version,date:q.lastUpdated})})):W.push(..._[0].versions.map(q=>({version:q.version,date:q.lastUpdated})))),W}async getAsset(R,O={},M=i.CancellationToken.None){const W=await this.commonHeadersPromise,_={type:"GET"},q=Object.assign(Object.assign({},W),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),_),{headers:q});const K=R.uri,H=R.fallbackUri,x=Object.assign(Object.assign({},O),{url:K});try{const ne=await this.requestService.request(x,M);if(ne.res.statusCode===200)return ne;const re=await n.asText(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${re}`)}catch(ne){if(v.isPromiseCanceledError(ne))throw ne;const re=v.getErrorMessage(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:K,message:re});const se=Object.assign(Object.assign({},O),{url:H});return this.requestService.request(se,M)}}async getLastValidExtensionVersion(R,O){const M=this.getLastValidExtensionVersionFromProperties(R,O);return M||this.getLastValidExtensionVersionRecursively(R,O)}getLastValidExtensionVersionFromProperties(R,O){for(const M of O){const W=ee(M);if(!W)return null;if(w.isEngineValid(W,this.productService.version,this.productService.date))return M}return null}async getEngine(R){const O=ee(R);if(O)return O;const M=V(R,t.Manifest);if(!M)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},_=await this.getAsset(M,{headers:W}),q=await n.asJson(_);if(q)return q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,O){if(!O.length)return null;const M=O[0],W=await this.getEngine(M);return w.isEngineValid(W,this.productService.version,this.productService.date)?Object.assign(Object.assign({},M),{properties:[...M.properties||[],{key:r.Engine,value:W}]}):this.getLastValidExtensionVersionRecursively(R,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await n.asJson(R),M=new Map;if(O)for(const W of O.malicious){const _=M.get(W)||{id:{id:W},malicious:!0,slow:!1};_.malicious=!0,M.set(W,_)}return[...M.values()]}};G=he([te(0,n.IRequestService),te(1,I.ILogService),te(2,y.IEnvironmentService),te(3,E.ITelemetryService),te(4,P.IFileService),te(5,g.IProductService),te(6,b.optional(m.IStorageService))],G),e.ExtensionGalleryService=G;async function N(F,R,O,M){const W={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},_=await D.getServiceMachineId(R,O,M);return W["X-Market-User-Id"]=_,W}e.resolveMarketplaceHeaders=N}),define(J[199],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(S){this.appender=S}listen(S,E){throw new Error(`Event not found: ${E}`)}call(S,E,{eventName:n,data:w}){return this.appender.log(n,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(S){this.channel=S}log(S,E){return this.channel.call("log",{eventName:S,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[200],Z([0,1,47,147,23,4,17,48,2,44,37]),function(z,e,v,L,A,S,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(g,m){this._configurationService=m,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=g.appender,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp(A.escapeRegExpCharacters(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(g,m){this._experimentProperties[g]=m}setEnabled(g){this._enabled=g}_updateUserOptIn(){var g;const m=(g=this._configurationService)===null||g===void 0?void 0:g.getValue(P);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const g=await this._commonProperties;let m=g.sessionID,D=g["common.instanceId"],b=g["common.machineId"],c=g["common.firstSessionDate"],u=g["common.msftInternal"];return{sessionId:m,instanceId:D,machineId:b,firstSessionDate:c,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(g,m,D){return this.isOptedIn?this._commonProperties.then(b=>{m=y.mixin(m,b),m=y.mixin(m,this._experimentProperties),m=y.cloneAndChange(m,c=>{if(typeof c=="string")return this._cleanupInfo(c,D)}),this._appender.log(g,m)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(g,m,D){return this.publicLog(g,m,D)}publicLogError(g,m){return this.sendErrorTelemetry?this.publicLog(g,m,!0):Promise.resolve(void 0)}publicLogError2(g,m){return this.publicLogError(g,m)}_cleanupInfo(g,m){let D=g;if(m){const b=[];for(let o of this._cleanupPatterns)for(;;){const t=o.exec(g);if(!t)break;b.push([t.index,o.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(D="";;){const o=u.exec(g);if(!o)break;!c.test(o[0])&&b.every(([t,r])=>o.index<t||o.index>=r)&&(D+=g.substring(l,o.index)+"<REDACTED: user-file-path>",l=u.lastIndex)}l<g.length&&(D+=g.substr(l))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=he([te(1,S.optional(E.IConfigurationService))],I),e.TelemetryService=I;const P="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:P,order:110,type:"object",title:L.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?L.localize(2,null,v.default.privacyStatementUrl):L.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[97],Z([0,1,17,44,13,9]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(g,m){return Promise.resolve(void 0)}publicLog2(g,m){return this.publicLog(g,m)}publicLogError(g,m){return Promise.resolve(void 0)}publicLogError2(g,m){return this.publicLogError(g,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(m,D,b){}async publicLogError(m,D,b){}}e.NullEndpointTelemetryService=E;function n(...g){return{log:(m,D)=>g.forEach(b=>b.log(m,D)),flush:()=>S.Promises.settled(g.map(m=>m.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(g,m){return m.onDidChangeConfiguration(D=>{D.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:v.ConfigurationTargetToString(D.source),configurationKeys:P(D.sourceConfig)})})}e.configurationTelemetry=w;function y(g){const m=Object.create(null),D=Object.create(null),b=Object.create(null);I(g,b);for(let c in b){c=c.length>150?c.substr(c.length-149):c;const u=b[c];typeof u=="number"?D[c]=u:typeof u=="boolean"?D[c]=u?1:0:typeof u=="string"?m[c]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(m[c]=u)}return{properties:m,measurements:D}}e.validateTelemetryData=y;function i(g){if(!g)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{g.indexOf(`${b}+`)===0&&(m=b)}),m}e.cleanRemoteAuthority=i;function I(g,m,D=0,b){if(!!g)for(let c of Object.getOwnPropertyNames(g)){const u=g[c],l=b?b+c:c;Array.isArray(u)?m[l]=L.safeStringify(u):u instanceof Date?m[l]=u.toISOString():A.isObject(u)?D<2?I(u,m,D+1,l+"."):m[l]=L.safeStringify(u):m[l]=u}}function P(g){if(!g)return[];const m=[];return p(m,"",g),m}function p(g,m,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>p(g,m?`${m}.${b}`:b,D[b])):g.push(m)}}),define(J[201],Z([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(J[202],Z([0,1,4,2,37,5,201,108]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=v.createDecorator("themeService");var w;(function(D){function b(c){return c&&typeof c=="object"&&typeof c.id=="string"}D.isThemeColor=b})(w=e.ThemeColor||(e.ThemeColor={}));function y(D){return{id:D}}e.themeColorFromId=y;var i;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||w.isThemeColor(r.color))}D.isThemeIcon=b;const c=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function u(r){const s=c.exec(r);if(!s)return;let[,a]=s;return{id:a}}D.fromString=u;function l(r,s){let a=r.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),s&&(a=`${a}~${s}`),{id:a}}D.modify=l;function o(r,s){var a,h;return r.id===s.id&&((a=r.color)===null||a===void 0?void 0:a.id)===((h=s.color)===null||h===void 0?void 0:h.id)}D.isEqual=o;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=n.CSSIcon.asClassNameArray,D.asClassName=n.CSSIcon.asClassName,D.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function I(D){switch(D){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class P{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),L.toDisposable(()=>{const c=this.themingParticipants.indexOf(b);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new P;A.Registry.add(e.Extensions.ThemingContribution,p);function g(D){return p.onColorThemeChange(D)}e.registerThemingParticipant=g;class m extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,c){let u=this.theme.getColor(b);return u&&c&&(u=c(u,this.theme)),u?u.toString():null}}e.Themable=m}),define(J[60],Z([0,1,14,3,38,4]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",w="#000000",y="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=S.createDecorator("themeMainService");let P=class{constructor(g){this.stateMainService=g}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return w;let g=this.stateMainService.getItem(i,null);if(!g){let m;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],g=m==="hc-black"?w:m==="vs"?E:n}return L.isMacintosh&&g.toUpperCase()===n&&(g="#171717"),g}saveWindowSplash(g,m){this.stateMainService.setItems([{key:y,data:m.baseTheme},{key:i,data:m.colorInfo.background},{key:I,data:m}]),typeof g=="number"&&this.updateBackgroundColor(g,m)}updateBackgroundColor(g,m){for(const D of v.BrowserWindow.getAllWindows())if(D.id===g){D.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};P=he([te(0,A.IStateMainService)],P),e.ThemeMainService=P}),define(J[41],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(L=e.StateType||(e.StateType={}));var A;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(A=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=v.createDecorator("updateService")}),define(J[203],Z([0,1,37,48,148,3]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:A.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:A.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[A.localize(2,null),A.localize(3,null),A.localize(4,null),A.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:A.localize(6,null),deprecationMessage:A.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:A.localize(8,null),description:A.localize(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:A.localize(10,null),tags:["usesOnlineServices"]}}})}),define(J[204],Z([0,1,5,41]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class A{constructor(n){this.service=n}listen(n,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(n,w,y){switch(w){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=A;class S{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(J[98],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=v.createDecorator("urlService")}),define(J[205],Z([0,1,7]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,w){throw new Error(`Event not found: ${w}`)}call(n,w,y){switch(w){case"handleURL":return this.handler.handleURL(v.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=L;class A{constructor(n){this.channel=n}handleURL(n,w){return this.channel.call("handleURL",[n.toJSON(),w])}}e.URLHandlerChannelClient=A;class S{constructor(n){this.next=n}async routeCall(n,w,y,i){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(y){const I=v.URI.revive(y);if(I&&I.query){const P=/\bwindowId=(\d+)/.exec(I.query);if(P){const p=P[1],g=new RegExp(`window:${p}`),m=n.connections.find(D=>g.test(D.ctx));if(m)return m}}}return this.next.routeCall(n,w,y,i)}routeEvent(n,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=S}),define(J[206],Z([0,1,7,9,2,22]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends A.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,i){const I=[...this.handlers.values()];return L.first(I.map(P=>()=>P.handleURL(y,i)),void 0,!1).then(P=>P||!1)}registerHandler(y){return this.handlers.add(y),A.toDisposable(()=>this.handlers.delete(y))}}e.AbstractURLService=E;let n=class extends E{constructor(y){super();this.productService=y}create(y){let{authority:i,path:I,query:P,fragment:p}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),v.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:P,fragment:p})}};n=he([te(0,S.IProductService)],n),e.NativeURLService=n}),define(J[207],Z([0,1,5,14,7,2,3,9]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(i){try{return A.URI.parse(i)}catch(I){return null}}class y{constructor(I,P,p,g,m){if(this.urlService=P,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=I,E.isWindows){const c=g.isBuilt?[]:[`"${g.appRoot}"`];c.push("--open-url","--"),L.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,c)}const D=v.Event.map(v.Event.fromNodeEventEmitter(L.app,"open-url",(c,u)=>({event:c,url:u})),({event:c,url:u})=>(c.preventDefault(),u));this.disposables.add(D(c=>{const u=w(c);!u||this.urlService.open(u,{originalUrl:c})})),p.getWindows().filter(c=>c.isReady).length>0?this.flush():v.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const P of this.uris)await this.urlService.open(P.uri,{originalUrl:P.url})||I.push(P);I.length!==0&&(this.uris=I,this.flushDisposable=n.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(J[76],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=v.createDecorator("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[208],Z([0,1,14,2,10,7,76]),function(z,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends L.Disposable{constructor(){super();const y=v.session.fromPartition(E.webviewPartitionId),i=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i),y.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i)}async handleWebviewRequest(y,i){try{const I=S.URI.parse(y.url),P=n.validWebviewFilePaths.get(I.path);if(typeof P=="string"){const p=I.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${P}`:`vs/workbench/contrib/webview/browser/pre/${P}`,g=A.FileAccess.asFileUri(p,z);return i(decodeURIComponent(g.fsPath))}}catch(I){}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(y){return!!y.workspaceUri}e.isWorkspaceToOpen=L;function A(y){return!!y.folderUri}e.isFolderToOpen=A;function S(y){return!!y.fileUri}e.isFileToOpen=S;function E(y){const i=n(y),I=y.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||v.isMacintosh&&v.isNative?"classic":I}e.getMenuBarVisibility=E;function n(y){if(v.isWeb)return"custom";const i=y.getValue("window");if(i){if(v.isMacintosh&&i.nativeTabs===!0||v.isMacintosh&&i.nativeFullScreen===!1)return"native";const p=i.titleBarStyle;if(p==="native"||p==="custom")return p}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function w(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=w}),define(J[34],Z([0,1,4]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var L;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}));const A=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=A;var S;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var E;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(E=e.WindowError||(e.WindowError={})),e.IWindowsMainService=v.createDecorator("windowsMainService")}),define(J[209],Z([0,1,14,2,74,76,208,34]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends L.Disposable{constructor(i,I){super();this.windowsMainService=I,this._register(new E.WebviewProtocolProvider);const P=v.session.fromPartition(S.webviewPartitionId);P.setPermissionRequestHandler((p,g,m)=>m(g==="clipboard-read")),P.setPermissionCheckHandler((p,g)=>g==="clipboard-read")}async setIgnoreMenuShortcuts(i,I){let P;if(typeof i.windowId=="number"){const{windowId:p}=i,g=this.windowsMainService.getWindowById(p);if(!(g==null?void 0:g.win))throw new Error(`Invalid windowId: ${p}`);P=g.win.webContents}else{const{webContentsId:p}=i;if(P=v.webContents.fromId(p),!P)throw new Error(`Invalid webContentsId: ${p}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(I)}};w=he([te(0,A.ITunnelService),te(1,n.IWindowsMainService)],w),e.WebviewMainService=w}),define(J[210],Z([0,1,5,2,9]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends L.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:w,getActiveWindowId:y}){super();this.disposables=this._register(new L.DisposableStore),v.Event.latch(v.Event.any(n,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=A.createCancelablePromise(()=>y()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(J[211],Z([0,1,7,15,4,36]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=A.createDecorator("contextService");var E;(function(P){P[P.EMPTY=1]="EMPTY",P[P.FOLDER=2]="FOLDER",P[P.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(P){const p=P;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=n;function w(P){const p=P;return!!(p&&typeof p=="object"&&v.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=w;class y{constructor(p,g,m,D){this._id=p,this._configuration=m,this._ignorePathCasing=D,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=g}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class i{constructor(p,g){this.raw=g,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return L.joinPath(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(P){return new i({uri:P,index:0,name:L.basenameOrAuthority(P)},{uri:P.toString()})}e.toWorkspaceFolder=I}),define(J[28],Z([0,1,4,151,211,7,3,8,15,104,43,10,39,29,73]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:L.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(U){return(typeof U=="string"?n.extname(U):w.extname(U))===m}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=v.createDecorator("workspacesService");function b(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function c(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=c;function u(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=u;function l(U){const $=U;return typeof($==null?void 0:$.id)=="string"&&S.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=l;function o(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=o;function t(U){const $=U;return typeof($==null?void 0:$.id)=="string"&&S.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function r(U){const $=U;if($==null?void 0:$.uri)return{id:$.id,uri:S.URI.revive($.uri)};const G=U;if(G==null?void 0:G.configPath)return{id:G.id,configPath:S.URI.revive(G.configPath)};if(U==null?void 0:U.id)return{id:U.id}}e.reviveIdentifier=r;function s(U,$){return w.extUriBiasedIgnorePathCase.isEqualOrParent(U,$.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function a(U){return h(U)||f(U)}e.isStoredWorkspaceFolder=a;function h(U){const $=U;return typeof($==null?void 0:$.path)=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=h;function f(U){const $=U;return typeof($==null?void 0:$.uri)=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=f;function d(U,$,G,N,F=!E.isWindows,R){if(U.scheme!==N.scheme)return{name:G,uri:U.toString(!0)};let O=$?void 0:R.relativePath(N,U);if(O!==void 0)O.length===0?O=".":E.isWindows&&U.scheme===I.Schemas.file&&!F&&(O=O.replace(/\//g,"\\"));else if(U.scheme===I.Schemas.file)O=U.fsPath,E.isWindows&&(O=P.normalizeDriveLetter(O),F&&(O=p.toSlashes(O)));else{if(!R.isEqualAuthority(U.authority,N.authority))return{name:G,uri:U.toString(!0)};O=U.path}return{name:G,path:O}}e.getStoredWorkspaceFolder=d;function k(U,$,G){let N=[],F=new Set;const R=G.dirname($);for(let O of U){let M;if(h(O))O.path&&(M=G.resolvePath(R,O.path));else if(f(O))try{M=S.URI.parse(O.uri),M.path[0]!=="/"&&(M=M.with({path:"/"+M.path}))}catch(W){console.warn(W)}if(M){let W=G.getComparisonKey(M);if(!F.has(W)){F.add(W);const _=O.name||G.basenameOrAuthority(M);N.push(new A.WorkspaceFolder({uri:M,name:_,index:N.length},O))}}}return N}e.toWorkspaceFolders=k;function T(U,$,G,N,F){let R=C($,U);const O=F.dirname($),M=F.dirname(N),W=[],_=V(R.folders);for(const x of R.folders){const ne=h(x)?F.resolvePath(O,x.path):S.URI.parse(x.uri);let re;G?re=!1:re=!h(x)||n.isAbsolute(x.path),W.push(d(ne,re,x.name,M,_,F))}const q={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},K=y.setProperty(U,["folders"],W,q);let H=y.applyEdits(U,K);return R.remoteAuthority===g.getRemoteAuthority(N)&&(H=y.applyEdits(H,y.removeProperty(H,["remoteAuthority"],q))),H}e.rewriteWorkspaceFileForNewLocation=T;function C(U,$){let G=i.parse($);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(N=>a(N));else throw new Error(`${U} looks like an invalid workspace file.`);return G}function V(U){return E.isWindows?U.some($=>h($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=V;function X(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function ee(U){return typeof U.folderUri=="string"}function B(U){return typeof U.fileUri=="string"}function Y(U,$){const G={workspaces:[],files:[]};if(U){const N=function(R,O){for(let M=0;M<R.length;M++)try{O(R[M],M)}catch(W){$.warn(`Error restoring recent entry ${JSON.stringify(R[M])}: ${W.toString()}. Skip entry.`)}},F=U;if(Array.isArray(F.entries))N(F.entries,R=>{const O=R.label,M=R.remoteAuthority;X(R)?G.workspaces.push({label:O,remoteAuthority:M,workspace:{id:R.workspace.id,configPath:S.URI.parse(R.workspace.configPath)}}):ee(R)?G.workspaces.push({label:O,remoteAuthority:M,folderUri:S.URI.parse(R.folderUri)}):B(R)&&G.files.push({label:O,remoteAuthority:M,fileUri:S.URI.parse(R.fileUri)})});else{const R=U;Array.isArray(R.workspaces3)&&N(R.workspaces3,(O,M)=>{const W=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[M]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?G.workspaces.push({label:W,workspace:{id:O.id,configPath:S.URI.parse(O.configURIPath)}}):typeof O=="string"&&G.workspaces.push({label:W,folderUri:S.URI.parse(O)})}),Array.isArray(R.files2)&&N(R.files2,(O,M)=>{const W=Array.isArray(R.fileLabels)&&R.fileLabels[M]||void 0;typeof O=="string"&&G.files.push({label:W,fileUri:S.URI.parse(O)})})}}return G}e.restoreRecentlyOpened=Y;function Q(U){const $={entries:[]};for(const G of U.workspaces)c(G)?$.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):$.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of U.files)$.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return $}e.toStoreData=Q}),define(J[50],Z([0,1,4,28]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=v.createDecorator("backupMainService");function A(S){const E=S;return E&&L.isWorkspaceIdentifier(E.workspace)}e.isWorkspaceBackupInfo=A}),define(J[51],Z([0,1,4,14,9,38,3,8,65,16,13,133,28,39,2,80]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=v.createDecorator("dialogMainService");let D=class gt{constructor(c){this.stateMainService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new A.Queue}pickFileFolder(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,pickFiles:!0,title:I.localize(0,null)}),u)}pickFolder(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFolders:!0,title:I.localize(1,null)}),u)}pickFile(c,u){return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:I.localize(2,null)}),u)}pickWorkspace(c,u){const l=I.localize(3,null),o=p.mnemonicButtonLabel(I.localize(4,null)),t=P.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},c),{pickFiles:!0,title:l,filters:t,buttonLabel:o}),u)}async doPick(c,u){const l={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};l.defaultPath=c.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(l.properties=void 0,c.pickFiles&&c.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&l.properties.push("treatPackageAsDirectory");const o=u||L.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(l,i.withNullAsUndefined(o));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,n.dirname(t.filePaths[0])),t.filePaths}getWindowDialogQueue(c){if(c){let u=this.windowDialogQueues.get(c.id);return u||(u=new A.Queue,this.windowDialogQueues.set(c.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(c,u){return this.getWindowDialogQueue(u).queue(async()=>u?L.dialog.showMessageBox(u,c):L.dialog.showMessageBox(c))}async showSaveDialog(c,u){const l=this.acquireFileDialogLock(c,u);if(!l)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let o;return u?o=await L.dialog.showSaveDialog(u,c):o=await L.dialog.showSaveDialog(c),o.filePath=this.normalizePath(o.filePath),o})}finally{g.dispose(l)}}normalizePath(c){return c&&E.isMacintosh&&(c=w.normalizeNFC(c)),c}normalizePaths(c){return c.map(u=>this.normalizePath(u))}async showOpenDialog(c,u){c.defaultPath&&(await y.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const l=this.acquireFileDialogLock(c,u);if(!l)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let o;return u?o=await L.dialog.showOpenDialog(u,c):o=await L.dialog.showOpenDialog(c),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{g.dispose(l)}}acquireFileDialogLock(c,u){if(!u)return g.Disposable.None;let l=this.windowFileDialogLocks.get(u.id);l||(l=new Set,this.windowFileDialogLocks.set(u.id,l));const o=m.hash(c);if(!l.has(o))return l.add(o),g.toDisposable(()=>{l==null||l.delete(o),(l==null?void 0:l.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};D.workingDirPickerStorageKey="pickerWorkingDir",D=he([te(0,S.IStateMainService)],D),e.DialogMainService=D}),define(J[212],Z([0,1,5,2,28]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends L.Disposable{constructor(n,w){super();this.logService=n,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,w)=>(n?n.push(w):n=[w],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const w=new Map,y=new Set;return n.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?w.set(i.key,I):y.add(i.key)}),{changed:Array.from(w.entries()),deleted:Array.from(y.values())}}listen(n,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(n,w,y){const i=A.reviveIdentifier(y.workspace),I=await this.withStorageInitialized(i);switch(w){case"getItems":return Array.from(I.items.entries());case"updateItems":{const P=y;if(P.insert)for(const[p,g]of P.insert)I.set(p,g);P.delete&&P.delete.forEach(p=>I.delete(p));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(n){const w=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await w.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${y}`)}return w}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[213],Z([0,1,16,5,2,6,123,86,8,96,31,27,28]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends A.Disposable{constructor(b){super();this.logService=b,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const b=await this.doCreate();this.storage.dispose(),this.storage=b,this._register(b.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(b);const c=b.getBoolean(y.IS_NEW_KEY);c===void 0?b.set(y.IS_NEW_KEY,!0):c&&b.set(y.IS_NEW_KEY,!1)}catch(b){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${b}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?b=>this.logService.trace(b):void 0,logError:b=>this.logService.error(b)}}doInit(b){return b.init()}get items(){return this.storage.items}get(b,c){return this.storage.get(b,c)}set(b,c){return this.storage.set(b,c)}delete(b){return this.storage.delete(b)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class g extends p{constructor(b,c,u){super(c);this.options=b,this.environmentService=u}async doCreate(){let b;return this.options.useInMemoryStorage?b=E.SQLiteStorageDatabase.IN_MEMORY_PATH:b=w.join(this.environmentService.globalStorageHome.fsPath,g.STORAGE_NAME),new n.Storage(new E.SQLiteStorageDatabase(b,{logging:this.createLogginOptions()}))}async doInit(b){await super.doInit(b),this.updateTelemetryState(b)}updateTelemetryState(b){b.get(i.instanceStorageKey,void 0)===void 0&&b.set(i.instanceStorageKey,I.generateUuid()),b.get(i.firstSessionDateStorageKey,void 0)===void 0&&b.set(i.firstSessionDateStorageKey,new Date().toUTCString());const l=b.get(i.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();b.set(i.lastSessionDateStorageKey,typeof l=="undefined"?null:l),b.set(i.currentSessionDateStorageKey,o)}}e.GlobalStorageMain=g,g.STORAGE_NAME="state.vscdb";class m extends p{constructor(b,c,u,l){super(u);this.workspace=b,this.options=c,this.environmentService=l}async doCreate(){const{storageFilePath:b,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new E.SQLiteStorageDatabase(b,{logging:this.createLogginOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const b=w.join(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=w.join(b,m.WORKSPACE_STORAGE_NAME);return await v.Promises.exists(b)?{storageFilePath:c,wasCreated:!1}:(await v.Promises.mkdir(b,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(b),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(b){let c;if(P.isSingleFolderWorkspaceIdentifier(this.workspace)?c={folder:this.workspace.uri.toString()}:P.isWorkspaceIdentifier(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const u=w.join(b,m.WORKSPACE_META_NAME);await v.Promises.exists(u)||await v.Promises.writeFile(u,JSON.stringify(c,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json"}),define(J[99],Z([0,1,42,2,53,4,18,6,213]),function(z,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=S.createDecorator("storageMainService");let y=class extends L.Disposable{constructor(I,P,p){super();this.logService=I,this.environmentService=P,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,P]of this.mapWorkspaceToStorage)I.join(P.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return v.once(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new w.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let P=this.mapWorkspaceToStorage.get(I.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),P=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,P),v.once(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),P}};y=he([te(0,n.ILogService),te(1,A.IEnvironmentService),te(2,E.ILifecycleMainService)],y),e.StorageMainService=y}),define(J[100],Z([0,1,7,28,15]),function(z,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(w,y,i){for(const P of w){const p=P.openedWorkspace;if(L.isWorkspaceIdentifier(p)){const g=i(p);if(g){if(g.folders.some(m=>A.extUriBiasedIgnorePathCase.isEqualOrParent(y,m.uri)))return P}else if(A.extUriBiasedIgnorePathCase.isEqualOrParent(y,p.configPath))return P}}const I=w.filter(P=>L.isSingleFolderWorkspaceIdentifier(P.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqualOrParent(y,P.openedWorkspace.uri));if(I.length)return I.sort((P,p)=>-(P.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function E(w,y){for(const i of w)if(L.isWorkspaceIdentifier(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,y)||L.isSingleFolderWorkspaceIdentifier(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,y))return i}e.findWindowOnWorkspaceOrFolder=E;function n(w,y){var i,I;const P=p=>y.some(g=>A.extUriBiasedIgnorePathCase.isEqual(v.URI.file(g),v.URI.file(p)));for(const p of w)if((I=(i=p.config)===null||i===void 0?void 0:i.extensionDevelopmentPath)===null||I===void 0?void 0:I.some(g=>P(g)))return p}e.findWindowOnExtensionDevelopmentPath=n}),define(J[214],Z([0,1,14,2,3,15,7,17,18,6,38,34,28]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class mt extends L.Disposable{constructor(u,l,o,t,r){super();this.windowsMainService=u,this.stateMainService=l,this.lifecycleMainService=o,this.logService=t,this.configurationService=r,this._state=g(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const l=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);l&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const o=D(u);this.stateMainService.setItem(mt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(o=>{var t;const r=P.isWorkspaceIdentifier(u.openedWorkspace)&&((t=o.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=P.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)&&o.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(o.folderUri,u.openedWorkspace.uri);(r||s)&&(o.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(u){return{workspace:P.isWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:P.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const l=this.doGetNewWindowState(u),o=this.configurationService.getValue("window");let t;return l.hasDefaultState?t=!!((o==null?void 0:o.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0)||A.isMacintosh&&(o==null?void 0:o.nativeFullScreen)!==!1:(t=!!(this.lifecycleMainService.wasRestarted||(o==null?void 0:o.restoreFullscreen)),t&&A.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),l.mode===3&&!t&&(l.mode=1),l}doGetNewWindowState(u){const l=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=u.workspace;if(P.isWorkspaceIdentifier(h)){const d=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===h.id).map(k=>k.uiState);if(d.length)return d[0]}if(P.isSingleFolderWorkspaceIdentifier(h)){const d=this.state.openedWindows.filter(k=>k.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(k.folderUri,h.uri)).map(k=>k.uiState);if(d.length)return d[0]}else if(u.backupPath){const d=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(d.length)return d[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!l&&f)return f.uiState}let o;const t=v.screen.getAllDisplays();if(t.length===1)o=t[0];else{if(A.isMacintosh){const h=v.screen.getCursorScreenPoint();o=v.screen.getDisplayNearestPoint(h)}!o&&l&&(o=v.screen.getDisplayMatching(l.getBounds())),o||(o=v.screen.getPrimaryDisplay()||t[0])}let r=I.defaultWindowState();r.x=Math.round(o.bounds.x+o.bounds.width/2-r.width/2),r.y=Math.round(o.bounds.y+o.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let a=!0;if(A.isMacintosh&&(s==null?void 0:s.nativeFullScreen)!==!1&&(l==null?void 0:l.isFullScreen))r.mode=3;else if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,a=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,a=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&l){const h=l.serializeWindowState();h.mode===3?r.mode=3:r=h,a=r.mode!==3&&s.newWindowDimensions==="offset"}}return a&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const l=this.windowsMainService.getWindows().map(o=>o.getBounds());for(;l.some(o=>o.x===u.x||o.y===u.y);)u.x+=30,u.y+=30;return u}};p.windowsStateStorageKey="windowsState",p=he([te(0,I.IWindowsMainService),te(1,i.IStateMainService),te(2,w.ILifecycleMainService),te(3,y.ILogService),te(4,n.IConfigurationService)],p),e.WindowsStateHandler=p;function g(c){const u={openedWindows:[]},l=c||{openedWindows:[]};return l.lastActiveWindow&&(u.lastActiveWindow=m(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(u.openedWindows=l.openedWindows.map(o=>m(o))),u}e.restoreWindowsState=g;function m(c){const u={uiState:c.uiState};return c.backupPath&&(u.backupPath=c.backupPath),c.remoteAuthority&&(u.remoteAuthority=c.remoteAuthority),c.folder&&(u.folderUri=E.URI.parse(c.folder)),c.workspaceIdentifier&&(u.workspace={id:c.workspaceIdentifier.id,configPath:E.URI.parse(c.workspaceIdentifier.configURIPath)}),u}function D(c){return{lastActiveWindow:c.lastActiveWindow&&b(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&b(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(u=>b(u))}}e.getWindowsStateStoreData=D;function b(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(J[56],Z([0,1,58,59,215,5,33,8,26,27,2,20,84,19,3]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(d){this.socket=d,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;p.onUnexpectedError(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const k=T=>d(I.VSBuffer.wrap(T));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(d){const k=T=>{d({type:0,hadError:T,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,k=>{if(k){if(k.code==="EPIPE")return;p.onUnexpectedError(k)}})}catch(k){if(k.code==="EPIPE")return;p.onUnexpectedError(k)}}end(){this.socket.end()}drain(){return new Promise((d,k)=>{if(this.socket.bufferSize===0){d();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),d()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=m;var D;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var b;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(b||(b={}));class c extends i.Disposable{constructor(d,k,T,C){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=C,k?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",V=>{console.error(V),p.onUnexpectedError(V),this._onClose.fire({type:0,hadError:!0,error:V})}),this._zlibInflate.on("data",V=>{this._pendingInflateData.push(V)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",V=>{console.error(V),p.onUnexpectedError(V),this._onClose.fire({type:0,hadError:!0,error:V})}),this._zlibDeflate.on("data",V=>{this._pendingDeflateData.push(V)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new P.ChunkStream,this._register(this.socket.onData(V=>this._acceptChunk(V))),this._register(this.socket.onClose(V=>this._onClose.fire(V)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(I.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,k){let T=2;d.byteLength<126?T+=0:d.byteLength<2**16?T+=2:T+=8;const C=I.VSBuffer.alloc(T);if(k?C.writeUInt8(194,0):C.writeUInt8(130,0),d.byteLength<126)C.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){C.writeUInt8(126,1);let V=1;C.writeUInt8(d.byteLength>>>8&255,++V),C.writeUInt8(d.byteLength>>>0&255,++V)}else{C.writeUInt8(127,1);let V=1;C.writeUInt8(0,++V),C.writeUInt8(0,++V),C.writeUInt8(0,++V),C.writeUInt8(0,++V),C.writeUInt8(d.byteLength>>>24&255,++V),C.writeUInt8(d.byteLength>>>16&255,++V),C.writeUInt8(d.byteLength>>>8&255,++V),C.writeUInt8(d.byteLength>>>0&255,++V)}this._totalOutgoingWireBytes+=C.byteLength+d.byteLength,this.socket.write(I.VSBuffer.concat([C,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),C=(k.readUInt8(0)&128)>>>7,V=k.readUInt8(1),X=(V&128)>>>7,ee=V&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=C,this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),T=k.readUInt8(1),C=(T&128)>>>7;let V=T&127,X=1;V===126?V=k.readUInt8(++X)*2**8+k.readUInt8(++X):V===127&&(V=k.readUInt8(++X)*0+k.readUInt8(++X)*0+k.readUInt8(++X)*0+k.readUInt8(++X)*0+k.readUInt8(++X)*2**24+k.readUInt8(++X)*2**16+k.readUInt8(++X)*2**8+k.readUInt8(++X));let ee=0;C&&(ee=k.readUInt8(++X)*2**24+k.readUInt8(++X)*2**16+k.readUInt8(++X)*2**8+k.readUInt8(++X)),this._state.state=3,this._state.readLen=V,this._state.mask=ee}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);u(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(I.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function u(f,d){if(d===0)return;let k=f.byteLength>>>2;for(let B=0;B<k;B++){const Y=f.readUInt32BE(B*4);f.writeUInt32BE(Y^d,B*4)}let T=k*4,C=f.byteLength-T;const V=d>>>24&255,X=d>>>16&255,ee=d>>>8&255;C>=1&&f.writeUInt8(f.readUInt8(T)^V,T),C>=2&&f.writeUInt8(f.readUInt8(T+1)^X,T+1),C>=3&&f.writeUInt8(f.readUInt8(T+2)^ee,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function o(){const f=y.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let d;return e.XDG_RUNTIME_DIR?d=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):d=n.join(w.tmpdir(),`vscode-ipc-${f}.sock`),r(d),d}e.createRandomIPCHandle=o;function t(f,d,k){const T=v.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${k}-${d}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=n.join(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${k}-${d}.sock`):C=n.join(f,`${k}-${d}.sock`),r(C),C}e.createStaticIPCHandle=t;function r(f){const d=l[g.platform];typeof d=="number"&&f.length>=d&&console.warn(`WARNING: IPC handle "${f}" is longer than ${d} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(d){super(s.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const k=S.Event.fromNodeEventEmitter(d,"connection");return S.Event.map(k,T=>({protocol:new P.Protocol(new m(T)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(f){return new Promise((d,k)=>{const T=L.createServer();T.on("error",k),T.listen(f,()=>{T.removeListener("error",k),d(new s(T))})})}e.serve=a;function h(f,d){return new Promise((k,T)=>{const C=L.createConnection(f,()=>{C.removeListener("error",T),k(P.Client.fromSocket(new m(C),d))});C.once("error",T)})}e.connect=h}),define(J[216],Z([0,1,56]),function(z,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(w){this.driver=w}listen(w,y){throw new Error("No event found")}call(w,y,i){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2])}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=L;class A{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,y){return this.channel.call("dispatchKeybinding",[w,y])}click(w,y,i,I){return this.channel.call("click",[w,y,i,I])}doubleClick(w,y){return this.channel.call("doubleClick",[w,y])}setValue(w,y,i){return this.channel.call("setValue",[w,y,i])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,y){return this.channel.call("isActiveElement",[w,y])}getElements(w,y,i){return this.channel.call("getElements",[w,y,i])}getElementXY(w,y,i,I){return this.channel.call("getElementXY",[w,y,i,I])}typeInEditor(w,y,i){return this.channel.call("typeInEditor",[w,y,i])}getTerminalBuffer(w,y){return this.channel.call("getTerminalBuffer",[w,y])}writeInTerminal(w,y,i){return this.channel.call("writeInTerminal",[w,y,i])}}e.DriverChannelClient=A;class S{constructor(w){this.registry=w}listen(w,y){throw new Error(`Event not found: ${y}`)}call(w,y,i){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=S;async function E(n){const w=await v.connect(n,"driverClient"),y=w.getChannel("driver"),i=new A(y);return{client:w,driver:i}}e.connect=E}),define(J[24],Z([0,1,8,46,4,53,160,56]),function(z,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=A.refineServiceDecorator(S.IEnvironmentService);class w extends E.NativeEnvironmentService{get cachedLanguagesPath(){return v.join(this.userDataPath,"clp")}get backupHome(){return v.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return v.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return n.createStaticIPCHandle(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}he([L.memoize],w.prototype,"cachedLanguagesPath",null),he([L.memoize],w.prototype,"backupHome",null),he([L.memoize],w.prototype,"backupWorkspacesPath",null),he([L.memoize],w.prototype,"mainIPCHandle",null),he([L.memoize],w.prototype,"sandbox",null),he([L.memoize],w.prototype,"driverVerbose",null),he([L.memoize],w.prototype,"disableUpdates",null),he([L.memoize],w.prototype,"disableKeytar",null),he([L.memoize],w.prototype,"codeCachePath",null),e.EnvironmentMainService=w}),define(J[217],Z([0,1,30,58,8,3,16,50,24,17,21,6,28,7,29,10,15]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{constructor(u,l,o){this.configurationService=l,this.logService=o,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=D.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>g.isEqual(t,r,!S.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let l=[];try{Array.isArray(u.rootURIWorkspaces)&&(l=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(l);let o=[];try{Array.isArray(u.folderURIWorkspaces)&&(o=u.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(o),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const l=this.configurationService.getValue();return((u=l==null?void 0:l.files)===null||u===void 0?void 0:u.hotExit)||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,l){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const o=this.getBackupPath(u.workspace.id);return l&&this.moveBackupFolderSync(o,l),o}moveBackupFolderSync(u,l){if(v.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),v.existsSync(l))try{v.renameSync(l,u)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}unregisterWorkspaceBackupSync(u){const l=u.id,o=this.workspaces.findIndex(t=>t.workspace.id===l);o!==-1&&(this.workspaces.splice(o,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(l=>this.backupUriComparer.isEqual(u,l))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const l=this.folders.findIndex(o=>this.backupUriComparer.isEqual(u,o));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(u,l){const o=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o))||(this.emptyWindows.push({backupFolder:o,remoteAuthority:l}),this.saveSync()),this.getBackupPath(o)}unregisterEmptyWindowBackupSync(u){const l=this.emptyWindows.findIndex(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,u));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(u){return A.join(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const l=new Set,o=[];for(let t of u){const r=t.workspace;if(!P.isWorkspaceIdentifier(r))return[];if(!l.has(r.id)){l.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==m.Schemas.file||await E.Promises.exists(r.configPath.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateFolders(u){if(!Array.isArray(u))return[];const l=[],o=new Set;for(let t of u){const r=this.backupUriComparer.getComparisonKey(t);if(!o.has(r)){o.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==m.Schemas.file||await E.Promises.exists(t.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const l=[],o=new Set;for(let t of u){const r=t.backupFolder;if(typeof r!="string")return[];if(!o.has(r)){o.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?l.push(t):await this.deleteStaleBackup(s)}}return l}async deleteStaleBackup(u){try{await E.Promises.exists(u)&&await E.Promises.rm(u,E.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const o=this.getBackupPath(l);try{await E.Promises.rename(u,o)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const o=this.getBackupPath(l);try{v.renameSync(u,o)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const u=[];for(const l of this.workspaces)await this.hasBackups(l)&&u.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&u.push(l);return u}hasBackups(u){let l;return p.URI.isUri(u)?l=this.getBackupPath(this.getFolderHash(u)):n.isWorkspaceBackupInfo(u)?l=this.getBackupPath(u.workspace.id):l=u.backupFolder,this.doHasBackups(l)}async doHasBackups(u){try{const l=await E.Promises.readdir(u);for(const o of l)try{if((await E.Promises.readdir(A.join(u,o))).length>0)return!0}catch(t){}}catch(l){}return!1}saveSync(){try{E.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let l;return u.scheme===m.Schemas.file?l=S.isLinux?u.fsPath:u.fsPath.toLowerCase():l=u.toString().toLowerCase(),L.createHash("md5").update(l).digest("hex")}};b=he([te(0,w.IEnvironmentMainService),te(1,y.IConfigurationService),te(2,I.ILogService)],b),e.BackupMainService=b}),define(J[45],Z([0,1,40,114,145,82,5,34,14,18,3,24,51,16,7,31,4,26,66,6,8,22,46,2,60]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=D.createDecorator("nativeHostMainService");let a=class ct extends r.Disposable{constructor(f,d,k,T,C,V,X,ee,B){super();this.sharedProcess=f,this.windowsMainService=d,this.dialogMainService=k,this.lifecycleMainService=T,this.environmentMainService=C,this.telemetryService=V,this.logService=X,this.productService=ee,this.themeMainService=B,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-maximize",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-unmaximize",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-blur",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-focus",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(w.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(w.screen,"display-metrics-changed",(Y,Q,U)=>U),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),E.Event.fromNodeEventEmitter(w.screen,"display-added"),E.Event.fromNodeEventEmitter(w.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors,dark:w.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(d=>{var k,T;return{id:d.id,workspace:d.openedWorkspace,title:(T=(k=d.win)===null||k===void 0?void 0:k.getTitle())!==null&&T!==void 0?T:"",filename:d.getRepresentedFilename(),dirty:d.isDocumentEdited()}})}async getWindowCount(f){return this.windowsMainService.getWindowCount()}async getActiveWindowId(f){const d=w.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(d)return d.id}openWindow(f,d,k){return Array.isArray(d)?this.doOpenWindow(f,d,k):this.doOpenEmptyWindow(f,d)}async doOpenWindow(f,d,k=Object.create(null)){d.length>0&&this.windowsMainService.open({context:5,contextWindowId:f,urisToOpen:d,cli:this.environmentMainService.args,forceNewWindow:k.forceNewWindow,forceReuseWindow:k.forceReuseWindow,preferNewWindow:k.preferNewWindow,diffMode:k.diffMode,addMode:k.addMode,gotoLineMode:k.gotoLineMode,noRecentEntry:k.noRecentEntry,waitMarkerFileURI:k.waitMarkerFileURI,remoteAuthority:k.remoteAuthority||void 0})}async doOpenEmptyWindow(f,d){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:f},d)}async toggleFullScreen(f){const d=this.windowById(f);d&&d.toggleFullScreen()}async handleTitleDoubleClick(f){const d=this.windowById(f);d&&d.handleTitleDoubleClick()}async isMaximized(f){const d=this.windowById(f);return(d==null?void 0:d.win)?d.win.isMaximized():!1}async maximizeWindow(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.maximize()}async unmaximizeWindow(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.unmaximize()}async minimizeWindow(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.minimize()}async focusWindow(f,d){var k;d&&typeof d.windowId=="number"&&(f=d.windowId);const T=this.windowById(f);T&&T.focus({force:(k=d==null?void 0:d.force)!==null&&k!==void 0?k:!1})}async setMinimumSize(f,d,k){const T=this.windowById(f);if(T==null?void 0:T.win){const[C,V]=T.win.getSize(),[X,ee]=T.win.getMinimumSize(),[B,Y]=[d??X,k??ee],[Q,U]=[Math.max(C,B),Math.max(V,Y)];(X!==B||ee!==Y)&&T.win.setMinimumSize(B,Y),(C!==Q||V!==U)&&T.win.setSize(Q,U)}}async saveWindowSplash(f,d){this.themeMainService.saveWindowSplash(f,d)}async installShellCommand(f){const{source:d,target:k}=await this.getShellCommandLink();try{const{symbolicLink:T}=await p.SymlinkSupport.stat(d);if(T&&!T.dangling){const C=await S.realpath(d);if(k===C)return}await p.Promises.unlink(d)}catch(T){if(T.code!=="ENOENT")throw T}try{await p.Promises.symlink(k,d)}catch(T){if(T.code!=="EACCES"&&T.code!=="ENOENT")throw T;const{response:C}=await this.showMessageBox(f,{type:"info",message:A.localize(0,null,this.productService.nameShort),buttons:[A.localize(1,null),A.localize(2,null)],cancelId:1});if(C===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${k}' '${d}'\\" with administrator privileges"`;await L.promisify(v.exec)(V)}catch(V){throw new Error(A.localize(3,null,d))}}}async uninstallShellCommand(f){const{source:d}=await this.getShellCommandLink();try{await p.Promises.unlink(d)}catch(k){switch(k.code){case"EACCES":const{response:T}=await this.showMessageBox(f,{type:"info",message:A.localize(4,null,this.productService.nameShort),buttons:[A.localize(5,null),A.localize(6,null)],cancelId:1});if(T===0)try{const C=`osascript -e "do shell script \\"rm '${d}'\\" with administrator privileges"`;await L.promisify(v.exec)(C)}catch(C){throw new Error(A.localize(7,null,d))}break;case"ENOENT":break;default:throw k}}}async getShellCommandLink(){const f=l.resolve(this.environmentMainService.appRoot,"bin","code"),d=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.Promises.exists(f))throw new Error(A.localize(8,null,f));return{source:d,target:f}}async showMessageBox(f,d){return this.dialogMainService.showMessageBox(d,this.toBrowserWindow(f))}async showSaveDialog(f,d){return this.dialogMainService.showSaveDialog(d,this.toBrowserWindow(f))}async showOpenDialog(f,d){return this.dialogMainService.showOpenDialog(d,this.toBrowserWindow(f))}toBrowserWindow(f){const d=this.windowById(f);if(d==null?void 0:d.win)return d.win}async pickFileFolderAndOpen(f,d){const k=await this.dialogMainService.pickFileFolder(d);k&&(this.sendPickerTelemetry(k,d.telemetryEventName||"openFileFolder",d.telemetryExtraData),this.doOpenPicked(await Promise.all(k.map(async T=>await p.SymlinkSupport.existsDirectory(T)?{folderUri:g.URI.file(T)}:{fileUri:g.URI.file(T)})),d,f))}async pickFolderAndOpen(f,d){const k=await this.dialogMainService.pickFolder(d);k&&(this.sendPickerTelemetry(k,d.telemetryEventName||"openFolder",d.telemetryExtraData),this.doOpenPicked(k.map(T=>({folderUri:g.URI.file(T)})),d,f))}async pickFileAndOpen(f,d){const k=await this.dialogMainService.pickFile(d);k&&(this.sendPickerTelemetry(k,d.telemetryEventName||"openFile",d.telemetryExtraData),this.doOpenPicked(k.map(T=>({fileUri:g.URI.file(T)})),d,f))}async pickWorkspaceAndOpen(f,d){const k=await this.dialogMainService.pickWorkspace(d);k&&(this.sendPickerTelemetry(k,d.telemetryEventName||"openWorkspace",d.telemetryExtraData),this.doOpenPicked(k.map(T=>({workspaceUri:g.URI.file(T)})),d,f))}doOpenPicked(f,d,k){this.windowsMainService.open({context:3,contextWindowId:k,cli:this.environmentMainService.args,urisToOpen:f,forceNewWindow:d.forceNewWindow})}sendPickerTelemetry(f,d,k){const T=f?f.length:0;this.telemetryService.publicLog(d,Object.assign(Object.assign({},k),{outcome:T?"success":"canceled",numberOfPaths:T}))}async showItemInFolder(f,d){w.shell.showItemInFolder(d)}async setRepresentedFilename(f,d){const k=this.windowById(f);k&&k.setRepresentedFilename(d)}async setDocumentEdited(f,d){const k=this.windowById(f);k&&k.setDocumentEdited(d)}async openExternal(f,d){return i.isLinuxSnap?this.safeSnapOpenExternal(d):w.shell.openExternal(d),!0}safeSnapOpenExternal(f){const d=process.env.GDK_PIXBUF_MODULE_FILE,k=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,w.shell.openExternal(f),process.env.GDK_PIXBUF_MODULE_FILE=d,process.env.GDK_PIXBUF_MODULEDIR=k}moveItemToTrash(f,d){return w.shell.trashItem(d)}async isAdmin(){let f;return i.isWindows?f=(await new Promise((d,k)=>{z(["native-is-elevated"],d,k)}))():f=process.getuid()===0,f}async writeElevated(f,d,k,T){const C=await new Promise((V,X)=>{z(["sudo-prompt"],V,X)});return new Promise((V,X)=>{const ee=[`"${this.cliPath}"`];(T==null?void 0:T.unlock)&&ee.push("--file-chmod"),ee.push("--file-write",`"${d.fsPath}"`,`"${k.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?l.join(l.dirname(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};C.exec(ee.join(" "),B,(Y,Q,U)=>{Q&&this.logService.trace(`[sudo-prompt] received stdout: ${Q}`),U&&this.logService.trace(`[sudo-prompt] received stderr: ${U}`),Y?X(Y):V(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?l.join(l.dirname(process.execPath),"bin",`${this.productService.applicationName}.cmd`):l.join(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?l.join(l.dirname(process.execPath),"bin",`${this.productService.applicationName}`):l.join(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?l.join(this.environmentMainService.appRoot,"bin","code"):l.join(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:b.totalmem(),freemem:b.freemem(),loadavg:b.loadavg()}}async getOSProperties(){return{arch:b.arch(),platform:b.platform(),release:b.release(),type:b.type(),cpus:b.cpus()}}async getOSVirtualMachineHint(){return c.virtualMachineHint.value()}async killProcess(f,d,k){process.kill(d,k)}async readClipboardText(f,d){return w.clipboard.readText(d)}async writeClipboardText(f,d,k){return w.clipboard.writeText(d,k)}async readClipboardFindText(f){return w.clipboard.readFindText()}async writeClipboardFindText(f,d){return w.clipboard.writeFindText(d)}async writeClipboardBuffer(f,d,k,T){return w.clipboard.writeBuffer(d,Buffer.from(k),T)}async readClipboardBuffer(f,d){return w.clipboard.readBuffer(d)}async hasClipboard(f,d,k){return w.clipboard.has(d,k)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){w.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){w.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){w.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){w.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){w.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(f,d){const k=this.windowById(f);k&&k.updateTouchBar(d)}async notifyReady(f){const d=this.windowById(f);d&&d.setReady()}async relaunch(f,d){return this.lifecycleMainService.relaunch(d)}async reload(f,d){const k=this.windowById(f);if(k)return this.lifecycleMainService.reload(k,(d==null?void 0:d.disableExtensions)!==void 0?{_:[],"disable-extensions":d==null?void 0:d.disableExtensions}:void 0)}async closeWindow(f){this.closeWindowById(f,f)}async closeWindowById(f,d){const k=this.windowById(d);if(k==null?void 0:k.win)return k.win.close()}async quit(f){const d=this.windowsMainService.getLastActiveWindow();(d==null?void 0:d.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&d.win?d.win.close():this.lifecycleMainService.quit()}async exit(f,d){await this.lifecycleMainService.kill(d)}async resolveProxy(f,d){var k,T;const C=this.windowById(f),V=(T=(k=C==null?void 0:C.win)===null||k===void 0?void 0:k.webContents)===null||T===void 0?void 0:T.session;if(V)return V.resolveProxy(d)}async openDevTools(f,d){const k=this.windowById(f);(k==null?void 0:k.win)&&k.win.webContents.openDevTools(d)}async toggleDevTools(f){const d=this.windowById(f);(d==null?void 0:d.win)&&d.win.webContents.toggleDevTools()}async sendInputEvent(f,d){const k=this.windowById(f);(k==null?void 0:k.win)&&(d.type==="mouseDown"||d.type==="mouseUp")&&k.win.webContents.sendInputEvent(d)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(f,d,k,T){if(!i.isWindows)return;const C=await new Promise((V,X)=>{z(["vscode-windows-registry"],V,X)});try{return C.GetStringRegKey(d,k,T)}catch(V){return}}async getPassword(f,d,k){const T=await this.withKeytar(),C=await T.getPassword(d,k);if(C)try{let{content:V,hasNextChunk:X}=JSON.parse(C);if(!V||!X)return C;let ee=1;for(;X;){const B=await T.getPassword(d,`${k}-${ee}`),Y=JSON.parse(B);V+=Y.content,X=Y.hasNextChunk}return V}catch(V){return C}return C}async setPassword(f,d,k,T){const C=await this.withKeytar(),V=3,X=async(ee,B,Y)=>{let Q=0,U;for(;Q<V;)try{await C.setPassword(ee,B,Y);return}catch($){U=$,this.logService.warn("Error attempting to set a password: ",$),Q++,await new Promise(G=>setTimeout(G,200))}throw U};if(i.isWindows&&T.length>ct.MAX_PASSWORD_LENGTH){let ee=0,B=0,Y=!0;for(;Y;){const Q=T.substring(ee,ee+ct.PASSWORD_CHUNK_SIZE);ee+=ct.PASSWORD_CHUNK_SIZE,Y=T.length-ee>0;const U={content:Q,hasNextChunk:Y};await X(d,B?`${k}-${B}`:k,JSON.stringify(U)),B++}}else await X(d,k,T);this._onDidChangePassword.fire({service:d,account:k})}async deletePassword(f,d,k){const C=await(await this.withKeytar()).deletePassword(d,k);return C&&this._onDidChangePassword.fire({service:d,account:k}),C}async findPassword(f,d){return(await this.withKeytar()).findPassword(d)}async findCredentials(f,d){return(await this.withKeytar()).findCredentials(d)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((f,d)=>{z(["keytar"],f,d)})}windowById(f){if(typeof f=="number")return this.windowsMainService.getWindowById(f)}};a.MAX_PASSWORD_LENGTH=2500,a.PASSWORD_CHUNK_SIZE=a.MAX_PASSWORD_LENGTH-100,he([t.memoize],a.prototype,"cliPath",null),a=he([te(1,n.IWindowsMainService),te(2,P.IDialogMainService),te(3,y.ILifecycleMainService),te(4,I.IEnvironmentMainService),te(5,m.ITelemetryService),te(6,u.ILogService),te(7,o.IProductService),te(8,s.IThemeMainService)],a),e.NativeHostMainService=a}),define(J[218],Z([0,1,2,5,80,14,6,34,45,89,27,22,25]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let g=class extends v.Disposable{constructor(D,b,c,u,l){super();this.logService=D,this.windowsMainService=b,this.nativeHostMainService=c,this.encryptionMainService=u,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const D=L.Event.fromNodeEventEmitter(S.app,"login",(b,c,u,l,o)=>({event:b,webContents:c,req:u,authInfo:l,callback:o}));this._register(D(this.onLogin,this))}async onLogin({event:D,authInfo:b,req:c,callback:u}){if(!b.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}D.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(b);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(l==null?void 0:l.username,l==null?void 0:l.password)}async resolveProxyCredentials(D){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.doResolveProxyCredentials(D);if(b)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D){var b,c,u,l;this.logService.trace("auth#doResolveProxyCredentials - enter",D);const o=String(A.hash({scheme:D.scheme,host:D.host,port:D.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,o);if(f){const d=JSON.parse(await this.encryptionMainService.decrypt(f));t=d.username,r=d.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const a={authInfo:D,username:(c=(b=this.sessionCredentials)===null||b===void 0?void 0:b.username)!==null&&c!==void 0?c:t,password:(l=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&l!==void 0?l:r,replyChannel:`vscode:proxyAuthResponse:${i.generateUuid()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",P.CancellationToken.None,a),this.state=p.LoginDialogShown;const h=await new Promise(f=>{var d;const k=async(T,C,V)=>{var X;if(C===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(X=s.win)===null||X===void 0||X.webContents.off("ipc-message",k),V){const ee={username:V.username,password:V.password};try{if(V.remember){const B=await this.encryptionMainService.encrypt(JSON.stringify(ee));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,o,B)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,o)}catch(B){this.logService.error(B)}f({username:ee.username,password:ee.password})}else f(void 0)};(d=s.win)===null||d===void 0||d.webContents.on("ipc-message",k)});return this.sessionCredentials=h,h}};g=he([te(0,E.ILogService),te(1,n.IWindowsMainService),te(2,w.INativeHostMainService),te(3,y.IEncryptionMainService),te(4,I.IProductService)],g),e.ProxyAuthHandler=g}),define(J[219],Z([0,1,216,155,34,56,2,33,57,176,3,5,79,106,9,18,45]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(l){return l<21}let c=class{constructor(o,t,r,s,a){this.windowServer=o,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new I.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const t=this.windowsMainService.getWindowById(o);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const t=this.windowsMainService.getWindowById(o);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(o,t){await this.whenUnfrozen(o);const r=p.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(o,s)}async _dispatchKeybinding(o,t){if(t instanceof P.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(o);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,a=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),f=new y.USLayoutResolvedKeybinding(a.toChord(),i.OS).getElectronAccelerator(),d=[];t.ctrlKey&&d.push("ctrl"),t.metaKey&&d.push("meta"),t.shiftKey&&d.push("shift"),t.altKey&&d.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:f,modifiers:d}),b(t.keyCode)||s.sendInputEvent({type:"char",keyCode:f,modifiers:d}),s.sendInputEvent({type:"keyUp",keyCode:f,modifiers:d}),await g.timeout(100)}async click(o,t,r,s){await(await this.getWindowDriver(o)).click(t,r,s)}async doubleClick(o,t){await(await this.getWindowDriver(o)).doubleClick(t)}async setValue(o,t,r){await(await this.getWindowDriver(o)).setValue(t,r)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,t){return await(await this.getWindowDriver(o)).isActiveElement(t)}async getElements(o,t,r){return await(await this.getWindowDriver(o)).getElements(t,r)}async getElementXY(o,t,r,s){return await(await this.getWindowDriver(o)).getElementXY(t,r,s)}async typeInEditor(o,t,r){await(await this.getWindowDriver(o)).typeInEditor(t,r)}async getTerminalBuffer(o,t){return await(await this.getWindowDriver(o)).getTerminalBuffer(t)}async writeInTerminal(o,t,r){await(await this.getWindowDriver(o)).writeInTerminal(t,r)}async getWindowDriver(o){await this.whenUnfrozen(o);const t=`window:${o}`,r=new n.StaticRouter(a=>a===t),s=this.windowServer.getChannel("windowDriver",r);return new L.WindowDriverChannelClient(s)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await I.Event.toPromise(this.onDidReloadingChange.event)}};c=he([te(2,A.IWindowsMainService),te(3,m.ILifecycleMainService),te(4,D.INativeHostMainService)],c),e.Driver=c;async function u(l,o,t,r){const s=t.driverVerbose,a=r.createInstance(c,l,{verbose:s}),h=new v.WindowDriverRegistryChannel(a);l.registerChannel("windowDriverRegistry",h);const f=await S.serve(o),d=new v.DriverChannel(a);return f.registerChannel("driver",d),E.combinedDisposable(f,l)}e.serve=u}),define(J[220],Z([0,1,59,56]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(A,S,E,n){const w=i=>n(i,void 0),y=v.createConnection({host:A,port:S},()=>{y.removeListener("error",w);const i=Buffer.alloc(16);for(let g=0;g<16;g++)i[g]=Math.round(Math.random()*256);const I=i.toString("base64");let P=[`GET ws://${/:/.test(A)?`[${A}]`:A}:${S}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];y.write(P.join(`\r
`)+`\r
\r
`);const p=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",p),n(void 0,new L.NodeSocket(y)))};y.on("data",p)});y.once("error",w)}}}),define(J[221],Z([0,1,59,9,2,115,17,6,22,190,74,220,75]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function p(b,c,u,l,o){return new g(b,c,u,l,o).waitForReady()}class g extends A.Disposable{constructor(c,u,l,o,t){super();this.defaultTunnelHost=u,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){var c;let u=await S.findFreePortFaster((c=this.suggestedLocalPort)!==null&&c!==void 0?c:this.tunnelRemotePort,2,1e3),l=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(c){c.pause();const u=await y.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),l=u.getSocket().socket,o=u.readEntireBuffer();u.dispose(),o.byteLength>0&&c.write(o.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),l.end()}),c.on("close",()=>l.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),l.destroy()}),l.on("end",()=>c.end()),l.on("close",()=>c.end()),l.on("error",()=>{c.destroy()}),c.pipe(l),l.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),l.end()})}}let m=class extends i.AbstractTunnelService{constructor(c,u,l,o,t){super(u);this.socketFactory=c,this.signService=l,this.productService=o,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,u,l,o,t,r){const s=this.getTunnelFromMap(u,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,l,o,t,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${l} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},h=p(a,this.defaultTunnelHost,u,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,l,h),h}}};m=he([te(1,n.ILogService),te(2,P.ISignService),te(3,w.IProductService),te(4,E.IConfigurationService)],m),e.BaseTunnelService=m;let D=class extends m{constructor(c,u,l,o){super(I.nodeSocketFactory,c,u,l,o)}};D=he([te(0,n.ILogService),te(1,P.ISignService),te(2,w.IProductService),te(3,E.IConfigurationService)],D),e.TunnelService=D}),define(J[222],Z([0,1,215,192,2,13,19,191,17,6,20,53,91]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends A.Disposable{constructor(m,D,b){super();this.environmentService=D,this.logService=b,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,D){this.logService.trace("RequestService#request",m.url);const{proxyUrl:b,strictSSL:c}=this,u=Object.assign(Object.assign({},process.env),await P.resolveShellEnv(this.logService,this.environmentService.args,process.env)),l=m.agent?m.agent:await n.getProxyAgent(m.url||"",u,{proxyUrl:b,strictSSL:c});return m.agent=l,m.strictSSL=c,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,D)}async getNodeRequest(m){return(L.parse(m.url).protocol==="https:"?await new Promise((c,u)=>{z(["https"],c,u)}):await new Promise((c,u)=>{z(["http"],c,u)})).request}_request(m,D){return new Promise(async(b,c)=>{let u;const l=L.parse(m.url),o=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:S.isBoolean(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),u=o(t,r=>{const s=S.isNumber(m.followRedirects)?m.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},m),{url:r.headers.location,followRedirects:s-1}),D).then(b,c);else{let a=r;r.headers["content-encoding"]==="gzip"&&(a=r.pipe(v.createGunzip())),b({res:r,stream:i.streamToBufferReadableStream(a)})}}),u.on("error",c),m.timeout&&u.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&u.write(m.data),u.end(),D.onCancellationRequested(()=>{u.abort(),c(E.canceled())})})}async resolveProxy(m){}};p=he([te(0,w.IConfigurationService),te(1,I.INativeEnvironmentService),te(2,y.ILogService)],p),e.RequestService=p}),define(J[223],Z([0,1,222,14]),function(z,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function A(E){return L.net.request}class S extends v.RequestService{request(n,w){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:A}),w)}}e.RequestMainService=S}),define(J[224],Z([0,1,47,14,24,9,6,18,60,10,3,2,85,13,5,55]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let D=class extends I.Disposable{constructor(c,u,l,o,t,r,s){super();this.machineId=c,this.userEnv=u,this.environmentMainService=l,this.lifecycleMainService=o,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new g.Emitter),this.onDidError=g.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),L.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,u)=>this.onWindowConnection(c,u))}async onWindowConnection(c,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const l=await this.connect();if(c.sender.isDestroyed())return l.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[l])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>L.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>L.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new L.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",z).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{var u;this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,u,l)=>this._onDidError.fire({type:3,details:{reason:l,exitCode:u}})))}async connect(){await this.whenIpcReady;const c=p.assertIsDefined(this.window);return P.connect(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var c,u;return(u=(c=this.window)===null||c===void 0?void 0:c.isVisible())!==null&&u!==void 0?u:!1}};D=he([te(2,A.IEnvironmentMainService),te(3,n.ILifecycleMainService),te(4,E.ILogService),te(5,w.IThemeMainService),te(6,m.IProtocolMainService)],D),e.SharedProcess=D}),define(J[225],Z([0,1,7,8,13,6,24,9,21,20]),function(z,e,v,L,A,S,E,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(p,g,m){this.storagePath=p,this.logService=g,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,g){const m=this.storage[p];return A.isUndefinedOrNull(m)?g:m}setItem(p,g){this.setItems([{key:p,data:g}])}setItems(p){let g=!1;for(const{key:m,data:D}of p)this.storage[m]!==D&&(A.isUndefinedOrNull(D)?A.isUndefined(this.storage[m])||(this.storage[m]=void 0,g=!0):(this.storage[m]=D,g=!0));g&&this.save()}removeItem(p){A.isUndefined(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,y.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(g){this.logService.error(g)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class bt{constructor(p,g,m){this.fileStorage=new i(v.URI.file(L.join(p.userDataPath,bt.STATE_FILE)),g,m)}async init(){return this.fileStorage.init()}getItem(p,g){return this.fileStorage.getItem(p,g)}setItem(p,g){this.fileStorage.setItem(p,g)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([te(0,E.IEnvironmentMainService),te(1,S.ILogService),te(2,w.IFileService)],I),e.StateMainService=I}),define(J[77],Z([0,1,5,9,17,18,22,41,24,6,49,25]),function(z,e,v,L,A,S,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function P(g,m,D){return`${D.updateUrl}/api/update/${g}/${m}/${D.commit}`}e.createUpdateURL=P;let p=class{constructor(m,D,b,c,u,l){this.lifecycleMainService=m,this.configurationService=D,this.environmentMainService=b,this.requestService=c,this.logService=u,this.productService=l,this._state=n.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=A.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),D=this.getProductQuality(m);if(!D){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(D),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return L.timeout(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},I.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([te(0,S.ILifecycleMainService),te(1,A.IConfigurationService),te(2,w.IEnvironmentMainService),te(3,i.IRequestService),te(4,y.ILogService),te(5,E.IProductService)],p),e.AbstractUpdateService=p}),define(J[226],Z([0,1,14,2,5,46,17,18,41,31,24,6,77,49,22]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends P.AbstractUpdateService{constructor(b,c,u,l,o,t,r){super(b,c,l,o,t,r);this.telemetryService=u,this.disposables=new L.DisposableStore}get onRawError(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"error",(b,c)=>c)}get onRawUpdateNotAvailable(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(b,c,u)=>({url:c,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(b,c,u,l)=>({releaseNotes:c,version:u,productVersion:u,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(b){this.logService.error("UpdateService error:",b);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?b:void 0;this.setState(w.State.Idle(1,u))}buildUpdateFeedUrl(b){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const u=P.createUpdateURL(c,b,this.productService);try{v.autoUpdater.setFeedURL({url:u})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return u}doCheckForUpdates(b){this.setState(w.State.CheckingForUpdates(b)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(b){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(b))}onUpdateDownloaded(b){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:b.version}),this.setState(w.State.Ready(b)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([S.memoize],m.prototype,"onRawError",null),he([S.memoize],m.prototype,"onRawUpdateNotAvailable",null),he([S.memoize],m.prototype,"onRawUpdateAvailable",null),he([S.memoize],m.prototype,"onRawUpdateDownloaded",null),m=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,y.ITelemetryService),te(3,i.IEnvironmentMainService),te(4,p.IRequestService),te(5,I.ILogService),te(6,g.IProductService)],m),e.DarwinUpdateService=m}),define(J[227],Z([0,1,22,17,18,41,31,24,6,77,49,25,45]),function(z,e,v,L,A,S,E,n,w,y,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends y.AbstractUpdateService{constructor(m,D,b,c,u,l,o,t){super(m,D,c,u,l,t);this.telemetryService=b,this.nativeHostMainService=o}buildUpdateFeedUrl(m){return y.createUpdateURL(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(S.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},I.CancellationToken.None).then(i.asJson).then(D=>{!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(D))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const b=m?D.message||D:void 0;this.setState(S.State.Idle(1,b))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(S.State.Idle(1))}};p=he([te(0,A.ILifecycleMainService),te(1,L.IConfigurationService),te(2,E.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,i.IRequestService),te(5,w.ILogService),te(6,P.INativeHostMainService),te(7,v.IProductService)],p),e.LinuxUpdateService=p}),define(J[228],Z([0,1,5,9,18,41,24,6,8,30,40,31]),function(z,e,v,L,A,S,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let P=class{constructor(m,D,b){if(this.lifecycleMainService=m,this.logService=b,this._state=S.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,D.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return L.timeout(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};P=he([te(0,A.ILifecycleMainService),te(1,E.IEnvironmentMainService),te(2,n.ILogService)],P);let p=class extends P{constructor(m,D,b,c,u,l){super(b,c,u);this.snap=m,this.snapRevision=D,this.telemetryService=l;const o=y.watch(w.dirname(this.snap)),t=v.Event.fromNodeEventEmitter(o,"change",(h,f)=>f),r=v.Event.filter(t,h=>h==="current"),a=v.Event.debounce(r,(h,f)=>f,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{a.dispose(),o.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.spawn("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((b,c)=>y.realpath(`${w.dirname(this.snap)}/current`,(u,l)=>u?c(u):b(l))),D=w.basename(m);return this.snapRevision!==D}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([te(2,A.ILifecycleMainService),te(3,E.IEnvironmentMainService),te(4,n.ILogService),te(5,I.ITelemetryService)],p),e.SnapUpdateService=p}),define(J[229],Z([0,1,30,8,16,46,17,18,22,41,31,24,6,77,49,112,26,40,25,9,21,7,45]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,d=1e3){for(;!f();)await u.timeout(d)}let s;function a(){return typeof s=="undefined"&&(s=v.existsSync(L.join(L.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends p.AbstractUpdateService{constructor(d,k,T,C,V,X,ee,B,Y){super(d,k,C,V,X,Y);this.telemetryService=T,this.fileService=ee,this.nativeHostMainService=B}get cachePath(){const d=L.join(D.tmpdir(),`vscode-update-${this.productService.target}-${process.arch}`);return A.Promises.mkdir(d,{recursive:!0}).then(()=>d)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(d){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),a()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),p.createUpdateURL(k,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(y.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},c.CancellationToken.None).then(g.asJson).then(k=>{const T=a();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(y.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(y.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(y.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(C=>A.Promises.exists(C).then(V=>{if(V)return Promise.resolve(C);const X=k.url,ee=k.hash,B=`${C}.tmp`;return this.requestService.request({url:X},c.CancellationToken.None).then(Y=>this.fileService.writeFile(o.URI.file(B),Y.stream)).then(ee?()=>m.checksum(B,k.hash):()=>{}).then(()=>A.Promises.rename(B,C)).then(()=>C)})).then(C=>{const V=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:C},V&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(y.State.Downloaded(k)):this.setState(y.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const T=d?k.message||k:void 0;this.setState(y.State.Idle(a(),T))}))}async doDownloadUpdate(d){d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(y.State.Idle(a()))}async getUpdatePackagePath(d){const k=await this.cachePath;return L.join(k,`CodeSetup-${this.productService.quality}-${d}.exe`)}async cleanup(d=null){const k=d?X=>!new RegExp(`${this.productService.quality}-${d}\\.exe$`).test(X):()=>!0,T=await this.cachePath,V=(await A.Promises.readdir(T)).filter(k).map(async X=>{try{await A.Promises.unlink(L.join(T,X))}catch(ee){}});await Promise.all(V)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const d=this.state.update;this.setState(y.State.Updating(d));const k=await this.cachePath;this.availableUpdate.updateFilePath=L.join(k,`CodeSetup-${this.productService.quality}-${d.version}.flag`),await A.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),b.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(y.State.Idle(a()))});const C=`${this.productService.win32MutexName}-ready`,V=await new Promise((X,ee)=>{z(["windows-mutex"],X,ee)});r(()=>V.isActive(C)).then(()=>this.setState(y.State.Ready(d)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?v.unlinkSync(this.availableUpdate.updateFilePath):b.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};he([S.memoize],h.prototype,"cachePath",null),h=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,i.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,g.IRequestService),te(5,P.ILogService),te(6,l.IFileService),te(7,t.INativeHostMainService),te(8,w.IProductService)],h),e.Win32UpdateService=h}),define(J[52],Z([0,1,28,24,8,16,30,3,5,6,58,43,10,2,15,4,153,22,14,13,50,51,100]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=m.createDecorator("workspacesManagementMainService");let r=class extends p.Disposable{constructor(f,d,k,T,C){super();this.environmentMainService=f,this.logService=d,this.backupMainService=k,this.dialogMainService=T,this.productService=C,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==P.Schemas.file)return;let d;try{d=E.readFileSync(f.fsPath,"utf8")}catch(k){return}return this.doResolveWorkspace(f,d)}isWorkspacePath(f){return v.isUntitledWorkspace(f,this.environmentMainService)||v.hasWorkspaceFileExtension(f)}doResolveWorkspace(f,d){try{const k=this.doParseStoredWorkspace(f,d),T=s(f);return{id:T.id,configPath:T.configPath,folders:v.toWorkspaceFolders(k.folders,T.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:k.remoteAuthority}}catch(k){this.logService.warn(k.toString())}}doParseStoredWorkspace(f,d){const k=I.parse(d);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(T=>v.isStoredWorkspaceFolder(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return k}async createUntitledWorkspace(f,d){const{workspace:k,storedWorkspace:T}=this.newUntitledWorkspace(f,d),C=k.configPath.fsPath;return await S.Promises.mkdir(A.dirname(C),{recursive:!0}),await S.Promises.writeFile(C,JSON.stringify(T,null,"	")),k}createUntitledWorkspaceSync(f,d){const{workspace:k,storedWorkspace:T}=this.newUntitledWorkspace(f,d),C=k.configPath.fsPath;return E.mkdirSync(A.dirname(C),{recursive:!0}),S.writeFileSync(C,JSON.stringify(T,null,"	")),k}newUntitledWorkspace(f=[],d){const k=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=g.joinPath(this.untitledWorkspacesHome,k),C=g.joinPath(T,v.UNTITLED_WORKSPACE_NAME),V=[];for(const X of f)V.push(v.getStoredWorkspaceFolder(X.uri,!0,X.name,T,!n.isWindows,g.extUriBiasedIgnorePathCase));return{workspace:s(C),storedWorkspace:{folders:V,remoteAuthority:d}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return v.isUntitledWorkspace(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const d=g.originalFSPath(f.configPath);try{S.rimrafSync(A.dirname(d));const k=A.join(this.environmentMainService.workspaceStorageHome.fsPath,f.id);E.existsSync(k)&&S.writeFileSync(A.join(k,"obsolete"),"")}catch(k){this.logService.warn(`Unable to delete untitled workspace ${d} (${k}).`)}}getUntitledWorkspacesSync(){const f=[];try{const d=S.readdirSync(this.untitledWorkspacesHome.fsPath).map(k=>g.joinPath(this.untitledWorkspacesHome,k,v.UNTITLED_WORKSPACE_NAME));for(const k of d){const T=s(k),C=this.resolveLocalWorkspaceSync(k);C?f.push({workspace:T,remoteAuthority:C.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(d){d.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${d}).`)}return f}async enterWorkspace(f,d,k){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,d,k))return;const C=this.doEnterWorkspace(f,s(k));if(!!C)return this._onDidEnterWorkspace.fire({window:f,workspace:C.workspace}),C}async isValidTargetWorkspacePath(f,d,k){if(!k)return!0;if(v.isWorkspaceIdentifier(f.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,k))return!1;if(t.findWindowOnWorkspaceOrFolder(d,k)){const T={title:this.productService.nameLong,type:"info",buttons:[D.localize(0,null)],message:D.localize(1,null,g.basename(k)),detail:D.localize(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,u.withNullAsUndefined(c.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,d){if(!f.config)return;f.focus();let k;return f.config.extensionDevelopmentPath||(k=this.backupMainService.registerWorkspaceBackupSync({workspace:d,remoteAuthority:f.remoteAuthority},f.config.backupPath)),v.isWorkspaceIdentifier(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=d,f.config.backupPath=k,{workspace:d,backupPath:k}}};r=he([te(0,L.IEnvironmentMainService),te(1,y.ILogService),te(2,l.IBackupMainService),te(3,o.IDialogMainService),te(4,b.IProductService)],r),e.WorkspacesManagementMainService=r;function s(h){function f(){let d=h.scheme===P.Schemas.file?g.originalFSPath(h):h.toString();return n.isLinux||(d=d.toLowerCase()),i.createHash("md5").update(d).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=s;function a(h,f){function d(){if(h.scheme!==P.Schemas.file)return i.createHash("md5").update(h.toString()).digest("hex");if(!f)try{f=E.statSync(h.fsPath)}catch(C){return}let T;return n.isLinux?T=f.ino:n.isMacintosh?T=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),i.createHash("md5").update(h.fsPath).update(T?String(T):"").digest("hex")}const k=d();if(typeof k=="string")return{id:k,uri:h}}e.getSingleFolderWorkspaceIdentifier=a}),define(J[101],Z([0,1,6,98,3,4,34,16,52,17,7,14,35,54,25,28,13]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=S.createDecorator(e.ID);let b=class{constructor(u,l,o,t,r){this.logService=u,this.windowsMainService=l,this.urlService=o,this.workspacesManagementMainService=t,this.configurationService=r}async start(u,l){this.logService.trace("Received data from other instance: ",u,l),A.isMacintosh&&I.app.focus({steal:!0});const o=this.parseOpenUrl(u);if(o.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of o)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(u,l)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?P.coalesce(u._urls.map(l=>{try{return{uri:i.URI.parse(l),url:l}}catch(o){return null}})):[]}async startOpenWindow(u,l){const o=p.isLaunchedFromCli(l)?0:4;let t=[];const r=u.wait&&u.waitMarkerFilePath?i.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:o,cli:u,userEnv:l,waitMarkerFileURI:r,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let a=!1;if(u["new-window"]||u["unity-launch"])a=!0;else if(u["reuse-window"])a=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!A.isMacintosh}}if(a)t=this.windowsMainService.open({context:o,cli:u,userEnv:l,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:o,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:o,cli:u,userEnv:l,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:u.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,n.whenDeleted(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return I.BrowserWindow.getAllWindows().forEach(l=>{const o=this.windowsMainService.getWindowById(l.id);o?u.push(this.codeWindowToInfo(o)):u.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const a=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",g.CancellationToken.None,{replyChannel:a,args:h}),I.ipcMain.once(a,(f,d)=>{d||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(d)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const l=[],o=u.openedWorkspace;if(m.isSingleFolderWorkspaceIdentifier(o))l.push(o.uri);else if(m.isWorkspaceIdentifier(o)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(o.configPath);t&&t.folders.forEach(s=>{l.push(s.uri)})}return l}codeWindowToInfo(u){const l=this.getFolderURIs(u),o=D.assertIsDefined(u.win);return this.browserWindowToInfo(o,l,u.remoteAuthority)}browserWindowToInfo(u,l=[],o){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:l,remoteAuthority:o}}};b=he([te(0,v.ILogService),te(1,E.IWindowsMainService),te(2,L.IURLService),te(3,w.IWorkspacesManagementMainService),te(4,y.IConfigurationService)],b),e.LaunchMainService=b}),define(J[230],Z([0,1,143,26,47,14,101,70,24,3,6,83,51,4,61,10,45,55,2]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=p.createDecorator("issueMainService");let u=class Et{constructor(o,t,r,s,a,h,f,d){this.userEnv=o,this.environmentMainService=t,this.launchMainService=r,this.logService=s,this.diagnosticsService=a,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=d,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async o=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(o,"vscode:issueSystemInfoResponse",s)}),S.ipcMain.on("vscode:listProcesses",async o=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:v.localize(0,null),rootProcess:await I.listProcesses(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(a=>{n.isRemoteDiagnosticError(a)?t.push({name:a.hostName,rootProcess:a}):a.processes&&t.push({name:a.hostName,rootProcess:a.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(o,"vscode:listProcessesResponse",t)}),S.ipcMain.on("vscode:issueReporterClipboard",async o=>{const t={message:v.localize(1,null),type:"warning",buttons:[v.localize(2,null),v.localize(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(o,"vscode:issueReporterClipboardResponse",r.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async o=>{const t=await this.getPerformanceInfo();this.safeSend(o,"vscode:issuePerformanceInfoResponse",t)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const o={message:v.localize(4,null),type:"warning",buttons:[v.localize(5,null),v.localize(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(o,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(o,t)=>{const{id:r,from:s,args:a}=t;let h;switch(s){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}h&&h.webContents.send("vscode:runAction",{id:r,from:s,args:a})}),S.ipcMain.on("vscode:openExternal",(o,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),S.ipcMain.on("vscode:closeIssueReporter",o=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",o=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async o=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(o,"vscode:windowsInfoResponse",t.windows)})}safeSend(o,t,...r){o.sender.isDestroyed()||o.sender.send(t,...r)}async openReporter(o){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new c.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,s,{backgroundColor:o.styles.backgroundColor,title:v.localize(7,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:o,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:L.type(),arch:L.arch(),release:L.release()},product:A.default}),this.issueReporterWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",z,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(o){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new c.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,s,{backgroundColor:o.styles.backgroundColor,title:v.localize(8,null),zoomLevel:o.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:o,product:A.default}),this.processExplorerWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",z,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(o,t,r){const s=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:r.title,backgroundColor:r.backgroundColor||Et.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:g.zoomLevelToZoomFactor(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return s.setMenuBarVisibility(!1),s}async getSystemStatus(){const[o,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(o,t)}getWindowPosition(o,t,r){let s;const a=S.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(y.isMacintosh){const d=S.screen.getCursorScreenPoint();s=S.screen.getDisplayNearestPoint(d)}!s&&o&&(s=S.screen.getDisplayMatching(o.getBounds())),s||(s=S.screen.getPrimaryDisplay()||a[0])}const h={width:t,height:r},f=s.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[o,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(o,t)}catch(o){throw this.logService.warn("issueService#getPerformanceInfo ",o.message),o}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([te(1,w.IEnvironmentMainService),te(2,E.ILaunchMainService),te(3,i.ILogService),te(4,n.IDiagnosticsService),te(5,P.IDialogMainService),te(6,D.INativeHostMainService),te(7,b.IProtocolMainService)],u),e.IssueMainService=u}),define(J[231],Z([0,1,8,149,72,5,7,14,24,6,17,22,61,2,3,34,28,52,50,198,60,31,51,39,202,18,99,21,10,54,25,55]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o,t,r,s,a,h,f,d,k,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(ee){ee[ee.NONE=0]="NONE",ee[ee.LOADING=1]="LOADING",ee[ee.NAVIGATING=2]="NAVIGATING",ee[ee.READY=3]="READY"})(V||(V={}));let X=class extends p.Disposable{constructor(B,Y,Q,U,$,G,N,F,R,O,M,W,_,q){super();this.logService=Y,this.environmentMainService=Q,this.fileService=U,this.configurationService=G,this.themeMainService=N,this.workspacesManagementMainService=F,this.backupMainService=R,this.telemetryService=O,this.dialogMainService=M,this.lifecycleMainService=W,this.productService=_,this.protocolMainService=q,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[K,H]=this.restoreWindowState(B.state);this.windowState=K,this.logService.trace("window#ctor: using window state",K);const x=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!x,title:this.productService.nameLong,webPreferences:Object.assign({preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",z).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:g.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:P.zoomLevelToZoomFactor(ne==null?void 0:ne.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};g.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${g.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),g.isLinux?re.icon=v.join(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=v.join(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),g.isMacintosh&&(re.acceptFirstMouse=!0,(ne==null?void 0:ne.clickThroughInactive)===!1&&(re.acceptFirstMouse=!1));const se=g.isMacintosh&&(ne==null?void 0:ne.nativeTabs)===!0;se&&(re.tabbingIdentifier=this.productService.nameShort);const le=P.getTitleBarStyle(this.configurationService)==="custom";if(le&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,g.isMacintosh||(re.frame=!1)),A.mark("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(re),A.mark("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),g.isMacintosh&&le&&this._win.setSheetOffset(22),g.isMacintosh&&H&&(!se||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}x&&(A.mark("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),A.mark("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=u.resolveMarketplaceHeaders(this.productService.version,this.environmentMainService,this.fileService,{get:K=>$.globalStorage.get(K),store:(K,H)=>$.globalStorage.set(K,H)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.backupPath}get openedWorkspace(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.workspace}get remoteAuthority(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionDevelopmentPath)}get isExtensionTestHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var B;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((B=this.currentConfig)===null||B===void 0?void 0:B.debugId)}setRepresentedFilename(B){g.isMacintosh?this._win.setRepresentedFilename(B):this.representedFilename=B}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(B){g.isMacintosh&&this._win.setDocumentEdited(B),this.documentEdited=B}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(B){g.isMacintosh&&(B==null?void 0:B.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(B=>{if(this.isReady)return B(this);this.whenReadyCallbacks.push(B)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(B=>{function Y(){Q.dispose(),U.dispose(),B()}const Q=this.onDidClose(()=>Y()),U=this.onWillLoad(()=>Y())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,G)=>this.onWindowError(2,G)),this._win.webContents.on("did-fail-load",($,G,N)=>this.onWindowError(3,{reason:N,exitCode:G})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const B=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Y=$=>{for(let G=$;G;G=G.parent)if(G.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Q=$=>$.resourceType==="xhr"||Y($.frame);this._win.webContents.session.webRequest.onBeforeRequest(($,G)=>{const N=E.URI.parse($.url);return N.path.endsWith(".svg")&&!(B.has(N.scheme)||N.path.includes(d.Schemas.vscodeRemoteResource))?G({cancel:!Q($)}):G({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived(($,G)=>{const N=$.responseHeaders,F=N["content-type"]||N["Content-Type"];if(F&&Array.isArray(F)){const R=E.URI.parse($.url);if(R.path.endsWith(".svg")&&B.has(R.scheme))return N["Content-Type"]=["image/svg+xml"],G({cancel:!1,responseHeaders:N});if(!R.path.includes(d.Schemas.vscodeRemoteResource)&&F.some(O=>O.toLowerCase().includes("image/svg")))return G({cancel:!Q($)})}return G({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async($,G)=>{const N=await this.marketplaceHeadersPromise;G({cancel:!1,requestHeaders:Object.assign($.requestHeaders,N)})})}async onWindowError(B,Y){var Q;switch(B){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window (reason: ${(Y==null?void 0:Y.reason)||"<unknown>"}, code: ${(Y==null?void 0:Y.exitCode)||"<unknown>"})`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:B,reason:Y==null?void 0:Y.reason,code:Y==null?void 0:Y.exitCode}),B===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(0,null)),r.mnemonicButtonLabel(L.localize(1,null)),r.mnemonicButtonLabel(L.localize(2,null))],message:L.localize(3,null),detail:L.localize(4,null),noLink:!0},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(B===2){let U;Y?U=L.localize(6,null,Y.reason,(Q=Y.exitCode)!==null&&Q!==void 0?Q:"<unknown>"):U=L.localize(5,null);const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(7,null)),r.mnemonicButtonLabel(L.localize(8,null))],message:U,detail:L.localize(9,null),noLink:!0},this._win);if(!this._win)return;$.response===0?this.reload():$.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(B){var Y;((Y=this.openedWorkspace)===null||Y===void 0?void 0:Y.id)===B.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B));let Y=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(Y==null?void 0:Y.endsWith("/"))&&(Y=Y.substr(0,Y.length-1));const Q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Y||"").indexOf("@")===-1&&(Y!==this.currentHttpProxy||Q!==this.currentNoProxy)){this.currentHttpProxy=Y,this.currentNoProxy=Q;const U=Y||"",$=Q?`${Q},<local>`:"<local>";this.logService.trace(`Setting proxy to '${U}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:U,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(B){g.isMacintosh&&B.win&&this._win.addTabbedWindow(B.win)}load(B,Y=Object.create(null)){this.isDocumentEdited()&&(!Y.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Y.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(B,Y),this.readyState===0?this.currentConfig=B:(this.pendingLoadConfig=B,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",z).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:B.workspace})}updateConfiguration(B,Y){var Q,U;const $=(U=(Q=this.currentConfig)!==null&&Q!==void 0?Q:this.pendingLoadConfig)===null||U===void 0?void 0:U.userEnv;$&&k.isLaunchedFromCli($)&&!k.isLaunchedFromCli(B.userEnv)&&(B.userEnv=Object.assign(Object.assign({},$),B.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(B.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Y.disableExtensions!==void 0&&(B["disable-extensions"]=Y.disableExtensions),B.fullscreen=this.isFullScreen,B.maximized=this._win.isMaximized(),B.partsSplash=this.themeMainService.getWindowSplash(),A.mark("code/willOpenNewWindow"),B.perfMarks=A.getMarks(),this.configObjectUrl.update(B)}async reload(B){const Y=Object.assign({},this.currentConfig);Y.workspace=await this.validateWorkspace(Y),delete Y.filesToOpenOrCreate,delete Y.filesToDiff,delete Y.filesToWait,this.isExtensionDevelopmentHost&&B&&(Y.verbose=B.verbose,Y.debugId=B.debugId,Y["inspect-extensions"]=B["inspect-extensions"],Y["inspect-brk-extensions"]=B["inspect-brk-extensions"],Y["extensions-dir"]=B["extensions-dir"]),Y.isInitialStartup=!1,this.load(Y,{isReload:!0,disableExtensions:B==null?void 0:B["disable-extensions"]})}async validateWorkspace(B){if(D.isWorkspaceIdentifier(B.workspace)){const Y=B.workspace.configPath;if(Y.scheme===d.Schemas.file&&!await this.fileService.exists(Y))return}else if(D.isSingleFolderWorkspaceIdentifier(B.workspace)){const Y=B.workspace.uri;if(Y.scheme===d.Schemas.file&&!await this.fileService.exists(Y))return}return B.workspace}serializeWindowState(){if(!this._win)return m.defaultWindowState();if(this.isFullScreen){let Q;try{Q=n.screen.getDisplayMatching(this.getBounds())}catch(G){}const U=m.defaultWindowState();return{mode:3,display:Q?Q.id:void 0,width:this.windowState.width||U.width,height:this.windowState.height||U.height,x:this.windowState.x||0,y:this.windowState.y||0}}const B=Object.create(null);let Y;if(!g.isMacintosh&&this._win.isMaximized()?Y=0:Y=1,Y===0?B.mode=0:B.mode=1,Y===1||Y===0){let Q;Y===1?Q=this.getBounds():Q=this._win.getNormalBounds(),B.x=Q.x,B.y=Q.y,B.width=Q.width,B.height=Q.height}return B}restoreWindowState(B){A.mark("code/willRestoreCodeWindowState");let Y=!1;if(B)try{const Q=n.screen.getAllDisplays();Y=Q.length>1,B=this.validateWindowState(B,Q)}catch(Q){this.logService.warn(`Unexpected error validating window state: ${Q}
${Q.stack}`)}return A.mark("code/didRestoreCodeWindowState"),[B||m.defaultWindowState(),Y]}validateWindowState(B,Y){var Q,U;if(this.logService.trace(`window#validateWindowState: validating window state on ${Y.length} display(s)`,B),typeof B.x!="number"||typeof B.y!="number"||typeof B.width!="number"||typeof B.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(B.width<=0||B.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Y.length===1){const N=this.getWorkingArea(Y[0]);if(N){let F=function(){!B||typeof B.x!="number"||typeof B.y!="number"||!N||(B.x<N.x&&(B.x=N.x),B.y<N.y&&(B.y=N.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",N),F(),B.width>N.width&&(B.width=N.width),B.height>N.height&&(B.height=N.height),B.x>N.x+N.width-128&&(B.x=N.x+N.width-B.width),B.y>N.y+N.height-128&&(B.y=N.y+N.height-B.height),F()}return B}if(B.display&&B.mode===3){const N=Y.find(F=>F.id===B.display);if(N&&typeof((Q=N.bounds)===null||Q===void 0?void 0:Q.x)=="number"&&typeof((U=N.bounds)===null||U===void 0?void 0:U.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const F=m.defaultWindowState(3);return F.x=N.bounds.x,F.y=N.bounds.y,F}}let $,G;try{$=n.screen.getDisplayMatching({x:B.x,y:B.y,width:B.width,height:B.height}),G=this.getWorkingArea($)}catch(N){}if($&&G&&B.x+B.width>G.x&&B.y+B.height>G.y&&B.x<G.x+G.width&&B.y<G.y+G.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",G),B}getWorkingArea(B){if(B.workArea.width>0&&B.workArea.height>0)return B.workArea;if(B.bounds.width>0&&B.bounds.height>0)return B.bounds}getBounds(){const[B,Y]=this._win.getPosition(),[Q,U]=this._win.getSize();return{x:B,y:Y,width:Q,height:U}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(B){this.useNativeFullScreen()?this.setNativeFullScreen(B):this.setSimpleFullScreen(B),this.sendWhenReady(B?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(B){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(B)}setSimpleFullScreen(B){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(B),this._win.webContents.focus()}useNativeFullScreen(){const B=this.configurationService.getValue("window");return!B||typeof B.nativeFullScreen!="boolean"||B.nativeTabs?!0:B.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let B=P.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(B)<0&&(B="classic"),B}setMenuBarVisibility(B,Y=!0){g.isMacintosh||(B==="toggle"&&Y&&this.send("vscode:showInfoMessage",L.localize(10,null)),B==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(B)}):this.doSetMenuBarVisibility(B))}doSetMenuBarVisibility(B){const Y=this.isFullScreen;switch(B){case"classic":this._win.setMenuBarVisibility(!Y),this._win.autoHideMenuBar=Y;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(B,Y,...Q){this.isReady?this.send(B,...Q):this.ready().then(()=>{Y.isCancellationRequested||this.send(B,...Q)})}send(B,...Y){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${B} for window that is destroyed`);return}this._win.webContents.send(B,...Y)}}updateTouchBar(B){!g.isMacintosh||this.touchBarGroups.forEach((Y,Q)=>{const U=B[Q];Y.segments=this.createTouchBarGroupSegments(U)})}createTouchBar(){if(!!g.isMacintosh){for(let B=0;B<10;B++){const Y=this.createTouchBarGroup();this.touchBarGroups.push(Y)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(B=[]){const Y=this.createTouchBarGroupSegments(B),Q=new n.TouchBar.TouchBarSegmentedControl({segments:Y,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:Q.segments[U].id,from:"touchbar"})}});return Q}createTouchBarGroupSegments(B=[]){return B.map(Q=>{var U,$;let G;Q.icon&&!s.ThemeIcon.isThemeIcon(Q.icon)&&(($=(U=Q.icon)===null||U===void 0?void 0:U.dark)===null||$===void 0?void 0:$.scheme)===d.Schemas.file&&(G=n.nativeImage.createFromPath(E.URI.revive(Q.icon.dark).fsPath),G.isEmpty()&&(G=void 0));let N;return typeof Q.title=="string"?N=Q.title:N=Q.title.value,{id:Q.id,label:G?void 0:N,icon:G}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};X=he([te(1,y.ILogService),te(2,w.IEnvironmentMainService),te(3,f.IFileService),te(4,h.IStorageMainService),te(5,i.IConfigurationService),te(6,l.IThemeMainService),te(7,b.IWorkspacesManagementMainService),te(8,c.IBackupMainService),te(9,o.ITelemetryService),te(10,t.IDialogMainService),te(11,a.ILifecycleMainService),te(12,I.IProductService),te(13,C.IProtocolMainService)],X),e.CodeWindow=X}),define(J[62],Z([0,1,152,35,38,14,6,39,5,3,28,52,9,15,7,10,16,18,4,2]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=c.createDecorator("workspacesHistoryMainService");let l=class Ke extends u.Disposable{constructor(f,d,k,T){super();this.stateMainService=f,this.logService=d,this.workspacesManagementMainService=k,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new P.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!y.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const d=[],k=[];for(let T of f)if(i.isRecentWorkspace(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&r(d,T.workspace)===-1&&d.push(T);else if(i.isRecentFolder(T))s(d,T.folderUri)===-1&&d.push(T);else{const C=a(k,T.fileUri)>=0,V=T.fileUri.scheme===m.Schemas.file&&Ke.COMMON_FILES_FILTER.indexOf(p.basename(T.fileUri))>=0;!C&&!V&&(k.push(T),y.isWindows&&T.fileUri.scheme===m.Schemas.file&&S.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(d,k),d.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(d.length=Ke.MAX_TOTAL_RECENT_ENTRIES),k.length>Ke.MAX_TOTAL_RECENT_ENTRIES&&(k.length=Ke.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:d,files:k}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const d=V=>{const X=t(V);for(const ee of f)if(p.extUriBiasedIgnorePathCase.isEqual(ee,X))return!1;return!0},k=this.getRecentlyOpened(),T=k.workspaces.filter(d),C=k.files.filter(d);(T.length!==k.workspaces.length||C.length!==k.files.length)&&(this.saveRecentlyOpened({files:C,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;S.app.clearRecentDocuments();const f=this.getRecentlyOpened(),d=[];let k=0;for(let C=0;C<f.workspaces.length&&k<Ke.MAX_MACOS_DOCK_RECENT_WORKSPACES;C++){const V=t(f.workspaces[C]);if(V.scheme===m.Schemas.file){const X=p.originalFSPath(V);await D.Promises.exists(X)&&(d.push(X),k++)}}const T=[];for(let C=0;C<f.files.length&&k<Ke.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;C++){const V=t(f.files[C]);if(V.scheme===m.Schemas.file){const X=p.originalFSPath(V);if(Ke.COMMON_FILES_FILTER.includes(p.basename(V))||d.includes(X))continue;await D.Promises.exists(X)&&(T.push(X),k++)}}T.reverse().forEach(C=>S.app.addRecentDocument(C)),d.reverse().forEach(C=>S.app.addRecentDocument(C))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var d,k;const T=[],C=[],V=(d=f==null?void 0:f.config)===null||d===void 0?void 0:d.workspace;i.isWorkspaceIdentifier(V)&&!this.workspacesManagementMainService.isUntitledWorkspace(V)?T.push({workspace:V}):i.isSingleFolderWorkspaceIdentifier(V)&&T.push({folderUri:V.uri});const X=(k=f==null?void 0:f.config)===null||k===void 0?void 0:k.filesToOpenOrCreate;if(X)for(let ee of X){const B=ee.fileUri;B&&a(C,B)===-1&&C.push({fileUri:B})}return this.addEntriesFromStorage(T,C),{workspaces:T,files:C}}addEntriesFromStorage(f,d){let k=this.getRecentlyOpenedFromStorage();for(let T of k.workspaces){let C=i.isRecentFolder(T)?s(f,T.folderUri):r(f,T.workspace);C>=0?f[C].label=f[C].label||T.label:f.push(T)}for(let T of k.files){let C=a(d,T.fileUri);C>=0?d[C].label=d[C].label||T.label:d.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem(Ke.recentlyOpenedStorageKey);return i.restoreRecentlyOpened(f,this.logService)}saveRecentlyOpened(f){const d=i.toStoreData(f);this.stateMainService.setItem(Ke.recentlyOpenedStorageKey,d)}updateWindowsJumpList(){if(!y.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:v.localize(0,null),description:v.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let d=[];for(let C of S.app.getJumpListSettings().removedItems){const V=C.args;if(V){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(V);X&&d.push(g.URI.parse(X[2]))}}this.removeRecentlyOpened(d);let k=!1;const T=L.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(C=>{const V=i.isRecentWorkspace(C)?C.workspace:C.folderUri,{title:X,description:ee}=this.getWindowsJumpListLabel(V,C.label);let B;return g.URI.isUri(V)?B=`--folder-uri "${V.toString()}"`:(k=!0,B=`--file-uri "${V.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:ee.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:k?v.localize(2,null):v.localize(3,null),items:T})}f.push({type:"recent"});try{S.app.setJumpList(f)}catch(d){this.logService.warn("updateWindowsJumpList#setJumpList",d)}}getWindowsJumpListLabel(f,d){if(d)return{title:n.splitName(d).name,description:d};if(g.URI.isUri(f))return{title:p.basename(f),description:o(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:v.localize(4,null),description:""};let k=p.basename(f.configPath);return k.endsWith(i.WORKSPACE_EXTENSION)&&(k=k.substr(0,k.length-i.WORKSPACE_EXTENSION.length-1)),{title:v.localize(5,null,k),description:o(f.configPath)}}};l.MAX_TOTAL_RECENT_ENTRIES=100,l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l.recentlyOpenedStorageKey="openedPathsList",l=he([te(0,A.IStateMainService),te(1,E.ILogService),te(2,I.IWorkspacesManagementMainService),te(3,b.ILifecycleMainService)],l),e.WorkspacesHistoryMainService=l;function o(h){return h.scheme==="file"?n.normalizeDriveLetter(h.fsPath):h.toString()}function t(h){return i.isRecentFolder(h)?h.folderUri:i.isRecentFile(h)?h.fileUri:h.workspace.configPath}function r(h,f){return h.findIndex(d=>i.isRecentWorkspace(d)&&d.workspace.id===f.id)}function s(h,f){return h.findIndex(d=>i.isRecentFolder(d)&&p.extUriBiasedIgnorePathCase.isEqual(d.folderUri,f))}function a(h,f){return h.findIndex(d=>p.extUriBiasedIgnorePathCase.isEqual(d.fileUri,f))}}),define(J[232],Z([0,1,144,3,24,14,61,17,31,41,22,9,6,39,34,62,181,7,38,18,45,25]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class vt{constructor(h,f,d,k,T,C,V,X,ee,B,Y){this.updateService=h,this.configurationService=f,this.windowsMainService=d,this.environmentMainService=k,this.telemetryService=T,this.workspacesHistoryMainService=C,this.stateMainService=V,this.lifecycleMainService=X,this.logService=ee,this.nativeHostMainService=B,this.productService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new I.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new I.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(L.isMacintosh||E.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(vt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(C,V,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:V==null?void 0:V.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(C,V,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:V==null?void 0:V.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(C,V,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(C,V,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const d=this.productService.reportIssueUrl;d&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(d,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(L.language){const C=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${C}lang=${L.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(L.language){const C=k.indexOf("?")>0?"&":"?";this.openUrl(`${T}${C}lang=${L.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!L.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(vt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!L.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!L.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=S.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(L.isMacintosh?new S.Menu:null);return}const f=new S.Menu;let d;if(L.isMacintosh){const T=new S.Menu;d=new S.MenuItem({label:this.productService.nameShort,submenu:T}),this.setMacApplicationMenu(T),f.append(d)}if(L.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const T=new S.Menu;T.append(new S.MenuItem({label:this.mnemonicLabel(v.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(T)}if(this.shouldDrawMenu("File")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(1,null)),submenu:T});this.setMenuById(T,"File"),f.append(C)}if(this.shouldDrawMenu("Edit")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(2,null)),submenu:T});this.setMenuById(T,"Edit"),f.append(C)}if(this.shouldDrawMenu("Selection")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(3,null)),submenu:T});this.setMenuById(T,"Selection"),f.append(C)}if(this.shouldDrawMenu("View")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(4,null)),submenu:T});this.setMenuById(T,"View"),f.append(C)}if(this.shouldDrawMenu("Go")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(5,null)),submenu:T});this.setMenuById(T,"Go"),f.append(C)}if(this.shouldDrawMenu("Run")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(6,null)),submenu:T});this.setMenuById(T,"Run"),f.append(C)}if(this.shouldDrawMenu("Terminal")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(7,null)),submenu:T});this.setMenuById(T,"Terminal"),f.append(C)}let k;if(this.shouldDrawMenu("Window")){const T=new S.Menu;k=new S.MenuItem({label:this.mnemonicLabel(v.localize(8,null)),submenu:T,role:"window"}),this.setMacWindowMenu(T)}if(k&&f.append(k),this.shouldDrawMenu("Help")){const T=new S.Menu,C=new S.MenuItem({label:this.mnemonicLabel(v.localize(9,null)),submenu:T,role:"help"});this.setMenuById(T,"Help"),f.append(C)}f.items&&f.items.length>0?S.Menu.setApplicationMenu(f):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(v.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),d=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const Q=new S.Menu;this.setMenuById(Q,"Preferences"),k=new S.MenuItem({label:this.mnemonicLabel(v.localize(11,null)),submenu:Q})}const T=new S.Menu,C=new S.MenuItem({label:v.localize(12,null),role:"services",submenu:T}),V=new S.MenuItem({label:v.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new S.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ee=new S.MenuItem({label:v.localize(15,null),role:"unhide"}),B=new S.MenuItem(this.likeAction("workbench.action.quit",{label:v.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(Q==null?void 0:Q.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Y=[f];Y.push(...d),k&&Y.push(s(),k),Y.push(s(),C,s(),V,X,ee,s(),B),Y.forEach(Q=>h.append(Q))}shouldDrawMenu(h){if(!L.isMacintosh&&E.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(d=>{if(D.isMenubarMenuItemSeparator(d))h.append(s());else if(D.isMenubarMenuItemSubmenu(d)){const k=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(d.label),submenu:k});this.setMenu(k,d.submenu.items),h.append(T)}else D.isMenubarMenuItemRecentAction(d)?h.append(this.createOpenRecentMenuItem(d)):D.isMenubarMenuItemAction(d)&&(d.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),L.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[d.id]?h.append(new S.MenuItem(this.likeAction(d.id,{label:this.mnemonicLabel(d.label),click:this.fallbackMenuHandlers[d.id]}))):h.append(this.createMenuItem(d.label,d.id,!1,d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)):h.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(d=>h.append(d)),h.append(s()))}createOpenRecentMenuItem(h){const f=b.URI.revive(h.uri),d=h.id,k=d==="openRecentFile"?{fileUri:f}:d==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new S.MenuItem(this.likeAction(d,{label:h.label,click:(T,C,V)=>{const X=this.isOptionClick(V);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!L.isMacintosh&&(h.ctrlKey||h.shiftKey)||L.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,d){const k={label:this.mnemonicLabel(h),role:d,enabled:!0};return new S.MenuItem(this.withKeybinding(f,k))}setMacWindowMenu(h){const f=new S.MenuItem({label:v.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),d=new S.MenuItem({label:v.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new S.MenuItem({label:v.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(v.localize(20,null),"workbench.action.switchWindow"),C=[];this.currentEnableNativeTabs&&(C.push(s()),C.push(this.createMenuItem(v.localize(21,null),"workbench.action.newWindowTab")),C.push(this.createRoleMenuItem(v.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.createRoleMenuItem(v.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.createRoleMenuItem(v.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.createRoleMenuItem(v.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,d,s(),T,...C,s(),k].forEach(V=>h.append(V))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:v.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:v.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:v.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,d,k){const T=this.mnemonicLabel(h),C=typeof f=="function"?f:(Y,Q,U)=>{const $=Y?Y.userSettingsLabel:null;let G=f;Array.isArray(f)&&(G=this.isOptionClick(U)?f[1]:f[0]),$&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:$}):this.runActionInRenderer({type:"commandId",commandId:G})},V=typeof d=="boolean"?d:this.windowsMainService.getWindowCount()>0,X=typeof k=="boolean"?k:!1,ee={label:T,click:C,enabled:V};X&&(ee.type="checkbox",ee.checked=X);let B;return typeof f=="string"?B=f:Array.isArray(f)&&(B=f[0]),L.isMacintosh&&(B==="editor.action.clipboardCutAction"?ee.role="cut":B==="editor.action.clipboardCopyAction"?ee.role="copy":B==="editor.action.clipboardPasteAction"&&(ee.role="paste"),B==="undo"?ee.click=this.makeContextAwareClickHandler(C,{inDevTools:Y=>Y.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?ee.click=this.makeContextAwareClickHandler(C,{inDevTools:Y=>Y.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(ee.click=this.makeContextAwareClickHandler(C,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(B,ee))}makeContextAwareClickHandler(h,f){return(d,k,T)=>{const C=S.BrowserWindow.getFocusedWindow();if(!C)return f.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return f.inDevTools(C.webContents.devToolsWebContents);h(d,k||C,T)}}runActionInRenderer(h){let f=S.BrowserWindow.getFocusedWindow();if(!f){const k=this.windowsMainService.getLastActiveWindow();(k==null?void 0:k.isMinimized())&&(f=k.win)}const d=f?this.windowsMainService.getWindowById(f.id):void 0;if(d){if(this.logService.trace("menubar#runActionInRenderer",h),L.isMacintosh&&!this.environmentMainService.isBuilt&&!d.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const k={id:h.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",o.CancellationToken.None,k)}else{const k={userSettingsLabel:h.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",o.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const d=typeof h=="string"?this.keybindings[h]:void 0;if(d==null?void 0:d.label){if(d.isNative!==!1)f.accelerator=d.label,f.userSettingsLabel=d.userSettingsLabel;else if(typeof f.label=="string"){const k=f.label.indexOf("[");k>=0?f.label=`${f.label.substr(0,k)} [${d.label}]`:f.label=`${f.label} [${d.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,d=!f.accelerator){d&&(f=this.withKeybinding(h,f));const k=f.click;return f.click=(T,C,V)=>{this.reportMenuActionTelemetry(h),k&&k(T,C,V)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return p.mnemonicMenuLabel(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([te(0,y.IUpdateService),te(1,n.IConfigurationService),te(2,g.IWindowsMainService),te(3,A.IEnvironmentMainService),te(4,w.ITelemetryService),te(5,m.IWorkspacesHistoryMainService),te(6,c.IStateMainService),te(7,u.ILifecycleMainService),te(8,P.ILogService),te(9,l.INativeHostMainService),te(10,i.IProductService)],r),e.Menubar=r;function s(){return new S.MenuItem({type:"separator"})}}),define(J[233],Z([0,1,232,6,4,18]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=A.createDecorator("menubarMainService");let E=class{constructor(w,y,i){this.instantiationService=w,this.lifecycleMainService=y,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(v.Menubar)}async updateMenubar(w,y){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(y,w)}};E=he([te(0,A.IInstantiationService),te(1,S.ILifecycleMainService),te(2,L.ILogService)],E),e.MenubarMainService=E}),define(J[234],Z([0,1,30,26,47,72,8,150,35,50,24,38,231,14,18,17,6,61,100,5,22,62,3,28,4,10,7,15,73,214,52,42,2,51,13,29,39,25,21,32,55]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o,t,r,s,a,h,f,d,k,T,C,V,X,ee,B,Y,Q,U,$,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(O){return r.isWorkspaceIdentifier(O==null?void 0:O.workspace)}function F(O){return r.isSingleFolderWorkspaceIdentifier(O==null?void 0:O.workspace)}let R=class xe extends V.Disposable{constructor(M,W,_,q,K,H,x,ne,re,se,le,oe,ue,me,Se){super();this.machineId=M,this.initialUserEnv=W,this.logService=_,this.stateMainService=q,this.environmentMainService=K,this.lifecycleMainService=H,this.backupMainService=x,this.configurationService=ne,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=le,this.dialogMainService=oe,this.fileService=ue,this.productService=me,this.protocolMainService=Se,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new k.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(M=>this._onDidSignalReadyWindow.fire(M.window))),this._register(this.onDidSignalReadyWindow(M=>{var W,_;if(((W=M.config)===null||W===void 0?void 0:W.extensionDevelopmentPath)||((_=M.config)===null||_===void 0?void 0:_.extensionTestsPath)){const q=new V.DisposableStore;if(q.add(u.Event.any(M.onDidClose,M.onDidDestroy)(()=>q.dispose())),M.config.extensionDevelopmentPath)for(const K of M.config.extensionDevelopmentPath)q.add(this.protocolMainService.addValidFileRoot(h.URI.file(K)));M.config.extensionTestsPath&&q.add(this.protocolMainService.addValidFileRoot(h.URI.file(M.config.extensionTestsPath)))}}))}openEmptyWindow(M,W){let _=this.environmentMainService.args;const q=(W==null?void 0:W.remoteAuthority)||void 0,K=!0,H=W==null?void 0:W.forceReuseWindow,x=!H;return this.open(Object.assign(Object.assign({},M),{cli:_,forceEmpty:K,forceNewWindow:x,forceReuseWindow:H,remoteAuthority:q}))}open(M){this.logService.trace("windowsManager#open"),M.addMode&&(M.initialStartup||!this.getLastActiveWindow())&&(M.addMode=!1);const W=[],_=[],q=[],K=[],H=[];let x,ne=0;const re=this.getPathsToOpen(M);this.logService.trace("windowsManager#open pathsToOpen",re);for(const me of re)F(me)?M.addMode?W.push(me):_.push(me):N(me)?q.push(me):me.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),x.filesToOpenOrCreate.push(me)):me.backupPath?H.push({backupFolder:E.basename(me.backupPath),remoteAuthority:me.remoteAuthority}):ne++;M.diffMode&&(x==null?void 0:x.filesToOpenOrCreate.length)===2&&(x.filesToDiff=x.filesToOpenOrCreate,x.filesToOpenOrCreate=[]),x&&M.waitMarkerFileURI&&(x.filesToWait={paths:[...x.filesToDiff,...x.filesToOpenOrCreate],waitMarkerFileUri:M.waitMarkerFileURI}),M.initialStartup?(K.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),q.push(...K),H.push(...this.backupMainService.getEmptyWindowBackupPaths())):H.length=0;const{windows:se,filesOpenedInWindow:le}=this.doOpen(M,q,_,H,ne,x,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${_.length}, emptyToRestore: ${H.length}, emptyToOpen: ${ne})`),se.length>1)if(le)le.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!M.forceEmpty&&!M.cli._.length&&!M.cli["file-uri"]&&!M.cli["folder-uri"]&&!(M.urisToOpen&&M.urisToOpen.length);let Se=!0,De=!0;if(me){const Ie=se.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),Se=!1,De=!1)}if(Se)for(let Ie=se.length-1;Ie>=0;Ie--){const we=se[Ie];if(!(we.openedWorkspace&&K.some(ye=>we.openedWorkspace&&ye.workspace.id===we.openedWorkspace.id)||we.backupPath&&H.some(ye=>we.backupPath&&ye.backupFolder===E.basename(we.backupPath)))){we.focus(),De=!1;break}}De&&se[se.length-1].focus()}const oe=x&&x.filesToDiff.length>0;if(!se.some(me=>me.isExtensionDevelopmentHost)&&!oe&&!M.noRecentEntry){const me=[];for(const Se of re)N(Se)?me.push({label:Se.label,workspace:Se.workspace,remoteAuthority:Se.remoteAuthority}):F(Se)?me.push({label:Se.label,folderUri:Se.workspace.uri,remoteAuthority:Se.remoteAuthority}):Se.fileUri&&me.push({label:Se.label,fileUri:Se.fileUri,remoteAuthority:Se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const ue=M.waitMarkerFileURI;return M.context===0&&ue&&se.length===1&&se[0]&&(async()=>{await se[0].whenClosedOrLoaded;try{await this.fileService.del(ue)}catch(me){}})(),se}doOpen(M,W,_,q,K,H,x){const ne=[];let re;function se(Ie,we){ne.push(Ie),we&&(re=Ie,H=void 0)}let{openFolderInNewWindow:le,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(M);if(!M.initialStartup&&x.length>0){const Ie=x[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(Ie);we&&se(this.doAddFoldersToExistingWindow(we,x.map(ye=>ye.workspace.uri)))}const ue=_.length+W.length+q.length;if(H&&ue===0){const Ie=H.filesToOpenOrCreate[0]||H.filesToDiff[0],we=this.getWindows().filter(Ae=>H&&Ae.remoteAuthority===H.remoteAuthority);let ye;(Ie==null?void 0:Ie.fileUri)&&!oe&&((M.context===4||M.context===0||M.context===1)&&(ye=c.findWindowOnFile(we,Ie.fileUri,Ae=>Ae.configPath.scheme===a.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ae.configPath):void 0)),ye||(ye=this.doGetLastActiveWindow(we))),ye?r.isWorkspaceIdentifier(ye.openedWorkspace)?W.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):r.isSingleFolderWorkspaceIdentifier(ye.openedWorkspace)?_.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):se(this.doOpenFilesInExistingWindow(M,ye,H),!0):se(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:H,forceNewWindow:!0,remoteAuthority:H.remoteAuthority,forceNewTabbedWindow:M.forceNewTabbedWindow}),!0)}const me=w.distinct(W,Ie=>Ie.workspace.id);if(me.length>0){const Ie=w.coalesce(me.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.configPath)));if(Ie.length>0){const we=Ie[0],ye=(H==null?void 0:H.remoteAuthority)===we.remoteAuthority?H:void 0;se(this.doOpenFilesInExistingWindow(M,we,ye),!!ye),le=!0}me.forEach(we=>{if(Ie.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===we.workspace.id))return;const ye=we.remoteAuthority,Ae=(H==null?void 0:H.remoteAuthority)===ye?H:void 0;se(this.doOpenFolderOrWorkspace(M,we,le,Ae),!!Ae),le=!0})}const Se=w.distinct(_,Ie=>f.extUriBiasedIgnorePathCase.getComparisonKey(Ie.workspace.uri));if(Se.length>0){const Ie=w.coalesce(Se.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.uri)));if(Ie.length>0){const we=Ie[0],ye=(H==null?void 0:H.remoteAuthority)===we.remoteAuthority?H:void 0;se(this.doOpenFilesInExistingWindow(M,we,ye),!!ye),le=!0}Se.forEach(we=>{if(Ie.some(Te=>r.isSingleFolderWorkspaceIdentifier(Te.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,we.workspace.uri)))return;const ye=we.remoteAuthority,Ae=(H==null?void 0:H.remoteAuthority)===ye?H:void 0;se(this.doOpenFolderOrWorkspace(M,we,le,Ae),!!Ae),le=!0})}const De=w.distinct(q,Ie=>Ie.backupFolder);if(De.length>0&&De.forEach(Ie=>{const we=Ie.remoteAuthority,ye=(H==null?void 0:H.remoteAuthority)===we?H:void 0;se(this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:ye,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:M.forceNewTabbedWindow,emptyWindowBackupInfo:Ie}),!!ye),le=!0}),ne.length===0||H){H&&!K&&K++;const Ie=H?H.remoteAuthority:M.remoteAuthority;for(let we=0;we<K;we++)se(this.doOpenEmpty(M,le,Ie,H),!!H),le=!0}return{windows:w.distinct(ne),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(M,W,_){var q;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const K={filesToOpenOrCreate:_==null?void 0:_.filesToOpenOrCreate,filesToDiff:_==null?void 0:_.filesToDiff,filesToWait:_==null?void 0:_.filesToWait,termProgram:(q=M==null?void 0:M.userEnv)===null||q===void 0?void 0:q.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",Q.CancellationToken.None,K),W}doAddFoldersToExistingWindow(M,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),M.focus();const _={foldersToAdd:W};return M.sendWhenReady("vscode:addFolders",Q.CancellationToken.None,_),M}doOpenEmpty(M,W,_,q,K){return!W&&!K&&typeof M.contextWindowId=="number"&&(K=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:_,forceNewWindow:W,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:q,windowToUse:K})}doOpenFolderOrWorkspace(M,W,_,q,K){return!_&&!K&&typeof M.contextWindowId=="number"&&(K=this.getWindowById(M.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:q,windowToUse:K})}getPathsToOpen(M){var W;let _,q=!1,K=!1;if(M.urisToOpen&&M.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(M),q=!0):M.forceEmpty?_=[Object.create(null)]:M.cli._.length||M.cli["folder-uri"]||M.cli["file-uri"]?(_=this.doExtractPathsFromCLI(M.cli),_.length===0&&_.push(Object.create(null)),q=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),K=!0),!M.addMode&&q){const H=_.filter(x=>F(x));if(H.length>1){const x=H[0].remoteAuthority;if(H.every(ne=>ne.remoteAuthority===x)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(H.map(re=>({uri:re.workspace.uri})));_.push({workspace:ne,remoteAuthority:x}),_=_.filter(re=>!F(re))}}}return M.initialStartup&&!K&&((W=this.configurationService.getValue("window"))===null||W===void 0?void 0:W.restoreWindows)==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(H=>N(H)||F(H)||H.backupPath)),_}doExtractPathsFromAPI(M){const W=[],_={gotoLineMode:M.gotoLineMode,remoteAuthority:M.remoteAuthority};for(const q of w.coalesce(M.urisToOpen||[])){const K=this.resolveOpenable(q,_);if(K)K.label=q.label,W.push(K);else{const H=this.resourceFromOpenable(q),x={title:this.productService.nameLong,type:"info",buttons:[n.localize(0,null)],message:H.scheme===a.Schemas.file?n.localize(1,null):n.localize(2,null),detail:H.scheme===a.Schemas.file?n.localize(3,null,Y.getPathLabel(H.fsPath,this.environmentMainService)):n.localize(4,null,H.toString()),noLink:!0};this.dialogMainService.showMessageBox(x,ee.withNullAsUndefined(p.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(M){const W=[],_={ignoreFileNotFound:!0,gotoLineMode:M.goto,remoteAuthority:M.remote||void 0,forceOpenWorkspaceAsFile:!1},q=M["folder-uri"];if(q)for(const x of q){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable({folderUri:ne},_);re&&W.push(re)}}const K=M["file-uri"];if(K)for(const x of K){const ne=this.cliArgToUri(x);if(ne){const re=this.resolveOpenable(r.hasWorkspaceFileExtension(x)?{workspaceUri:ne}:{fileUri:ne},_);re&&W.push(re)}}const H=M._;for(const x of H){const ne=_.remoteAuthority?this.doResolvePathRemote(x,_):this.doResolveFilePath(x,_);ne&&W.push(ne)}return W}cliArgToUri(M){try{const W=h.URI.parse(M);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${M}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${M}, ${W.message}`)}}doGetPathsFromLastSession(){const M=this.getRestoreWindowsSetting();switch(M){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];M!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const q of W)if(q.workspace){const K=this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority});N(K)&&_.push(K)}else if(q.folderUri){const K=this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});F(K)&&_.push(K)}else M!=="folders"&&q.backupPath&&_.push({backupPath:q.backupPath,remoteAuthority:q.remoteAuthority});return _}}getRestoreWindowsSetting(){let M;if(this.lifecycleMainService.wasRestarted)M="all";else{const W=this.configurationService.getValue("window");M=(W==null?void 0:W.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(M)||(M="all")}return M}resolveOpenable(M,W={}){let _=this.resourceFromOpenable(M);return _.scheme===a.Schemas.file?(b.isFileToOpen(M)&&(W=Object.assign(Object.assign({},W),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(_.fsPath,W)):this.doResolveRemoteOpenable(M,W)}doResolveRemoteOpenable(M,W){let _=this.resourceFromOpenable(M);const q=d.getRemoteAuthority(_)||W.remoteAuthority;if(_=f.removeTrailingPathSeparator(f.normalizePath(_)),b.isFileToOpen(M)){if(W.gotoLineMode){const{path:K,line:H,column:x}=B.parseLineAndColumnAware(_.path);return{fileUri:_.with({path:K}),lineNumber:H,columnNumber:x,remoteAuthority:q}}return{fileUri:_,remoteAuthority:q}}else if(b.isWorkspaceToOpen(M))return{workspace:T.getWorkspaceIdentifier(_),remoteAuthority:q};return{workspace:T.getSingleFolderWorkspaceIdentifier(_),remoteAuthority:q}}resourceFromOpenable(M){return b.isWorkspaceToOpen(M)?M.workspaceUri:b.isFolderToOpen(M)?M.folderUri:M.fileUri}doResolveFilePath(M,W){let _,q;W.gotoLineMode&&({path:M,line:_,column:q}=B.parseLineAndColumnAware(M)),M=B.sanitizeFilePath(E.normalize(M),$.cwd());try{const K=v.statSync(M);if(K.isFile()){if(!W.forceOpenWorkspaceAsFile){const H=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(M));if(H)return{workspace:{id:H.id,configPath:H.configPath},remoteAuthority:H.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(M),lineNumber:_,columnNumber:q,exists:!0}}else if(K.isDirectory())return{workspace:T.getSingleFolderWorkspaceIdentifier(h.URI.file(M),K),exists:!0}}catch(K){const H=h.URI.file(M);if(this.workspacesHistoryMainService.removeRecentlyOpened([H]),W.ignoreFileNotFound)return{fileUri:H,exists:!1}}}doResolvePathRemote(M,W){const _=M.charCodeAt(0),q=W.remoteAuthority;let K,H;W.gotoLineMode&&({path:M,line:K,column:H}=B.parseLineAndColumnAware(M)),_!==47&&(B.isWindowsDriveLetter(_)&&M.charCodeAt(M.charCodeAt(1))===58&&(M=B.toSlashes(M)),M=`/${M}`);const x=h.URI.from({scheme:a.Schemas.vscodeRemote,authority:q,path:M});if(M.charCodeAt(M.length-1)!==47){if(r.hasWorkspaceFileExtension(M))return W.forceOpenWorkspaceAsFile?{fileUri:x,lineNumber:K,columnNumber:H,remoteAuthority:W.remoteAuthority}:{workspace:T.getWorkspaceIdentifier(x),remoteAuthority:q};if(W.gotoLineMode||E.posix.basename(M).indexOf(".")!==-1)return{fileUri:x,lineNumber:K,columnNumber:H,remoteAuthority:q}}return{workspace:T.getSingleFolderWorkspaceIdentifier(x),remoteAuthority:q}}shouldOpenNewWindow(M){const W=this.configurationService.getValue("window"),_=(W==null?void 0:W.openFoldersInNewWindow)||"default",q=(W==null?void 0:W.openFilesInNewWindow)||"off";let K=(M.preferNewWindow||M.forceNewWindow)&&!M.forceReuseWindow;!M.forceNewWindow&&!M.forceReuseWindow&&(_==="on"||_==="off")&&(K=_==="on");let H=!1;return M.forceNewWindow||M.forceReuseWindow?H=!!M.forceNewWindow&&!M.forceReuseWindow:(t.isMacintosh?M.context===1&&(H=!0):M.context!==3&&M.context!==2&&!(M.userEnv&&M.userEnv.TERM_PROGRAM==="vscode")&&(H=!0),!M.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(H=q==="on")),{openFolderInNewWindow:!!K,openFilesInNewWindow:H}}openExtensionDevelopmentHostWindow(M,W){const _=c.findWindowOnExtensionDevelopmentPath(this.getWindows(),M);if(_)return this.lifecycleMainService.reload(_,W.cli),_.focus(),[_];let q=W.cli["folder-uri"]||[],K=W.cli["file-uri"]||[],H=W.cli._;if(!H.length&&!q.length&&!K.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=se&&(se.workspace||se.folderUri);le&&(h.URI.isUri(le)?le.scheme===a.Schemas.file?H=[le.fsPath]:q=[le.toString()]:le.configPath.scheme===a.Schemas.file?H=[f.originalFSPath(le.configPath)]:K=[le.configPath.toString()])}let x=W.remoteAuthority;for(const se of M)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=h.URI.parse(se),oe=d.getRemoteAuthority(le);oe&&(x?oe!==x&&this.logService.error("more than one extension development path authority"):x=oe)}H=H.filter(se=>{const le=h.URI.file(se);return c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:d.getRemoteAuthority(le)===x}),q=q.filter(se=>{const le=this.cliArgToUri(se);return le&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?d.getRemoteAuthority(le)===x:!1}),K=K.filter(se=>{const le=this.cliArgToUri(se);return le&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?d.getRemoteAuthority(le)===x:!1}),W.cli._=H,W.cli["folder-uri"]=q,W.cli["file-uri"]=K;const ne=!H.length&&!q.length&&!K.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:x};return this.open(re)}openInBrowserWindow(M){var W,_,q,K,H;const x=this.configurationService.getValue("window"),ne=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),M.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:M.emptyWindowBackupInfo?E.join(this.environmentMainService.backupHome,M.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:M.remoteAuthority,workspace:M.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),M.userEnv),filesToOpenOrCreate:(W=M.filesToOpen)===null||W===void 0?void 0:W.filesToOpenOrCreate,filesToDiff:(_=M.filesToOpen)===null||_===void 0?void 0:_.filesToDiff,filesToWait:(q=M.filesToOpen)===null||q===void 0?void 0:q.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:A.default,isInitialStartup:M.initialStartup,perfMarks:S.getMarks(),os:{release:L.release(),hostname:L.hostname()},zoomLevel:typeof(x==null?void 0:x.zoomLevel)=="number"?x.zoomLevel:void 0,autoDetectHighContrast:(K=x==null?void 0:x.autoDetectHighContrast)!==null&&K!==void 0?K:!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}});let re;if(!M.forceNewWindow&&!M.forceNewTabbedWindow&&(re=M.windowToUse||this.getLastActiveWindow(),re&&re.focus()),re){const se=re.config;!ne.extensionDevelopmentPath&&se&&!!se.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=se.extensionDevelopmentPath,ne.verbose=se.verbose,ne["inspect-brk-extensions"]=se["inspect-brk-extensions"],ne.debugId=se.debugId,ne["inspect-extensions"]=se["inspect-extensions"],ne["extensions-dir"]=se["extensions-dir"])}else{const se=this.windowsStateHandler.getNewWindowState(ne);S.mark("code/willCreateCodeWindow");const le=re=this.instantiationService.createInstance(P.CodeWindow,{state:se,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});if(S.mark("code/didCreateCodeWindow"),M.forceNewTabbedWindow){const ue=this.getLastActiveWindow();ue&&ue.addTabbedWindow(le)}xe.WINDOWS.push(le),this._onDidOpenWindow.fire(le),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),C.once(le.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(le)),C.once(le.onDidClose)(()=>this.onWindowClosed(le)),C.once(le.onDidDestroy)(()=>this._onDidDestroyWindow.fire(le));const oe=ee.assertIsDefined((H=le.win)===null||H===void 0?void 0:H.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(le)),this.lifecycleMainService.registerWindow(le)}return ne.windowId=re.id,re.isReady?this.lifecycleMainService.unload(re,4).then(se=>{se||this.doOpenInBrowserWindow(re,ne,M)}):this.doOpenInBrowserWindow(re,ne,M),re}doOpenInBrowserWindow(M,W,_){if(!W.extensionDevelopmentPath)if(r.isWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if(r.isSingleFolderWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const q=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(q,W.remoteAuthority)}M.load(W)}onWindowClosed(M){const W=xe.WINDOWS.indexOf(M);xe.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const M=p.BrowserWindow.getFocusedWindow();if(M)return this.getWindowById(M.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(M){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===M))}doGetLastActiveWindow(M){const W=Math.max.apply(Math,M.map(_=>_.lastFocusTime));return M.find(_=>_.lastFocusTime===W)}sendToFocused(M,...W){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(M,Q.CancellationToken.None,...W)}sendToAll(M,W,_){for(const q of this.getWindows())_&&_.indexOf(q.id)>=0||q.sendWhenReady(M,Q.CancellationToken.None,W)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(M){const W=this.getWindows().filter(_=>_.id===M);return w.firstOrDefault(W)}getWindowByWebContents(M){const W=p.BrowserWindow.fromWebContents(M);if(!!W)return this.getWindowById(W.id)}};R.WINDOWS=[],R=he([te(2,D.ILogService),te(3,I.IStateMainService),te(4,i.IEnvironmentMainService),te(5,g.ILifecycleMainService),te(6,y.IBackupMainService),te(7,m.IConfigurationService),te(8,o.IWorkspacesHistoryMainService),te(9,T.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,X.IDialogMainService),te(12,U.IFileService),te(13,l.IProductService),te(14,G.IProtocolMainService)],R),e.WindowsMainService=R}),define(J[235],Z([0,1,52,34,62,50]),function(z,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(w,y,i,I){this.workspacesManagementMainService=w,this.windowsMainService=y,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,y){const i=this.windowsMainService.getWindowById(w);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(w,y,i){return this.workspacesManagementMainService.createUntitledWorkspace(y,i)}deleteUntitledWorkspace(w,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(w,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}async removeRecentlyOpened(w,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([te(0,v.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,A.IWorkspacesHistoryMainService),te(3,S.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[236],Z([0,1,26,30,14,3,234,18,91,41,204,33,122,85,224,101,4,71,69,6,38,24,17,98,205,31,97,199,200,196,22,218,2,34,7,28,235,66,229,227,226,230,179,19,207,219,233,119,8,15,131,10,228,99,212,217,50,62,206,52,70,157,45,51,13,39,209,76,21,43,27,20,89,210,195,54,29,9,169,184,42,73,75,90,172]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o,t,r,s,a,h,f,d,k,T,C,V,X,ee,B,Y,Q,U,$,G,N,F,R,O,M,W,_,q,K,H,x,ne,re,se,le,oe,ue,me,Se,De,Ie,we,ye,Ae,Te,$e,Ne,He,et,Be,st,tt,ut,Xe,ht,ot,j,ie,ae,ce,fe,be,Me,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ue=class extends V.Disposable{constructor(de,pe,ve,ge,Ee,ke,Re,Le,Pe,Ce){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Ee,this.lifecycleMainService=ke,this.configurationService=Re,this.stateMainService=Le,this.fileService=Pe,this.productService=Ce,this.configureSession(),this.registerListeners()}configureSession(){const de=ve=>ve.startsWith(`${x.Schemas.vscodeWebview}://`);A.session.defaultSession.setPermissionRequestHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?Ee(ge==="clipboard-read"):Ee(!1)),A.session.defaultSession.setPermissionCheckHandler((ve,ge,Ee,ke)=>de(ke.requestingUrl)?ge==="clipboard-read":!1);const pe=A.session.defaultSession;typeof pe.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&pe.setCodeCachePath(q.join(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){R.setUnexpectedErrorHandler(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>this.onUnexpectedError(ve)),process.on("unhandledRejection",ve=>R.onUnexpectedError(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),_.registerContextMenuListener(),A.app.on("accessibility-support-changed",(ve,ge)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ge)}),A.app.on("activate",(ve,ge)=>{var Ee;this.logService.trace("app#activate"),ge||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),A.app.on("web-contents-created",(ve,ge)=>{ge.on("will-attach-webview",(Ee,ke,Re)=>{const Le=Pe=>{if(!Pe)return!1;const Ce=ee.URI.parse(Pe);if(Ce.scheme===x.Schemas.vscodeWebview)return Ce.path==="/index.html"||Ce.path==="/electron-browser-index.html";const je=Ce.fsPath.toLowerCase(),qe=ee.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return je.startsWith(qe+q.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Le(Re.src)&&Le(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ee.preventDefault())}),ge.on("will-navigate",Ee=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ee.preventDefault()}),ge.setWindowOpenHandler(({url:Ee})=>{var ke;return(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,Ee),{action:"deny"}})});let de=[],pe;A.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),A.app.on("new-window-for-tab",()=>{var ve;(ve=this.windowsMainService)===null||ve===void 0||ve.openEmptyWindow({context:4})}),A.ipcMain.handle("vscode:fetchShellEnv",ve=>{var ge;const Ee=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(ve.sender);let ke,Re;return(Ee==null?void 0:Ee.config)?(ke=Ee.config,Re=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(ke=this.environmentMainService.args,Re=process.env),w.resolveShellEnv(this.logService,ke,Re)}),A.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Ee)=>{const ke=this.validateNlsPath([ge]);if(!ke||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(ke,st.VSBuffer.fromString(Ee))}),A.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Ee=this.validateNlsPath(ge);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),A.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),A.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),A.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let pe;for(const ve of de)typeof ve=="string"&&(typeof pe!="string"?pe=ve:pe=q.join(pe,ve));if(!(typeof pe!="string"||!q.isAbsolute(pe)||!ot.isEqualOrParent(pe,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return ee.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const ve={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(ve))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;S.isWindows&&de&&A.app.setAppUserModelId(de);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!A.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&A.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new P.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Ee,sharedProcessClient:ke}=this.setupSharedProcess(ve),Re=await this.initServices(ve,ge,Ee);if(this.environmentMainService.driverHandle){const Pe=await M.serve(pe,this.environmentMainService.driverHandle,this.environmentMainService,Re);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(Re.createInstance(C.ProxyAuthHandler)),Re.invokeFunction(Pe=>this.initChannels(Pe,pe,ke));const Le=Re.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));Re.invokeFunction(Pe=>this.afterWindowOpen(Pe,ge)),this.environmentMainService.args.trace&&Re.invokeFunction(Pe=>this.stopTracingEventually(Pe,Le))}async resolveMachineId(){let de=this.stateMainService.getItem(a.machineIdKey);return(!de||S.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await Q.getMachineId(),this.stateMainService.setItem(a.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(g.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(Ee,"main")})(),ge=(async()=>(await pe.whenReady(),ve))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,pe,ve){const ge=new b.ServiceCollection;switch(process.platform){case"win32":ge.set(y.IUpdateService,new c.SyncDescriptor(U.Win32UpdateService));break;case"linux":S.isLinuxSnap?ge.set(y.IUpdateService,new c.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(y.IUpdateService,new c.SyncDescriptor($.LinuxUpdateService));break;case"darwin":ge.set(y.IUpdateService,new c.SyncDescriptor(G.DarwinUpdateService));break}ge.set(X.IWindowsMainService,new c.SyncDescriptor(E.WindowsMainService,[de,this.userEnv])),ge.set(ye.IDialogMainService,new c.SyncDescriptor(ye.DialogMainService)),ge.set(m.ILaunchMainService,new c.SyncDescriptor(m.LaunchMainService)),ge.set(De.IDiagnosticsService,I.ProxyChannel.toService(I.getDelayedChannel(ve.then(ke=>ke.getChannel("diagnostics"))))),ge.set(N.IIssueMainService,new c.SyncDescriptor(N.IssueMainService,[this.userEnv])),ge.set(tt.IEncryptionMainService,new c.SyncDescriptor(tt.EncryptionMainService,[de])),ge.set(Xe.IKeyboardLayoutMainService,new c.SyncDescriptor(Xe.KeyboardLayoutMainService)),ge.set(we.INativeHostMainService,new c.SyncDescriptor(we.NativeHostMainService,[pe])),ge.set(Ne.IWebviewManagerService,new c.SyncDescriptor($e.WebviewMainService)),ge.set(B.IWorkspacesService,new c.SyncDescriptor(Y.WorkspacesMainService)),ge.set(Se.IWorkspacesManagementMainService,new c.SyncDescriptor(Se.WorkspacesManagementMainService)),ge.set(ue.IWorkspacesHistoryMainService,new c.SyncDescriptor(ue.WorkspacesHistoryMainService)),ge.set(W.IMenubarMainService,new c.SyncDescriptor(W.MenubarMainService)),ge.set(ie.IExtensionUrlTrustService,new c.SyncDescriptor(ae.ExtensionUrlTrustService)),ge.set(re.IStorageMainService,new c.SyncDescriptor(re.StorageMainService)),S.isWindows?ge.set(Me.IExternalTerminalMainService,new c.SyncDescriptor(Fe.WindowsExternalTerminalService)):S.isMacintosh?ge.set(Me.IExternalTerminalMainService,new c.SyncDescriptor(Fe.MacExternalTerminalService)):S.isLinux&&ge.set(Me.IExternalTerminalMainService,new c.SyncDescriptor(Fe.LinuxExternalTerminalService));const Ee=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(oe.IBackupMainService,Ee),ge.set(r.IURLService,new c.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const ke=I.getDelayedChannel(ve.then(je=>je.getChannel("telemetryAppender"))),Re=new f.TelemetryAppenderClient(ke),Le=k.resolveCommonProperties(this.fileService,v.release(),v.hostname(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ce={appender:Re,commonProperties:Le,piiPaths:Pe,sendErrorTelemetry:!0};ge.set(a.ITelemetryService,new c.SyncDescriptor(d.TelemetryService,[Ce]))}else ge.set(a.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,pe,ve){const ge=I.ProxyChannel.fromService(de.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Ee=new i.UpdateChannel(de.get(y.IUpdateService));pe.registerChannel("update",Ee);const ke=I.ProxyChannel.fromService(de.get(N.IIssueMainService));pe.registerChannel("issue",ke);const Re=I.ProxyChannel.fromService(de.get(tt.IEncryptionMainService));pe.registerChannel("encryption",Re);const Le=I.ProxyChannel.fromService(de.get(be.ISignService));pe.registerChannel("sign",Le);const Pe=I.ProxyChannel.fromService(de.get(Xe.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=de.get(we.INativeHostMainService);const Ce=I.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ce),ve.then(Ve=>Ve.registerChannel("nativeHost",Ce));const je=I.ProxyChannel.fromService(de.get(B.IWorkspacesService));pe.registerChannel("workspaces",je);const qe=I.ProxyChannel.fromService(de.get(W.IMenubarMainService));pe.registerChannel("menubar",qe);const Ge=I.ProxyChannel.fromService(de.get(r.IURLService));pe.registerChannel("url",Ge);const Qe=I.ProxyChannel.fromService(de.get(ie.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Qe);const _e=I.ProxyChannel.fromService(de.get(Ne.IWebviewManagerService));pe.registerChannel("webview",_e);const it=this._register(new se.StorageDatabaseChannel(this.logService,de.get(re.IStorageMainService)));pe.registerChannel("storage",it),ve.then(Ve=>Ve.registerChannel("storage",it));const nt=I.ProxyChannel.fromService(de.get(Me.IExternalTerminalMainService));pe.registerChannel("externalTerminal",nt);const Ze=new F.LogLevelChannel(de.get(u.ILogService));pe.registerChannel("logLevel",Ze),ve.then(Ve=>Ve.registerChannel("logLevel",Ze));const rt=new F.LoggerChannel(de.get(u.ILoggerService));pe.registerChannel("logger",rt),ve.then(Ve=>Ve.registerChannel("logger",rt));const at=new Ie.ElectronExtensionHostDebugBroadcastChannel(de.get(X.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",at)}openFirstWindow(de,pe){const ve=this.windowsMainService=de.get(X.IWindowsMainService),ge=de.get(r.IURLService),Ee=de.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const ke=[],Re=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:ee.URI.parse(We),url:We}}catch(Je){return}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(We.uri);return Je?(ke.push(Je),!1):!0}),Le=this,Pe=this.environmentMainService,Ce=this.productService;ge.registerHandler({async handleURL(We,Je){if(We.scheme===Ce.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:ee.URI.parse(We.query).path,query:""})),Le.shouldBlockURI(We))return!0;const St=Le.getWindowOpenableFromProtocolLink(We);if(St){const[ft]=ve.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[St],gotoLineMode:!0});return ft.focus(),!0}if(S.isMacintosh&&ve.getWindowCount()===0){const[ft]=ve.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:fe.getRemoteAuthority(We)});return await ft.ready(),ge.open(We,Je)}return!1}});const je=this._register(new ut.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),qe=new I.StaticRouter(We=>je.getActiveClientId().then(Je=>We===Je)),Ge=new s.URLHandlerRouter(qe),Qe=pe.getChannel("urlHandler",Ge);ge.registerHandler(new s.URLHandlerChannelClient(Qe)),this._register(new O.ElectronURLListener(Re,ge,ve,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=ht.isLaunchedFromCli(process.env)?0:4,Ze=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],Ve=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?ee.URI.file(_e.waitMarkerFilePath):void 0,yt=_e.remote||void 0;return ke.length>0?ve.open({context:nt,cli:_e,urisToOpen:ke,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Ze&&!rt&&!at?ve.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:yt}):it.length&&!Ze&&!rt&&!at?ve.open({context:1,cli:_e,urisToOpen:it.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:Ve,waitMarkerFileURI:dt,initialStartup:!0}):ve.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Ze&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:Ve,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:yt})}shouldBlockURI(de){return!!(de.authority===x.Schemas.file&&S.isWindows&&A.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[Te.mnemonicButtonLabel(H.localize(0,null)),Te.mnemonicButtonLabel(H.localize(1,null))],cancelId:1,message:H.localize(2,null,Te.getPathLabel(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:H.localize(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===x.Schemas.file)return{fileUri:ee.URI.file(de.fsPath)};if(de.authority===x.Schemas.vscodeRemote){const pe=de.path.indexOf(q.posix.sep,1);if(pe!==-1){const ve=de.path.substring(1,pe),ge=de.path.substring(pe),Ee=ee.URI.from({scheme:x.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return B.hasWorkspaceFileExtension(ge)?{workspaceUri:Ee}:/:[\d]+$/.test(ge)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(de){try{if(L.statSync(de).isDirectory())return{folderUri:ee.URI.file(de)};if(B.hasWorkspaceFileExtension(de))return{workspaceUri:ee.URI.file(de)}}catch(pe){}return{fileUri:ee.URI.file(de)}}async afterWindowOpen(de,pe){var ve;this.lifecycleMainService.phase=3;let ge=!1;ce.once(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Ee=de.get(a.ITelemetryService);this._register(pe.onDidError(({type:Le,details:Pe})=>{var Ce,je,qe,Ge;let Qe;switch(Le){case 1:Qe="SharedProcess: detected unresponsive window";break;case 2:Qe=`SharedProcess: crashed (detail: ${(Ce=Pe==null?void 0:Pe.reason)!==null&&Ce!==void 0?Ce:"<unknown>"}, code: ${(je=Pe==null?void 0:Pe.exitCode)!==null&&je!==void 0?je:"<unknown>"})`;break;case 3:Qe=`SharedProcess: failed to load (detail: ${(qe=Pe==null?void 0:Pe.reason)!==null&&qe!==void 0?qe:"<unknown>"}, code: ${(Ge=Pe==null?void 0:Pe.exitCode)!==null&&Ge!==void 0?Ge:"<unknown>"})`;break}R.onUnexpectedError(new Error(Qe)),Ee.publicLog2("sharedprocesserror",{type:Le,reason:Pe==null?void 0:Pe.reason,code:Pe==null?void 0:Pe.exitCode,visible:pe.isVisible(),shuttingdown:ge})}));const ke=this.productService.win32MutexName;if(S.isWindows&&ke)try{const Le=z.__$__nodeRequire("windows-mutex").Mutex,Pe=new Le(ke);ce.once(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(Le){this.logService.error(Le)}A.protocol.registerHttpProtocol(x.Schemas.vscodeRemoteResource,(Le,Pe)=>{Pe({url:Le.url.replace(/^vscode-remote-resource:/,"http:"),method:Le.method})});const Re=de.get(y.IUpdateService);(Re instanceof U.Win32UpdateService||Re instanceof $.LinuxUpdateService||Re instanceof G.DarwinUpdateService)&&Re.initialize(),(async()=>{const Le=this._register(new j.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));Le.schedule(),await w.resolveShellEnv(this.logService,this.environmentMainService.args,process.env),Le.dispose()})();try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse(et.stripComments(Pe))["enable-crash-reporter"]===void 0){const je=(ve=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ve!==void 0?ve:!0,qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${Be.generateUuid()}"`,"}"],Ge=Pe.substring(0,Pe.length-2).concat(`,
`,qe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,st.VSBuffer.fromString(Ge))}}catch(Le){this.logService.error(Le)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(ye.IDialogMainService);let ge=!1;const Ee=async Re=>{if(ge)return;ge=!0;const Le=await A.contentTracing.stopRecording(K.joinPath(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Re?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):ve.showMessageBox({type:"info",message:H.localize(4,null),detail:H.localize(5,null,Le),buttons:[H.localize(6,null)]},Ae.withNullAsUndefined(A.BrowserWindow.getFocusedWindow()))},ke=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(Re=>Re.ready())).then(()=>{clearTimeout(ke),Ee(!1)})}};Ue=he([te(2,D.IInstantiationService),te(3,u.ILogService),te(4,o.IEnvironmentMainService),te(5,n.ILifecycleMainService),te(6,t.IConfigurationService),te(7,l.IStateMainService),te(8,He.IFileService),te(9,T.IProductService)],Ue),e.CodeApplication=Ue}),define(J[240],Z([0,1,14,30,16,11,3,72,47,54,161,18,33,56,174,71,69,6,225,38,17,188,49,223,236,39,94,93,19,60,42,75,194,197,182,183,10,21,74,221,22,29,23,8,35,24,67,97,180,32,55,185,9,203]),function(z,e,v,L,A,S,E,n,w,y,i,I,P,p,g,m,D,b,c,u,l,o,t,r,s,a,h,f,d,k,T,C,V,X,ee,B,Y,Q,U,$,G,N,F,R,O,M,W,_,q,K,H,x,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class re{main(){try{this.startup()}catch(oe){console.error(oe.message),v.app.exit(1)}}async startup(){d.setUnexpectedErrorHandler(ye=>console.error(ye));const[oe,ue,me,Se,De,Ie,we]=this.createServices();try{try{await this.initServices(me,Se,De)}catch(ye){throw this.handleStartupDataDirError(me,we.nameLong,ye),ye}await oe.invokeFunction(async ye=>{const Ae=ye.get(b.ILogService),Te=ye.get(I.ILifecycleMainService),$e=ye.get(Q.IFileService),Ne=await this.claimInstance(Ae,me,Te,oe,we,!0);return Ie.logger=new h.SpdLogLogger("main",R.join(me.logsPath,"main.log"),!0,Ie.getLevel()),T.once(Te.onWillShutdown)(()=>{$e.dispose(),Se.dispose()}),oe.createInstance(s.CodeApplication,Ne,ue).startup()})}catch(ye){oe.invokeFunction(this.quit,ye)}}createServices(){const oe=new m.ServiceCollection,ue=Object.assign({_serviceBrand:void 0},w.default);oe.set(G.IProductService,ue);const me=new M.EnvironmentMainService(this.resolveArgs(),ue),Se=this.patchEnvironment(me);oe.set(M.IEnvironmentMainService,me);const De=new f.BufferLogService,Ie=new b.MultiplexLogService([new b.ConsoleMainLogger(b.getLogLevel(me)),De]);process.once("exit",()=>Ie.dispose()),oe.set(b.ILogService,Ie);const we=new ee.FileService(Ie);oe.set(Q.IFileService,we);const ye=new B.DiskFileSystemProvider(Ie);we.registerProvider(Y.Schemas.file,ye),oe.set(b.ILoggerService,new q.LoggerService(Ie,we));const Ae=new o.ConfigurationService(me.settingsResource,we);oe.set(l.IConfigurationService,Ae),oe.set(I.ILifecycleMainService,new D.SyncDescriptor(I.LifecycleMainService));const Te=new c.StateMainService(me,Ie,we);return oe.set(u.IStateMainService,Te),oe.set(t.IRequestService,new D.SyncDescriptor(r.RequestMainService)),oe.set(k.IThemeMainService,new D.SyncDescriptor(k.ThemeMainService)),oe.set(C.ISignService,new D.SyncDescriptor(V.SignService)),oe.set(U.ITunnelService,new D.SyncDescriptor($.TunnelService)),oe.set(H.IProtocolMainService,new D.SyncDescriptor(x.ProtocolMainService)),[new g.InstantiationService(oe,!0),Se,me,Ae,Te,De,ue]}patchEnvironment(oe){const ue={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const Se=process.env[me];typeof Se=="string"&&(ue[me]=Se)}),Object.assign(process.env,ue),ue}initServices(oe,ue,me){return ne.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(Se=>Se?A.Promises.mkdir(Se,{recursive:!0}):void 0)),ue.initialize(),me.init()])}async claimInstance(oe,ue,me,Se,De,Ie){let we;try{n.mark("code/willStartMainServer"),we=await p.serve(ue.mainIPCHandle),n.mark("code/didStartMainServer"),T.once(me.onWillShutdown)(()=>we.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,De.nameLong,ye),ye;let Ae;try{Ae=await p.connect(ue.mainIPCHandle,"main")}catch(Ne){if(!Ie||E.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog(S.localize(0,null,De.nameShort),S.localize(1,null),De.nameLong),Ne;try{L.unlinkSync(ue.mainIPCHandle)}catch(He){throw oe.warn("Could not delete obsolete instance handle",He),He}return this.claimInstance(oe,ue,me,Se,De,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ne),Ae.dispose(),new Error(Ne)}let Te;!ue.args.wait&&!ue.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog(S.localize(2,null,De.nameShort),S.localize(3,null),De.nameLong)},1e4));const $e=P.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0});if(ue.args.status)return Se.invokeFunction(async()=>{const Ne=new X.DiagnosticsService(_.NullTelemetryService,De),He=await $e.getMainProcessInfo(),et=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(He,et);throw console.log(Be),new d.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow($e,oe),oe.trace("Sending env to running instance..."),await $e.start(ue.args,process.env),Ae.dispose(),Te&&clearTimeout(Te),new d.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(oe,ue,me){if(me.code==="EACCES"||me.code==="EPERM"){const Se=O.coalesce([oe.userDataPath,oe.extensionsPath,p.XDG_RUNTIME_DIR]).map(De=>a.getPathLabel(De,oe));this.showStartupWarningDialog(S.localize(4,null),S.localize(5,null,W.toErrorMessage(me),Se.join(`
`)),ue)}}showStartupWarningDialog(oe,ue,me){v.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[a.mnemonicButtonLabel(S.localize(6,null))],message:oe,detail:ue,noLink:!0})}async windowsAllowSetForegroundWindow(oe,ue){if(E.isWindows){const me=await oe.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((Se,De)=>{z(["windows-foreground-love"],Se,De)})).allowSetForegroundWindow(me)}catch(Se){ue.error(Se)}}}quit(oe,ue){const me=oe.get(b.ILogService),Se=oe.get(I.ILifecycleMainService);let De=0;ue&&(ue.isExpected?ue.message&&me.trace(ue.message):(De=1,ue.stack?me.error(ue.stack):me.error(`Startup error: ${ue.toString()}`))),Se.kill(De)}resolveArgs(){const oe=this.validatePaths(y.parseMainProcessArgv(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const ue=i.createWaitMarkerFile(oe.verbose);ue&&(y.addArg(process.argv,"--waitMarkerFilePath",ue),oe.waitMarkerFilePath=ue)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const ue=this.doValidatePaths(oe._,oe.goto);oe._=ue}return oe}doValidatePaths(oe,ue){const me=K.cwd(),Se=oe.map(we=>{let ye=String(we),Ae;ue&&(Ae=N.parseLineAndColumnAware(ye),ye=Ae.path),ye&&(ye=this.preparePath(me,ye));const Te=N.sanitizeFilePath(ye,me),$e=R.basename(Te);return $e&&!N.isValidBasename($e)?null:ue&&Ae?(Ae.path=Te,this.toPath(Ae)):Te}),De=E.isWindows||E.isMacintosh,Ie=O.distinct(Se,we=>we&&De?we.toLowerCase():we||"");return O.coalesce(Ie)}preparePath(oe,ue){return E.isWindows&&(ue=F.rtrim(ue,'"')),ue=F.trim(F.trim(ue," "),"	"),E.isWindows&&(ue=R.resolve(oe,ue),ue=F.rtrim(ue,".")),ue}toPath(oe){const ue=[oe.path];return typeof oe.line=="number"&&ue.push(String(oe.line)),typeof oe.column=="number"&&ue.push(String(oe.column)),ue.join(":")}}new re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e1161be26874f0d39a5b9cdeb2c5fbfd4f83bb80/core/vs/code/electron-main/main.js.map
